
// ******************************
// *** serielle Schnittstelle ***
// ******************************


VAR
  SER0_Zeichen : Byte;


procedure INIT_SER0_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0H := 0;
    UBRR0L := UBRR_VAL;

{
Bit 4 RXEN: Receiver Enable
Bit 3 TXEN: Transmitter Enable
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER0_PORT;





procedure RX0_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    SER0_Zeichen:=UDR0;
  else
    SER0_Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX0_Puffer_abfragen;





procedure sende_Zeichen0(s_Zeichen0 : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE0) do
//    SetBit(LED_GRUEN); // gruen ein
  endwhile;

 // ClearBit(LED_GRUEN); // gruen aus

  UDR0:=s_Zeichen0;

end sende_Zeichen0;



procedure sende_HEX_Zeichen0(h_Zeichen : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
begin

  HexHigh:=h_Zeichen and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  sende_Zeichen0(HexHigh);

  HexLow:=h_Zeichen and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  sende_Zeichen0(HexLow);

  sende_Zeichen0($48); // H

end sende_HEX_Zeichen0;



procedure sende_HEX_Zeichen0_Ln(Wert_Byte : Byte);
begin
  sende_HEX_Zeichen0(Wert_Byte);
  sende_Zeichen0($0D); // CR
  sende_Zeichen0($0A); // LF
end sende_HEX_Zeichen0_Ln;






procedure Write_SER0;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(Write_String);
  for b1:=1 to Laenge do
    c1:=Write_String[b1];
    b2:=CharToByte(c1);
    sende_Zeichen0(b2);
  endfor;

end Write_SER0;




procedure WriteLn_SER0;
begin
  Write_SER0;
  sende_Zeichen0($0D); // CR
  sende_Zeichen0($0A); // LF
end WriteLn_SER0;



