VAR

{
 Definitions marked "MEMORY MAPPED"are extended I/O ports
 and cannot be used with IN/OUT instructions
}

  // *** Timer/Counter 3 ***

  // Output Compare Register B
  OCR3BL, OCR3BH,
  // Output Compare Register A
  OCR3AL, OCR3AH,
  // Timer/Counter Register
  TCNT3L, TCNT3H,
  // Timer/Counter Control Register B
  TCCR3B,
  // Timer/Counter Control Register A
  TCCR3A,

  // Input Capture Register Low und High
  ICR3L, ICR3H,


  // Extended Timer Interrupt Mask Register
  ETIMSK,

  // Extended Timer Interrupt Flag Register
  ETIFR,

  // Pin Change Mask Register 1
  PCMSK1,
  // Pin Change Mask Register 1
  PCMSK0,

  // Clock Prescale Register
  CLKPR


   : ByteConVar;






{
  alle Register, die mit In/OUT angesprochen werden koennen
}

  // Status Register
  SREG,

  // Stack Pointer Low und High
  SPL, SPH,


  // General Interrupt Control Register
  GICR,

  // General Interrupt Flag Register
  GIFR,

  // Timer Interrupt Mask Register
  TIMSK,

  // Timer Interrupt Flag Register
  TIFR,

  // Store Program Memory Control Register
  SPMCR,

  // Extended MCU Control Register
  EMCUCR,

  // MCU Control Register
  MCUCR,

  // MCU Control and Status Register
  MCUCSR,

  // Timer/Counter Control Register
  TCCR0,

  // Timer/Counter Register
  TCNT0,


  // Output Compare Register TC0
  OCR0,


  // Special Function IO Register
  SFIOR,



  // *** Timer/Counter 1 ***

  // Timer/Counter Control Register A und B
  TCCR1A, TCCR1B,

  // Timer/Counter 1, Hight und Low
  TCNT1H, TCNT1L,

  // Output Compare Register 1 A, Hight und Low
  OCR1AH, OCR1AL,

  // Output Compare Register 1 B, Hight und Low
  OCR1BH, OCR1BL,

  // Input Capture Register 1, Hight und Low
  ICR1H, ICR1L,




  // *** Timer/Counter 2 ***

  //Timer/Counter Control Register
  TCCR2,

  // Timer/Counter 2
  TCNT2,

  // Output Compare Register 2
  OCR2,

  // Asynchronous Status Register
  ASSR,




  // Watchdog Timer Control Register
  WDTCR,




  // *** USART0 ***
  // *** (UNIVERSAL SYNCHRONOUS and ASYNCHRONOUS RECEIVER and TRANSMITTER) ***

  // I/O Data Register
  UDR0,
  // Baud Raten Register High Byte
  UBRR0H,
  // Baud Raten Register Low Byte
  UBRR0L,
  // Control Status Register A bis C
  UCSR0A, UCSR0B, UCSR0C,



  // *** USART1 ***
  // *** (UNIVERSAL SYNCHRONOUS and ASYNCHRONOUS RECEIVER and TRANSMITTER) ***

  // I/O Data Register
  UDR1,
  // Baud Raten Register High Byte
  UBRR1H,
  // Baud Raten Register Low Byte
  UBRR1L,
  // Control Status Register A bis C
  UCSR1A, UCSR1B, UCSR1C,






  // *** EEPROM ***

  // The EEPROM Adress Register
  EEARH, EEARL,

  // The EEPROM Data Register
  EEDR,

  // The EEPROM Control Register
  EECR,



  // *** SPI ***

  // SPI Data Register
  SPDR,

  // SPI Status Register
  SPSR,

  // SPI Control Register
  SPCR,



  // Analog Comparator Control and Status Register
  ACSR,


  // Oscillator Calibration Register
  OSCCAL,


  // On-chip Debug Register
  OCDR,




  // *** PORT A ***

  // Data Register
  PORTA,
  // Data Direction Register
  DDRA,
  // Input Pins Adress
  PINA,


  // *** PORT B ***

  // Data Register
  PORTB,
  // Data Direction Register
  DDRB,
  // Input Pins Adress
  PINB,


    // *** PORT C ***

  // Data Register
  PORTC,
  // Data Direction Register
  DDRC,
  // Input Pins Adress
  PINC,


  // *** PORT D ***

  // Data Register
  PORTD,
  // Data Direction Register
  DDRD,
  // Input Pins Adress
  PIND,


  // *** PORT E ***

  // Data Register
  PORTE,
  // Data Direction Register
  DDRE,
  // Input Pins Adress
  PINE


    : ByteConReg;




// *** ISR-Liste ***
//
ISR_LISTE( 2,'INT0addr' ,'EXT_INT0'     ,'External Interrupt Request 0');
ISR_LISTE( 3,'INT1addr' ,'EXT_INT1'     ,'External Interrupt Request 1');
ISR_LISTE( 4,'INT2addr' ,'EXT_INT2'     ,'External Interrupt Request 1');

ISR_LISTE( 5,'PCI0addr' ,'PCINT0'       ,'Pin Change Interrupt Request 0');
ISR_LISTE( 6,'PCI1addr' ,'PCINT1'       ,'Pin Change Interrupt Request 1');

ISR_LISTE( 7,'ICP1addr' ,'TIMER3_CAPT'  ,'Timer/Counter3 Capture Event');
ISR_LISTE( 8,'OC1Aaddr' ,'TIMER3_COMPA' ,'Timer/Counter3 Compare Match A');
ISR_LISTE( 9,'OC1Baddr' ,'TIMER3_COMPB' ,'Timer/Counter3 Compare Match B');
ISR_LISTE(10,'OVF1addr' ,'TIMER3_OVF'   ,'Timer/Counter3 Overflow');

ISR_LISTE(11,'OC2addr'  ,'TIMER2_COMP'  ,'Timer/Counter2 Compare Match');
ISR_LISTE(12,'OVF2addr' ,'TIMER2_OVF'   ,'Timer/Counter2 Overflow');

ISR_LISTE(13,'ICP1addr' ,'TIMER1_CAPT'  ,'Timer/Counter1 Capture Event');
ISR_LISTE(14,'OC1Aaddr' ,'TIMER1_COMPA' ,'Timer/Counter1 Compare Match A');
ISR_LISTE(15,'OC1Baddr' ,'TIMER1_COMPB' ,'Timer/Counter1 Compare Match B');
ISR_LISTE(16,'OVF1addr' ,'TIMER1_OVF'   ,'Timer/Counter1 Overflow');

ISR_LISTE(17,'OC0addr'  ,'TIMER0_COMP'  ,'Timer/Counter0 Compare Match');
ISR_LISTE(19,'OVF0addr' ,'TIMER0_OVF'   ,'Timer/Counter0 Overflow');

ISR_LISTE(19,'SPIaddr'  ,'SPI_STC'      ,'Serial Transfer Complete');

ISR_LISTE(20,'URXC0addr' ,'USART0_RXC'  ,'USART0, Rx Complete');
ISR_LISTE(21,'URXC1addr' ,'USART1_RXC'  ,'USART1, Rx Complete');
ISR_LISTE(22,'UDRE0addr' ,'USART0_UDRE' ,'USART0 Data Register Empty');
ISR_LISTE(23,'UDRE1addr' ,'USART1_UDRE' ,'USART1 Data Register Empty');
ISR_LISTE(24,'UTXC0addr' ,'USART0_TXC'  ,'USART0, Tx Complete');
ISR_LISTE(25,'UTXC1addr' ,'USART1_TXC'  ,'USART1, Tx Complete');

ISR_LISTE(26,'ERDYaddr' ,'EE_RDY'       ,'EEPROM Ready');

ISR_LISTE(27,'ACIaddr'  ,'ANA_COMP'     ,'Analog Comparator');

ISR_LISTE(28,'SPMRaddr' ,'SPM_RDY'      ,'Store Program Memory Ready');



