PROGRAM SOUND;

DEVICE = mega328p;

{$I mega328P_Register.INC}

{$I mega328P_TC.INC}


// Frequenz = 16.000.000 Hz;

CONST

  // Sound-Befehle
  SND_kein_Befehl      : Byte = 00;
  SND_Reset_Lied_TAB   : Byte = 01;
  SND_Lade_Lied_TAB    : Byte = 02;
  SND_Spiele_Lied_TAB  : Byte = 03;

  SND_Setze_MIDI       : Byte = 04;
  SND_Setze_DAUER      : Byte = 05;
  SND_Setze_INSTR      : Byte = 06;

  SND_Spiele_Save_TAB  : Byte = 12;

  // Instrument-Befehle
  INSTR_KirchenOrgel   : Byte = 00;
  INSTR_Sinus          : Byte = 01;


  // BA_Mode
  BA_mode_keineBA : Byte = 0;
  BA_mode_INI     : Byte = 1;
  BA_mode_SET_WR  : Byte = 2;
  BA_mode_WR      : Byte = 3;
  BA_mode_SET_RD  : Byte = 4;
  BA_mode_RD      : Byte = 5;


  // RECEIVE_MODE
  NO_RECEIVE_MODE    : Byte = 0;
  RECEIVE_SOUND      : Byte = 1;
  RECEIVE_DEVCODE    : Byte = 2;
  RECEIVE_ERROR_CODE : Byte = 3;


  // SEND_MODE
  NO_SEND_MODE : Byte = 0;
  SEND_SOUND   : Byte = 1;


  RE_CONST   : BYTE = 1;  // Code fuer RECEIVE CONST
  RE_CONIN   : BYTE = 2;  // Code fuer RECEIVE CONIN
  SE_CONOUT  : BYTE = 3;  // Code fuer SEND CONOUT
  RE_SECNT   : BYTE = 4;  // Code fuer RECEIVE SECTOR COUNT
  RE_SECTOR  : BYTE = 5;  // Code fuer RECEIVE SECTOR
  RE_RD_ISEC : BYTE = 6;  // Code fuer RECEIVE READ IMAGE SECTOR
  SE_WR_ISEC : BYTE = 7;  // Code fuer SEND WRITE IMAGE SECTOR
  SE_STD     : BYTE = 8;  // Code fuer SEND SECTOR, TRACK, DRIVE
  SE_LIST    : BYTE = 9;  // Code fuer SEND LIST
  RE_ERROR_CODE
             : BYTE = 10;  // Code fuer RECEIVE ERROR CODE

  SE_SOUND   : BYTE = 15;  // Code fuer SEND SOUND



  RE_WHO_ARE_YOU
           : BYTE = 20; // Code fuer Abfrage der Funktionalitaet
			//  des angeschlossenen Geraetes


// ------------------------------------------------------

  DEVCODE_PC_CPM_EMU   : BYTE = 2;  // Code fuer PC-CP/M-Emulator
  DEVCODE_KEYBOARD     : BYTE = 3;  // Code fuer Tastatur
  DEVCODE_DISPLAY      : BYTE = 4;  // Code fuer LCD-Display
  DEVCODE_RAMFLOPPY    : BYTE = 5;  // Code fuer RAM-Floppy
  DEVCODE_CONINOUT     : BYTE = 6;  // Code fuer Tastatur und Display
  DEVCODE_SOUND        : BYTE = 7;  // Code fuer Tonausgabe


// Nachricht auf die Anfrage "Wer bist Du?" RE_WHO_ARE_YOU ist
// die Nachricht "Wer bin ich?" MESSAGE_WHO_AM_I
//
//  !!!!! Achtung diese Zeile muss bei jedem Geraet angepasst werden !!!!!
//

   MESSAGE_WHO_AM_I    : BYTE = 7;  // DEVCODE_RAMFLOPPY



{$I PIPE_ORGAN_TAB.INC}

{$I SinTab.INC}

{$I MIDI_Tab.INC}



LIED_TAB2_Laenge : Word = 31;

LIED_TAB2 : array[0..LIED_TAB2_Laenge] of Byte = (

  60, 25,
  64, 80,
  68, 20,
  00, 60,
  62, 30,
  00, 50,
  68, 90,
  00, 20,
  50, 30,
  00, 15,
  85, 80,
  00, 40,
  68, 40,
  00, 50,
  55, 60,
  00, 20

);





VAR
  Zaehler_T0, Zaehler_T1,
  Ton_Periode,
  MIDI_Nummer, LIED_TAB_Zeiger,
  Ton_Dauer, LIED_TAB_Laenge : Word;

  SIN_wert, Ton_Dauer_Byte, MIDI_Nummer_Byte : Byte;

  LED_Rot[PortB, 0] : bit;
  BA_Mode, RECEIVE_MODE, SEND_MODE,
  ERROR_CODE, ERROR_PARAM, Sound_Byte,
  Lade_Byte : Byte;


  DDWR_E[PINC, 4]   : bit; // E

  DDAC_A[PortC, 5]  : bit; // A

  CDEN_E[PINB, 1]   : bit; // E
  CDEN_A[PortB, 1]  : bit; // A
  CDEN_P[DDRB, 1]   : bit; // P { 1=Ausgang, 0=Eingang }

  CRAC_A[PortB, 2]  : bit; // A
  CRAC_E[PINB, 2]   : bit; // E
  CRAC_P[DDRB, 2]   : bit; // P { 1=Ausgang, 0=Eingang }


  LIED_TAB : Array [0..511] of Byte;

  Sound_Befehl : Byte;
  ARRAY_Adresse : Adress;



procedure InitPorts;
begin

// PORT B
{
ITP2 Steuerleitungen
PB0 = LED_ROT = A
PB1 = CDEN (ITP2) = E/A
PB2 = CRAC (ITP2) = A/E
}
  DDRB:= DDRB or %00000101;

// PORT C
{ PC0..PC3 = E -> Daten
ITP2 Steuerleitungen
PC4 = DDWR (ITP2) = E
PC5 = DDAC (ITP2) = A
}
  DDRC:= %00100000;


// PORT D -> D/A-Wandler
  DDRD:=  %11111111;





end InitPorts;




procedure InitAdressen;
begin
  ARRAY_Adresse:=ArrToAdress(SINTAB);
end InitAdressen;





{ *** SOUND-Programme *** }





procedure lese_Sound_Byte;
var
  w1 : Word;
  b1 : Byte;
begin

  case Sound_Befehl of

    SND_kein_Befehl      :   Sound_Befehl:=Sound_Byte;

    |

    SND_Setze_MIDI       :   LIED_TAB[LIED_TAB_Laenge]:=Sound_Byte;
                             INC(LIED_TAB_Laenge);
                             Sound_Befehl:=SND_Setze_DAUER;

    |

    SND_Setze_DAUER      :   LIED_TAB[LIED_TAB_Laenge]:=Sound_Byte;
                             INC(LIED_TAB_Laenge);
                             Sound_Befehl:=SND_kein_Befehl;

    |

    SND_Setze_INSTR      :   LIED_TAB[LIED_TAB_Laenge]:=01;
                             INC(LIED_TAB_Laenge);
                             LIED_TAB[LIED_TAB_Laenge]:=Sound_Byte;
                             INC(LIED_TAB_Laenge);
                             Sound_Befehl:=SND_kein_Befehl;

    |

  endcase;





  // die Ein-Byte-Soundbefehle
  case Sound_Befehl of

    SND_Reset_Lied_TAB  :   LIED_TAB_Laenge:=0;
                            TIMER1_aus;
                            TIMER0_aus;
                            Sound_Befehl:=SND_kein_Befehl;

    |

    SND_Spiele_Lied_TAB :   LIED_TAB_Zeiger:=0;
                            Zaehler_T0:=0;
                            Ton_Dauer:=1;
                            TIMER1_aus;
                            Init_TIMER0_OVF;
                            Sound_Befehl:=SND_kein_Befehl;
    |

    SND_Spiele_Save_TAB :   for w1:=0 to LIED_TAB2_Laenge do
                              b1:=LIED_TAB2[w1];
                              LIED_TAB[w1]:=b1;
                            endfor;
                            LIED_TAB_Laenge:=LIED_TAB2_Laenge+1;
                            LIED_TAB_Zeiger:=0;
                            Zaehler_T0:=0;
                            Ton_Dauer:=1;
                            TIMER1_aus;
                            Init_TIMER0_OVF;
                            Sound_Befehl:=SND_kein_Befehl;
    |


  endcase; { case Sound_Befehl of }



end lese_Sound_Byte;



{--------------------------------------------------------------}




isr TIMER0_OVF;
begin

  TCNT0:=0;

  INC(Zaehler_T0);

  if Zaehler_T0=Ton_Dauer then

    Zaehler_T0:=0;

    MIDI_Nummer_Byte:=LIED_TAB[LIED_TAB_Zeiger];
    MIDI_Nummer:=ByteToWord(MIDI_Nummer_Byte);
    Inc(LIED_TAB_Zeiger);

    Ton_Dauer_Byte:=LIED_TAB[LIED_TAB_Zeiger];
    Ton_Dauer:=ByteToWord(Ton_Dauer_Byte);
    Inc(LIED_TAB_Zeiger);

    if LIED_TAB_Zeiger>=LIED_TAB_Laenge then
      LIED_TAB_Zeiger:=0;
      TIMER0_aus;
      TIMER1_aus;
    endif;

    Zaehler_T1:=0;

    case MIDI_Nummer_Byte of

      0 : TIMER1_aus;
          ClearBit(LED_Rot);

      |

      1 : case Ton_Dauer_Byte of

            INSTR_KirchenOrgel : ARRAY_Adresse:=ArrToAdress(PIPE_ORGAN_TAB);
            |
            INSTR_Sinus        : ARRAY_Adresse:=ArrToAdress(SINTAB);
            |

           endcase;
           TIMER1_aus;
           Ton_Dauer:=1;
           ClearBit(LED_Rot);

      |

    else

      Ton_Periode:=MIDI_TAB[MIDI_Nummer];
      Init_TIMER1_COMPA(Ton_Periode);
      SetBit(LED_Rot);

    endcase;

  endif;

end TIMER0_OVF;








isr TIMER1_COMPA;
begin

  SIN_wert:=ReadAdrArray(ARRAY_Adresse,Zaehler_T1);
  PORTD:=SIN_wert;
  INC(Zaehler_T1);
  if Zaehler_T1=128 then
    Zaehler_T1:=0;
  endif;

end TIMER1_COMPA;






{ *** Anfang - Daten Programme *** }



procedure change_mode(DATA_Byte : Byte);
begin
  case DATA_Byte of

    SE_SOUND       : SEND_MODE := SEND_SOUND;
    |
    RE_WHO_ARE_YOU : RECEIVE_MODE := RECEIVE_DEVCODE;
    |
    RE_ERROR_CODE  : RECEIVE_MODE := RECEIVE_ERROR_CODE;
    |

  else
//    SetBit(LED_ROT);
    ERROR_CODE := $01;
    ERROR_PARAM := DATA_Byte;
  endcase;
end change_mode;






procedure DATA_SEND(DATA_Byte : Byte);
var
  Zeichen : Char;
begin
  case SEND_MODE of

    NO_SEND_MODE : change_mode(DATA_Byte);
    |

    SEND_SOUND   : Sound_Byte:=DATA_Byte;
                   SEND_MODE:=NO_SEND_MODE;
                   RECEIVE_MODE := RECEIVE_SOUND;
    |
  else
    ERROR_CODE := $02;
    ERROR_PARAM := DATA_Byte;
  endcase;
end DATA_SEND;







// sendet ein Nibble an die Z80
procedure SEND_ONE_NIBBLE(ONE_NIBBLE : Byte);
var
  Bit_Test : Byte;
begin
  // erstmal alles auf 0
  ClearBit(CDEN_A);

  PortC := ONE_NIBBLE;

  NOP;
  NOP;
  NOP;
  NOP;

  while BitLow(CRAC_E) do
    SetBit(CDEN_A);
  endwhile;

  while BitHigh(CRAC_E) do
    ClearBit(CDEN_A);
  endwhile;

end SEND_ONE_NIBBLE;




// sendet ein Byte an die Z80
procedure RUN_RECEIVE_MESSAGE(RECEIVE_MESSAGE : Byte);
var
  ONE_NIBBLE : Byte;
begin
 ONE_NIBBLE := RECEIVE_MESSAGE and $0F;
 SEND_ONE_NIBBLE(ONE_NIBBLE);

 ONE_NIBBLE := RECEIVE_MESSAGE;
 shr(ONE_NIBBLE);
 shr(ONE_NIBBLE);
 shr(ONE_NIBBLE);
 shr(ONE_NIBBLE);
 SEND_ONE_NIBBLE(ONE_NIBBLE);

end RUN_RECEIVE_MESSAGE;




procedure RUN_RECEIVE_SOUND;
begin
  // SetBit(LED_ROT);
  lese_Sound_Byte;
  RECEIVE_MODE := NO_RECEIVE_MODE;
end RUN_RECEIVE_SOUND;








procedure RUN_RECEIVE_DEVCODE;
begin
  RUN_RECEIVE_MESSAGE(MESSAGE_WHO_AM_I);
  RECEIVE_MODE := NO_RECEIVE_MODE;
end RUN_RECEIVE_DEVCODE;





procedure RUN_RECEIVE_ERROR_CODE;
begin
  RUN_RECEIVE_MESSAGE(ERROR_CODE);  // Fehlercode 0=kein Fehler
  RUN_RECEIVE_MESSAGE(ERROR_PARAM);  // Parameter fuer Fehlercode
  RECEIVE_MODE := NO_RECEIVE_MODE;
end RUN_RECEIVE_ERROR_CODE;






{ *** Ende - Daten Programme *** }












{ *** Anfang - Betriebsarten Programme *** }




procedure RUN_BA_mode_keineBA;
begin
  BA_Mode:=BA_mode_INI;
end RUN_BA_mode_keineBA;





procedure RUN_BA_mode_SET_RD;
begin

  { Umschalten auf Server = Lesen, Client = Schreiben
   D0-D3 = Ausgaenge,
   CDEN = Ausgang,
   CRAC = Eingang  }
  DDRC:=DDRC OR %00001111; // D0-D3 A

  ClearBit(CDEN_A); // 0 - Vorbelegung
  SetBit(CDEN_P); // A
  ClearBit(CDEN_A); // 0 - Vorbelegung
  ClearBit(CRAC_P); // E

  ClearBit(DDAC_A); // DDAC=0 -> RD = Bestaetigung der Umstellung

  BA_Mode:=BA_mode_RD;

end RUN_BA_mode_SET_RD;





procedure RUN_BA_mode_INI;
begin

  if BitLow(DDWR_E) then // Am Anfang von WR -> RD (1 -> 0)
    RUN_BA_mode_SET_RD;
  endif;

end RUN_BA_mode_INI;






procedure RUN_BA_mode_SET_WR;
begin

  BA_Mode:=BA_mode_WR;
  { Umschalten auf Server = Schreiben, Client = Lesen
    D0-D3 = Eingaenge,
    CDEN = Eingang,
    CRAC = Ausgang  }
  DDRC := DDRC AND %11110000; // D0-D7 E

  ClearBit(CDEN_P); // E
  ClearBit(CRAC_A); // 0 - Vorbelegung
  SetBit(CRAC_P); // A
  ClearBit(CRAC_A); // 0 - Vorbelegung

  SetBit(DDAC_A);  // DDAC=1 -> WR = Bestaetigung der Umstellung
end RUN_BA_mode_SET_WR;






procedure RUN_BA_mode_RD;
begin

  if RECEIVE_MODE <> NO_RECEIVE_MODE then
    case RECEIVE_MODE of

      RECEIVE_SOUND : RUN_RECEIVE_SOUND;
      |
      RECEIVE_DEVCODE : RUN_RECEIVE_DEVCODE;
      |
      RECEIVE_ERROR_CODE : RUN_RECEIVE_ERROR_CODE;
      |

    endcase; { if RECEIVE_MODE <> NO_RECEIVE_MODE then }
  endif; { if RECEIVE_MODE <> NO_RECEIVE_MODE then }


  if BitHigh(DDWR_E) then  // ist DDWR_E=1, dann will der
                       // Server auf WR umstellen
    RUN_BA_mode_SET_WR;
  endif;
end RUN_BA_mode_RD;











procedure RUN_BA_mode_WR;
var
  DATA_Buf_LOW : Byte;
  DATA_Buf_HIGH : Byte;
  DATA_Buf : Byte;
begin

  if BitHigh(CDEN_E) then  // ist CDEN_E=1, dann hat der Server
                       // Daten gesendet

    NOP;
    NOP;
    NOP;
    NOP;

    DATA_Buf_LOW := PINC;
    DATA_Buf_LOW := DATA_Buf_LOW and %00001111; // Daten aus Port C lesen
                                               // es sind aber nur D0-D3 Daten
                                              // die anderen werden ausgeblendet

    while BitHigh(CDEN_E) do
      SetBit(CRAC_A);
    endwhile;

    while BitLow(CDEN_E) do
      ClearBit(CRAC_A);
    endwhile;

    // 2. Lauf

    NOP;
    NOP;
    NOP;
    NOP;

    DATA_Buf_HIGH := PINC and %00001111; // Daten aus Port C lesen
                                           // es sind aber nur D0-D3 Daten
                                          // die anderen werden ausgeblendet

    SHL(DATA_Buf_HIGH);
    SHL(DATA_Buf_HIGH);
    SHL(DATA_Buf_HIGH);
    SHL(DATA_Buf_HIGH);

    DATA_Buf := DATA_Buf_HIGH or DATA_Buf_LOW;

    DATA_SEND(DATA_Buf);

    while BitHigh(CDEN_E) do
      SetBit(CRAC_A);
    endwhile;

    ClearBit(CRAC_A);

  endif; { if Bit(CDEN_E) then }


  if BitLow(DDWR_E) then  // ist DDWR_E=0, dann will der
                           // Server auf RD umstellen
    RUN_BA_mode_SET_RD;
  endif;

end RUN_BA_mode_WR;


{ *** Ende - Betriebsarten Programme *** }








isr TIMER2_OVF;
begin

  CASE BA_Mode OF
      BA_mode_keineBA : RUN_BA_mode_keineBA;
      |
      BA_mode_INI     : RUN_BA_mode_INI;
      |
      BA_mode_RD      : RUN_BA_mode_RD;
      |
      BA_mode_WR      : RUN_BA_mode_WR;
      |
  ENDCASE;

end TIMER2_OVF;








BEGIN

  Zaehler_T0:=0;
  Zaehler_T1:=0;

  Sound_Befehl:=SND_kein_Befehl;
  InitAdressen;

  SetBit(DDAC_A);  // DDAC=1
  ClearBit(CRAC_A);  // CRAC=0

  ClearBit(LED_Rot);

  BA_Mode:= BA_mode_keineBA;
  SEND_MODE := NO_SEND_MODE;
  RECEIVE_MODE := NO_RECEIVE_MODE;

  ERROR_CODE := $00;
  ERROR_PARAM := $00;

  InitPorts;


  Init_TIMER2_OVF;


  EnableInts;


  LOOP
  ENDLOOP;



END SOUND.

