; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: VGAGEN2P.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        CTC_WERT  =  0x02BA ; WORD
.equ        VL_RESET  =  0x00 ; BYTE
.equ        VL_VER_IMP  =  0x01 ; BYTE
.equ        VL_OUT_VA  =  0x02 ; BYTE
.equ        VL_INC_VA  =  0x03 ; BYTE
.equ        VL_MEMREADY  =  0x04 ; BYTE
.equ        LAENGE_VLINE  =  0x020D ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
SCHALTER_MEMREADY:   ; Byte
.byte     1
SPEICHER_VER_ADR:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Timer/Counter1 Compare Match A
.ORG OC1Aaddr
        JMP        TIMER1_COMPA
 
; PROCEDURE - Anfang (INIT_TIMER1_COMPA)
INIT_TIMER1_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (OCR1AH)
        STS        OCR1AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (OCR1AL)
        STS        OCR1AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (INIT_TIMER1_COMPA)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; ISR - Einsprung
TIMER1_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
;****************************************************************************
;****************************************************************************
;	VIDEO - Interruptroutine
;****************************************************************************
;****************************************************************************


; 2. Register in der Interruptroutine

.def memready = R17
.def VER_ADR  = R18


.equ 	port_adr_low	= porta
.equ 	port_adr_hig	= portb
.equ 	port_control	= portd

.equ 	ddr_dat		= ddrc

; *** port_control
.equ 	HOR		= 2			; Horizontale Synchronimpulse Pin 13
.equ 	VER		= 3			; Vertikale Synchronimpulse Pin 14
.equ 	G		= 4			; /CE fuer 74HC244
.equ 	WE		= 5			; /WE fuer SRAM
.equ 	OE		= 6			; /OE fuer SRAM
.equ 	RAMPAGE		= 7			;  RAMPAGE fuer SRAM


; ****************************************************************************************
; **** VIDEO RENDERING INTERRUPT / R2=SOUND FREQUENCY / RETURNS R25=MEMREADY
; ****************************************************************************************
VIDEO:


; bei 21,504 MHz
; HSP =  3800 nS / 46,5 nS =  81
; HBP =  1540 nS / 46,5 nS =  33
; HPX = 25600 nS / 46,5 nS = 550
; HFP =   640 nS / 46,5 nS =  14

; (3)

; EQUALIZE INTERRUPT LATENCY
; Angleichen der Interrupt Verborgenheit

	lds		R16,tcnt1l                    	;2
	cpi		R16,10	                       	;1
	brlo            LATFIX1	                      	;1/2

LATFIX1:
	cpi		R16,11	                	;1
	brlo           	LATFIX2		        	;1/2

LATFIX2:
	cpi		R16,12	                	;1
	brlo           	LATFIX3		                ;1/2

LATFIX3:
	cpi		R16,13	                	;1
	brlo	        LATFIX4		        	;1/2

LATFIX4:


; HORIZONTAL SYNC LOW
	cbi		port_control, HOR       	;2


; ---------------------------------------------
;  HSP - HBP - HPX   -    HFP
;   76   31   512         12
;__     ____xxxxxxxxxxxx_____
; |     |
; -------
; 1     2   3           4   5
; |
; ---------------------------------------------
; ab hier 76 Zyklen HSP

; (0)

; PUSH REGISTERS TO STACK
	push     	zl				;2
	push           	zh				;2

        lds		memready, Schalter_MemReady     ;2
        lds		VER_ADR, Speicher_VER_ADR       ;2


; (8)

; SET POINTER TO VLINE TABLE
	ldi		zl,low(2*VLINE)	              	;1
	ldi		zh,high(2*VLINE)        	;1



; SET VLINE TABLE POSITION
	add		zl,yl				;1
	adc		zh,yh				;1


; READ VLINE TABLE BYTE
	lpm		R16,z		                ;3


; (15)


; INCREMENT VERTICAL ADDRESS
	sbrs         	R16,VL_INC_VA	        	;1/2
	inc		VER_ADR				;1


; RESET VERTICAL ADDRESS
	sbrc     	R16,VL_RESET			;1/2	; ueberspringen von ser, wenn
	ser		VER_ADR				;1		; Bit0=0 in R16


; INCREMENT VLINE COUNTER
	adiw      	yh:yl,1				;1


; (20)


; RESET VLINE COUNTER
	sbrc         	R16,VL_RESET			;1/2
	clr		yl				;1
	sbrc            R16,VL_RESET			;1/2
	clr		yh				;1


; (24)


; VERTICAL SYNC CONTROL
	sbrc    	R16,VL_VER_IMP	                ;1/2
	cbi		port_control,VER		;2
	sbrs           	R16,VL_VER_IMP	                ;1/2
	sbi		port_control,VER		;2

; (29)


; SET MEMREADY FLAG
	sbrc       	R16,VL_MEMREADY	               	;1/2
	clr		memready			;1
	sbrs            R16,VL_MEMREADY	                ;1/2
	ser		memready			;1


; (33)


; HORIZONTAL SYNC HIGH
	sbi		port_control,HOR		;2


; (35)


; ---------------------------------------------
;  HSP - HBP - HPX   -    HFP
;   76   31   512         12
;__     ____xxxxxxxxxxxx_____
; |     |
; -------
; 1     2   3           4   5
;       |
; ---------------------------------------------
; ab hier 31 Zyklen HBP


; (0)



; ****************************************************************************************
; **** HORIZONTAL BACK PORCH = 36 CYCLES
; ****************************************************************************************

; SET VERTICAL ADDRESS
	sbrc          	R16,VL_OUT_VA	            	;1/2
	out		port_adr_hig,VER_ADR            ;1

; CONTROL ACTIVE LINES
	sbrs     	R16,VL_OUT_VA                   ;1/2
	rjmp            NOVID	                        ;2

; (5)

; SET SRAM TO IDLE
	sbi		port_control,WE			;2
	sbi		port_control,OE			;2

; RELEASE DATA BUS
	clr		R16				;1
	out		ddr_dat,R16			;1

; (11)

; SET SRAM TO READ
	cbi		port_control,OE			;2

; (13)


; ****************************************************************************************
; **** HORIZONTAL ACTIVE LINE = 512 CYCLES
; ****************************************************************************************

	; SET TO FRONT BUFFER
	in		R16,port_control		;1
	sbrc            R16,RAMPAGE			;1/2
	cbi		port_control,RAMPAGE            ;2
	sbrs            R16,RAMPAGE			;1/2
	sbi		port_control,RAMPAGE            ;2

; (19)

	; RESET HORIZONTAL ADDRESS
	clr		R16				;1
	out		port_adr_low,R16		;1

; (21)

	; TURN ON VIDEO DAC
	cbi		port_control,G			;2



; (23)


; ---------------------------------------------
;  HSP - HBP - HPX   -    HFP
;   76   31   512         12
;__     ____xxxxxxxxxxxx_____
; |     |
; -------
; 1     2   3           4   5
;           |
; ---------------------------------------------
; ab hier 512 Zyklen HPX


	; PIXEL 1-10
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1


	; PIXEL 11-20
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 21-30
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 31-40
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 41-50
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 51-60
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 61-70
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 71-80
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 81-90
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 91-100
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 101-110
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 111-120
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 121-130
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 131-140
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 141-150
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1


	; PIXEL 151-160
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 161-170
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 171-180
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 181-190
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 191-200
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1


	; PIXEL 201-210
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 211-220
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1



	; PIXEL 221-230
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1


	; PIXEL 231-240
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1


	; PIXEL 241-250
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1


	; PIXEL 251-256
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1
	inc		R16				;1
	out		port_adr_low,R16	;1


; 256*2=512


; (0)

; TURN OFF VIDEO DAC
	sbi		port_control,G	        	;2


; (2)

; SET TO BACK BUFFER
	in		R16,port_control		;1
	sbrc            R16,RAMPAGE			;1/2
	cbi		port_control,RAMPAGE            ;2
	sbrs            R16,RAMPAGE			;1/2
	sbi		port_control,RAMPAGE            ;2

; (8)


; SET SRAM TO IDLE
	sbi		port_control,OE			;2


; ENABLE DATA BUS
	ser		R16				;1
	out		ddr_dat,R16			;1

; (12)



; ****************************************************************************************
; **** HORIZONTAL FRONT PORCH = 12 CYCLES
; ****************************************************************************************



; BLANKING LINES EXIT POINT
NOVID:

        sts		Schalter_MemReady,memready      ;2
        sts		Speicher_VER_ADR, VER_ADR       ;2


; POP REGISTERS FROM STACK
	pop		zh		                ;2
	pop		zl		                ;2


; (20)

; ---------------------------------------------
;  HSP - HBP - HPX   -    HFP
;   76   31   512         12
;__     ____xxxxxxxxxxxx_____
; |     |
; -------
; 1     2   3           4   5
; |
; ---------------------------------------------


;19+ 47 + 42 +  512  +    35 = 655

; bei 22 MHz (45,45 ns) = 30 us (max. 31,75 us)


 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Word-Parameter(1) fuer PROCEDURE (INIT_TIMER1_COMPA)
        LDI        R16, LOW(0x02BA)
        MOV        R0, R16
        LDI        R17, HIGH(0x02BA)
        MOV        R1, R17
 
; Aufruf PROCEDURE (INIT_TIMER1_COMPA)
        CALL       INIT_TIMER1_COMPA
 
; Interrupt erlauben
        SEI
 
; LOOP - Start_Marke
M_LOOP_01:
 
; LOOP - Ende
        RJMP       M_LOOP_01
 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; UBRR0 (V) WORDCONVAR
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; OCR0 (V) WORDCONVAR
; OCR2 (V) WORDCONVAR
; TCCR0 (V) WORDCONVAR
; TCNT1 (V) WORDCONVAR
; OCR1A (V) WORDCONVAR
; OCR1B (V) WORDCONVAR
; ICR1 (V) WORDCONVAR
; EEAR (V) WORDCONVAR
; ADC (V) WORDCONVAR
; INIT_TIMER1_COMPA (P) 
; CTC_WERT (C) WORD Wert=0x02BA
; VL_RESET (C) BYTE Wert=0x00
; VL_VER_IMP (C) BYTE Wert=0x01
; VL_OUT_VA (C) BYTE Wert=0x02
; VL_INC_VA (C) BYTE Wert=0x03
; VL_MEMREADY (C) BYTE Wert=0x04
; LAENGE_VLINE (C) WORD Wert=0x020D
; VLINE (A) 
; SCHALTER_MEMREADY (V) BYTE
; SPEICHER_VER_ADR (V) BYTE
; INITPORTS (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE INIT_TIMER1_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; PROCEDURE INITPORTS;
 
; *** Konstanten-ARRAYs ***
;
 
VLINE:
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x12
.db    0x12,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x10,0x00
.db    0x01,0x00
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=INT0          Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=INT1          Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=INT2addr     ISR=INT2          Bemerkung=External Interrupt Request 1
; Nummer=5    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=6    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=7    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=8    ORG=PCI3addr     ISR=PCINT3        Bemerkung=Pin Change Interrupt Request 3
; Nummer=9    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=10   ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=11   ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=12   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=13   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=14   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=15   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=16   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=17   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=18   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=19   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=20   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=21   ORG=URXCaddr     ISR=USART0_RXC    Bemerkung=USART0, Rx Complete
; Nummer=22   ORG=UDREaddr     ISR=USART0_UDRE   Bemerkung=USART0 Data Register Empty
; Nummer=23   ORG=UTXCaddr     ISR=USART0_TXC    Bemerkung=USART0, Tx Complete
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=26   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=27   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=28   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
