

// *****************
// Timer / Counter 1
// *****************




procedure Init_TIMER1_COMPA(Wert : Word);
VAR
  B_wert_L : Byte;
  B_Wert_H : Byte;
begin
{
 CTC Modus (Clear Timer on Compare Match mode)
 ---------------------------------------------

 genutzt wird der 16-Bit Timer1

 TCCR1B = Timer/Counter control Register B des Timers1
 | ICNC1 | ICES1 | leer | WGM13 | WGM12 | CS12 | CS11 | CS10 |
 CS12  CS11  CS10
   0     0     1  = CPU-Takt ohne Teiler

 WGM12 = // CTC-Modus, TOP = OCR1A
}

  // Timer/Counter Control Register 0
  // Bit 4:3 – WGM13:2: Waveform Generation Mode
  //   0 1 - CTC - OCR1A
//  TCCR1B:=%00001000;    // kein Takt (Timer/Zaehler ist gestoppt)
  TCCR1B:=%00001001;    // kein Vorteiler
//  TCCR1B:=%00001010;    // Vorteiler = Takt/8
//  TCCR1B:=%00001011;    // Vorteiler = Takt/64
//  TCCR1B:=%00001100;    // Vorteiler = Takt/256
//  TCCR1B:=%00001101;    // Vorteiler = Takt/1024
//  TCCR1B:=%00001110;    // Externe Taktquelle an T0 Pin. Takt an der fallenden Flanke
//  TCCR1B:=%00001111;    // Externe Taktquelle an T0 Pin. Takt an der steigenden Flanke

{
; Einstellen der Interrupt-Zeit
}
  B_Wert_H:=High(Wert);
  B_Wert_L:=Low(Wert);

  // Achtung!!! Das High-Register muss vor dem Low-Register
  //            beschrieben werden
  OCR1AH:=B_Wert_H;
  OCR1AL:=B_Wert_L;

{
; TIMSK
; |  -  |  -  | ICIE1 |  -  |  -  | OCIE1B | OCIE1A | TOIE1 |
;
; ICIE1  - Timer 1 Input Capture Interrupt Enable
; OCIE1B - Timer 1 Output Compare B Match Interrupt Enable
; OCIE1A - Timer 1 Output Compare A Match Interrupt Enable
; TOIE1  - Timer 1 Overflow Interrupt Enable
;
; OCIE1A - Timer/Counter 1 Vergleichszahl A Interrupt
           Int bei Erreichen Stand in A
;
}

  TIMSK1:=%00000010;

end Init_TIMER1_COMPA;







