PROGRAM GCON2;

// Version 1.10 vom 24.02.2015


DEVICE = mega1284P;

{$I mega1284_Register.INC}



CONST

  // bei 22,1184 MHz ->
  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 22118;


  // bei 22,118 MHz ->
  UBRR_VAL : Byte = 1;


  XON  : Byte = $11;
  XOFF : Byte = $13;



  // Festwerte fuer Farben
  cl_White    : Byte = $FF; // %11111111
  cl_Black    : Byte = $00; // %00000000
  cl_Red      : Byte = $43; // %11000011
  cl_Green    : Byte = $4C; // %11001100
  cl_Blue     : Byte = $B0; // %11110000
  cl_Yellow   : Byte = $4F; // %11001100
  cl_Purple   : Byte = $73; // %11001100
  cl_Aqua     : Byte = $7C; // %11001100
  cl_Gray     : Byte = $6A; // %01101010
  cl_DarkGray : Byte = $2A; // %00101010



  // TerminalMode
  Normal_TM            : Byte = 0;
  IBM_ESC_TM           : Byte = 1;
  IBM_CSI_TM           : Byte = 2;
  IBM_CSI_TM_Par_1     : Byte = 3;
  IBM_CSI_TM_Par_2     : Byte = 4;
  IBM_CSI_TM_Par_3     : Byte = 5;
  IBM_GRAFIK_Par_1_TM  : Byte = 6;
  IBM_GRAFIK_Par_2_TM  : Byte = 7;


  // Werte fuer Font_Bez
  fnt_6x8   : Byte = 1;
  fnt_8x8   : Byte = 2;
  fnt_8x12  : Byte = 3;
  fnt_10x16 : Byte = 4;
  fnt_12x20 : Byte = 5;



// Font fuer 6x8 Zeichen
{$I font6x8.INC}

// Font fuer 8x8 Zeichen
{$I font8x8.INC}

// Font fuer 8x12 Zeichen
{$I font8x12.INC}

// Font fuer 10x16 Zeichen
{$I font10x16.INC}

// Font fuer 12x20 Zeichen
{$I font12x20.INC}


// Bild 75x60
{$I STRUGN.INC}

// Bild 75x60
{$I STRURT.INC}

// Kreis 20x20
//{$I KREIS.INC}


// Sinus-Tabelle
{$I SinTab.INC}



VAR
  // Globale Variablen

// /VS1_GS2 = 1 (D7), /OE = 1 (D6), /WE = 1 (D5)
// A18 = 1 (D4), A17/LED_GE = 1 (D3), A16 = 1 (D2)
// TX0 = 1 (D1),RX0 = 0 (D0)

  A16[PortD, 2]     : bit; // A
  A17[PortD, 3]     : bit; // A
  A18[PortD, 4]     : bit; // A

  WE[PortD, 5]      : bit; // A
  OE[PortD, 6]      : bit; // A

  VS1_GS2[PortD, 7] : bit; // A


  Zeichenbreite, Zeichenhoehe,
  X_ANF, Y_ANF,
  X_PIX_POS, Y_PIX_POS,
  X_KUR_POS, Y_KUR_POS,
  X_END_POS, Y_END_POS,
  delta_x, delta_y : Word;

  Kursor_Schleife,
  ZeichenbreiteDW : DWord;

  Zeichenbreite0, Zeichenhoehe0 : Byte;

  Steuer_String : String[20];

  FCOLOR, BCOLOR, PIXCOLOR : Byte;

  Seite1_aktiv, KopieBWS : Boolean;


  // Variablen zum Font
  max_Spalten, max_Zeilen : Word;
  Font_Bez : Byte;

  TermMode : Byte;

  CSI_Parameter1, CSI_Parameter2,
  CSI_Parameter3 : Word;

  Escape_Sequenz : String[10];

  // Kursor-Variablen
  Kursor_sichtbar, Kursor_Ein,
  KurArr_Aktuell : Boolean;

  Kursor_Array : Array [0..239] of Byte;  // Breite*Hoehe = 12x20=240
  CHAR_Array   : Array [0..239] of Byte;

  // Variablen zum Bild
  BILD_Adresse : Adress;



// System (WaitMS)
{$I SYSTEM.INC}

{$I mega1284_UART_oI.INC}



{
        338 mmm
       XXXXXXXXXX
 480   XXXXXXXXXX  272 mm
 Pixel XXXXXXXXXX
       XXXXXXXXXX
       600 Pixel

  480x600 ist ideal

}








procedure InitPorts;
begin
{
Grafik-Controller-2 (GCON2) (ATmega1284P-PU)
===================

D0..D7 = 8 (A0..A7)
A0..A16 = 17 (B0..B7, C0..C7, D2..D4)

RX = 0 (D0)
TX = 0 (D1)

/WE = 1 (D5)
/OE = 1 (D6)

/VS1_GS2 = 1 (D7)
(0 = Counter (V) auf S1, Controller (G) auf S2)
(1 = Counter (V) auf S2, Controller (G) auf S1)

}

  DDRA:=  %00000000;
  PORTA:= %00000000;

  DDRB:=  %11111111;
  PORTB:= %00000000;

  DDRC:=  %11111111;
  PORTC:= %00000000;

// /VS1_GS2 = 1 (D7), /OE = 1 (D6), /WE = 1 (D5)
// A18 = 1 (D4), A17/LED_GE = 1 (D3), A16 = 1 (D2)
// TX0 = 1 (D1),RX0 = 0 (D0)
  DDRD:=  %11111110;

// /VS1_GS2 = 0 (D7), /OE = 1 (D6), /WE = 1 (D5)
// A18 = 0 (D4), A17/LED_GE = 0 (D3), A16 = 0 (D2)
// TX0 = 0 (D1),RX0 = 0 (D0)
  PORTD:= %01100000;

end InitPorts;








// *** Basis-Programme ***



PROCEDURE setze_Font(FontGroesse : Byte);
BEGIN
  Font_Bez:=FontGroesse;

  CASE Font_Bez OF

    fnt_6x8 : Zeichenbreite := 6;
              Zeichenbreite0 := 5;
              Zeichenhoehe  := 10; // 8 + 2 = 10
              Zeichenhoehe0 := 7;

              X_ANF := 2;
              Y_ANF := 6;


              max_Spalten := 98;  // 0..99 = 100
              max_Zeilen := 46;   // 0..46 = 47

    |

    fnt_8x8 : Zeichenbreite := 8;
              Zeichenbreite0 := 7;
              Zeichenhoehe  := 10; // 8 + 2 = 10
              Zeichenhoehe0 := 7;

              X_ANF := 4;
              Y_ANF := 6;

              max_Spalten := 73;  // 0..73 = 74
              max_Zeilen := 46;  // 0..46 = 47

    |

    fnt_8x12 : Zeichenbreite := 8;
               Zeichenbreite0 := 7;
               Zeichenhoehe  := 15; // 12 + 3 = 20
               Zeichenhoehe0 := 11;

               X_ANF := 4;
               Y_ANF := 1;

               max_Spalten := 73;  // 0..73 = 74
               max_Zeilen := 31;  // 0..31 = 32

    |

    fnt_10x16 : Zeichenbreite := 10;
                Zeichenbreite0 := 9;
                Zeichenhoehe  := 18; // 16 + 2 = 18
                Zeichenhoehe0 := 15;

                X_ANF := 5;
                Y_ANF := 8;

                max_Spalten := 58;  // 0..58 = 59
                max_Zeilen := 25;  // 0..25 = 26

    |

    fnt_12x20 : Zeichenbreite := 12;
                Zeichenbreite0 := 11;
                Zeichenhoehe  := 22; // 20 + 2 = 22
                Zeichenhoehe0 := 19; // 0..19 = 20

                X_ANF := 6;
                Y_ANF := 10;

                max_Spalten := 48;  // 0..48 = 49
                max_Zeilen := 20;  // 0..20 = 21

    |

    ENDCASE;

    ZeichenbreiteDW := WordToDword(Zeichenbreite);


END setze_Font;





procedure clear_RAM(HG_Farbe : Byte);
begin

{$I ClearRAM.inc}

end clear_RAM;






procedure Umschalten_Speicherseite;
begin

  if Seite1_aktiv then
    ClearBit(VS1_GS2);
    Seite1_aktiv:=false;
  else
    SetBit(VS1_GS2);
    Seite1_aktiv:=true;
  endif;

end Umschalten_Speicherseite;





procedure Reset_Form;
begin

  FCOLOR:= cl_Black;
  BCOLOR:= cl_White;

  clear_RAM(BCOLOR);
  Umschalten_Speicherseite;
  clear_RAM(BCOLOR);
  Umschalten_Speicherseite;

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

  X_PIX_POS:= X_ANF;
  Y_PIX_POS:= Y_ANF;

end Reset_Form;







// *********************************
// ***      Grafik-Routinen      ***
// *********************************



// Berechnung der Adresse (1.Pixel)
function Anfangsadresse : DWord;
var
  A2 : DWord;
  Adresse : DWord;
begin
  // Berechnung der Adresse (1.Pixel)
  A2:=WordToDWord(Y_PIX_POS);
  Adresse:=A2*1024;
  A2:=WordToDWord(X_PIX_POS);
  Adresse:=Adresse+A2;
  Result:=Adresse;

end Anfangsadresse;





procedure Init_BILD_Adresse;
begin
  BILD_Adresse:=ArrToAdress(STRUGN);
end Init_BILD_Adresse;




var
  Offset : DWord;
  Offset_Word : Word;


// schreibt ein Bild an die Position: X_PIX_POS / Y_PIX_POS
// ohne Transparenz
procedure schreibe_IMAGE_oT;
VAR
  x1: Byte;
  x2 : Byte;
  x_bis : Byte;
  y_bis : Byte;
  B_Wert : Byte;
  Adresse : DWord;
  B_Pointer : Word;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;

begin

  SetBit(WE);
  SetBit(OE);

  Adresse:=Anfangsadresse;
  B_Pointer:=0;

  // Laden und Berechnen der Bild-Breite
  x_bis:=ReadAdrArray(BILD_Adresse,B_Pointer);
  Inc(B_Pointer);

  Offset_Word:=ByteToWord(x_bis);
  Offset:=WordToDWord(Offset_Word);
  Offset:=1024-Offset;

  Dec(x_bis);

  // Laden und Berechnen der Bild-Hoehe
  y_bis:=ReadAdrArray(BILD_Adresse,B_Pointer);
  Inc(B_Pointer);
  Dec(y_bis);


  // Kopieren des Bildes
  for x2:=0 to y_bis do


    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
      SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;


    for x1:=0 to x_bis do

      B_Wert:=ReadAdrArray(BILD_Adresse,B_Pointer);

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      DDRA:= %11111111;

      PortA:= B_Wert;

      NOP;
      NOP;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;

      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      DDRA:= %00000000;

      Inc(Adresse);
      Inc(B_Pointer);

    endfor; { for x1:=0 to x_bis do }

    Adresse:=Adresse+Offset;

  endfor; { for x2:=0 to y_bis do }


  // Grundeinstellungen
  SetBit(WE);
  ClearBit(A16);
  ClearBit(A17);
  ClearBit(A18);

end schreibe_IMAGE_oT;





// schreibt ein Bild an die Position: X_PIX_POS / Y_PIX_POS
// mit Transparenz
procedure schreibe_IMAGE_mT;
VAR
  x1: Byte;
  x2 : Byte;
  x_bis : Byte;
  y_bis : Byte;
  B_Wert : Byte;
  Adresse : DWord;
  B_Pointer : Word;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;

begin

  SetBit(WE);
  SetBit(OE);

  Adresse:=Anfangsadresse;
  B_Pointer:=0;

  // Laden und Berechnen der Bild-Breite
  x_bis:=ReadAdrArray(BILD_Adresse,B_Pointer);
  Inc(B_Pointer);

  Offset_Word:=ByteToWord(x1);
  Offset:=WordToDWord(Offset_Word);
  Offset:=1024-Offset;

  Dec(x_bis);

  // Laden und Berechnen der Bild-Hoehe
  y_bis:=ReadAdrArray(BILD_Adresse,B_Pointer);
  Inc(B_Pointer);
  Dec(y_bis);

  // Kopieren des Bildes
  for x2:=0 to y_bis do

    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
      SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;

    for x1:=0 to x_bis do

      B_Wert:=ReadAdrArray(BILD_Adresse,B_Pointer);

      // der Farbwert FFH (Weiss) ist der Wert fuer die Transparenzfarbe
      if B_Wert<$FF then

        PORTB:= DWordToByte(0,Adresse);
        PORTC:= DWordToByte(1,Adresse);

        DDRA:= %11111111;

        PortA:= B_Wert;

        NOP;
        NOP;

        ClearBit(WE);

        NOP;
        NOP;
        NOP;
        NOP;

        NOP;
        NOP;
        NOP;
        NOP;

        SetBit(WE);

        DDRA:= %00000000;

        Inc(Adresse);
        Inc(B_Pointer);

      else

        Inc(Adresse);
        Inc(B_Pointer);

      endif;

    endfor; { for x1:=0 to x_bis do }

    Adresse:=Adresse+Offset;

  endfor; { for x2:=0 to y_bis do }

  // Grundeinstellungen
  SetBit(WE);
  ClearBit(A16);
  ClearBit(A17);
  ClearBit(A18);

end schreibe_IMAGE_mT;




// schreibt ein Image mit der Laenge 75x60 auf die gesammte Flaeche
// einer RAM-Page
procedure schreibe_Hintergrund_on_RAMPAGE;
var
  b1 : Byte;
  b2 : Byte;
begin

  Y_PIX_POS:= 0;

  for b2:=1 to 8 do

    X_PIX_POS:= 0;

    for b1:=1 to 8 do

      schreibe_IMAGE_oT;
      X_PIX_POS:= X_PIX_POS + 75;

    endfor;

    Y_PIX_POS:= Y_PIX_POS + 60;

  endfor;

end schreibe_Hintergrund_on_RAMPAGE;






//
procedure schreibe_Hintergrund;
var

begin

  Kursor_Ein:=false;

  schreibe_Hintergrund_on_RAMPAGE;

  if KopieBWS then

    Umschalten_Speicherseite;
    schreibe_Hintergrund_on_RAMPAGE;
    Umschalten_Speicherseite;

  endif; { if KopieBWS then }

end schreibe_Hintergrund;








// schreibt einen Punkt an die Stelle: X_PIX_POS und Y_PIX_POS
procedure Grafik_setze_Punkt_on_RAMPAGE;
VAR
  Adresse : DWord;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;

begin

  // Berechnung der Adresse fuer den Punkt
  Adresse:=Anfangsadresse;

  ADR_HIGH:= DWordToByte(2,Adresse);

  ADR_BIT:=ADR_HIGH and %00000001;
  if ADR_BIT=0 then
    ClearBit(A16);
  else
    SetBit(A16);
  endif;

  ADR_BIT:=ADR_HIGH and %00000010;
  if ADR_BIT=0 then
    ClearBit(A17);
  else
    SetBit(A17);
  endif;

  ADR_BIT:=ADR_HIGH and %00000100;
  if ADR_BIT=0 then
    ClearBit(A18);
  else
    SetBit(A18);
  endif;

  PORTB:= DWordToByte(0,Adresse);
  PORTC:= DWordToByte(1,Adresse);

  DDRA:= %11111111;
  PortA:=PIXCOLOR;

  NOP;
  NOP;

  ClearBit(WE);

  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;

  SetBit(WE);

  DDRA:= %00000000;

end Grafik_setze_Punkt_on_RAMPAGE;





procedure Grafik_setze_Punkt;
begin

  Grafik_setze_Punkt_on_RAMPAGE;
  if KopieBWS then
    Umschalten_Speicherseite;
    Grafik_setze_Punkt_on_RAMPAGE;
    Umschalten_Speicherseite;
  endif;

end Grafik_setze_Punkt;








// zeichnet eine Linie zwischen den Punkten:
// P1(X_PIX_POS,Y_PIX_POS) und P2(X_END_POS,Y_END_POS)
// auf die aktuelle RAM-Page
procedure Grafik_zeichne_Linie_on_RAMPAGE;
var
  x1 : Word;
  xp_anf : Word;
  xp_end : Word;
  y1 : Word;
  yp_anf : Word;
  yp_end : Word;

begin

  // da ohne Vorzeichen gearbeitet wird muss
  // als Erstes festgestellt werden, welcher
  // X-Wert groesser ist ...
  if X_PIX_POS<X_END_POS then
    delta_x:=X_END_POS-X_PIX_POS;
    xp_anf:=X_PIX_POS;
    xp_end:=X_END_POS;
  else
    delta_x:=X_PIX_POS-X_END_POS;
    xp_anf:=X_END_POS;
    xp_end:=X_PIX_POS;
  endif;

  // ... und welcher Y-Wert groesser ist
  if Y_PIX_POS<Y_END_POS then
    delta_y:=Y_END_POS-Y_PIX_POS;
    yp_anf:=Y_PIX_POS;
    yp_end:=Y_END_POS;
  else
    delta_y:=Y_PIX_POS-Y_END_POS;
    yp_anf:=Y_END_POS;
    yp_end:=Y_PIX_POS;
  endif;

  // die Schleife laeuft am Besten entlang der
  // laengeren Seite
  if delta_x>delta_y then

    // Ausnahmebehandlung: Y_PIX_POS=Y_END_POS (waagerechter Strich)
    if delta_y=0 then
      // Durchlaufen aller X-Werte
      for x1:=xp_anf to xp_end do
        X_PIX_POS:=x1;
        Grafik_setze_Punkt_on_RAMPAGE;
      endfor;
    else

      if delta_y>127 then
        SHR(delta_x);
        SHR(delta_y);
      endif;

      if delta_x>0 then

         // Durchlaufen aller x-Werte
        for x1:=xp_anf to xp_end do

          // aktueller x-Wert mal Anstiegsfaktor ergibt den
          // aktuellen y-Wert
          y1:=x1*delta_y;
          y1:=y1 DIV delta_x;
          y1:=y_anf+y1;

          X_PIX_POS:=x1;
          Y_PIX_POS:=y1;
          Grafik_setze_Punkt_on_RAMPAGE;

        endfor;

      endif; { if delta_x>0 then }

    endif; { if delta_y=0 then }
  else

    // Ausnahmebehandlung: X_PIX_POS=X_END_POS (senkrechter Strich)
    if delta_x=0 then

      // Durchlaufen aller y-Werte
      for y1:=yp_anf to yp_end do
        Y_PIX_POS:=y1;
        Grafik_setze_Punkt_on_RAMPAGE;
       endfor;

    else

      if delta_x>127 then
        SHR(delta_x);
        SHR(delta_y);
      endif;

      if delta_y>0 then

        // Durchlaufen aller y-Werte
        for y1:=yp_anf to yp_end do

          // aktueller y-Wert mal Anstiegsfaktor ergibt den
          // aktuellen x-Wert
          x1:=y1*delta_x;
          x1:=x1 DIV delta_y;
          x1:=x_anf+x1;

          X_PIX_POS:=x1;
          Y_PIX_POS:=y1;
          Grafik_setze_Punkt_on_RAMPAGE;
        endfor;

      endif; { if delta_y>0 then }

    endif; { if delta_x=0 then }

  endif; { if delta_x>delta_y then }

end Grafik_zeichne_Linie_on_RAMPAGE;





procedure Grafik_zeichne_Linie;
var
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;
  X_END_POS2 : Word;
  Y_END_POS2 : Word;
begin

  X_PIX_POS2:=X_PIX_POS;
  Y_PIX_POS2:=Y_PIX_POS;
  X_END_POS2:=X_END_POS;
  Y_END_POS2:=Y_END_POS;

  Grafik_zeichne_Linie_on_RAMPAGE;
  if KopieBWS then
    Umschalten_Speicherseite;
    X_PIX_POS:=X_PIX_POS2;
    Y_PIX_POS:=Y_PIX_POS2;
    Grafik_zeichne_Linie_on_RAMPAGE;
    Umschalten_Speicherseite;
  endif;

  X_PIX_POS:=X_END_POS2;
  Y_PIX_POS:=Y_END_POS2;

end Grafik_zeichne_Linie;






procedure Grafik_zeichne_Rechteck_on_RAMPAGE;
var
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;
  w1 : Word;
begin

  X_PIX_POS2:=X_PIX_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  for w1:=X_PIX_POS2 to X_END_POS do
    X_PIX_POS:=w1;
    Grafik_setze_Punkt_on_RAMPAGE;
  endfor;

  for w1:=Y_PIX_POS2 to Y_END_POS do
    Y_PIX_POS:=w1;
    Grafik_setze_Punkt_on_RAMPAGE;
  endfor;

  X_PIX_POS:=X_PIX_POS2;
  Y_PIX_POS:=Y_PIX_POS2;

  for w1:=Y_PIX_POS2 to Y_END_POS do
    Y_PIX_POS:=w1;
    Grafik_setze_Punkt_on_RAMPAGE;
  endfor;

  for w1:=X_PIX_POS2 to X_END_POS do
    X_PIX_POS:=w1;
    Grafik_setze_Punkt_on_RAMPAGE;
  endfor;

end Grafik_zeichne_Rechteck_on_RAMPAGE;




procedure Grafik_zeichne_Rechteck;
var
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;
begin

  X_PIX_POS2:=X_PIX_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  Grafik_zeichne_Rechteck_on_RAMPAGE;
  if KopieBWS then
    Umschalten_Speicherseite;
    X_PIX_POS:=X_PIX_POS2;
    Y_PIX_POS:=Y_PIX_POS2;
    Grafik_zeichne_Rechteck_on_RAMPAGE;
    Umschalten_Speicherseite;
  endif;

  X_END_POS:=X_PIX_POS2;
  Y_END_POS:=Y_PIX_POS2;

end Grafik_zeichne_Rechteck;








procedure Grafik_zeichne_volles_Rechteck_on_RAMPAGE;
VAR
  Adresse : DWord;
  w1 : Word;
  w2 : Word;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;
begin

  DDRA:=  %11111111;
  SetBit(WE);
  PortA:=PIXCOLOR;

  for w2:=Y_PIX_POS to Y_END_POS do

    // Berechnung der Adresse fuer den Punkt
    Y_PIX_POS:=w2;
    Adresse:=Anfangsadresse;

    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
      SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;

    // waagerechter Strich
    for w1:=X_PIX_POS to X_END_POS do

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      NOP;
      NOP;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      INC(Adresse);

    endfor;

  endfor;

  DDRA:= %00000000;

  SetBit(OE);

end Grafik_zeichne_volles_Rechteck_on_RAMPAGE;





procedure Grafik_zeichne_volles_Rechteck;
var
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;
  X_END_POS2 : Word;
  Y_END_POS2 : Word;
begin

  X_PIX_POS2:=X_PIX_POS;
  Y_PIX_POS2:=Y_PIX_POS;
  X_END_POS2:=X_END_POS;
  Y_END_POS2:=Y_END_POS;

  Grafik_zeichne_volles_Rechteck_on_RAMPAGE;

  if KopieBWS then
    Umschalten_Speicherseite;
    X_PIX_POS:=X_PIX_POS2;
    Y_PIX_POS:=Y_PIX_POS2;
    Grafik_zeichne_volles_Rechteck_on_RAMPAGE;
    Umschalten_Speicherseite;
  endif;

  X_PIX_POS:=X_END_POS2;
  Y_PIX_POS:=Y_END_POS2;

end Grafik_zeichne_volles_Rechteck;












function Sinus(Winkel, Radius : Word) : Word;
var
  w1 : Word;
  Sin_dw1 : DWord;
  Sin_dw2 : DWord;

begin

  w1:=SinTab[Winkel];
  Sin_dw1:=WordTODWord(w1);
  Sin_dw2:=WordTODWord(Radius);
  Sin_dw1:=Sin_dw1*Sin_dw2;
  Sin_dw1:=Sin_dw1 DIV $FFFF;
  w1:=DWLow(Sin_dw1);

  Result:=w1;
end Sinus;






procedure Grafik_zeichne_Kreis_on_Rampage(Radius : Word);
var
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;
  Winkel : Word;
begin

  X_PIX_POS2:=X_PIX_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  // Kreissegment 0..89 Grad
  for Winkel:=0 to 199 do

    // Delta Radius fuer x1
    X_PIX_POS:=Sinus(Winkel,Radius);

    // x1 fuer Kreis-Punkt
    X_PIX_POS:=X_PIX_POS2+X_PIX_POS;

    // Delta Radius fuer y1
    Y_PIX_POS:=200-Winkel;
    Y_PIX_POS:=Sinus(Y_PIX_POS,Radius);

    // y1 fuer Kreis-Punkt
    Y_PIX_POS:=Y_PIX_POS2-Y_PIX_POS;

    Grafik_setze_Punkt_on_RAMPAGE;

  endfor;

  // Kreissegment 90..179 Grad
  for Winkel:=0 to 199 do

    // Delta Radius fuer x1
    X_PIX_POS:=200-Winkel;
    X_PIX_POS:=Sinus(X_PIX_POS,Radius);

    // x1 fuer Kreis-Punkt
    X_PIX_POS:=X_PIX_POS2+X_PIX_POS;

    // Delta Radius fuer y1
    Y_PIX_POS:=Sinus(Winkel,Radius);

    // y1 fuer Kreis-Punkt
    Y_PIX_POS:=Y_PIX_POS2+Y_PIX_POS;

    Grafik_setze_Punkt_on_RAMPAGE;

  endfor;

  // Kreissegment 180..269 Grad
  for Winkel:=0 to 199 do

    // Delta Radius fuer x1
    X_PIX_POS:=Sinus(Winkel,Radius);

    // x1 fuer Kreis-Punkt
    X_PIX_POS:=X_PIX_POS2-X_PIX_POS;

    // Delta Radius fuer y1
    Y_PIX_POS:=200-Winkel;
    Y_PIX_POS:=Sinus(Y_PIX_POS,Radius);

    // y1 fuer Kreis-Punkt
    Y_PIX_POS:=Y_PIX_POS2+Y_PIX_POS;

    Grafik_setze_Punkt_on_RAMPAGE;

  endfor;

  // Kreissegment 270..359 Grad
  for Winkel:=0 to 199 do

    // Delta Radius fuer x1
    X_PIX_POS:=200-Winkel;
    X_PIX_POS:=Sinus(X_PIX_POS,Radius);

    // x1 fuer Kreis-Punkt
    X_PIX_POS:=X_PIX_POS2-X_PIX_POS;

    // Delta Radius fuer y1
    Y_PIX_POS:=Sinus(Winkel,Radius);

    // y1 fuer Kreis-Punkt
    Y_PIX_POS:=Y_PIX_POS2-Y_PIX_POS;

    Grafik_setze_Punkt_on_RAMPAGE;

  endfor;

  X_PIX_POS:=X_PIX_POS2;
  Y_PIX_POS:=Y_PIX_POS2;

end Grafik_zeichne_Kreis_on_Rampage;









procedure Grafik_zeichne_Kreis(Radius : Word);
begin

  Grafik_zeichne_Kreis_on_Rampage(Radius);

  if KopieBWS then
    Umschalten_Speicherseite;
    Grafik_zeichne_Kreis_on_Rampage(Radius);
    Umschalten_Speicherseite;
  endif;

end Grafik_zeichne_Kreis;






// von X_PIX_POS nach X_END_POS
// an der Stelle Y_PIX_POS
procedure Zeichne_waagerechten_Strich;
VAR
  Adresse : DWord;
  w1 : Word;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;
begin

  SetBit(WE);

  // Berechnung der Adresse fuer den Punkt
  Adresse:=Anfangsadresse;

  ADR_HIGH:= DWordToByte(2,Adresse);

  ADR_BIT:=ADR_HIGH and %00000001;
  if ADR_BIT=0 then
    ClearBit(A16);
  else
    SetBit(A16);
  endif;

  ADR_BIT:=ADR_HIGH and %00000010;
  if ADR_BIT=0 then
    ClearBit(A17);
  else
    SetBit(A17);
  endif;

  ADR_BIT:=ADR_HIGH and %00000100;
  if ADR_BIT=0 then
    ClearBit(A18);
  else
    SetBit(A18);
  endif;


  // waagerechter Strich
  for w1:=X_PIX_POS to X_END_POS do

    PORTB:= DWordToByte(0,Adresse);
    PORTC:= DWordToByte(1,Adresse);

    DDRA:= %11111111;
    PortA:=PIXCOLOR;

    NOP;
    NOP;

    ClearBit(WE);

    NOP;
    NOP;
    NOP;
    NOP;
    NOP;
    NOP;

    SetBit(WE);

    DDRA:= %00000000;

    INC(Adresse);

  endfor; // for w1:=X_PIX_POS to X_END_POS do

  DDRA:= %00000000;

end Zeichne_waagerechten_Strich;








procedure Grafik_zeichne_vollen_Kreis_on_Rampage(Radius : Word);
var
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;
  Winkel : Word;
begin

  X_PIX_POS2:=X_PIX_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  // Kreissegment 0..89 Grad
  for Winkel:=0 to 199 do

    // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
    // Delta Radius fuer X-Position
    X_PIX_POS:=Sinus(Winkel,Radius);

   // X_END_POS ist rechte X-Position
    X_END_POS:=X_PIX_POS2+X_PIX_POS;

    // X_PIX_POS ist linke X-Position
    X_PIX_POS:=X_PIX_POS2-X_PIX_POS;

    // YYYYYYYYYYYYYYYYYYYYYYYYYYYYYY
    // Delta Radius fuer y1
    Y_PIX_POS:=200-Winkel;
    Y_PIX_POS:=Sinus(Y_PIX_POS,Radius);

    // y1 fuer Kreis-Punkt
    Y_PIX_POS:=Y_PIX_POS2-Y_PIX_POS;
    Y_END_POS:=Y_PIX_POS;

    Zeichne_waagerechten_Strich;

  endfor;

  // Kreissegment 90..179 Grad
  for Winkel:=0 to 199 do
    // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
    // Delta Radius fuer X-Position
    X_PIX_POS:=200-Winkel;
    X_PIX_POS:=Sinus(X_PIX_POS,Radius);

   // X_END_POS ist rechte X-Position
    X_END_POS:=X_PIX_POS2+X_PIX_POS;

    // X_PIX_POS ist linke X-Position
    X_PIX_POS:=X_PIX_POS2-X_PIX_POS;

    // YYYYYYYYYYYYYYYYYYYYYYYYYYYYYY
    // Delta Radius fuer Y-Position
    Y_PIX_POS:=Sinus(Winkel,Radius);

    // y1 fuer Kreis-Punkt
    Y_PIX_POS:=Y_PIX_POS2+Y_PIX_POS;
    Y_END_POS:=Y_PIX_POS;

    Zeichne_waagerechten_Strich;

  endfor;

  X_PIX_POS:=X_PIX_POS2;
  Y_PIX_POS:=Y_PIX_POS2;

end Grafik_zeichne_vollen_Kreis_on_Rampage;











// Definitionsbereich (x) : 1..57600
// Wertebereich       (y) : 1..240
function Wurzel(Wert_x : Word) : Word;
begin

{$I Wurzel.inc}

  Result:=Wert_x;

end Wurzel;













procedure Grafik_zeichne_vollen_Kreis2_on_Rampage(Radius : Word);
var
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;
  Radius_Zaehler : Word;
  Radius_Quatrat : Word;
begin

  X_PIX_POS2:=X_PIX_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  Radius_Quatrat:=Radius*Radius;


  // Kreissegment oberer Halbkreis
  for Radius_Zaehler:=Radius downto 1 do

    // a2 + b2 = c2
    // a = Radius_Zaehler
    // b = X_PIX_POS
    // c = Radius
    // b = Wurzel(c2 - a2) -> Wurzel(Radius_Quatrat - Radius_Zaehler2)
    // Radius_Zaehler2
    X_PIX_POS:=Radius_Zaehler*Radius_Zaehler;
    // Radius_Quatrat - Radius_Zaehler2
    X_PIX_POS:=Radius_Quatrat-X_PIX_POS;
    // Wurzel(Radius_Quatrat - Radius_Zaehler2)
    X_PIX_POS:=Wurzel(X_PIX_POS);

   // X_END_POS ist rechte X-Position
    X_END_POS:=X_PIX_POS2+X_PIX_POS;

    // X_PIX_POS ist linke X-Position
    X_PIX_POS:=X_PIX_POS2-X_PIX_POS;

    // y1 fuer Kreis-Punkt
    Y_PIX_POS:=Y_PIX_POS2-Radius_Zaehler;

    Zeichne_waagerechten_Strich;

  endfor; { for Radius_Zaehler:=Radius downto 1 do }



  // einmal Waagerechten Strich genau auf der
  // Geraden durch den Mittelpunkt (X_PIX_POS2, Y_PIX_POS2)

  // X_END_POS ist rechte X-Position
  X_END_POS:=X_PIX_POS2+Radius;

  // X_PIX_POS ist linke X-Position
  X_PIX_POS:=X_PIX_POS2-Radius;

  // y1 fuer Kreis-Punkt
  Y_PIX_POS:=Y_PIX_POS2;

  Zeichne_waagerechten_Strich;



  // Kreissegment unterer Halbkreis
  for Radius_Zaehler:=1 to Radius do

    // a2 + b2 = c2
    // a = Radius_Zaehler
    // b = X_PIX_POS
    // c = Radius
    // b = Wurzel(c2 - a2) -> Wurzel(Radius_Quatrat - Radius_Zaehler2)
    // Radius_Zaehler2
    X_PIX_POS:=Radius_Zaehler*Radius_Zaehler;
    // Radius_Quatrat - Radius_Zaehler2
    X_PIX_POS:=Radius_Quatrat-X_PIX_POS;
    // Wurzel(Radius_Quatrat - Radius_Zaehler2)
    X_PIX_POS:=Wurzel(X_PIX_POS);

   // X_END_POS ist rechte X-Position
    X_END_POS:=X_PIX_POS2+X_PIX_POS;

    // X_PIX_POS ist linke X-Position
    X_PIX_POS:=X_PIX_POS2-X_PIX_POS;

    // y1 fuer Kreis-Punkt
    Y_PIX_POS:=Y_PIX_POS2+Radius_Zaehler;

    Zeichne_waagerechten_Strich;

  endfor; { for Radius_Zaehler:=1 to Radius do }

  X_PIX_POS:=X_PIX_POS2;
  Y_PIX_POS:=Y_PIX_POS2;

end Grafik_zeichne_vollen_Kreis2_on_Rampage;













procedure Grafik_zeichne_vollen_Kreis(Radius : Word);
begin

  Grafik_zeichne_vollen_Kreis2_on_Rampage(Radius);

  if KopieBWS then
    Umschalten_Speicherseite;
    Grafik_zeichne_vollen_Kreis2_on_Rampage(Radius);
    Umschalten_Speicherseite;
  endif;

end Grafik_zeichne_vollen_Kreis;

















// *********************************
// *** Zeichen-Ausgabe der Fonts ***
// *********************************




// schreibt ein Zeichen in die aktuelle RamPage
// ohne Kursorbewegung
procedure Write_Char_6x8;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;
  Adresse : DWord;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;

begin

  SetBit(WE);
  SetBit(OE);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr-$20;
  FontPtr:=FontPtr*8;

  Adresse:=Anfangsadresse;


  for y_cnt:=0 to 7 do

    FontZeile:=font6x8[FontPtr];
    INC(FontPtr);
    SHR(FontZeile);
    SHR(FontZeile);

    for x_cnt:=0 to 5 do

      ADR_HIGH:= DWordToByte(2,Adresse);

      ADR_BIT:=ADR_HIGH and %00000001;
      if ADR_BIT=0 then
        ClearBit(A16);
      else
        SetBit(A16);
      endif;

      ADR_BIT:=ADR_HIGH and %00000010;
      if ADR_BIT=0 then
        ClearBit(A17);
      else
        SetBit(A17);
      endif;

      ADR_BIT:=ADR_HIGH and %00000100;
      if ADR_BIT=0 then
        ClearBit(A18);
      else
        SetBit(A18);
      endif;


      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTA:= BCOLOR;
      else
        PORTA:= FCOLOR;
      endif;

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      DDRA:= %11111111;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      SHR(FontZeile);
      INC(Adresse);

      DDRA:= %00000000;

    endfor; { for x_cnt:=0 to 5 do }

    Adresse:=Adresse+1018; // Adresse + PixelProZeile(1024) - Zeichenbreite

  endfor; { for y_cnt:=0 to 7 do }


  // Grundeinstellungen
  SetBit(WE);
  ClearBit(A16);
  ClearBit(A17);
  ClearBit(A18);

end Write_Char_6x8;








// schreibt ein Zeichen in die aktuelle RamPage
// ohne Kursorbewegung
procedure Write_Char_8x8;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;
  Adresse : DWord;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;
  A2 : DWord;
begin

  SetBit(WE);
  SetBit(OE);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr-$20;
  FontPtr:=FontPtr*8;

  // Berechnung der Adresse (1.Pixel)
  Adresse:=Anfangsadresse;


  for y_cnt:=0 to 7 do

    FontZeile:=font8x8[FontPtr];
    INC(FontPtr);

    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
      SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;

    for x_cnt:=0 to 7 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTA:= BCOLOR;
      else
        PORTA:= FCOLOR;
      endif;

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      DDRA:= %11111111;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      DDRA:= %00000000;

      SHR(FontZeile);
      INC(Adresse);

    endfor; { for x_cnt:=0 to 5 do }

    Adresse:=Adresse+1016; // Adresse + PixelProZeile(1024) - Zeichenbreite

  endfor; { for y_cnt:=0 to 7 do }


  // Grundeinstellungen
  SetBit(WE);
  ClearBit(A16);
  ClearBit(A17);
  ClearBit(A18);

end Write_Char_8x8;









// schreibt ein Zeichen in die aktuelle RamPage
// ohne Kursorbewegung
procedure Write_Char_8x12;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;
  Adresse : DWord;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;
begin

  SetBit(WE);
  SetBit(OE);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr*12;

  // Berechnung der Adresse (1.Pixel)
  Adresse:=Anfangsadresse;


  for y_cnt:=0 to 11 do

    FontZeile:=font8x12[FontPtr];
    INC(FontPtr);

    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
      SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;

    for x_cnt:=0 to 7 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTA:= BCOLOR;
      else
        PORTA:= FCOLOR;
      endif;

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      DDRA:= %11111111;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      DDRA:= %00000000;

      SHR(FontZeile);
      INC(Adresse);

    endfor; { for x_cnt:=0 to 7 do }

    Adresse:=Adresse+1016; // Adresse + PixelProZeile(1024) - Zeichenbreite


  endfor; { for y_cnt:=0 to 7 do }


  // Grundeinstellungen
  SetBit(WE);
  ClearBit(A16);
  ClearBit(A17);
  ClearBit(A18);

end Write_Char_8x12;







// schreibt ein Zeichen in die aktuelle RamPage
// ohne Kursorbewegung
procedure Write_Char_10x16;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;
  Adresse : DWord;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;
begin

  SetBit(WE);
  SetBit(OE);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
//  FontPtr:=FontPtr-$20;
  FontPtr:=FontPtr*32;


  // Berechnung der Adresse (1.Pixel)
  Adresse:=Anfangsadresse;

  for y_cnt:=1 to 16 do

    FontZeile:=font10x16[FontPtr];
    INC(FontPtr);

    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);

    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
      SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;


    for x_cnt:=0 to 1 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTA:= BCOLOR;
      else
        PORTA:= FCOLOR;
      endif;

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      DDRA:= %11111111;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      DDRA:= %00000000;

      SHR(FontZeile);
      INC(Adresse);

    endfor; { for x_cnt:=0 to 5 do }


    FontZeile:=font10x16[FontPtr];
    INC(FontPtr);


    for x_cnt:=0 to 7 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTA:= BCOLOR;
      else
        PORTA:= FCOLOR;
      endif;

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      DDRA:= %11111111;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      DDRA:= %00000000;

      SHR(FontZeile);
      INC(Adresse);

    endfor; { for x_cnt:=0 to 5 do }

    Adresse:=Adresse+1014; // Adresse + PixelProZeile(1024) - Zeichenbreite

  endfor; { for y_cnt:=0 to 7 do }


  // Grundeinstellungen
  SetBit(WE);
  ClearBit(A16);
  ClearBit(A17);
  ClearBit(A18);

end Write_Char_10x16;






// schreibt ein Zeichen in die aktuelle RamPage
// ohne Kursorbewegung
procedure Write_Char_12x20;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;
  Adresse : DWord;
  ADR_HIGH : Byte;
  ADR_BIT : Byte;
begin

  SetBit(WE);
  SetBit(OE);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr*40;


  // Berechnung der Adresse (1.Pixel)
  Adresse:=Anfangsadresse;

  for y_cnt:=1 to 20 do

    FontZeile:=font12x20[FontPtr];
    INC(FontPtr);

    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);

    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
      SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;


    for x_cnt:=0 to 3 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTA:= BCOLOR;
      else
        PORTA:= FCOLOR;
      endif;

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      DDRA:= %11111111;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      DDRA:= %00000000;

      SHR(FontZeile);
      INC(Adresse);

    endfor; { for x_cnt:=0 to 5 do }


    FontZeile:=font12x20[FontPtr];
    INC(FontPtr);


    for x_cnt:=0 to 7 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTA:= BCOLOR;
      else
        PORTA:= FCOLOR;
      endif;

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      DDRA:= %11111111;

      ClearBit(WE);

      NOP;
      NOP;
      NOP;
      NOP;

      SetBit(WE);

      DDRA:= %00000000;

      SHR(FontZeile);
      INC(Adresse);

    endfor; { for x_cnt:=0 to 5 do }

    Adresse:=Adresse+1012; // Adresse + PixelProZeile(1024) - Zeichenbreite

  endfor; { for y_cnt:=0 to 7 do }


  // Grundeinstellungen
  SetBit(WE);
  ClearBit(A16);
  ClearBit(A17);
  ClearBit(A18);

end Write_Char_12x20;






procedure Write_Char;
begin

  CASE Font_Bez OF
    fnt_6x8 : Write_Char_6x8;
    |
    fnt_8x8 : Write_Char_8x8;
    |
    fnt_8x12 : Write_Char_8x12;
    |
    fnt_10x16 : Write_Char_10x16;
    |
    fnt_12x20 : Write_Char_12x20;
    |
  ENDCASE;

end Write_Char;






// **********************************
// *** Hilfsprogramme fuer Kursor ***
// **********************************




// liest alle Pixel eines Zeichens an der angegebenen
// Zeichenposition vom VRAM und schreibt sie in das CHAR_Array
procedure VRAM_to_CHAR_Array;
var
  Adresse : DWord;
  x_cnt : Byte;
  y_cnt : Byte;
  Array_Pos : Word;
  ADR_BIT : Byte;
  ADR_HIGH : Byte;

begin

  // Zeichen aus VRAM lesen -> Zeichen in Puffer schreiben
  SetBit(WE);
  SetBit(OE);

  DDRA:= %00000000;

  Adresse:=Anfangsadresse;
  Array_Pos:=0;

  for y_cnt:=0 to Zeichenhoehe0 do

    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
       SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;

    for x_cnt:=0 to Zeichenbreite0 do

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      NOP;

      ClearBit(OE);

      NOP;
      NOP;
      NOP;
      NOP;

      CHAR_Array[Array_Pos]:=PINA;

      NOP;

      SetBit(OE);

      INC(Adresse);
      INC(Array_Pos);

    endfor; { for x_cnt:=0 to Zeichenbreite0 do }

    Adresse:=Adresse+1024;
    Adresse:=Adresse-ZeichenbreiteDW;

  endfor; { for x_cnt:=0 to Zeichenbreite0 do }

  // VRAM Steuerleitungen auf Grundstellung
  SetBit(WE);
  DDRA:= %00000000;
  SetBit(OE);

end VRAM_to_CHAR_Array;







// schreibt alle Pixel eines Zeichens an der angegebenen
// Zeichenposition vom CHAR_Array in das VRAM
procedure CHAR_Array_to_VRAM;
var
  Adresse : DWord;
  x_cnt : Byte;
  y_cnt : Byte;
  Array_Pos : Word;
  ADR_BIT : Byte;
  ADR_HIGH : Byte;

begin

    // Zeichen aus Puffer lesen -> in VRAM schreiben
    SetBit(WE);
    SetBit(OE);

    Adresse:=Anfangsadresse;
    Array_Pos:=0;

    for y_cnt:=0 to Zeichenhoehe0 do

      ADR_HIGH:= DWordToByte(2,Adresse);

      ADR_BIT:=ADR_HIGH and %00000001;
      if ADR_BIT=0 then
        ClearBit(A16);
      else
        SetBit(A16);
      endif;

      ADR_BIT:=ADR_HIGH and %00000010;
      if ADR_BIT=0 then
        ClearBit(A17);
      else
        SetBit(A17);
      endif;

      ADR_BIT:=ADR_HIGH and %00000100;
      if ADR_BIT=0 then
        ClearBit(A18);
      else
        SetBit(A18);
      endif;

      for x_cnt:=0 to Zeichenbreite0 do

        PORTB:= DWordToByte(0,Adresse);
        PORTC:= DWordToByte(1,Adresse);


        DDRA:= %11111111;

        PORTA:=CHAR_Array[Array_Pos];

        NOP;
        NOP;

        ClearBit(WE);

        NOP;
        NOP;
        NOP;
        NOP;

        SetBit(WE);

        DDRA:= %00000000;

        INC(Adresse);
        INC(Array_Pos);


      endfor; { for x_cnt:=0 to Zeichenbreite0 do }

      Adresse:=Adresse-ZeichenbreiteDW;
      Adresse:=Adresse+1024;

    endfor; { for x_cnt:=0 to Zeichenbreite0 do }

    // VRAM Steuerleitungen auf Grundstellung
    SetBit(WE);
    DDRA:= %00000000;
    SetBit(OE);

end CHAR_Array_to_VRAM;









procedure VRAM_to_Kursor_Array;
var
  Adresse : DWord;
  x_cnt : Byte;
  y_cnt : Byte;
  Array_Pos : Word;
  ADR_BIT : Byte;
  ADR_HIGH : Byte;

begin

  // Zeichen aus VRAM lesen -> Zeichen in Puffer schreiben
  SetBit(WE);
  SetBit(OE);

  Adresse:=Anfangsadresse;
  Array_Pos:=0;

  for y_cnt:=0 to Zeichenhoehe0 do

    ADR_HIGH:= DWordToByte(2,Adresse);

    ADR_BIT:=ADR_HIGH and %00000001;
    if ADR_BIT=0 then
      ClearBit(A16);
    else
      SetBit(A16);
    endif;

    ADR_BIT:=ADR_HIGH and %00000010;
    if ADR_BIT=0 then
      ClearBit(A17);
    else
      SetBit(A17);
    endif;

    ADR_BIT:=ADR_HIGH and %00000100;
    if ADR_BIT=0 then
      ClearBit(A18);
    else
      SetBit(A18);
    endif;

    for x_cnt:=0 to Zeichenbreite0 do

      PORTB:= DWordToByte(0,Adresse);
      PORTC:= DWordToByte(1,Adresse);

      NOP;

      ClearBit(OE);

      NOP;
      NOP;
      NOP;
      NOP;

      Kursor_Array[Array_Pos]:=PINA;

      NOP;

      SetBit(OE);

      INC(Adresse);
      INC(Array_Pos);

    endfor; { for x_cnt:=0 to Zeichenbreite0 do }

    Adresse:=Adresse-ZeichenbreiteDW;
    Adresse:=Adresse+1024;

  endfor; { for x_cnt:=0 to Zeichenbreite0 do }

  // VRAM Steuerleitungen auf Grundstellung
  SetBit(WE);
  DDRA:= %00000000;
  SetBit(OE);

  KurArr_Aktuell:=true;

end VRAM_to_Kursor_Array;






procedure Kursor_Array_to_VRAM;
var
  Adresse : DWord;
  x_cnt : Byte;
  y_cnt : Byte;
  Array_Pos : Word;
  ADR_BIT : Byte;
  ADR_HIGH : Byte;

begin

  if KurArr_Aktuell then

    // Zeichen aus Puffer lesen -> in VRAM schreiben
    SetBit(WE);
    SetBit(OE);

    Adresse:=Anfangsadresse;
    Array_Pos:=0;

    for y_cnt:=0 to Zeichenhoehe0 do

      ADR_HIGH:= DWordToByte(2,Adresse);

      ADR_BIT:=ADR_HIGH and %00000001;
      if ADR_BIT=0 then
        ClearBit(A16);
      else
        SetBit(A16);
      endif;

      ADR_BIT:=ADR_HIGH and %00000010;
      if ADR_BIT=0 then
        ClearBit(A17);
      else
        SetBit(A17);
      endif;

      ADR_BIT:=ADR_HIGH and %00000100;
      if ADR_BIT=0 then
        ClearBit(A18);
      else
        SetBit(A18);
      endif;

      for x_cnt:=0 to Zeichenbreite0 do

        PORTB:= DWordToByte(0,Adresse);
        PORTC:= DWordToByte(1,Adresse);

        DDRA:= %11111111;

        PORTA:=Kursor_Array[Array_Pos];

        NOP;
        NOP;

        ClearBit(WE);

        NOP;
        NOP;
        NOP;
        NOP;
        NOP;
        NOP;

        SetBit(WE);

        DDRA:= %00000000;

        INC(Adresse);
        INC(Array_Pos);


      endfor; { for x_cnt:=0 to Zeichenbreite0 do }

      Adresse:=Adresse-ZeichenbreiteDW;
      Adresse:=Adresse+1024;

    endfor; { for x_cnt:=0 to Zeichenbreite0 do }

    // VRAM Steuerleitungen auf Grundstellung
    SetBit(WE);
    DDRA:= %00000000;
    SetBit(OE);

  endif; { if KurArr_Aktuell then }

end Kursor_Array_to_VRAM;







procedure Schalte_Kursor_Ein;
begin

  VRAM_to_Kursor_Array;

  // Kursor schreiben
  Zeichen:=$5F;

  Write_Char;
  if KopieBWS then
    Umschalten_Speicherseite;
    Write_Char;
    Umschalten_Speicherseite;
  endif;

end Schalte_Kursor_Ein;







procedure Schalte_Kursor_Aus;
begin

  Kursor_Array_to_VRAM;

  if KopieBWS then
    Umschalten_Speicherseite;
    Kursor_Array_to_VRAM;
    Umschalten_Speicherseite;
  endif;

end Schalte_Kursor_Aus;








// *** Hilfsprogramme fuer CONOUT ***




// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_RIGHT;
begin

  if X_KUR_POS<max_Spalten then
    Inc(X_KUR_POS);
    X_PIX_POS:=X_PIX_POS+Zeichenbreite;
  endif;

end CURSOR_RIGHT;





procedure CURSOR_UP;
begin
  if Y_KUR_POS>0 then
    DEC(Y_KUR_POS);
    Y_PIX_POS:=Y_PIX_POS-Zeichenhoehe;
  endif;
end CURSOR_UP;





// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_DOWN;
begin

  if Y_KUR_POS<max_Zeilen then
    Inc(Y_KUR_POS);
    Y_PIX_POS:=Y_PIX_POS+Zeichenhoehe;
  endif;

end CURSOR_DOWN;




// Loeschen von Kursorpossition bis zum Zeilenende
procedure DELETE_EOL;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;
begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  for Kur_Pos_Cnt:=X_KUR_POS2 to max_Spalten do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do }

  if KopieBWS then

    Umschalten_Speicherseite;

    X_KUR_POS:=X_KUR_POS2;
    X_PIX_POS:=X_PIX_POS2;

    for Kur_Pos_Cnt:=X_KUR_POS2 to max_Spalten do
      Write_Char;
      INC(X_KUR_POS);
      X_PIX_POS:= X_PIX_POS+Zeichenbreite;
    endfor; { for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do }

    Umschalten_Speicherseite;

  endif; { if KopieBeideSeiten then }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_EOL;






// Loeschen von Anfang bis Kursorpossition
procedure DELETE_BOL;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to X_KUR_POS2 do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=0 to X_KUR_POS2 do }

  if KopieBWS then

    Umschalten_Speicherseite;

    X_KUR_POS:=0;
    X_PIX_POS:=X_ANF;

    for Kur_Pos_Cnt:=0 to X_KUR_POS2 do
      Write_Char;
      INC(X_KUR_POS);
      X_PIX_POS:= X_PIX_POS+Zeichenbreite;
    endfor; { for Kur_Pos_Cnt:=0 to X_KUR_POS2 do }

    Umschalten_Speicherseite;

  endif; { if KopieBeideSeiten then }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_BOL;







// Loeschen der gesammten Zeile auf Y-Kursorposition
procedure DELETE_LINE;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to max_Spalten do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=0 to max_Spalten do }

  if KopieBWS then

    Umschalten_Speicherseite;

    X_KUR_POS:=0;
    X_PIX_POS:=X_ANF;

    for Kur_Pos_Cnt:=0 to max_Spalten do
      Write_Char;
      INC(X_KUR_POS);
      X_PIX_POS:= X_PIX_POS+Zeichenbreite;
    endfor; { for Kur_Pos_Cnt:=0 to max_Spalten do }

    Umschalten_Speicherseite;

  endif; { if KopieBeideSeiten then }


  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_LINE;





// Loeschen der gesammten Zeile auf Y-Kursorposition
procedure CLEAR_LINE_on_RAMPAGE;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to max_Spalten do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end CLEAR_LINE_on_RAMPAGE;




// Loeschen der letzten Zeile
procedure DELETE_last_LINE_on_RAMPAGE;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;
  Y_KUR_POS2 : Word;
  Y_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;
  Y_KUR_POS2:=Y_KUR_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;
  Y_KUR_POS:=max_Zeilen;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF; // 231

  for Kur_Pos_Cnt:=0 to max_Spalten do
    Write_Char;
    INC(X_KUR_POS);
    X_PIX_POS:= X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;
  Y_KUR_POS:=Y_KUR_POS2;
  Y_PIX_POS:=Y_PIX_POS2;

end DELETE_last_LINE_on_RAMPAGE;





// Loeschen der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure DELETE_LINE_SCR_ROLL_on_RAMPAGE;
var
  Kur_Pos_X_Cnt : Word;
  Kur_Pos_Y_Cnt : Word;
  Y_PIX_POS_von : Word;
  Y_PIX_POS_nach : Word;
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;

begin

  if Y_KUR_POS<=max_Zeilen then

    X_PIX_POS2:=X_PIX_POS;
    Y_PIX_POS2:=Y_PIX_POS;

    for Kur_Pos_Y_Cnt:=Y_KUR_POS to max_Zeilen do

      Y_PIX_POS_nach:=Kur_Pos_Y_Cnt*Zeichenhoehe;
      Y_PIX_POS_nach:=Y_PIX_POS_nach+Y_ANF;
      Y_PIX_POS_von:=Y_PIX_POS_nach+Zeichenhoehe;

      X_PIX_POS:=X_ANF;

      for Kur_Pos_X_Cnt:=0 to max_Spalten do
        Y_PIX_POS:=Y_PIX_POS_von;
        VRAM_to_CHAR_Array;
        Y_PIX_POS:=Y_PIX_POS_nach;
        CHAR_Array_to_VRAM;
        X_PIX_POS:= X_PIX_POS+Zeichenbreite;
      endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten do }

    endfor; { for Kur_Pos_Y_Cnt:=Y_KUR_POS to max_Zeilen2 do }

    X_PIX_POS:=X_PIX_POS2;
    Y_PIX_POS:=Y_PIX_POS2;

  endif; { if Y_KUR_POS<=22 then }

end DELETE_LINE_SCR_ROLL_on_RAMPAGE;





// Loeschen der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure DELETE_LINE_SCR_ROLL;
begin
  DELETE_LINE_SCR_ROLL_on_RAMPAGE;
  DELETE_last_LINE_on_RAMPAGE;

  if KopieBWS then

    Umschalten_Speicherseite;

    DELETE_LINE_SCR_ROLL_on_RAMPAGE;
    DELETE_last_LINE_on_RAMPAGE;
    Umschalten_Speicherseite;

  endif; { if KopieBeideSeiten then }

end DELETE_LINE_SCR_ROLL;






// neue Zeile der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure INSERT_LINE_SCR_ROLL_on_RAMPAGE;
var
  Kur_Pos_X_Cnt : Word;
  Kur_Pos_Y_Cnt : Word;
  Y_PIX_POS_von : Word;
  Y_PIX_POS_nach : Word;
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;


begin

  if Y_KUR_POS<=max_Zeilen then

    X_PIX_POS2:=X_PIX_POS;
    Y_PIX_POS2:=Y_PIX_POS;

    for Kur_Pos_Y_Cnt:=max_Zeilen downto Y_KUR_POS do

      Y_PIX_POS_von:=Kur_Pos_Y_Cnt*Zeichenhoehe;
      Y_PIX_POS_von:=Y_PIX_POS_von+Y_ANF;
      Y_PIX_POS_nach:=Y_PIX_POS_von+Zeichenhoehe;

      X_PIX_POS:=X_ANF;

      for Kur_Pos_X_Cnt:=0 to max_Spalten do
        Y_PIX_POS:=Y_PIX_POS_von;
        VRAM_to_CHAR_Array;
        Y_PIX_POS:=Y_PIX_POS_nach;
        CHAR_Array_to_VRAM;
        X_PIX_POS:= X_PIX_POS+Zeichenbreite;
      endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten do }

    endfor; { for Kur_Pos_Y_Cnt:=max_Zeilen2 downto Y_KUR_POS do }

    X_PIX_POS:=X_PIX_POS2;
    Y_PIX_POS:=Y_PIX_POS2;

  endif; { if Y_KUR_POS<=max_Zeilen2 then }

end INSERT_LINE_SCR_ROLL_on_RAMPAGE;





// neue Zeile der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure INSERT_LINE_SCR_ROLL;
begin
  INSERT_LINE_SCR_ROLL_on_RAMPAGE;
  CLEAR_LINE_on_RAMPAGE;

  if KopieBWS then

    Umschalten_Speicherseite;

    INSERT_LINE_SCR_ROLL_on_RAMPAGE;
    CLEAR_LINE_on_RAMPAGE;
    Umschalten_Speicherseite;

  endif; { if KopieBWS then }

end INSERT_LINE_SCR_ROLL;





procedure ERASE_DOWN_on_RAMPAGE;
var
  Kur_Pos_X_Cnt : Byte;
  Kur_Pos_Y_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;
  Y_KUR_POS2 : Word;
  Y_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  Y_KUR_POS2:=Y_KUR_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  for Y_KUR_POS:=Y_KUR_POS2 to max_Zeilen do

    X_PIX_POS:=X_ANF;

    for X_KUR_POS:=0 to max_Spalten do
      Write_Char;
      X_PIX_POS:=X_PIX_POS+Zeichenbreite;
    endfor; { for Kur_Pos_Cnt:=0 to 79 do }

    Y_PIX_POS:=Y_PIX_POS+Zeichenhoehe;

  endfor;

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

  Y_KUR_POS:=Y_KUR_POS2;
  Y_PIX_POS:=Y_PIX_POS2;

end ERASE_DOWN_on_RAMPAGE;





// Erases the screen from the current line down to the bottom of the screen.
procedure ERASE_DOWN;
begin
  ERASE_DOWN_on_RAMPAGE;

  if KopieBWS then

    Umschalten_Speicherseite;

    ERASE_DOWN_on_RAMPAGE;
    Umschalten_Speicherseite;

  endif; { if KopieBeideSeiten then }

end ERASE_DOWN;








procedure ScreenRoll_on_RAMPAGE;
var
  Kur_Pos_X_Cnt : Word;
  Kur_Pos_Y_Cnt : Word;
  Y_PIX_POS_von : Word;
  Y_PIX_POS_nach : Word;

begin

  // Dauer fuer 2 x RAMPAGE = 2,843s

  // Verschieben von Zeile 1 bis Ende-2 um 1 nach oben
  for Kur_Pos_Y_Cnt:=0 to max_Zeilen-1 do

    Y_PIX_POS_nach:=Kur_Pos_Y_Cnt*Zeichenhoehe;
    Y_PIX_POS_nach:=Y_PIX_POS_nach+Y_ANF;
    Y_PIX_POS_von:=Y_PIX_POS_nach+Zeichenhoehe;

    X_PIX_POS:=X_ANF;

    for Kur_Pos_X_Cnt:=0 to max_Spalten do

      Y_PIX_POS:=Y_PIX_POS_von;
      VRAM_to_CHAR_Array;
      Y_PIX_POS:=Y_PIX_POS_nach;
      CHAR_Array_to_VRAM;
      X_PIX_POS:= X_PIX_POS+Zeichenbreite;

    endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten2 do }

  endfor; { for Kur_Pos_Y_Cnt:=0 to max_Zeilen2-1 do }



  // Loeschen der letzten Zeile
  Zeichen:=$20;

  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

  X_PIX_POS:=X_ANF;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;

  for X_KUR_POS:=0 to max_Spalten do
    Write_Char;
    X_PIX_POS:=X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }


  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

  X_PIX_POS:=X_ANF;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;


end ScreenRoll_on_RAMPAGE;






procedure ScreenRoll2_on_RAMPAGE;
var
  YA  : Byte;
  ZH0 : Byte;
  ZH  : Byte;
  MZ  : Byte;
begin

  // Dauer fuer 2 x RAMPAGE = 617ms

  YA  := Low(Y_ANF);
  ZH0 := Zeichenhoehe0;
  INC(ZH0);
  ZH  := Low(Zeichenhoehe);
  MZ  := Low(max_Zeilen);

{
  Parameter:
  R0 = Zeichenhoehe0  -> entspricht der gesammten Hoehe des Zeichens
                         inklusive Freiraum zwischen den Zeilen
  R1 = Zeichenhoehe   -> entspricht nur der reinen (zu kopierenden)
                         Hoehe des Zeichens

  -----
         -> Y_ANF = R0
  -----
  X   X  \                 \
   X X    \                 \
    X      > Zeichenhoehe0   \
   X X    /     = R1          \
  X   X  /                     > Zeichenhoehe
  -----                       /      = R2
                             /
  -----

}


{$I ScreenRoll.inc}



  // Loeschen der letzten Zeile
  Zeichen:=$20;

  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

  X_PIX_POS:=X_ANF;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;

  for X_KUR_POS:=0 to max_Spalten do
    Write_Char;
    X_PIX_POS:=X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }


  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

  X_PIX_POS:=X_ANF;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;



end ScreenRoll2_on_RAMPAGE;












procedure ScreenRoll3_on_RAMPAGE;

begin




  // Loeschen der letzten Zeile
  Zeichen:=$20;

  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

  X_PIX_POS:=X_ANF;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;

  for X_KUR_POS:=0 to max_Spalten do
    Write_Char;
    X_PIX_POS:=X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }


  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

  X_PIX_POS:=X_ANF;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;


end ScreenRoll3_on_RAMPAGE;















procedure SET_CURSOR_POSITION(Zeile, Spalte : Word); // bezogen auf 0,0 !!!
begin

  // 1. Zeile setzen
  X_KUR_POS:=Spalte;

  if X_KUR_POS>max_Spalten then
    X_KUR_POS:=max_Spalten;
  endif;

  X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  X_PIX_POS:=X_PIX_POS+X_ANF;

  // 2. Spalte setzen
  Y_KUR_POS:=Zeile;

  if Y_KUR_POS>max_Zeilen then
    Y_KUR_POS:=max_Zeilen;
  endif;

  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;

end SET_CURSOR_POSITION;




procedure Write_Char_in_beide_RP;
begin
  Write_Char;

  if KopieBWS then

    Umschalten_Speicherseite;
    Write_Char;
    Umschalten_Speicherseite;

  endif; { if KopieBeideSeiten then }

  CURSOR_RIGHT;
end Write_Char_in_beide_RP;





procedure Anzeige_Zeichensatz;
var
  Zaehler1 : Word;
  Zaehler2 : Word;
begin

  Zeichen:=$0;
  FCOLOR:=$0;

  for Zaehler1:=0 to max_Zeilen do

    for Zaehler2:=0 to max_Spalten do

      Write_Char_in_beide_RP;

      Inc(Zeichen);
      Inc(FCOLOR);

    endfor;

    CURSOR_DOWN;
    X_KUR_POS:=0;
    X_PIX_POS:= X_ANF;

  endfor;

end Anzeige_Zeichensatz;














// *********************
// *** TERMINAL MODE ***
// *********************









procedure Normal_Terminal_Mode;
begin

  case Zeichen of

    $0A :   // 0A = Zeilenschaltung (Line Feed)
            // Y_KUR_POS von 0..23 = 24 Zeilen pro Bildschirm
            if Y_KUR_POS<max_Zeilen then
              INC(Y_KUR_POS);
              Y_PIX_POS:= Y_PIX_POS+Zeichenhoehe;
            else
              ScreenRoll_on_RAMPAGE;
              if KopieBWS then
                Umschalten_Speicherseite;
                ScreenRoll_on_RAMPAGE;
                Umschalten_Speicherseite;
              endif; { if KopieBeideSeiten then }

            endif;

    |

   $0C :    // 0C = Bildschirm loeschen (Clear Screen)
            Reset_Form;

    |

    $0D :   // 0D = Wagenruecklauf (Carridge Return)
            X_KUR_POS:=0;
            X_PIX_POS:=X_ANF;

    |

    $1B :   // ESC-Modus
            TermMode:=IBM_ESC_TM;

    |

  else


    if Zeichen>=$20 then
      if Zeichen<=$7F then
        if X_KUR_POS<=max_Spalten then

          Write_Char_in_beide_RP;

          VRAM_to_Kursor_Array;
          Kursor_sichtbar:=false;
          Kursor_Schleife:=0;
          KurArr_Aktuell:=true;

        endif; { if X_KUR_POS<80 then }
      endif; { if Zeichen<=$7F then }
    endif; { if Zeichen>=$20 then  }

  endcase; { case Zeichen of }


end Normal_Terminal_Mode;







procedure Escape_Reset;
begin
  CSI_Parameter1:=0;
  CSI_Parameter2:=0;
  CSI_Parameter3:=0;
  TermMode:=Normal_TM;
  Escape_Sequenz:='';
end Escape_Reset;






procedure Escape_Fehler;
var
  ESC_Zaehler : Byte;
  ESC_Laenge  : Byte;
  ESC_Zeichen : Char;
begin

  Zeichen:=$45; // E
  Write_Char_in_beide_RP;

  Zeichen:=$53; // S
  Write_Char_in_beide_RP;

  Zeichen:=$43; // C
  Write_Char_in_beide_RP;

  ESC_Laenge:=Length(Escape_Sequenz);

  for ESC_Zaehler:=1 to ESC_Laenge do
    ESC_Zeichen:=Escape_Sequenz[ESC_Zaehler];
    Zeichen:=CharToByte(ESC_Zeichen);
    Write_Char_in_beide_RP;
  endfor;

  Escape_Reset;
end Escape_Fehler;




procedure IBM_ESC_Terminal_Mode;
begin

  case Zeichen of

    $5B : TermMode:=IBM_CSI_TM; // Control Sequence Introducer (CSI) = ESC [
    |

    $47 : TermMode:=IBM_GRAFIK_Par_1_TM; // GRAFIK-Mode = ESC G
    |

  else

    Escape_Fehler;

  endcase;

end IBM_ESC_Terminal_Mode;







procedure Set_Display_Attributes(DispAttr : Word);
begin


  case DispAttr of

    // *** Textattribute ***


    // ESC [ 0 m = Alle Attribute AUS (Reset all attributes)
    0 : FCOLOR:=cl_Blue;
    |

    // ESC [ 1 m = Fett ein
    1 : FCOLOR:=cl_Gray;
    |

    // ESC [ 4 m = Unterstreichen
    4 : FCOLOR:=cl_Purple;
    |

    // ESC [ 5 m = Blinken EIN
    5 : FCOLOR:=cl_Red;
    |

    // ESC [ 7 m = Invertierte Darstellung
    7 : FCOLOR:=cl_Black;
    |

    // ESC [ 8 m = Versteckt ein
    8 : FCOLOR:=cl_White;
    |



   // *** Schriftgroesse ***

    // ESC [ 11 m = Font 6x8
    11 :   setze_Font(fnt_6x8);
    |

    // ESC [ 12 m = Font 8x8
    12 :   setze_Font(fnt_8x8);
    |

    // ESC [ 13 m = Font 8x12
    13 :   setze_Font(fnt_8x12);
    |

    // ESC [ 14 m = Font 10x16
    14 :   setze_Font(fnt_10x16);
    |

    // ESC [ 15 m = Font 12x20
    15 :   setze_Font(fnt_12x20);
    |



    // *** Vordergrundfarben ***

    // ESC [ 30 m = Vordergrundfarbe - 30 Schwarz
    30 : FCOLOR:=cl_Black;
    |

    // ESC [ 31 m = Vordergrundfarbe - 31 Rot
    31 : FCOLOR:=cl_Red;
    |

    // ESC [ 32 m = Vordergrundfarbe - 32 Grün
    32 : FCOLOR:=cl_Green;
    |

    // ESC [ 33 m = Vordergrundfarbe - 33 Gelb
    33 : FCOLOR:=cl_Yellow;
    |

    // ESC [ 34 m = Vordergrundfarbe - 34 Blau
    34 : FCOLOR:=cl_Blue;
    |

    // ESC [ 35 m = Vordergrundfarbe - 35 Karmesinrot (Purpur, lila)
    35 : FCOLOR:=cl_Purple;
    |

    // ESC [ 36 m = Vordergrundfarbe - 36 Cyanblau
    36 : FCOLOR:=cl_Aqua;
    |

    // ESC [ 37 m = Vordergrundfarbe - 37 Weiß
    37 : FCOLOR:=cl_White;
    |



    // *** Hintergrundfarben ***

    // ESC [ 40 m = Hintergrundfarbe - 40 Schwarz
    40 : BCOLOR:=cl_Black;
    |

    // ESC [ 41 m = Hintergrundfarbe - 41 Rot
    41 : BCOLOR:=cl_Red;
    |

    // ESC [ 42 m = Hintergrundfarbe - 42 Grün
    42 : BCOLOR:=cl_Green;
    |

    // ESC [ 43 m = Hintergrundfarbe - 43 Gelb
    43 : BCOLOR:=cl_Yellow;
    |

    // ESC [ 44 m = Hintergrundfarbe - 44 Blau
    44 : BCOLOR:=cl_Blue;
    |

    // ESC [ 45 m = Hintergrundfarbe - 45 Karmesinrot (Purpur, lila)
    45 : BCOLOR:=cl_Purple;
    |

    // ESC [ 46 m = Hintergrundfarbe - 46 Cyanblau
    46 : BCOLOR:=cl_Aqua;
    |

    // ESC [ 47 m = Hintergrundfarbe - 47 Weiß
    47 : BCOLOR:=cl_White;
    |

    else
      Escape_Fehler;
    endcase;

end Set_Display_Attributes;








procedure IBM_CSI_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=ByteToWord(Zeichen)-$30;
               TermMode:=IBM_CSI_TM_Par_1;
    |

    $4B : // Loeschen bis Zeilenende = ESC [ K
          DELETE_EOL;
          Escape_Reset;
    |

    $66 : // Schirm loeschen = ESC [ f
          Reset_Form;
          Escape_Reset;
    |

    $6D : // Turn off character attributes = ESC [ m
          Set_Display_Attributes(0);
          Escape_Reset;
    |

    $3F : // Hide/Show the cursor = ESC [ ? 2 5 h
          CSI_Parameter1:=0;
          TermMode:=IBM_CSI_TM_Par_1;
    |

    $48 : // "H" -- MOVE CURSOR = ESC [ H
          SET_CURSOR_POSITION(0,0);
          Escape_Reset;
    |

    $4A : // "J" -- Erase Down = ESC [ J
          // Erases the screen from the current line down to the bottom of the screen.
          ERASE_DOWN;
          Escape_Reset;
    |

    $4D : // "M" -- Move the cursor up in scrolling region = ESC [ M
          DELETE_LINE;
          CURSOR_UP;
          DELETE_LINE;
          Escape_Reset;
    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }

end IBM_CSI_Terminal_Mode;










// IBM_CSI_TM_Par_1
procedure IBM_CSI_Par_1_Terminal_Mode;
var
  Zaehler : Word;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_CSI_TM_Par_1;
    |

    $3B :      // ";"
	       // ESC [ Pn1 ; PN2 H oder
	       // ESC [ Pn1 ; PN2 f oder
               // ESC [ Pn1 ; PN2 m oder
	       // Xterm 256 colors - ESC[48;5;BCOLOR m oder
	       // Xterm 256 colors - ESC[38;5;FCOLOR m
               TermMode:=IBM_CSI_TM_Par_2;

    |

    $4A : // Zeilen loeschen = ESC [ Pn J

          case CSI_Parameter1 of

            2 : // Loeschen gesammte zeile
                Reset_Form;

            |
          else
            Escape_Fehler;
          endcase;
          Escape_Reset;
    |


    $4B : // Zeilen loeschen = ESC [ Pn K

          case CSI_Parameter1 of

            0 : // Löschen bis Zeilenende
                DELETE_EOL;
            |

            1 : // Löschen von Anfang bis Kursor
                DELETE_BOL;
            |

            2 : // Löschen gesammte zeile
                DELETE_LINE;
            |

          else
            Escape_Fehler;
          endcase;
          Escape_Reset;
    |


    $4C : // INSERT_LINE_SCR_ROLL = ESC [ Pn L
          for Zaehler:=0 to CSI_Parameter1-1 do
            INSERT_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
    |


    $4D : // "M" DELETE_LINE_SCR_ROLL = ESC [ Pn M
          for Zaehler:=0 to CSI_Parameter1-1 do
            DELETE_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
    |


    $6D : // "m" Character Attributes = ESC [ Pn m
          Set_Display_Attributes(CSI_Parameter1);
          Escape_Reset;
    |



    $6C : // "l" ESC [ ? X X l

          case CSI_Parameter1 of

            // "l" Text_Kursor_Aus = ESC [ ? 2 5 l
            25 : if Kursor_sichtbar then
                   Kursor_sichtbar:=false;
                   Schalte_Kursor_Aus;
                 endif;

                 Kursor_Ein:=false;
                 Escape_Reset;

            |

            // "l" Kopie_BWS_Aus AUS = ESC [ ? 2 6 l
            26 : KopieBWS:=false;
                 Escape_Reset;

            |

          else
            Escape_Fehler;
          endcase; { case CSI_Parameter1 of }

    |


    $68 : // "h" ESC [ ? X X h

          case CSI_Parameter1 of

            // "h" Text_Kursor_Ein = ESC [ ? 2 5 h
            25 : Kursor_Schleife:=0;
                 Kursor_Ein:=true;
                 Escape_Reset;

            |

            // "h" Kopie_BWS_Ein EIN = ESC [ ? 2 6 h
            26 : KopieBWS:=true;
                 Escape_Reset;

            |


            // "h" Umschalten_Speicherseite = ESC [ ? 2 7 h
            27 : Umschalten_Speicherseite;
                 Escape_Reset;

            |

          else
            Escape_Fehler;
          endcase; { case CSI_Parameter1 of }

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }

end IBM_CSI_Par_1_Terminal_Mode;








// IBM_CSI_TM_Par_2
procedure IBM_CSI_Par_2_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_CSI_TM_Par_2;
    |

    $3B : // ";"
          // Xterm 256 colors - ESC[48;5;BCOLOR m
          // Xterm 256 colors - ESC[38;5;FCOLOR m
          TermMode:=IBM_CSI_TM_Par_3;
    |


    $48 : // "H" -- MOVE CURSOR = ESC [ Pn1 ; PN2 H
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $66 : // "f" -- MOVE CURSOR = ESC [ Pn1 ; PN2 f
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $6D : // "m" -- 2 mal Character Attributes = ESC [ Pn1 ; PN2 m
          Set_Display_Attributes(CSI_Parameter1);
          Set_Display_Attributes(CSI_Parameter2);
          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_CSI_Par_2_Terminal_Mode;





procedure IBM_CSI_Par_3_Terminal_Mode;
begin


  case Zeichen of

    $30..$39 : CSI_Parameter3:=CSI_Parameter3*10;
               CSI_Parameter3:=CSI_Parameter3+ByteToWord(Zeichen);
               CSI_Parameter3:=CSI_Parameter3-$30;

               TermMode:=IBM_CSI_TM_Par_3;

    |


    $6D : // "m"

          case CSI_Parameter1 of

          48 : // Xterm 256 colors - ESC[48;5;BCOLOR m
               if CSI_Parameter2=5 then
                 BCOLOR:=Low(CSI_Parameter3);
               else
                 Escape_Fehler;
               endif;
          |

          38 : // Xterm 256 colors - ESC[38;5;FCOLOR m
               if CSI_Parameter2=5 then
                 FCOLOR:=Low(CSI_Parameter3);
               else
                 Escape_Fehler;
               endif;
          |

          else
            Set_Display_Attributes(CSI_Parameter1);
            Set_Display_Attributes(CSI_Parameter2);
            Set_Display_Attributes(CSI_Parameter3);
          endcase;

          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_CSI_Par_3_Terminal_Mode;





// ESC G - Auswertung der ESC-Grafik-Steuerzeichen



procedure IBM_GRAFIK_Par_1_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_GRAFIK_Par_1_TM;

    |

    $3B : // ";"
          TermMode:=IBM_GRAFIK_Par_2_TM;

    |

    $43 : // "C" -- Grafik_setze_Farbe = ESC G Pn1 C
          PIXCOLOR:=Low(CSI_Parameter1);
          Escape_Reset;

    |

    $4B : // "K" -- Grafik_zeichne_Kreis = ESC G Pn1 K
          Grafik_zeichne_Kreis(CSI_Parameter1);
          Escape_Reset;

    |

    $56 : // "V" -- Grafik_zeichne_vollen_Kreis = ESC G Pn1 V
          Grafik_zeichne_vollen_Kreis(CSI_Parameter1);
          Escape_Reset;

    |


  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_GRAFIK_Par_1_Terminal_Mode;





procedure IBM_GRAFIK_Par_2_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_GRAFIK_Par_2_TM;

    |

    $47 : // "G" -- Grafik_setze_Position = ESC G Pn1 ; Pn2 G
          X_PIX_POS:=CSI_Parameter1;
          Y_PIX_POS:=CSI_Parameter2;
          Escape_Reset;

    |

    $50 : // "P" -- Grafik_zeichne_Punkt = ESC G Pn1 ; Pn2 P
          X_PIX_POS:=CSI_Parameter1;
          Y_PIX_POS:=CSI_Parameter2;
          Grafik_setze_Punkt;
          Escape_Reset;

    |

    $4C : // "L" -- Grafik_zeichne_Linie = ESC G Pn1 ; Pn2 L
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          Grafik_zeichne_Linie;
          Escape_Reset;

    |

    $52 : // "R" -- Grafik_zeichne_Rechteck = ESC G Pn1 ; Pn2 R
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          Grafik_zeichne_Rechteck;
          Escape_Reset;

    |

    $46 : // "F" -- Grafik_zeichne_volles_Rechteck = ESC G Pn1 ; Pn2 F
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          Grafik_zeichne_volles_Rechteck;
          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_GRAFIK_Par_2_Terminal_Mode;








procedure CONOUT;
var
  C_Zeichen : Char;
begin

  if Kursor_sichtbar then
    Schalte_Kursor_Aus;
    Kursor_sichtbar:=false;
  endif;
  Kursor_Schleife:=0;
  KurArr_Aktuell:=false;

  // Abspeichern der Escape-Steuerzeichen fuer die
  // Anzeige der nicht ausgewerteter Sequenzen im Fehlerfall
  if TermMode<>Normal_TM then
    C_Zeichen:=ByteToChar(Zeichen);
    Escape_Sequenz:=Escape_Sequenz+C_Zeichen;
  endif;

  case TermMode of

    Normal_TM            : Normal_Terminal_Mode;
    |

    IBM_ESC_TM           : IBM_ESC_Terminal_Mode;
    |

    IBM_CSI_TM           : IBM_CSI_Terminal_Mode;
    |

    IBM_CSI_TM_Par_1     : IBM_CSI_Par_1_Terminal_Mode;
    |

    IBM_CSI_TM_Par_2     : IBM_CSI_Par_2_Terminal_Mode;
    |

    IBM_CSI_TM_Par_3     : IBM_CSI_Par_3_Terminal_Mode;
    |

    IBM_GRAFIK_Par_1_TM  : IBM_GRAFIK_Par_1_Terminal_Mode;
    |

    IBM_GRAFIK_Par_2_TM  : IBM_GRAFIK_Par_2_Terminal_Mode;
    |

  else

    Escape_Fehler;

  endcase;

end CONOUT;





procedure Text_an_CONOUT;
var
  b1 : Byte;
  b2 : Byte;
  c1 : Char;
begin

  b1:=Length(Write_String);

  for b2:=1 to b1 do

    c1:=Write_String[b2];
    Zeichen:=CharToByte(c1);
    CONOUT;

  endfor;

  Zeichen:=$0D;
  CONOUT;

  Zeichen:=$0A;
  CONOUT;

end Text_an_CONOUT;







BEGIN


ASM;
.equ UBRR0 = UBRR0L
ENDASM;

  // Einschwingzeit
  wait_ms(10);


  // Initialisierung der Hardware
  InitPorts;

  INIT_SER_PORT;


  // Initialisierung der Variablen
  setze_Font(fnt_6x8);
  KopieBWS:=true;

  Kursor_Ein:=true;
  Kursor_sichtbar:=false;
  KurArr_Aktuell:=false;
  Kursor_Schleife:=0;

  Escape_Sequenz:='';

  TermMode:=Normal_TM;
  CSI_Parameter1:=0;
  CSI_Parameter2:=0;
  CSI_Parameter3:=0;


  PORTB:= %00000000;
  PORTC:= %00000000;

  ClearBit(A16);
  ClearBit(A17);
  ClearBit(A18);

  SetBit(WE);
  SetBit(OE);

  Seite1_aktiv:=true;
  Umschalten_Speicherseite;

  setze_Font(fnt_8x12);

  Reset_Form;

  Write_String:='Systemtest GCON2 o.k.';
  Text_an_CONOUT;

  Init_BILD_Adresse;

  sende_Zeichen(XON);


  loop

    RX_Puffer_abfragen;


    if Zeichen>0 then

      sende_Zeichen(XON);

      case Zeichen of

        // F09
        $FC : setze_Font(fnt_6x8);
              Reset_Form;
              Anzeige_Zeichensatz;

        |

        // F10
        $FD : BILD_Adresse:=ArrToAdress(STRUGN);
              schreibe_Hintergrund;

        |

        // F11
        $FE : BILD_Adresse:=ArrToAdress(STRURT);
              schreibe_Hintergrund;

        |

        // F12
        $FF : Umschalten_Speicherseite;

        |

      else

        CONOUT;

      endcase;

    endif;


    Inc(Kursor_Schleife);

    if Kursor_Ein then
      if Kursor_Schleife=100000 then
        Kursor_Schleife:=0;
        if Kursor_sichtbar then
          Kursor_sichtbar:=false;
          Schalte_Kursor_Aus;
        else
          Kursor_sichtbar:=true;
          Schalte_Kursor_Ein;
        endif; { if Kursor_Ein then }
      endif; { if Kursor_Schleife=63000 then }
    endif; { if Kursor_Ein then }


  endloop;


END GCON2.
