

  SetBit(WE);
  SetBit(OE);

  DDRA:= %00000000;


  ASM;




; Voreinstellungen
; ----------------


      LDI    TEMP01, 0x00
      MOV    Wert_00H, TEMP01
      LDI    TEMP01, 0xFF
      MOV    Wert_FFH, TEMP01
      LDI    TEMP01, 0x1
      MOV    Wert_1, TEMP01



      ; Loeschen von A16-A18
      CBI    PORTD, C_A16
      CBI    PORTD, C_A17
      CBI    PORTD, C_A18


      // 1. Laden Ziel-Adresse mit Y_ANF

      //  ADR_PORTC mit Y_ANF laden
      MOV    ADR_PORTC, Parameter1
      LSL    ADR_PORTC
      LSL    ADR_PORTC

      //  ADR_PORTD mit 0 laden
      MOV    ADR_PORTD, Wert_00H

      // 2. Laden Quell-Adresse mit Y_ANF+Zeichenhoehe

      //  ADR_PORTC_von mit Y_ANF laden
      MOV    ADR_PORTC_von, Parameter1
      // Addieren der Zeichenhoehe
      ADD    ADR_PORTC_von, Parameter_ZH
      LSL    ADR_PORTC_von
      LSL    ADR_PORTC_von

      //  ADR_PORTD_von mit 0 laden
      MOV    ADR_PORTD_von, Wert_00H

      // ab sofort ist in Parameter_ZH die Differenz
      // Parameter_ZH - Parameter_ZH0 -> das ist die Anzahl der leeren
      // Zeilen nach einer Zeichenzeile
      SUB    Parameter_ZH, Parameter_ZH0
      LSL    Parameter_ZH
      LSL    Parameter_ZH



// ****************************************
// ***** START der Verschiebe-Schleifen ***
// ****************************************



      // ab hier beginnt das Verschieben aller Zeilen

      MOV    CNT_Y2, Parameter_MZ


      // ab hier beginnt das Verschieben einer Zeichen-Zeile

Screen_Roll_F:


      MOV    CNT_Y, Parameter_ZH0


      // ab hier beginnt das Verschieben einer Pixel-Zeile

Screen_Roll_G:


      // Verschieben einer PIXEL-Zeile

      LDI    CNT_X, 32
      CALL   Screen_Roll_UP
      INC    ADR_PORTC
      INC    ADR_PORTC_von

      LDI    CNT_X, 32
      CALL   Screen_Roll_UP
      INC    ADR_PORTC
      INC    ADR_PORTC_von

      LDI    CNT_X, 11
      CALL   Screen_Roll_UP
      INC    ADR_PORTC
      INC    ADR_PORTC_von


      // naechste Zeile
      ADD    ADR_PORTC, Wert_1
      BRCC   Screen_Roll_I

      // beim Ueberlauf von ADR_PORTC wird
      // ADR_PORTD um 1 erhoeht
      INC    ADR_PORTD

Screen_Roll_I:

      // naechste Zeile
      ADD    ADR_PORTC_von, Wert_1
      BRCC   Screen_Roll_J

      // beim Ueberlauf von ADR_PORTC_von wird
      // ADR_PORTD_von um 1 erhoeht
      INC    ADR_PORTD_von

Screen_Roll_J:

      DEC    CNT_Y
      BRNE   Screen_Roll_G


      // ab hier ist eine komplette Zeichen-Zeile kopiert


      // Addieren der leeren Zeilen fuer ADR_PORTC
      ADD    ADR_PORTC, Parameter_ZH
      BRCC   Screen_Roll_C

      // beim Ueberlauf von ADR_PORTC wird
      // ADR_PORTD um 1 erhoeht
      INC    ADR_PORTD

Screen_Roll_C:

      // Addieren der leeren Zeilen fuer ADR_PORTC_von
      ADD    ADR_PORTC_von, Parameter_ZH
      BRCC   Screen_Roll_D

      // beim Ueberlauf von ADR_PORTC_von wird
      // ADR_PORTD_von um 1 erhoeht
      INC    ADR_PORTD_von

Screen_Roll_D:

      // die gesammte Anzahl der zu verschiebenden Zeilen
      // wird nun CNT_Y2 mal wiederholt
      DEC    CNT_Y2
      BRNE   Screen_Roll_F

      JMP    Screen_Roll_END





// ******************************
// Unterprogram Verschieben
// ******************************

Screen_Roll_UP:

      //  ADR_PORTB mit 0 laden
      MOV    ADR_PORTB, Wert_00H

      //  ADR_PORTB mit 0 laden
      MOV    ADR_PORTB_von, Wert_00H


Screen_Roll_A:

     // Lesen und Schreiben der 8 Farb_Speicher

      OUT    PORTC, ADR_PORTC_von


      // setzen vo A16-A18 nach dem Wert von ADR_PORTD_von
      SBRC   ADR_PORTD_von, 0
      SBI    PORTD, C_A16
      SBRS   ADR_PORTD_von, 0
      CBI    PORTD, C_A16

      SBRC   ADR_PORTD_von, 1
      SBI    PORTD, C_A17
      SBRS   ADR_PORTD_von, 1
      CBI    PORTD, C_A17

      SBRC   ADR_PORTD_von, 2
      SBI    PORTD, C_A18
      SBRS   ADR_PORTD_von, 2
      CBI    PORTD, C_A18


      // Lesen von 8 Farb_Speicher


      // PORTA auf Eingang schalten
      OUT    DDRA, Wert_00H
      SBI    PORTD, C_WE


      // lesen Farb_Speicher_01

      OUT    PORTB, ADR_PORTB_von

      NOP
      NOP

      ; ClearBit(OE);
      CBI    PORTD, C_OE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      IN     Farb_Speicher_01, PINA

      NOP
      NOP

      ; SetBit(OE);
      SBI    PORTD, C_OE

      NOP
      NOP

      INC    ADR_PORTB_von

      // lesen Farb_Speicher_02

      OUT    PORTB, ADR_PORTB_von

      NOP
      NOP

      ; ClearBit(OE);
      CBI    PORTD, C_OE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      IN     Farb_Speicher_02, PINA

      NOP
      NOP

      ; SetBit(OE);
      SBI    PORTD, C_OE
      INC    ADR_PORTB_von

      // lesen Farb_Speicher_03

      OUT    PORTB, ADR_PORTB_von

      NOP
      NOP

      ; ClearBit(OE);
      CBI    PORTD, C_OE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      IN     Farb_Speicher_03, PINA

      NOP
      NOP

      ; SetBit(OE);
      SBI    PORTD, C_OE
      INC    ADR_PORTB_von

      // lesen Farb_Speicher_04

      OUT    PORTB, ADR_PORTB_von

      NOP
      NOP

      ; ClearBit(OE);
      CBI    PORTD, C_OE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      IN     Farb_Speicher_04, PINA

      NOP
      NOP

      ; SetBit(OE);
      SBI    PORTD, C_OE
      INC    ADR_PORTB_von

      // lesen Farb_Speicher_05

      OUT    PORTB, ADR_PORTB_von

      NOP
      NOP

      ; ClearBit(OE);
      CBI    PORTD, C_OE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      IN     Farb_Speicher_05, PINA

      NOP
      NOP

      ; SetBit(OE);
      SBI    PORTD, C_OE
      INC    ADR_PORTB_von

      // lesen Farb_Speicher_06

      OUT    PORTB, ADR_PORTB_von

      NOP
      NOP

      ; ClearBit(OE);
      CBI    PORTD, C_OE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      IN     Farb_Speicher_06, PINA

      NOP
      NOP

      ; SetBit(OE);
      SBI    PORTD, C_OE
      INC    ADR_PORTB_von

      // lesen Farb_Speicher_07

      OUT    PORTB, ADR_PORTB_von

      NOP
      NOP

      ; ClearBit(OE);
      CBI    PORTD, C_OE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      IN     Farb_Speicher_07, PINA

      NOP
      NOP

      ; SetBit(OE);
      SBI    PORTD, C_OE
      INC    ADR_PORTB_von

      // lesen Farb_Speicher_08

      OUT    PORTB, ADR_PORTB_von

      NOP
      NOP

      ; ClearBit(OE);
      CBI    PORTD, C_OE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      IN     Farb_Speicher_08, PINA

      NOP
      NOP

      ; SetBit(OE);
      SBI    PORTD, C_OE
      INC    ADR_PORTB_von





;      MOV    Farb_Speicher_01, Wert_00H
;      MOV    Farb_Speicher_02, Wert_FFH
;      MOV    Farb_Speicher_03, Wert_00H
;      MOV    Farb_Speicher_04, Wert_FFH
;      MOV    Farb_Speicher_05, Wert_00H
;      MOV    Farb_Speicher_06, Wert_FFH
;      MOV    Farb_Speicher_07, Wert_00H
;      MOV    Farb_Speicher_08, Wert_FFH






      // Schreiben der 8 Farb_Speicher

      OUT    PORTC, ADR_PORTC


      // setzen vo A16-A18 nach dem Wert von ADR_PORTD
      SBRC   ADR_PORTD, 0
      SBI    PORTD, C_A16
      SBRS   ADR_PORTD, 0
      CBI    PORTD, C_A16

      SBRC   ADR_PORTD, 1
      SBI    PORTD, C_A17
      SBRS   ADR_PORTD, 1
      CBI    PORTD, C_A17

      SBRC   ADR_PORTD, 2
      SBI    PORTD, C_A18
      SBRS   ADR_PORTD, 2
      CBI    PORTD, C_A18


      // PORTA auf Ausgang schalten
      OUT    DDRA, Wert_FFH


      // schreiben Farb_Speicher_01

      OUT    PORTB, ADR_PORTB

      OUT    DDRA, Wert_FFH
      OUT    PORTA, Farb_Speicher_01

      NOP
      NOP

     ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      OUT    DDRA, Wert_00H

      INC    ADR_PORTB

      // schreiben Farb_Speicher_02

      OUT    PORTB, ADR_PORTB
      OUT    DDRA, Wert_FFH
      OUT    PORTA, Farb_Speicher_02

      NOP
      NOP

     ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      OUT    DDRA, Wert_FFH

      INC    ADR_PORTB

      // schreiben Farb_Speicher_03

      OUT    PORTB, ADR_PORTB
      OUT    DDRA, Wert_FFH
      OUT    PORTA, Farb_Speicher_03

      NOP
      NOP

     ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      OUT    DDRA, Wert_00H

      INC    ADR_PORTB

      // schreiben Farb_Speicher_04

      OUT    PORTB, ADR_PORTB
      OUT    DDRA, Wert_FFH
      OUT    PORTA, Farb_Speicher_04

      NOP
      NOP

     ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      OUT    DDRA, Wert_00H

      INC    ADR_PORTB

      // schreiben Farb_Speicher_05

      OUT    PORTB, ADR_PORTB
      OUT    DDRA, Wert_FFH
      OUT    PORTA, Farb_Speicher_05

      NOP
      NOP

      ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      OUT    DDRA, Wert_00H

      INC    ADR_PORTB

      // schreiben Farb_Speicher_06

      OUT    PORTB, ADR_PORTB
      OUT    DDRA, Wert_FFH
      OUT    PORTA, Farb_Speicher_06

      NOP
      NOP

      ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      OUT    DDRA, Wert_00H

      INC    ADR_PORTB

      // schreiben Farb_Speicher_07

      OUT    PORTB, ADR_PORTB
      OUT    DDRA, Wert_FFH
      OUT    PORTA, Farb_Speicher_07

      NOP
      NOP

      ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      OUT    DDRA, Wert_00H

      INC    ADR_PORTB

      // schreiben Farb_Speicher_08

      OUT    PORTB, ADR_PORTB
      OUT    DDRA, Wert_FFH
      OUT    PORTA, Farb_Speicher_08

      NOP
      NOP

      ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      OUT    DDRA, Wert_00H

      INC    ADR_PORTB

      // PORTA auf Eingang schalten
      OUT    DDRA, Wert_00H

      // das Lesen und Schreiben der 8 Speicherstellen
      // wird nun CNT_X mal wiederholt
      DEC    CNT_X
      BREQ   Screen_Roll_B

      JMP    Screen_Roll_A

      // ab hier ist eine Teil-Pixel-Zeile vollstaendig kopiert
Screen_Roll_B:

      RET

// ******************************
// *** ENDE - Unterprogram Verschieben
// ******************************


Screen_Roll_END:




  ENDASM;

  SetBit(WE);
  SetBit(OE);

  DDRA:= %00000000;








