PROGRAM CONIO2;

// Version 1.02 vom 27.01.2015


DEVICE = mega328p;

{$I mega328P_Register.INC}


CONST



  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 22118;

  // bei 22,118 MHz ->
  UBRR_VAL : Byte = 1;


  XON  : Byte = $11;
  XOFF : Byte = $13;

  Char_Null : Char = #0;
  Char_FC   : Char = #252;
  Char_FD   : Char = #253;
  Char_FE   : Char = #254;
  Char_FF   : Char = #255;


// *** Tastatur-Konstanten ***


  // LedState
  no_LED_State : Byte = %00000000;
  LEDScroll    : Byte = %00000001;
  LEDNum       : Byte = %00000010;
  LEDCaps      : Byte = %00000100;


  // KeybState
  KeyStat_Byte1 : Byte = 1;  // KeyStat_Byte1 = normaler Tastaturcode (1 Byte)
  KeyStat_E0    : Byte = 2;  // KeyStat_E0 = erweiterter Tataturcode beginnt mit E0 (z.B. fuer INSERT, HOME, PRINT ...)
  KeyStat_F0    : Byte = 3;  // KeyStat_F0 = freigesetzt BREAK beginnt mit F0 (Taste wird losgelassen - auch nach Repetierung)

  // KbShiftState
  no_ShiftState : Byte = %00000000;
  shShift       : Byte = %00100000;
  shCtrl        : Byte = %00010000;
  shAlt         : Byte = %00001000;
  shCaps        : Byte = %00000100;
  shNum         : Byte = %00000010;
  shScroll      : Byte = %00000001;



  CodeTab_NORMAL : array[0..$7F] of Char =
  (
  { *** Tabelle SCAN-Code - ohne SHIFT *** }
  { 00-0F / 00-15 }
{  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  }
{      F9        F5   F3   F1   F2  F12       F10   F8   F6   F4  TAB   ^        }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #09, '^',  #0,
  { 10-1F / 16-31 }
{    LAlt  LSh      Strg   Q    1                   Y    S    A    W    2        }
  #0,  #0,  #0,  #0,  #0, 'q', '1',  #0,  #0,  #0, 'y', 's', 'a', 'w', '2',  #0,
  { 20-2F / 32-47 }
{      C    X    D    E    4    3            Spac   V    F    T    R    5        }
  #0, 'c', 'x', 'd', 'e', '4', '3',  #0,  #0, ' ', 'v', 'f', 't', 'r', '5',  #0,
  { 30-3F / 48-63 }
{      N    B    H    G    Z    6                   M    J    U    7    8        }
  #0, 'n', 'b', 'h', 'g', 'z', '6',  #0,  #0,  #0, 'm', 'j', 'u', '7', '8',  #0,
  { 40-4F / 64-79 }
{      ,    K    I    O    0    9              .    -    L    Ö    P    ß        }
  #0, ',', 'k', 'i', 'o', '0', '9',  #0,  #0, '.', '-', 'l', 'o', 'p', '\',  #0,
  { 50-5F / 80-95 }
{           Ä         Ü    ´            CaLo  RSh Retu   +         #             }
  #0,  #0, 'a',  #0, 'u', #39,  #0,  #0,  #0,  #0, #13, '+',  #0, '#',  #0,  #0,
  { 60-6F / 96-111 }
{                               BS                                               }
  #0,  #0,  #0,  #0,  #0,  #0,#127,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 70-7F / 112-127 }
{                              Esc  Num  F11                          Roll       }
  #0,  #0,  #0,  #0,  #0,  #0, #27,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0);



  CodeTab_SHIFT : array[0..$7F] of Char =
  (
  { *** Tabelle SCAN-Code - mit SHIFT *** }
  { 00-0F / 00-15 }
{  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  }
{      F9        F5   F3   F1   F2  F12       F10   F8   F6   F4  TAB   ^       }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #09, '^',  #0,
  { 10-1F / 16-31 }
{    LAlt  LSh      Strg   Q    1                   Y    S    A    W    2        }
  #0,  #0,  #0,  #0,  #0, 'Q', '!',  #0,  #0,  #0, 'Y', 'S', 'A', 'W', '"',  #0,
  { 20-2F / 32-47 }
{      C    X    D    E    4    3            Spac   V    F    T    R    5        }
  #0, 'C', 'X', 'D', 'E', '$', '#',  #0,  #0, ' ', 'V', 'F', 'T', 'R', '%',  #0,
  { 30-3F / 48-63 }
{      N    B    H    G    Z    6                   M    J    U    7    8        }
  #0, 'N', 'B', 'H', 'G', 'Z', '&',  #0,  #0,  #0, 'M', 'J', 'U', '/', '(',  #0,
  { 40-4F / 64-79 }
{      ,    K    I    O    0    9              .    -    L    Ö    P    ß        }
  #0, ';', 'K', 'I', 'O', '=', ')',  #0,  #0, ':', '_', 'L', 'O', 'P', '?',  #0,
  { 50-5F / 80-95 }
{           Ä         Ü    ´            CaLo  RSh Retu   +         #             }
  #0,  #0, 'A',  #0, 'U', #96,  #0,  #0,  #0,  #0, #13, '*',  #0, #39,  #0,  #0,
  { 60-6F / 96-111 }
{                               BS                                               }
  #0,  #0,  #0,  #0,  #0,  #0,#127,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 70-7F / 112-127 }
{                              Esc  Num  F11                          Roll       }
  #0,  #0,  #0,  #0,  #0,  #0, #27,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0);



  CodeTab_CTRL : array[0..$7F] of Char =
  (
  { *** Tabelle SCAN-Code - mit CTRL *** }
  { 00-0F / 00-15 }
{  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  }
{      F9        F5   F3   F1   F2  F12       F10   F8   F6   F4  TAB   ^       }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #09, #30,  #0,
  { 10-1F / 16-31 }
{    LAlt  LSh      Strg   Q    1                   Y    S    A    W    2        }
  #0,  #0,  #0,  #0,  #0, #17,  #0,  #0,  #0,  #0, #25, #19, #01, #23,  #0,  #0,
  { 20-2F / 32-47 }
{      C    X    D    E    4    3            Spac   V    F    T    R    5        }
  #0, #03, #24, #04, #05,  #0,  #0,  #0,  #0, ' ', #22, #06, #20, #18,  #0,  #0,
  { 30-3F / 48-63 }
{      N    B    H    G    Z    6                   M    J    U    7    8        }
  #0, #14, #02, #08, #07, #26,  #0,  #0,  #0,  #0, #13, #10, #21,  #0, #27,  #0,
  { 40-4F / 64-79 }
{      ,    K    I    O    0    9              .    -    L    Ö    P    ß        }
  #0,  #0, #11, #09, #15,  #0, #29,  #0,  #0,  #0,  #0, #12, #15, #16, #28,  #0,
  { 50-5F / 80-95 }
{           Ä         Ü    ´            CaLo  RSh Retu   +         #             }
  #0,  #0, #01,  #0, #21,  #0,  #0,  #0,  #0,  #0, #13,  #0,  #0,  #0,  #0,  #0,
  { 60-6F / 96-111 }
{                               BS                                               }
  #0,  #0,  #0,  #0,  #0,  #0,#127,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 70-7F / 112-127 }
{                              Esc  Num  F11                          Roll       }
  #0,  #0,  #0,  #0,  #0,  #0, #27,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0);



  CodeTab_ALT : array[0..$7F] of Char =
  (
  { *** Tabelle SCAN-Code - mit ALT *** }
  { 00-0F / 00-15 }
{  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  }
{      F9        F5   F3   F1   F2  F12       F10   F8   F6   F4  TAB   ^       }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #09,  #0,  #0,
  { 10-1F / 16-31 }
{    LAlt  LSh      Strg   Q    1                   Y    S    A    W    2        }
  #0,  #0,  #0,  #0,  #0, '@',  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 20-2F / 32-47 }
{      C    X    D    E    4    3            Spac   V    F    T    R    5        }
  #0,  #0,  #0,  #0, #36,  #0, '#',  #0,  #0, ' ',  #0,  #0,  #0,  #0,  #0,  #0,
  { 30-3F / 48-63 }
{      N    B    H    G    Z    6                   M    J    U    7    8        }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, '{', '[',  #0,
  { 40-4F / 64-79 }
{      ,    K    I    O    0    9              .    -    L    Ö    P    ß        }
  #0,  #0,  #0,  #0,  #0, '}', ']',  #0,  #0,  #0,  #0,  #0,  #0,  #0, '\',  #0,
  { 50-5F / 80-95 }
{           Ä         Ü    ´            CaLo  RSh Retu   +         #             }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #13, '~',  #0,  #0,  #0,  #0,
  { 60-6F / 96-111 }
{                               BS                                               }
  #0,  #0,  #0,  #0,  #0,  #0,#127,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 70-7F / 112-127 }
{                              Esc  Num  F11                          Roll       }
  #0,  #0,  #0,  #0,  #0,  #0, #27,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0);




  // keyboard codes
  // 1 Byte
  kbdNum         : byte      = $77;
  kbdCaps        : byte      = $58;
  kbdScroll      : byte      = $7E;
  kbdAlt         : byte      = $11;
  kbdCtrl        : byte      = $14;
  kbdLShift      : byte      = $12;
  kbdRShift      : byte      = $59;

  kbdEnter       : Byte      = $5A;
  kbdSpace       : Byte      = $29;
  kbdBS          : Byte      = $66;
  kbdTab         : Byte      = $0D;
  kbdESC         : Byte      = $76;



  kbdF1          : byte      = $05;
  kbdF2          : byte      = $06;
  kbdF3          : byte      = $04;
  kbdF4          : byte      = $0C;
  kbdF5          : byte      = $03;
  kbdF6          : byte      = $0B;
  kbdF7          : byte      = $83;
  kbdF8          : byte      = $0A;
  kbdF9          : byte      = $01;
  kbdF10         : byte      = $09;
  kbdF11         : byte      = $78;
  kbdF12         : byte      = $07;



  // 2 Byte - E0 XX
  kbdRGUI        : byte      = $27;
  kbdLGUI        : byte      = $1F;
  kbdApps        : byte      = $2F;



  // 4 Byte - E0 12 E0 XX
  kbdEnd         : byte      = $69;  // Ende
  kbdHome        : byte      = $6C;  // Pos1

  kbdUp          : Byte      = $75;
  kbdDn          : Byte      = $72;
  kbdLeft        : Byte      = $6B;
  kbdRight       : Byte      = $74;

  kbdPgUp        : Byte      = $7D;
  kbdPgDn        : Byte      = $7A;

  kbdInsert      : byte      = $70;
  kbdDelete      : byte      = $71;

  kbdPrint       : byte      = $12;



  // E1 14 77 E1 F0 14 F0 77
  kbdPause       : byte      = $E1;



  scanBreak      : byte      = $F0;
  scanExt        : byte      = $E0;



  // special chars send to host
  hstScroll      : byte      = $00;

  hstPrint       : byte      = $10; // Ctrl-P
  hstIns         : byte      = $16; // Ctrl-V
  hstHome        : byte      = $00;
  hstPgUp        : byte      = $12; // Ctrl-R
  hstPgDn        : byte      = $03; // Ctrl-C
  hstDel         : byte      = $08; // Ctrl-H
  hstEnd         : byte      = $00;
  hstLeft        : byte      = $13;  // Ctrl-S
  hstRight       : byte      = $04;  // Ctrl-D
  hstUp          : byte      = $05;  // Ctrl-E
  hstDn          : byte      = $18;  // Ctrl-X
  hstRGUI        : byte      = $00;
  hstLGUI        : byte      = $00;
  hstApps        : byte      = $00;

  hstF1          : byte      = $80;
  hstF2          : byte      = $81;
  hstF3          : byte      = $82;
  hstF4          : byte      = $83;
  hstF5          : byte      = $84;
  hstF6          : byte      = $85;
  hstF7          : byte      = $86;
  hstF8          : byte      = $87;
  hstF9          : byte      = $88;
  hstF10         : byte      = $89;
  hstF11         : byte      = $8A;
  hstF12         : byte      = $8B;




// *** ITP2-Konstanten ***



  // BA_Mode
  BA_mode_keineBA : Byte = 0;
  BA_mode_INI     : Byte = 1;
  BA_mode_SET_WR  : Byte = 2;
  BA_mode_WR      : Byte = 3;
  BA_mode_SET_RD  : Byte = 4;
  BA_mode_RD      : Byte = 5;


  // RECEIVE_MODE
  NO_RECEIVE_MODE    : Byte = 0;
  RECEIVE_CONST      : Byte = 1;
  RECEIVE_CONIN      : Byte = 2;
  RECEIVE_CONOUT     : Byte = 3;
  RECEIVE_DEVCODE    : Byte = 4;
  RECEIVE_ERROR_CODE : Byte = 5;


  // SEND_MODE
  NO_SEND_MODE : Byte = 0;
  SEND_CONOUT  : Byte = 1;
  SEND_LIST    : Byte = 2;


  RE_CONST   : BYTE = 1;  // Code fuer RECEIVE CONST
  RE_CONIN   : BYTE = 2;  // Code fuer RECEIVE CONIN
  SE_CONOUT  : BYTE = 3;  // Code fuer SEND CONOUT
  RE_SECNT   : BYTE = 4;  // Code fuer RECEIVE SECTOR COUNT
  RE_SECTOR  : BYTE = 5;  // Code fuer RECEIVE SECTOR
  RE_RD_ISEC : BYTE = 6;  // Code fuer RECEIVE READ IMAGE SECTOR
  SE_WR_ISEC : BYTE = 7;  // Code fuer SEND WRITE IMAGE SECTOR
  SE_STD     : BYTE = 8;  // Code fuer SEND SECTOR, TRACK, DRIVE
  SE_LIST    : BYTE = 9;  // Code fuer SEND LIST
  RE_ERROR_CODE
             : BYTE = 10;  // Code fuer RECEIVE ERROR CODE



  RE_WHO_ARE_YOU
           : BYTE = 20; // Code fuer Abfrage der Funktionalitaet
			//  des angeschlossenen Geraetes


// ------------------------------------------------------

  DEVCODE_PC_CPM_EMU   : BYTE = 2;  // Code fuer PC-CP/M-Emulator
  DEVCODE_KEYBOARD     : BYTE = 3;  // Code fuer Tastatur
  DEVCODE_DISPLAY      : BYTE = 4;  // Code fuer LCD-Display
  DEVCODE_RAMFLOPPY    : BYTE = 5;  // Code fuer RAM-Floppy
  DEVCODE_CONINOUT     : BYTE = 6;  // Code fuer Tastatur und Display
  DEVCODE_SOUND        : BYTE = 7;  // Code fuer Tonausgabe


// Nachricht auf die Anfrage "Wer bist Du?" RE_WHO_ARE_YOU ist
// die Nachricht "Wer bin ich?" MESSAGE_WHO_AM_I
//
//  !!!!! Achtung diese Zeile muss bei jedem Geraet angepasst werden !!!!!
//

   MESSAGE_WHO_AM_I    : BYTE = DEVCODE_CONINOUT;



VAR
  SUMMER[PortB, 0] : bit; // A
  LED_GN[PortB, 1] : bit; // A
  Taste_01[PINB,2] : bit; // E

  KEY_CLK_A[PortD, 2] : bit; // A
  KEY_CLK_E[PinD, 2]  : bit; // E
  KEY_CLK_D[DDRD, 2]  : bit; // D

  KEY_DAT_A[PortD, 3] : bit; // A
  KEY_DAT_E[PinD, 3]  : bit; // E
  KEY_DAT_D[DDRD, 3]  : bit; // D



  Steuer_String : String[50];
  Text_String : String[15];


  // PC keyboard Variablen
  BitCntr, KeybState,
  LedState, LocalByte,
  KbShiftState, tmpByte : Byte;

  CAPS_pressed, NUM_pressed,
  Scroll_pressed, doClick,
  InitFailed, LocalMode : Boolean;

  ch     : char;

  // Puffer fuer den SCAN-Code der Tastatur
  SCANBuffer      : array [0..32] of byte;
  SCANBufferPtr   : Word;

  // Puffer fuer die (aus dem SCAN-Code konvertierten) Tasten-Bytes
  KeyBuffer      : array [0..32] of byte;
  keyBufferPtr   : Word;

  SCAN_Zeichen : Byte;



// *** ITP2-Variablen ***


  BA_Mode, RECEIVE_MODE, SEND_MODE,
  ERROR_CODE, ERROR_PARAM, Sound_Byte,
  Lade_Byte : Byte;


  DDWR_E[PIND, 4]   : bit; // E

  DDAC_A[PortD, 5]  : bit; // A

  CDEN_E[PIND, 6]   : bit; // E
  CDEN_A[PortD, 6]  : bit; // A
  CDEN_P[DDRD, 6]   : bit; // P { 1=Ausgang, 0=Eingang }

  CRAC_A[PortD, 7]  : bit; // A
  CRAC_E[PIND, 7]   : bit; // E
  CRAC_P[DDRD, 7]   : bit; // P { 1=Ausgang, 0=Eingang }


  // sonstige Variablen
  TX_warten : Boolean;
  AusgabeByte : Byte;






// System (WaitMS)
{$I SYSTEM.INC}

// serielle Schnittstelle ohne Interrupt
{$I mega328P_UART_oI.INC}


// I2C/TWI
{$I mega328P_TWI_MA.INC}





procedure InitPorts;
begin

{
  SUMMER[PortB, 0] : bit; // A
  LED_GN[PortB, 1] : bit; // A
  Taste_01[PINB,2] : bit; // E
  PB3 -> MISO
  PB4 -> SCK
  PB5 -> MOSI
}
  //       EEEEEEAA
  DDRB:=  %00000011;

  // PORT B Voreinstellungen
  PORTB:= %00000100;


{
  PC0..4 -> ITP2-Daten // E
  PC4 -> SDA  // E
  PC5 -> SCL  // E
}
  //       EEEEEEEE
  DDRC:=  %00000000;

  // PORT C Voreinstellungen
  PORTC:= %00000000;


{
  PD0 -> RXD      // E
  PD1 -> TXD      // A
  PD2 -> KEY_CLK  // E
  PD3 -> KEY_DAT  // E
  DDWR_E[PIND, 4]   : bit; // E
  DDAC_A[PortD, 5]  : bit; // A
  CDEN_E[PIND, 6]   : bit; // E
  CRAC_E[PIND, 7]   : bit; // E
}

  //       EEAEEEAE
  DDRD:=  %00100010;

end InitPorts;







procedure Init_INT0;
begin


//PCICR |= (1 << PCIE0);
// PCMSK0 |= (1 << PCINT0);



//  DDRD:= DDRD or %00100000;

  // init port interrupt INT0
  // Bit 1 -> ISC01 = 1
  // Bit 0 -> ISC00 = 0
  // 10 -> fallende Flanke löst den Interrupt aus
  //
  // MCUCR:= MCUCR or %00000010; // falling edge INT0
  EICRA := EICRA or %00000010; // falling edge INT0


  // GIFR := GIFR or %01000000;  // reset  INT0
  // EIMSK (External Interrupt Mask Register)
  // Bit 0 – INT0: External Interrupt Request 0 Enable
  // When the INT0 bit is set (one) and the I-bit in the Status Register (SREG)
  // is set (one), the external pin interrupt is enabled.
  // The Interrupt Sense Control0 bits 1/0 (ISC01 and ISC00) in the
  // External Interrupt Control Register A (EICRA) define whether the external
  // interrupt is activated on rising and/or falling edge of the INT0
  // pin or level sensed. Activity on the pin will cause an interrupt request
  // even if INT0 is configured as an output.
  // The corresponding interrupt of External Interrupt Request 0 is
  // executed from the INT0 Interrupt Vector.
  EIMSK := EIMSK or %00000001;


  // GICR := GICR or %01000000;  // enable INT0
  // EIFR – External Interrupt Flag Register
  // Bit 0 – INTF0: External Interrupt Flag 0
  // When an edge or logic change on the INT0 pin triggers an interrupt request,
  // INTF0 becomes set (one). If the I-bit in SREG and the INT0 bit in EIMSK
  // are set (one), the MCU will jump to the corresponding Interrupt Vector.
  // The flag is cleared when the interrupt routine is executed.
  // Alternatively, the flag can be cleared by writing a logical one to it.
  // This flag is always cleared when INT0 is configured as a level interrupt.
  EIFR := EIFR or %00000001;


end Init_INT0;












// *************************************************************


procedure Ton_Sirene(Dauer : Word);
var
  Frequenz : Word;
begin

  for Frequenz:=Dauer downto 1 do

    SetBit(SUMMER);
    wait_ms(Frequenz);
    ClearBit(SUMMER);
    wait_ms(Frequenz);

  endfor;

  for Frequenz:=1 to Dauer do

    SetBit(SUMMER);
    wait_ms(Frequenz);
    ClearBit(SUMMER);
    wait_ms(Frequenz);

  endfor;

end Ton_Sirene;



procedure Click;
begin
  Ton_Sirene(1);
end Click;







// *** Unterprogramme serielle Schnittstelle ***




procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    SER0_Zeichen:=UDR0;

    if SER0_Zeichen=XON then
      TX_warten:=false;
    else
      if SER0_Zeichen=XOFF then
        TX_warten:=true;
      else
        Ton_Sirene(20);
      endif; { if empfangenes_Zeichen=XOFF then }
    endif; { if SER0_Zeichen=XON then }

  else
    SER0_Zeichen:=0;
  endif; { if BitHigh(RXC0) then }

end RX_Puffer_abfragen;










// *** Unterprogramme zum SCAN-Buffer ***



procedure write_SCAN(write_SCAN_value : byte);
begin
  if SCANBufferPtr<32 then
    inc(SCANBufferPtr);
    SCANBuffer[SCANBufferPtr]:=write_SCAN_value;
  endif;
end write_SCAN;





function read_SCAN : Byte;
var
  read_SCAN_value : Byte;
  SCAN_counter : Word;
  b1 : Byte;
begin
  read_SCAN_value:=SCANBuffer[1];
  dec(SCANBufferPtr);
  if SCANBufferPtr>0 then
    for SCAN_counter:=1 to SCANBufferPtr do
      b1 := SCANBuffer[SCAN_counter+1];
      SCANBuffer[SCAN_counter] := b1;
    endfor;
  endif;

  Result:=read_SCAN_value;

end  read_SCAN;








// *** Unterprogramme zum key-Buffer ***




function read_key : Byte;
var
  read_key_value : Byte;
  key_counter : Word;
  b1 : Byte;
begin
  DisableInts;
  read_key_value:=KeyBuffer[1];
  dec(keyBufferPtr);
  if keyBufferPtr>0 then
    for key_counter:=1 to keyBufferPtr do
      b1 := KeyBuffer[key_counter+1];
      KeyBuffer[key_counter] := b1;
    endfor;
  endif;
  EnableInts;

  Result:=read_key_value;

end read_key;





procedure write_key(write_key_value : byte);
begin
  DisableInts;
  if keyBufferPtr<32 then
    inc(keyBufferPtr);
    KeyBuffer[keyBufferPtr]:=write_key_value;
  endif;
  EnableInts;
end write_key;



procedure write_c_key(cKey : char);
var
  b1 : Byte;
begin
  b1:=CharToByte(cKey);
  write_key(b1);
end write_c_key;




procedure write_text;
var
  Zaehler : Byte;
  c1 : Char;
begin
  for zaehler:=1 to length(Text_String) do
    c1:=Text_String[Zaehler];
    write_c_key(c1);
  endfor;
end write_text;




procedure SendKey(sKey : byte);
var
  c1 : Char;
  b1 : Byte;
begin

  b1 := $0D;
  c1:=ByteToChar(b1);

  case sKey of

    $00 : Ton_Sirene(20);
      |

    $80 : Text_String:='DIR'+c1;
          write_text; // F1
      |

    $81 : Text_String:='POWER'+c1;
          write_text; // F2

      |
    $82 : Text_String:='COPY'+c1;
          write_text; // F3

      |
    $83 : Text_String:='ERA'+c1;
          write_text; // F4

      |
    $84 : Text_String:='TYPEX'+c1;
          write_text; // F5

      |
    $85 : Text_String:='EXIT'+c1;
          write_text; // F6

      |
    $86 : Text_String:='TURBO'+c1;
          write_text; // F7

      |

    $87 : Text_String:='TURBO'+c1;
          write_text; // F8

      |

    $88 : c1:=Char_FC;
          Text_String:=c1;
          write_text; // F9

      |

    $89 : c1:=Char_FD;
          Text_String:=c1;
          write_text; // F10

      |

    $8A : c1:=Char_FE;
          Text_String:=c1;
          write_text; // F11

      |

    $8B : c1:=Char_FF;
          Text_String:=c1;
          write_text; // F12

      |


  else
    write_key(sKey);
  endcase;
end SendKey;


procedure SendKeyChar(sKey : char);
var
  b1 : Byte;
begin

  b1:=CharToByte(sKey);
  SendKey(b1);

end SendKeyChar;





// *********************************

// Tastatur - Hardware- Routinen

// *********************************









isr EI_INT0;
begin

ASM;
  PUSH   R18
ENDASM;


  if InitFailed then
  else

    // Bit 3 to 10 is data. Parity bit,
    // if (BitCntr in [3..10]) then
    if BitCntr>2 then
      if BitCntr<11 then

        // tmpByte:= tmpByte shr 1;  // start and stop bits are ignored.
        SHR(tmpByte);

        // setBit(tmpByte, 7, PinD.3);
        if BitHigh(KEY_DAT_E) then
          tmpByte:= tmpByte or %10000000;
        else
          tmpByte:= tmpByte and %01111111;
        endif;

      endif; //  if BitCnt<11 then
    endif; // if BitCnt>2 then


    dec (BitCntr);

    if BitCntr = 0 then                // All bits received
      BitCntr:= 11;
      if LocalMode then
        LocalByte:= tmpByte;
        LocalMode:= false;
      else

        ASM;
          PUSH   R0
          PUSH   R17
          PUSH   R19
          PUSH   R24
          PUSH   R25
          PUSH   ZL
          PUSH   ZH
        ENDASM;

        write_SCAN(tmpByte);

        ASM;
          POP   ZH
          POP   ZL
          POP   R25
          POP   R24
          POP   R19
          POP   R17
          POP   R0
        ENDASM;

      endif;
    endif;      // BitCntr = 0

  endif; // else InitFailed

ASM;
  POP   R18
ENDASM;

end EI_INT0;












// Grundeinstellungen der Variablen fuer
// die Tastarurabfrage
Procedure InitKeyb;
begin
  BitCntr:= 11;
  KeybState:= KeyStat_Byte1;

  SCANBufferPtr:=0;
end InitKeyb;




procedure Set_Kbd_clk;
begin
  BitCntr:= 11;

  // reset INT0
  EIFR := EIFR or %00000001;

  // PortD.2:= 1;
  SetBit(KEY_CLK_A);

  // DDRD.2:= 0; -> Taktleitung auf Eingang
  ClearBit(KEY_CLK_D);

  EnableInts;
end Set_Kbd_clk;



procedure Reset_Kbd_clk;
begin

  DisableInts;

  BitCntr:= 11;

  // PortD.2:= 0;
  ClearBit(KEY_CLK_A);

  // DDRD.2:= 1; -> Taktleitung auf Ausgang
  SetBit(KEY_CLK_D);

end Reset_Kbd_clk;




function NOT_PARITY(das_Byte : Byte) : Boolean;
var
  Ergebnis : Boolean;
  b2 : Byte;
  b3 : Byte;
  b4 : Byte;
begin

  b3 :=0;

  for b4:=0 to 7 do
    b2 := das_Byte and %00000001;
    if b2=%00000001 then
      Inc(b3);
    endif;
    SHR(das_Byte);
  endfor;

  b2 := b3 and %00000001;
  if b2=%00000001 then
    Ergebnis:=false;
  else
    Ergebnis:=true;
  endif;

  Result:=Ergebnis;
end NOT_PARITY;





// Transmit Byte to Keyboard
procedure SendToKbd(b1 : Byte);
var
  p    : boolean;
  w    : word;
  cnt  : byte;
  reg  : byte;
  test : byte;
begin

  DisableInts;

  // p := not Parity(b1);
  p:=NOT_PARITY(b1);

  // DDRD.2 := 0; -> Taktleitung auf Eingang
  ClearBit(KEY_CLK_D);

  // check clock line
  w:= 60000;

  {
  repeat
    dec(w);
  until PinD.2 and (w > 0);
  }
  while w>5 do

    dec(w);

    test := PinD and %00000100;

    if test=%00000100 then
      w:=2;
    endif;

  endwhile;

  // Ist die Datenleitung nun High -> dann gehts weiter
  if w=2 then


    // Bring the Clock line low for at least 100 microseconds.
    // DDRD.2 := 1;  -> Taktleitung auf Ausgang
    SetBit(KEY_CLK_D);

    // PortD.2 := 0;
    ClearBit(KEY_CLK_A);

    // mDelay(100);
    wait_ms(100);

    // Bring the Data line low.
    // PortD.3 := 0;
    ClearBit(KEY_DAT_A);

    // DDRD.3 := 1;  -> Datenleitung auf Ausgang
    SetBit(KEY_DAT_D);

    // Release the Clock line.
    // PortD.2 := 1;
    SetBit(KEY_CLK_A);

    // DDRD.2 := 0; -> Taktleitung auf Eingang
    ClearBit(KEY_CLK_D);


    // Wait for the device to bring the Clock line low.
    w:= 60000;

    {
    repeat
      dec(w);
    until not PinD.2 and (w > 0);
    }

    while w>5 do

      dec(w);

      test := PinD and %00000100;

      if test=%00000000 then
        w:=2;
      endif;

    endwhile;


    // Ist die Datenleitung nun Low -> dann gehts weiter
    if w=2 then


  // R16/R17 (_ACCA/_ACCB)


  ASM;

    // Sending the 8 bit data

    // R16:=B1
    MOV    R16, R0

    // Zaehler in R17
    LDI    R17, 8

M_tx_data:
    // Bit 0 in C
    ROR    R16

    // Set/reset the Data line to send the first data bit
    BRCS     M_tx_data0

    // set databit -> 0
    CBI    PortD, 3
    RJMP     M_tx_data1

M_tx_data0:
    // set databit -> 1
    SBI    PortD, 3

M_tx_data1:
    // Wait for the device to bring Clock high.
    SBIS   PIND, 2
    RJMP   M_tx_data1;         // wait till CLK rise

M_tx_data2:
    // Wait for the device to bring Clock low.
    SBIC   PIND, 2
    RJMP   M_tx_data2;         // now wait till CLK falls down

    // next bit please ...
    DEC    R17
    BRNE   M_tx_data


  ENDASM;


  // PARITY BIT
  // ????? even/odd ????????

  // _ACCA.0 := P;
  if P then
    reg := reg or %00000001;
  else
    reg := reg and %11111110;
  endif;

  ASM;

    // R16:=reg
    MOV    R16, R5

    ROR    R16
    BRCS   M_tx_data3

    // set databit -> 0
    CBI    PortD, 3
    RJMP   M_tx_data5

M_tx_data3:
    // set databit -> 1
    SBI    PortD, 3


M_tx_data5:
    // Wait for the device to bring Clock high.
    SBIS   PIND, 2
    RJMP   M_tx_data5;     // wait till CLK rise

    M_tx_data6:
    // Wait for the device to bring Clock low.
    SBIC   PIND, 2
    RJMP   M_tx_data6;     // now wait till CLK falls down

    // Getting stopbit
    SBI PortD, 3

    M_tx_data7:
    // waiting until clock will rise
    SBIS   PIND, 2
    RJMP   M_tx_data7;     // wait till CLK rise

    // Now release the Data line.
    //  DDRD.3 := 0;
    CBI    DDRD, 3;

  ENDASM;


  // Wait for the device to bring Data and Clock low.
  // repeat
  // until not PinD.3 and not PinD.2;

      w:=0;
      while w<2 do

        w:=0;

        test := PinD and %00000100;

        if test=%00000000 then
          Inc(w);
        endif;

        test := PinD and %00001000;

        if test=%00000000 then
          Inc(w);
        endif;

      endwhile;


  // Wait for the device to release Data and Clock
  // repeat
  // until PinD.2 and PinD.3;


      w:=0;
      while w<2 do

        w:=0;

        test := PinD and %00000100;

        if test=%00000100 then
          Inc(w);
        endif;

        test := PinD and %00001000;

        if test=%00001000 then
          Inc(w);
        endif;

      endwhile;


      Reset_Kbd_clk;
      LocalMode:= true;

      Set_Kbd_clk;  // enable the keyboard

      // ignore first byte
      // repeat
      // until not LocalMode;
      w:=0;
      while w=0 do

        if LocalMode then
          w:=0;
        else
          w:=1;
        endif;

      endwhile;


    else
      InitFailed:= true;
    endif;


  else
    InitFailed:= true;
  endif;


end SendToKbd;




// Set/Reset LEDs
procedure Set_Kbd_state;
begin
  SendToKbd($ED);
  SendToKbd(LedState);
End Set_Kbd_state;





procedure KbdReset;
var
  warten_auf_Tastatur : Boolean;
begin

  InitFailed:= false;
  Reset_Kbd_clk;          // disable the Keyboard

  wait_ms(500);

  LocalByte:= 0;

  // Wird die Tastatur zurückgesetzt (PC schickt Reset = $FF),
  // antwortet sie bei erfolgreichem Basic Assurance Test mit Bat = $AA

  // Wird die Tastatur zurückgesetzt und es gibt einen Fehlerfall,
  // klemmt beispielsweise eine Taste, reagiert sie mit BatE1 = $FC oder BatE2 = $FD.

  warten_auf_Tastatur:=true;

  while warten_auf_Tastatur do

    SendToKbd($FF);

    // Moegliche Ergebnisse auf das Ruecksetzkommando

    // 1. $AA -> erfolgreichem Basic Assurance Test
    if LocalByte=$AA then
      warten_auf_Tastatur:=false;
    endif;

    // 2. $FA -> Allgemein werden alle Kommandos zur Tastatur
    //           mit Acknowledge Ack = $FA von der Tastatur bestätigt.
    if LocalByte=$FA then
      warten_auf_Tastatur:=false;
    endif;

    if InitFailed then
      warten_auf_Tastatur:=false;
    endif;

  endwhile;


  if InitFailed then
    Set_Kbd_clk;
    LedState:= no_LED_State;
    KbShiftState:= no_ShiftState;
    KeybState:= KeyStat_Byte1;
  else
    // war die Initialisierung erfolgreich,
    // so wird die NUM-LED eingeschaltet
    LedState:= LEDNum;
    Set_Kbd_state;
    InitKeyb;
  endif;

end KbdReset;





procedure start_keyboard;
begin

  InitKeyb;

  KbdReset;

  if InitFailed then
    Ton_Sirene(20);
  else
    Ton_Sirene(4);
  endif;

end start_keyboard;











// *****************************************************

//   Konvertierung des SCAN-Codes in einen Tasten-Code

// *****************************************************


procedure Setze_Bit_in_KbShiftState(Shift_Taste : Byte);
begin
  KbShiftState:= KbShiftState or Shift_Taste;
end Setze_Bit_in_KbShiftState;



procedure Loesche_Bit_in_KbShiftState(Shift_Taste : Byte);
var
  b1 : Byte;
begin

  b1:=Negation_Byte(Shift_Taste);
  KbShiftState:= KbShiftState and b1;

end Loesche_Bit_in_KbShiftState;





procedure Setze_Bit_in_LedState(State_LED : Byte);
begin
  LedState:= LedState or State_LED;
end Setze_Bit_in_LedState;





procedure Loesche_Bit_in_LedState(State_LED : Byte);
var
  b1 : Byte;
begin

  b1:=Negation_Byte(State_LED);
  LedState:= LedState and b1;

end Loesche_Bit_in_LedState;






procedure SCAN_TO_KEY(curScan : Byte);
var
  b1 : Byte;
  curScan_Word : Word;
begin

  curScan_Word:=ByteToWord(curScan);

      // Decode scan codes into char
      case KeybState of
        KeyStat_Byte1 : doClick:= true;
                      case curScan of
                        scanExt    : KeybState:= KeyStat_E0;         // $E0
                                     doClick:= false;
                                   |
                        scanBreak  : KeybState:= KeyStat_F0;        // $F0
                                     doClick:= false;
                                   |

                        kbdAlt     : // left ALT pressed
                                     Setze_Bit_in_KbShiftState(shAlt);
                                     doClick:= false;
                                   |
                        kbdLShift  : // SHIFT pressed
                                     Setze_Bit_in_KbShiftState(shShift);
                                     doClick:= false;
                                   |

                        kbdRShift  : // SHIFT pressed
                                     Setze_Bit_in_KbShiftState(shShift);
                                     doClick:= false;
                                   |

                        kbdCtrl    : // left CTRL pressed
                                     Setze_Bit_in_KbShiftState(shCtrl);
                                     doClick:= false;
                                   |

                        kbdCaps    : // CAPS pressed

                                     if CAPS_pressed then
                                     else
                                       b1:=KbShiftState and shCaps;
                                       if b1=shCaps then
                                         // excl(KbShiftState, [shCaps]);
                                         Loesche_Bit_in_KbShiftState(shCaps);
                                         // excl(LedState, [LedCaps]);
                                         Loesche_Bit_in_LedState(LedCaps);
                                       else
                                         // incl(KbShiftState, [shCaps]);
                                         Setze_Bit_in_KbShiftState(shCaps);
                                         // incl(LedState, [LedCaps]);
                                         Setze_Bit_in_LedState(LedCaps);
                                       endif;
                                       Set_Kbd_state;
                                       CAPS_pressed:=true; // nur einmal annehmen
                                     endif;

                                     doClick:= false;

                                   |

                        kbdNum     : // NUM pressed
                                     if NUM_pressed then
                                     else
                                       b1:=KbShiftState and shNum;
                                       if b1=shNum then
                                         // excl(KbShiftState, [shNum]);
                                         Loesche_Bit_in_KbShiftState(shNum);
                                         // excl(LedState, [LedNum]);
                                         Loesche_Bit_in_LedState(LedNum);
                                       else
                                         // incl(KbShiftState, [shNum]);
                                         Setze_Bit_in_KbShiftState(shNum);
                                         // incl(LedState, [LedNum]);
                                         Setze_Bit_in_LedState(LedNum);
                                       endif;
                                       Set_Kbd_state;
                                       NUM_pressed:=true; // nur einmal annehmen
                                     endif;
                                     doClick:= false;
                                   |


                        kbdScroll  : // Scroll pressed
                                     if Scroll_pressed then
                                     else
                                       b1:=KbShiftState and shScroll;
                                       if b1=shScroll then
                                         // excl(KbShiftState, [shScroll]);
                                         Loesche_Bit_in_KbShiftState(shScroll);
                                         // excl(LedState, [LedScroll]);
                                         Loesche_Bit_in_LedState(LedScroll);
                                       else
                                         // incl(KbShiftState, [shScroll]);
                                         Setze_Bit_in_KbShiftState(shScroll);
                                         // incl(LedState, [LedScroll]);
                                         Setze_Bit_in_LedState(LedScroll);
                                        endif;
                                       Set_Kbd_state;
                                       Scroll_pressed:=true; // nur einmal annehmen
                                     endif;
                                     doClick:= false;
                                   |



                        // special keys which can not handled by the lookup table
                        kbdEnter   : // Enter
                                     SendKey($0D);
                                   |
                        kbdSpace   :
                                     SendKeyChar(' ');
                                   |
                        kbdBS      :
                                     SendKey($7F);
                                   |
                        kbdTab     :
                                     SendKey($09);
                                   |
                        kbdESC     :
                                     SendKey($1B);
                                   |

                        kbdF1      : // F1
                                     SendKey(hstF1);
                                   |
                        kbdF2      : // F2
                                     SendKey(hstF2);
                                   |
                        kbdF3      : // F3
                                     SendKey(hstF3);
                                   |
                        kbdF4      : // F4
                                     SendKey(hstF4);
                                   |
                        kbdF5      : // F5
                                     SendKey(hstF5);
                                   |
                        kbdF6      : // F6
                                     SendKey(hstF6);
                                   |
                        kbdF7      : // F7
                                     SendKey(hstF7);
                                   |
                        kbdF8      : // F8
                                     SendKey(hstF8);
                                   |
                        kbdF9      : // F9
                                     SendKey(hstF9);
                                   |
                        kbdF10     : // F10
                                     SendKey(hstF10);
                                   |
                        kbdF11     : // F11
                                     SendKey(hstF11);
                                   |
                        kbdF12     : // F12
                                     SendKey(hstF12);
                                   |
                        kbdPause   : // Pause/Break, special case with multiple chars
                                     // Taste Pause lieber nicht druecken
                                     // E1 14 77 E1 F0 14 F0 77
                                   |
                      else
                        // wir muessen den SHIFT, CTRL, ALT und CAPS Status einfuegen
                        // fuer die Deutsche Tastatur

                        ch:=Char_Null;

                        b1:=KbShiftState and shShift;
                        if b1=shShift then
                          b1:=KbShiftState and shCaps;
                          if b1=shCaps then
                            ch:= CodeTab_NORMAL[curScan_Word];
                          else
                            ch:= CodeTab_SHIFT[curScan_Word];
                          endif;
                        else
                          b1:=KbShiftState and shCaps;
                          if b1=shCaps then
                            ch:= CodeTab_SHIFT[curScan_Word];
                          else
                            ch:= CodeTab_NORMAL[curScan_Word];
                          endif;
                        endif;

                        b1:=KbShiftState and shCtrl;
                        if b1=shCtrl then
                          ch:= CodeTab_CTRL[curScan_Word];
                        endif;

                        b1:=KbShiftState and shAlt;
                        if b1=shAlt then
                          ch:= CodeTab_ALT[curScan_Word];
                        endif;

                        SendKeyChar(ch);

                      endcase;

                      if doClick then
                        Click;
                      endif;


                    |
        KeyStat_E0 : KeybState:= KeyStat_Byte1;
                      doClick:= true;

                      // der letzte Scan war $E0 = extended
                      case curScan of
                        scanBreak : KeybState:= KeyStat_F0;  // $F0
                                    doClick:= false;
                                  |
                        kbdAlt    : // ALT Gr pressed
                                    Setze_Bit_in_KbShiftState(shAlt);
                                    doClick:= false;
                                  |
                        kbdCtrl   : // right CTRL pressed
                                    Setze_Bit_in_KbShiftState(shCtrl);
                                    doClick:= false;
                                  |
                        kbdEnter  : // NumPad Enter
                                    SendKey($0D);
                                  |
                        kbdUp     :
                                    SendKey(hstUp);
                                  |
                        kbdDn     :
                                    SendKey(hstDn);
                                  |
                        kbdLeft   :
                                    SendKey(hstLeft);
                                  |
                        kbdRight  :
                                    SendKey(hstRight);
                                  |
                        kbdPgUp   :
                                    SendKey(hstPgUp);
                                  |
                        kbdPgDn   :
                                    SendKey(hstPgDn);
                                  |
                        kbdHome   :
                                    SendKey(hstHome);
                                  |
                        kbdInsert :
                                    SendKey(hstIns);
                                  |
                        kbdDelete :
                                    SendKey(hstDel);
                                  |
                        kbdEnd    :
                                    SendKey(hstEnd);
                                  |
                        kbdRGUI   :
                                    SendKey(hstRGUI);
                                  |
                        kbdLGUI   :
                                    SendKey(hstLGUI);
                                  |
                        kbdApps   :
                                    SendKey(hstApps);
                                  |
                        kbdPrint  : // Print Screen, special case with multiple chars
                                    // hstPrint
                                  |
                      endcase;

                      if doClick then
                        Click;
                      endif;


                    |
        KeyStat_F0 : case curScan of     // last scan was $F0 = break
                        kbdAlt    : // ALT released
                                    Loesche_Bit_in_KbShiftState(shAlt);
                                  |
                        kbdLShift : // SHIFT released
                                    Loesche_Bit_in_KbShiftState(shShift);
                                  |

                        kbdRShift : // SHIFT released
                                    Loesche_Bit_in_KbShiftState(shShift);
                                  |

                        kbdCtrl   : // CTRL released
                                    Loesche_Bit_in_KbShiftState(shCtrl);
                                  |

                        kbdCaps   : // CAPS released
                                    CAPS_pressed:=false;
                                  |
                        kbdNum    : // NUM released
                                    NUM_pressed:=false;
                                  |
                        kbdScroll : // Scroll released
                                    Scroll_pressed:=false;
                                  |

                      endcase;
                      KeybState:= KeyStat_Byte1;
                    |


      endcase;  // KeybState


end SCAN_TO_KEY;






{--------------------------------------------------------------}






{ *** Anfang - Daten Programme *** }



procedure change_mode(DATA_Byte : Byte);
begin
  case DATA_Byte of

    RE_CONST       : RECEIVE_MODE := RECEIVE_CONST;
    |
    RE_CONIN       : RECEIVE_MODE := RECEIVE_CONIN;
    |
    SE_CONOUT      : SEND_MODE    := SEND_CONOUT;
    |
    RE_WHO_ARE_YOU : RECEIVE_MODE := RECEIVE_DEVCODE;
    |
    RE_ERROR_CODE  : RECEIVE_MODE := RECEIVE_ERROR_CODE;
    |

  else
//    SetBit(LED_ROT);
    ERROR_CODE := $01;
    ERROR_PARAM := DATA_Byte;
  endcase;
end change_mode;






procedure DATA_SEND(DATA_Byte : Byte);
var
  Zeichen : Char;
begin
  case SEND_MODE of

    NO_SEND_MODE : change_mode(DATA_Byte);
    |

    SEND_CONOUT : AusgabeByte:=DATA_Byte;
                  SEND_MODE:=NO_SEND_MODE;
                  RECEIVE_MODE := RECEIVE_CONOUT;

    |
  else
    ERROR_CODE := $02;
    ERROR_PARAM := DATA_Byte;
  endcase;
end DATA_SEND;







// sendet ein Nibble an die Z80
procedure SEND_ONE_NIBBLE(ONE_NIBBLE : Byte);
var
  Bit_Test : Byte;
begin
  // erstmal alles auf 0
  ClearBit(CDEN_A);


  // PortC := PortC and %11110000;
  // PortC := PortC or ONE_NIBBLE;
  PortC := ONE_NIBBLE;



  NOP;
  NOP;
  NOP;
  NOP;

  while BitLow(CRAC_E) do
    SetBit(CDEN_A);
  endwhile;

  while BitHigh(CRAC_E) do
    ClearBit(CDEN_A);
  endwhile;

end SEND_ONE_NIBBLE;




// sendet ein Byte an die Z80
procedure RUN_RECEIVE_MESSAGE(RECEIVE_MESSAGE : Byte);
var
  ONE_NIBBLE : Byte;
begin
 ONE_NIBBLE := RECEIVE_MESSAGE and $0F;
 SEND_ONE_NIBBLE(ONE_NIBBLE);

 ONE_NIBBLE := RECEIVE_MESSAGE;
 shr(ONE_NIBBLE);
 shr(ONE_NIBBLE);
 shr(ONE_NIBBLE);
 shr(ONE_NIBBLE);
 SEND_ONE_NIBBLE(ONE_NIBBLE);

end RUN_RECEIVE_MESSAGE;









procedure RUN_RECEIVE_CONST;
var
  RECEIVE_MESSAGE : Byte;
begin
  if keyBufferPtr=0 then
    RECEIVE_MESSAGE:=$00;
  else
    RECEIVE_MESSAGE:=$FF;
  endif;
  RUN_RECEIVE_MESSAGE(RECEIVE_MESSAGE);

  RECEIVE_MODE := NO_RECEIVE_MODE;

end RUN_RECEIVE_CONST;









procedure RUN_RECEIVE_CONIN;
var
  RECEIVE_MESSAGE : Byte;
  C_Zaehler : Byte;
begin

  if keyBufferPtr=0 then
    RECEIVE_MESSAGE:=$00;
  else
    RECEIVE_MESSAGE:=read_key;
  endif; { if keyBufferPtr=0 then }

  RUN_RECEIVE_MESSAGE(RECEIVE_MESSAGE);
  RECEIVE_MODE := NO_RECEIVE_MODE;

end RUN_RECEIVE_CONIN;








procedure RUN_RECEIVE_CONOUT;
begin

  while TX_warten do
    RX_Puffer_abfragen;
    SetBit(LED_GN);
  endwhile;
  ClearBit(LED_GN);

  sende_Zeichen0(AusgabeByte);
  TX_warten:=true;

  RECEIVE_MODE := NO_RECEIVE_MODE;
end RUN_RECEIVE_CONOUT;







procedure RUN_RECEIVE_DEVCODE;
begin
  RUN_RECEIVE_MESSAGE(MESSAGE_WHO_AM_I);
  RECEIVE_MODE := NO_RECEIVE_MODE;
end RUN_RECEIVE_DEVCODE;





procedure RUN_RECEIVE_ERROR_CODE;
begin
  RUN_RECEIVE_MESSAGE(ERROR_CODE);  // Fehlercode 0=kein Fehler
  RUN_RECEIVE_MESSAGE(ERROR_PARAM);  // Parameter fuer Fehlercode
  RECEIVE_MODE := NO_RECEIVE_MODE;
end RUN_RECEIVE_ERROR_CODE;





{ *** Anfang - Betriebsarten Programme *** }




procedure RUN_BA_mode_keineBA;
begin
  BA_Mode:=BA_mode_INI;
end RUN_BA_mode_keineBA;





procedure RUN_BA_mode_SET_RD;
begin

  { Umschalten auf Server = Lesen, Client = Schreiben
   D0-D3 = Ausgaenge,
   CDEN = Ausgang,
   CRAC = Eingang  }



  // DDRC:=DDRC OR %00001111; // D0-D3 A
  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  DDRC:=%00001111; // D0-D3 A



  ClearBit(CDEN_A); // 0 - Vorbelegung
  SetBit(CDEN_P); // A
  ClearBit(CDEN_A); // 0 - Vorbelegung
  ClearBit(CRAC_P); // E

  ClearBit(DDAC_A); // DDAC=0 -> RD = Bestaetigung der Umstellung

  BA_Mode:=BA_mode_RD;

end RUN_BA_mode_SET_RD;





procedure RUN_BA_mode_INI;
begin

  if BitLow(DDWR_E) then // Am Anfang von WR -> RD (1 -> 0)
    RUN_BA_mode_SET_RD;
  endif;

end RUN_BA_mode_INI;






procedure RUN_BA_mode_SET_WR;
begin

  BA_Mode:=BA_mode_WR;
  { Umschalten auf Server = Schreiben, Client = Lesen
    D0-D3 = Eingaenge,
    CDEN = Eingang,
    CRAC = Ausgang  }



  // DDRC := DDRC AND %11110000; // D0-D7 E
  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  DDRC := %00000000; // D0-D3 E



  ClearBit(CDEN_P); // E
  ClearBit(CRAC_A); // 0 - Vorbelegung
  SetBit(CRAC_P); // A
  ClearBit(CRAC_A); // 0 - Vorbelegung

  SetBit(DDAC_A);  // DDAC=1 -> WR = Bestaetigung der Umstellung
end RUN_BA_mode_SET_WR;






procedure RUN_BA_mode_RD;
begin

  if RECEIVE_MODE <> NO_RECEIVE_MODE then
    case RECEIVE_MODE of

      RECEIVE_CONST : RUN_RECEIVE_CONST;
      |
      RECEIVE_CONIN : RUN_RECEIVE_CONIN;
      |
      RECEIVE_CONOUT : RUN_RECEIVE_CONOUT;
      |
      RECEIVE_DEVCODE : RUN_RECEIVE_DEVCODE;
      |
      RECEIVE_ERROR_CODE : RUN_RECEIVE_ERROR_CODE;
      |

    endcase; { if RECEIVE_MODE <> NO_RECEIVE_MODE then }
  endif; { if RECEIVE_MODE <> NO_RECEIVE_MODE then }


  if BitHigh(DDWR_E) then  // ist DDWR_E=1, dann will der
                       // Server auf WR umstellen
    RUN_BA_mode_SET_WR;
  endif;
end RUN_BA_mode_RD;






procedure RUN_BA_mode_WR;
var
  DATA_Buf_LOW : Byte;
  DATA_Buf_HIGH : Byte;
  DATA_Buf : Byte;
begin

  if BitHigh(CDEN_E) then  // ist CDEN_E=1, dann hat der Server
                       // Daten gesendet

    NOP;
    NOP;
    NOP;
    NOP;

    DATA_Buf_LOW := PINC;
    DATA_Buf_LOW := DATA_Buf_LOW and %00001111; // Daten aus Port C lesen
                                               // es sind aber nur D0-D3 Daten
                                              // die anderen werden ausgeblendet

    while BitHigh(CDEN_E) do
      SetBit(CRAC_A);
    endwhile;

    while BitLow(CDEN_E) do
      ClearBit(CRAC_A);
    endwhile;

    // 2. Lauf

    NOP;
    NOP;
    NOP;
    NOP;

    DATA_Buf_HIGH := PINC and %00001111; // Daten aus Port C lesen
                                           // es sind aber nur D0-D3 Daten
                                          // die anderen werden ausgeblendet

    SHL(DATA_Buf_HIGH);
    SHL(DATA_Buf_HIGH);
    SHL(DATA_Buf_HIGH);
    SHL(DATA_Buf_HIGH);

    DATA_Buf := DATA_Buf_HIGH or DATA_Buf_LOW;

    DATA_SEND(DATA_Buf);

    while BitHigh(CDEN_E) do
      SetBit(CRAC_A);
    endwhile;

    ClearBit(CRAC_A);

  endif; { if Bit(CDEN_E) then }


  if BitLow(DDWR_E) then  // ist DDWR_E=0, dann will der
                           // Server auf RD umstellen
    RUN_BA_mode_SET_RD;
  endif;

end RUN_BA_mode_WR;


{ *** Ende - Betriebsarten Programme *** }






procedure Text_an_CONOUT;
var
  b1 : Byte;
  b2 : Byte;
  c1 : Char;
begin

  b1:=Length(Write_String);

  for b2:=1 to b1 do

    c1:=Write_String[b2];
    AusgabeByte:=CharToByte(c1);
    RUN_RECEIVE_CONOUT;

  endfor;

  AusgabeByte:=$0D;
  RUN_RECEIVE_CONOUT;

  AusgabeByte:=$0A;
  RUN_RECEIVE_CONOUT;

end Text_an_CONOUT;







// ************************************



BEGIN

ASM;

.equ UBRR0 = UBRR0L

ENDASM;

  wait_ms(10);


  // Initialisieren der Ports
  InitPorts;
  Init_INT0;
  INIT_SER0_PORT;


  // Intitialisieren der ITP2-Variablen
  BA_Mode:= BA_mode_keineBA;
  SEND_MODE := NO_SEND_MODE;
  RECEIVE_MODE := NO_RECEIVE_MODE;

  ERROR_CODE := $00;
  ERROR_PARAM := $00;


  // Initialisieren der Tastatur-Variablen
  CAPS_pressed:=false;
  NUM_pressed:=false;
  Scroll_pressed:=false;

  LedState:=no_LED_State;
  KeybState:=KeyStat_Byte1;
  KbShiftState:=no_ShiftState;

  keyBufferPtr:=0;

  SetBit(DDAC_A);  // DDAC=1
  ClearBit(CRAC_A);  // CRAC=0

  TX_warten:=false;

  ClearBit(LED_GN);
  ClearBit(SUMMER);

  start_keyboard;


  Write_String:='Systemtest CONIO2 o.k.';
  Text_an_CONOUT;




  loop

    if SCANBufferPtr>0 then
      SCAN_Zeichen:=read_SCAN;
      SCAN_TO_KEY(SCAN_Zeichen);
    endif;  { if SCANBufferPtr<>0 then }


    case BA_Mode of
      BA_mode_keineBA : RUN_BA_mode_keineBA;
      |
      BA_mode_INI : RUN_BA_mode_INI;
      |
      BA_mode_RD : RUN_BA_mode_RD;
      |
      BA_mode_WR : RUN_BA_mode_WR;
      |
    endcase;



  endloop;


END CONIO2.
