
// ******************************
// *** serielle Schnittstelle ***
// ******************************


VAR
  SER0_Zeichen : Byte;
  SER1_Zeichen : Byte;
  SER0_warten : Boolean;
  SER1_warten : Boolean;


procedure INIT_SER0_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0H := 0;
    UBRR0L := UBRR_VAL_S0;

{
Bit 4 RXEN: Receiver Enable
Bit 3 TXEN: Transmitter Enable
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER0_PORT;






procedure INIT_SER1_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}
    UBRR1H := 0;
    UBRR1L := UBRR_VAL_S1;

{
Bit 4 RXEN: Receiver Enable
Bit 3 TXEN: Transmitter Enable
}
    UCSR1B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR1C := %10000110;


    SER1_warten:=false;


end INIT_SER1_PORT;






procedure RX0_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    SER0_Zeichen:=UDR0;
  else
    SER0_Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX0_Puffer_abfragen;







procedure RX1_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC1) then

    SER1_Zeichen:=UDR1;

  else
    SER1_Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX1_Puffer_abfragen;







// im Puffer fuer die serielle Schnittstelle 0
// wurde ein Byte empfangen
procedure Serial1_abfragen;
begin

  RX1_Puffer_abfragen;

  if SER1_Zeichen=XON then

    SER1_warten:=false;

  endif;

end Serial1_abfragen;







procedure sende_Zeichen0(s_Zeichen0 : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE0) do
//    SetBit(LED_GRUEN); // gruen ein
  endwhile;

 // ClearBit(LED_GRUEN); // gruen aus

  UDR0:=s_Zeichen0;

end sende_Zeichen0;












procedure sende_Zeichen1_XON(s_Zeichen : Byte);
begin


  while SER1_warten do

    Serial1_abfragen;

  endwhile; { while SER1_warten do }


  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE1) do
  endwhile;

  UDR1:=s_Zeichen;

  SER1_warten:=true;

end sende_Zeichen1_XON;









// im Puffer fuer die serielle Schnittstelle 0
// wurde ein Byte empfangen
procedure Serial0_abfragen;
begin

  RX0_Puffer_abfragen;

  case SER0_Zeichen of

    XON            : SER0_warten:=false;
    |

    Monitor_links  : sende_Zeichen1_XON(Monitor_links);
    |

    Monitor_rechts : sende_Zeichen1_XON(Monitor_rechts);
    |

  else
          {
    SetBit(LED_RT);
    wait_ms(600);
    ClearBit(LED_RT);
            }
  endcase;

end Serial0_abfragen;







procedure sende_Zeichen0_XON(s_Zeichen : Byte);
begin


  while SER0_warten do

    Serial0_abfragen;

  endwhile; { while SER1_warten do }


  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE0) do
  endwhile;

  UDR0:=s_Zeichen;

  SER0_warten:=true;

end sende_Zeichen0_XON;




