
// ******************************
// *** serielle Schnittstelle ***
// ******************************


VAR
  SER0_Zeichen : Byte;
  SER1_Zeichen : Byte;
  {
  SER0_warten : Boolean;
  SER1_warten : Boolean;
            }

procedure INIT_SER0_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0H := 0;
    UBRR0L := UBRR_VAL_S0;

{
Bit 4 RXEN: Receiver Enable
Bit 3 TXEN: Transmitter Enable
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER0_PORT;






procedure INIT_SER1_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}
    UBRR1H := 0;
    UBRR1L := UBRR_VAL_S1;

{
Bit 4 RXEN: Receiver Enable
Bit 3 TXEN: Transmitter Enable
}
    UCSR1B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR1C := %10000110;


 //   SER1_warten:=false;


end INIT_SER1_PORT;






procedure RX0_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    SER0_Zeichen:=UDR0;
  else
    SER0_Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX0_Puffer_abfragen;





procedure RX1_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC1) then

    SER1_Zeichen:=UDR1;

  else
    SER1_Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX1_Puffer_abfragen;






procedure sende_Zeichen0(s_Zeichen0 : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE0) do
//    SetBit(LED_GRUEN); // gruen ein
  endwhile;

 // ClearBit(LED_GRUEN); // gruen aus

  UDR0:=s_Zeichen0;

end sende_Zeichen0;








procedure sende_Zeichen1(s_Zeichen1 : Byte);
begin
  // wenn UDRE1 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE1 = 0
  while BitLow(UDRE1) do
//    SetBit(LED_GRUEN); // gruen ein
  endwhile;

 // ClearBit(LED_GRUEN); // gruen aus

  UDR1:=s_Zeichen1;

end sende_Zeichen1;







procedure Write_SER1;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(Write_String);
  for b1:=1 to Laenge do
    c1:=Write_String[b1];
    b2:=CharToByte(c1);
    sende_Zeichen1(b2);
  endfor;

end Write_SER1;




procedure WriteLn_SER1;
begin
  Write_SER1;
  sende_Zeichen1($0D); // CR
  sende_Zeichen1($0A); // LF
end WriteLn_SER1;






