
// ADC Control and Status Register A.


procedure Init_ADC;
begin

  // ADC Control and Status Register A.

  {
  Name
  ADEN ADSC ADFR ADIF ADIE ADPS2 ADPS1 ADPS0 (Name)
  7    6    5    4    3    2     1     0     (Bit)
  1    0    1    0    0    1     1     1     (Belegung)

  ADPS2...ADPS0 (ADC Prescaler Select Bits)
  16.000.000 Hz / 200.000 Hz = 80
  16.000.000 Hz / 50.000 Hz = 320

  Teilungsfaktor 128 -> 16.000.000 / 128 = 125 KHz
  }
  ADCSRA := %11100111;



  // ADMUX ADC Multiplexer Select Register
  {
  Name
  REFS1 REFS0 ADLAR MUX4 MUX3 MUX2 MUX1 MUX0 (Name)
  7     6     5     4    3    2     1     0     (Bit)
  0     1     1     0    0    0     0     0     (Belegung)

  REFS1=0 und REFS0=1 -> AVCC als Referenz (interne Referenz: Avcc)
  ADLAR (ADC Left Adjust Result)=1 -> linkssbuendig
  MUX4...MUX0
  }

  ADMUX:=%01100000;



end Init_ADC;






// startet den ADC auf Kanal 0
procedure ADC_starten;
var
  Ergebnis_Low  : Byte;
  Ergebnis_High : Byte;

begin

 // ADMUX ADC Multiplexer Select Register
  {
  Name
  REFS1 REFS0 ADLAR MUX4 MUX3 MUX2 MUX1 MUX0 (Name)
  7     6     5     4    3    2     1     0     (Bit)
  0     1     1     0    0    0     0     0     (Belegung)

  REFS1=0 und REFS0=1 -> AVCC als Referenz (interne Referenz: Avcc)
  ADLAR (ADC Left Adjust Result)=1 -> linkssbuendig
  MUX4...MUX0
  }
  ADMUX:=%01100000;



  // ADC Control and Status Register A.

  {
  Name
  ADEN ADSC ADFR ADIF ADIE ADPS2 ADPS1 ADPS0 (Name)
  7    6    5    4    3    2     1     0     (Bit)
  1    1    1    0    0    1     1     1     (Belegung)

  ADPS2...ADPS0 (ADC Prescaler Select Bits)
  16.000.000 Hz / 200.000 Hz = 80
  16.000.000 Hz / 50.000 Hz = 320

  Teilungsfaktor 128 -> 18.432.000 / 128 = 144 KHz
  }
  ADCSRA := %11100111;

end ADC_starten;







function ADC_lesen : Byte;
var
  Ergebnis_Low  : Byte;
  Ergebnis_High : Byte;
begin

  Ergebnis_Low:=ADCL;
  Ergebnis_High:=ADCH;

  RESULT:=Ergebnis_High;

end ADC_lesen;







