PROGRAM CPD8_CORE;

// DEVICE = MEGA1284P;
// {$I mega1284_Register.INC}

DEVICE = MEGA32;

{$I mega32_Register.INC}




CONST

  // TaktFrequenz in KHz
//  TaktFrequenz : Word = 18432;
//  UBRR_VAL : Byte = 9;  // 115200 Baud


 // TaktFrequenz in KHz
//   TaktFrequenz : Word = 16384;
//  UBRR_VAL : Byte = 7;  // 128000 Baud


 // TaktFrequenz in KHz
  TaktFrequenz : Word = 14746;
  UBRR_VAL : Byte = 7;  // 115200 Baud




  // Befehlscode fuer IORQ
  IORQ_LED_Ein     : Byte = 01;
  IORQ_LED_Aus     : Byte = 02;
  IORQ_CONOUT      : Byte = 03;
  IORQ_CONIN       : Byte = 04;
  IORQ_CONST       : Byte = 05;
  IORQ_START_PROG  : Byte = 06;
  IORQ_RAM2ARR     : Byte = 07;
  IORQ_ARR2RAM     : Byte = 08;
  IORQ_STD2UC      : Byte = 09;
  IORQ_RD_PC2ARR   : Byte = 10;
  IORQ_BDOS2RAM    : Byte = 11;
  IORQ_CCP2RAM     : Byte = 12;
  IORQ_WR_ARR2PC   : Byte = 14;
  IORQ_DISK2RAM    : Byte = 15;
  IORQ_LIST 	   : Byte = 16;
  IORQ_TIME 	   : Byte = 17;
  IORQ_WR_ARR2I2C  : Byte = 18;
  IORQ_RD_I2C2ARR  : Byte = 19;
  IORQ_RD_ITP32ARR : Byte = 20;
  IORQ_WR_ARR2ITP3 : Byte = 21;





CONST
  nul  : Byte = $00;
  xon  : Byte = $11;
  xoff : Byte = $13;



  // Befehlscode fuer UART
  UART_WHO_AM_I   : Byte = 01;
  UART_ERROR_CODE : Byte = 02;

  UART_CONOUT : Byte = 03;
  UART_CONST  : Byte = 04;
  UART_CONIN  : Byte = 05;
  UART_READ   : Byte = 06;
  UART_WRITE  : Byte = 07;
  UART_STD    : Byte = 08;



VAR

  // Globale Variablen

{
A0 - DB0_ITP3 = E
A1 - DB1_ITP3 = E
A2 - DB2_ITP3 = E
A3 - DB3_ITP3 = E
A4 - DS0_ITP3 = A / H
A5 - DS1_ITP3 = A / H
A6 - DS2_ITP3 = A / H
A7 - DS3_ITP3 = A / H
}



{
B0 - DR_ITP3  = E
B1 - IORQ_Z80 = E
B2 - OE_RAM   = E
B3 - WE_RAM   = E
B4 - G_RAMSW  = A / H
B5 - A16_RAM - MOSI = A / L
B6 - A17_RAM - MISO = A / L
B7 - A18_RAM - SCK  = A / L
}

  DR_ITP3_A[PortB,0] : bit; // A
  DR_ITP3_E[PINB,0]  : bit; // E
  DR_ITP3_D[DDRB,0]  : bit; // D

  IORQ_Z80_E[PINB,1] : bit; // E

  OE_RAM_A[PortB,2]  : bit; // A
  OE_RAM_D[DDRB,2]   : bit; // D

  WE_RAM_A[PortB,3]  : bit; // E
  WE_RAM_D[DDRB,3]   : bit; // E

  G_RAMSW[PortB,4]  : bit; // A / H
  A16_RAM[PortB,5]  : bit; // A / L
  A17_RAM[PortB,6]  : bit; // A / L
  A18_RAM[PortB,7]  : bit; // A / L


{
C0..C7 - D0_Z80..D7_Z80
}


{
D0 - RXD0      = E
D1 - TXD0      = A / L
D2 - SCL - I2C = E
D3 - SDA - I2C = E
D4 - RD_Z80    = E
D5 - WR_Z80    = E
D6 - RESET_Z80 = A / H
D7 - CLK_Z80   = A / L
}
  SCL_I2C_A[PortD,2] : bit; // A
  SCL_I2C_E[PIND,2]  : bit; // E
  SCL_I2C_D[DDRD,2]  : bit; // D

  SDA_I2C_A[PortD,3] : bit; // A
  SDA_I2C_E[PIND,3]  : bit; // E
  SDA_I2C_D[DDRD,3]  : bit; // D

  RD_Z80_E[PIND,4]   : bit; // E
  WR_Z80_E[PIND,5]   : bit; // E
  RESET_Z80[PortD,6] : bit; // A
  CLK_Z80[PortD,7]   : bit; // A



  Array_Pos : Word;

  ConsoleIn : Byte;
  ConsoleIn_gelesen : Boolean;

  ConsoleOut : Byte;

  Steuer_String : String[50];
  Anzeige_String : String[80];

  // Sektor-Puffer
  Sektor_Puffer : Array [0..127] of Byte;
  Sektor_Puffer_Zeiger : Word;

  // STD
  SECTOR, TRACK_L, TRACK_H, DISKNO : Byte;

  Datum_gesetzt : Boolean;

  Serial_Device_connected : Byte;



CONST

// BIOS - Z80-Code
{$I CPD8_TXT.INC}

// BDOS - Z80-Code
{$I BDOS_TXT.INC}

// CCP - Z80-Code
{$I CCP_TXT.INC}


// RAM-Floppy
{$I DISK_TXT.INC}
//{$I DISK_TXT_dummy.INC}


{$I SYSTEM.INC}


// {$I mega_S0_UART_oI_XON.INC}
{$I mega_16_32_UART_oI_XON.INC}




{$I I2C_AT24C512.INC}
//{$I I2C_AT24FC1025.INC}



{$I ITP3_SRV_PORT.INC}
{$I ITP3_SRV_PRG.INC}



// {$I UART_PRG_128.INC}
{$I UART_PRG_32.INC}


// {$I RAM_512K.INC}
{$I RAM_128K.INC}





// *** INITIALISIERUNG ***


procedure InitPorts;
begin

{
A0 - DB0_ITP3 = E
A1 - DB1_ITP3 = E
A2 - DB2_ITP3 = E
A3 - DB3_ITP3 = E
A4 - DS0_ITP3 = A / H
A5 - DS1_ITP3 = A / H
A6 - DS2_ITP3 = A / H
A7 - DS3_ITP3 = A / H
}

  DDRA  :=  %11110000;
  PortA :=  %11110000;


{
B0 - DR_ITP3  = E
B1 - IORQ_Z80 = E
B2 - OE_RAM   = E
B3 - WE_RAM   = E
B4 - G_RAMSW  = A / H
B5 - A16_RAM - MOSI = A / L
B6 - A17_RAM - MISO = A / L
B7 - A18_RAM - SCK  = A / L
}
  DDRB  :=  %11110000;
  PortB :=  %01010000;

{
C0..C7 - D0_Z80..D7_Z80
}
  DDRC  :=  %00000000;
  PortC :=  %00000000;

{
D0 - RXD0      = E
D1 - TXD0      = A / L
D2 - SCL - I2C = E
D3 - SDA - I2C = E
D4 - RD_Z80    = E
D5 - WR_Z80    = E
D6 - RESET_Z80 = A / H
D7 - CLK_Z80   = A / L
}
  DDRD  :=  %11000010;
  PortD :=  %01000000;


end InitPorts;






// *** Z80 Hardware-Steuerprogramme ***



procedure sende_50_Takte;
var
  Zaehler : Byte;
begin

  for Zaehler:=1 to 100 do
    SetBit(CLK_Z80);
    NOP;
    NOP;
    ClearBit(CLK_Z80);
  endfor;

end sende_50_Takte;







procedure lade_CPD8_Array_in_RAM;
begin


  // 3. Abschalten der /RD und /WR Signale der Z80 an den RAM
  SetBit(G_RAMSW);


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);


  // OE und WE DIR Ausgabe
  SetBit(OE_RAM_D);
  SetBit(WE_RAM_D);


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);


  for Array_Pos:=0 to Laenge_CPD8_Array do

    warte_solange_RD_High;

    // 5. Einschreiben der Daten vom CPD5_ARR in den RAM
    // an der aktuellen Adresse (entspricht Array_Pos)

    // Daten-Port auf Schreiben
    DDRC  :=  %11111111;

    // Anlegen der Z80-Daten
    PORTC := CPD8_ARR[Array_Pos];

    NOP;
    NOP;
    NOP;

    ClearBit(WE_RAM_A);

    NOP;
    NOP;
    NOP;
    NOP;
    NOP;
    NOP;
    SetBit(WE_RAM_A);


    // 6. Anlegen von NOP an den Datenport fuer die Z80
    PORTC := 0;  // NOP

    warte_solange_RD_Low;


    // Daten-Port auf Lesen
    DDRC  :=  %00000000;


  // 8. Wiederholen bis das ganze ARRAY in den RAM geladen wurde
  endfor; { for Array_Pos:=0 to Laenge_CPD6_Array do }


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Eingabe
  ClearBit(OE_RAM_D);
  ClearBit(WE_RAM_D);


  // 11. Zuschalten der /RD und /WR Signale der Z80 an den RAM
  ClearBit(G_RAMSW);


end lade_CPD8_Array_in_RAM;









// laedt das Z80-BIOS in den RAM
// und startet es durch RESET
procedure Z80_RESET_und_URLOAD;
begin


  // 0. /RESET auf High setzen
  SetBit(RESET_Z80);

  sende_50_Takte;


  // 1. /RESET auf LOW setzen
  ClearBit(RESET_Z80);


  // 2a. Senden von min. 3 Takten (10 Takte)
  sende_50_Takte;

  // 2b. /RESET auf High setzen
  SetBit(RESET_Z80);


  lade_CPD8_Array_in_RAM;

  // 9. /RESET auf LOW setzen
  ClearBit(RESET_Z80);

  // 10a. Senden von min. 3 Takten (10 Takte)
  sende_50_Takte;


  // 10b. /RESET auf High setzen
  SetBit(RESET_Z80);

end Z80_RESET_und_URLOAD;








procedure IORQ_Ende;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  DDRC:=%00000000;

end IORQ_Ende;









procedure Z80_CONOUT;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das auszugebende Zeichen
  warte_solange_IORQ_High;

  ConsoleOut := PinC;

  IORQ_Ende;

end Z80_CONOUT;








procedure Z80_LIST;
var
  IO_Wert : Byte;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das auszugebende Zeichen
  warte_solange_IORQ_High;

  IO_Wert := PinC;

  ByteToString(IO_Wert);
 // SER0_String:='l'+Byte_String;
//  WriteLn_SER0;

  IORQ_Ende;

end Z80_LIST;









procedure Z80_CONIN;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das einzulesende Zeichen
  warte_solange_IORQ_High;

  DDRC:=%11111111;
  PortC:=ConsoleIn;

  IORQ_Ende;

end Z80_CONIN;




//{$I RAM_512K.INC}



















procedure STD_an_uC;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist der SECTOR
  warte_solange_IORQ_High;

  SECTOR := PinC;


  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist der TRACK_L
  warte_solange_IORQ_High;

  TRACK_L := PinC;


  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist der TRACK_H
  warte_solange_IORQ_High;

  TRACK_H := PinC;


  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist der DISKNO
  warte_solange_IORQ_High;

  DISKNO := PinC;


  IORQ_Ende;


end STD_an_uC;






// **********************************************




// Read -> -> I2C-Flash an den Sektor_Puffer
procedure I2C_an_Sektor_senden;

begin

  berechne_I2C_Address;
  AT_Read_Data_Array;

end I2C_an_Sektor_senden;




// Write -> Sektor_Puffer an den I2C-Flasch
procedure Sektor_an_I2C_senden;

begin

  berechne_I2C_Address;
  AT_Write_Data_Array_Wait;

end Sektor_an_I2C_senden;






// **********************************************
// Verteiler-Programme
// **********************************************




procedure CONOUT_to_Device;
begin

  // einlesen des auszugebenden Bytes
  Z80_CONOUT;


  // ITP3-CONOUT
  if CONOUT_Device<100 then

    DEV_NR:=CONOUT_Device;
    ITP3_sende_CONOUT(ConsoleOut);

  endif;


  // nur bei CONOUT_Device=0 wird
  // die serielle Schnittstelle ignoriert
  if CONOUT_Device<>0 then
    UART_CONOUT_senden;
  endif;

end CONOUT_to_Device;








procedure CONST_to_Device;
begin

  // ITP3-CONOUT
  if CONIN_Device<100 then
    DEV_NR:=CONIN_Device;
    ConsoleIn:=ITP3_empfange_CONST;
  else
    CONST_von_UART_lesen;
  endif;

  Z80_CONIN;

end CONST_to_Device;




procedure CONIN_to_Device;
begin

  // ITP3-CONOUT
  if CONIN_Device<100 then
    DEV_NR:=CONIN_Device;
    ITP3_CONIN_Schleife;
  else
    UART_CONIN_Schleife;
  endif;

  Z80_CONIN;

end CONIN_to_Device;





procedure LIST_to_Device;
begin

  Z80_LIST;

end LIST_to_Device;



// **********************************************




// Start eines beliebigen Testprogramms des uC
// durch die Z80
procedure START_PROG;
begin

  I2C_load_Address_List;

  IORQ_Ende;

end START_PROG;






// **********************************************






procedure Auswerten_IORQ;
var
  IO_Wert : Byte;
begin


  if BitLow(WR_Z80_E) then

    // Daten-Port auf Lesen
    DDRC  :=  %00000000;

    IO_Wert := PinC;

    case IO_Wert of



      // CP/M Device Routinen
      IORQ_CONOUT      : CONOUT_to_Device;
      |

      IORQ_CONIN       : CONIN_to_Device;
      |

      IORQ_CONST       : CONST_to_Device;
      |

      IORQ_LIST        : LIST_to_Device;
      |



      // ITP3-Schnittstelle (Drive_D - USB-Stick-Image)
      IORQ_RD_ITP32ARR : ITP3_sende_STD;
                         ITP3_Sektor_lesen;
      |

      IORQ_WR_ARR2ITP3 : ITP3_sende_STD;
                         ITP3_Sektor_schreiben;
      |



      // UART Schnittstelle (zum USB-Serial-Wandler zum PC
      //                     oder zum RPI)
      IORQ_RD_PC2ARR   : STD_an_UART_senden;
                         Sektor_von_UART_lesen_Komp;
      |

      IORQ_WR_ARR2PC   : STD_an_UART_senden;
                         Sektor_an_UART_senden;
      |



      // interne RAM-Floppy auf dem Board
      IORQ_RAM2ARR     : START_RAM2ARR;
      |

      IORQ_ARR2RAM     : START_ARR2RAM;
      |

      IORQ_STD2UC      : STD_an_uC;
      |



      // CP/M Hilfsroutinen
      IORQ_BDOS2RAM    : START_BDOS2RAM;
      |

      IORQ_CCP2RAM     : START_CCP2RAM;
      |

      IORQ_DISK2RAM    : COPY_DISK_TO_RAM;
      |



      // I2C - die Flasch-Floppy mit serial ICs
      IORQ_RD_I2C2ARR  : I2C_an_Sektor_senden;
      |

      IORQ_WR_ARR2I2C  : Sektor_an_I2C_senden;
      |




      // Testprogramme
      IORQ_LED_Ein     : IORQ_Ende;
      |

      IORQ_LED_Aus     : IORQ_Ende;
      |


      IORQ_START_PROG  : START_PROG;
      |





    endcase; { case IO_Wert of }

  endif; // if BitLow(WR_Z80) then

end Auswerten_IORQ;








BEGIN



  InitPorts;

  ITP3_Init;

  INIT_SER0_PORT;

  Init_I2C;

//  Init_Flash_Floppy;

  ConsoleIn:=0;
  ConsoleOut:=0;
  Steuer_String:='';
  Datum_gesetzt:=false;
  ConsoleIn_gelesen:=false;
  Serial_Device_connected:=0;


  sende_Zeichen0(64);  // @  = Ruecksetzen der Hardware




  // Laden des Z80-Bios
  Z80_RESET_und_URLOAD;




  ITP3_pruefe_Anschluesse;


  // wurde ein CONOUT_Device=0 beim ITP3-Anschluss
  // erkannt, dann ist am Anschluss 0 ein
  // CONOUT-Geraet angeschlossen
  // Wenn nicht, wird versucht ein CONOUT-Geraet
  // an der seriellen Schnittstelle zu erkennen
  if CONOUT_Device<>0 then
    UART_Abfrageschleife_SER0;
  endif;



  // Endlosschleife fuer Takterzeugung
  // Taktfrequenz etwa 3 MHz
  LOOP

    SetBit(CLK_Z80);      // 2 Takte


ASM;

//    LDS      R16, UCSR0A
    LDS      R16, UCSRA
    SBRC     R16, 7

    // fuer RPI, sonst ignoriert
    CALL     RX0_wait_before_sending_abfragen;


ENDASM;

    ClearBit(CLK_Z80);    // 2 Takte

ASM;

    SBIS     PinB, 1
    CALL     AUSWERTEN_IORQ

ENDASM;


    // SBI  = 1 Takt
    // SBIS = 1 Takt
    // CBI  = 1 Takt
    // RJMP = 2 Takte

    // 18,4 / 5 = 3,7 MHz

  ENDLOOP;




END CPD8_CORE.
