
// ****************************
// *** ITP3-Server-Routinen ***
// *** Softwareteil         ***
// ****************************


CONST

{

  Konfiguration WHO_ARE_YOU - Byte
  D7 - CONOUT
  D6 - CONIN
  D5 - LIST
  D4 - SOUND
  D3 - DIVE_D
  D2 - N.N.
  D1 - N.N.
  D0 - N.N.

}


  // Befehlscode fuer ITP3
  ITP3_WHO_ARE_YOU : Byte = 01;
  ITP3_ERROR_CODE  : Byte = 02;

  ITP3_CONOUT  : Byte = 03;
  ITP3_CONST   : Byte = 04;
  ITP3_CONIN   : Byte = 05;
  ITP3_STD     : Byte = 06;
  ITP3_RD_SEC  : Byte = 07;
  ITP3_WR_SEC  : Byte = 08;


  DEV_DS0 : Byte = 00;
  DEV_DS1 : Byte = 01;
  DEV_DS2 : Byte = 02;
  DEV_DS3 : Byte = 03;


VAR
  DEV_NR : Byte;
  CONOUT_Device, CONIN_Device,
  LIST_Device, SOUND_Device,
  DRIVE_D_Device : Byte;



procedure ITP3_Init;
begin

  // alle Datenleitungen auf Eingang schalten
  ClearBit(ITP3_D0_D);
  ClearBit(ITP3_D1_D);
  ClearBit(ITP3_D2_D);
  ClearBit(ITP3_D3_D);

  // Device Select auf Ausgang
  SetBit(ITP3_DS0_A);
  SetBit(ITP3_DS0_D);
  SetBit(ITP3_DS1_A);
  SetBit(ITP3_DS1_D);
  SetBit(ITP3_DS2_A);
  SetBit(ITP3_DS2_D);
  SetBit(ITP3_DS3_A);
  SetBit(ITP3_DS3_D);

  // DR auf Eingang
  ClearBit(ITP3_DR_D);

  // ITP-Device 0 ist selektiert
  DEV_NR:=DEV_DS0;

  CONOUT_Device:=100;
  CONIN_Device:=100;
  LIST_Device:=100;
  SOUND_Device:=100;
  DRIVE_D_Device:=100;

end ITP3_Init;




procedure DEV_NR_ClearBit;
begin

  case  DEV_NR of
    DEV_DS0 : ClearBit(ITP3_DS0_A);
    |
    DEV_DS1 : ClearBit(ITP3_DS1_A);
    |
    DEV_DS2 : ClearBit(ITP3_DS2_A);
    |
    DEV_DS3 : ClearBit(ITP3_DS3_A);
    |
  endcase;

end DEV_NR_ClearBit;




procedure DEV_NR_SetBit;
begin

  case  DEV_NR of
    DEV_DS0 : SetBit(ITP3_DS0_A);
    |
    DEV_DS1 : SetBit(ITP3_DS1_A);
    |
    DEV_DS2 : SetBit(ITP3_DS2_A);
    |
    DEV_DS3 : SetBit(ITP3_DS3_A);
    |
  endcase;

end DEV_NR_SetBit;







// Byte senden

procedure ITP3_sende_Halbbyte(SB : Byte);
var
  b1 : Byte;
begin

  // D0 setzen
  b1:=SB and %00000001;
  if b1=0 then
    ClearBit(ITP3_D0_A);
  else
    SetBit(ITP3_D0_A);
  endif;

  // D1 setzen
  b1:=SB and %00000010;
  if b1=0 then
    ClearBit(ITP3_D1_A);
  else
    SetBit(ITP3_D1_A);
  endif;

  // D2 setzen
  b1:=SB and %00000100;
  if b1=0 then
    ClearBit(ITP3_D2_A);
  else
    SetBit(ITP3_D2_A);
  endif;

  // D3 setzen
  b1:=SB and %00001000;
  if b1=0 then
    ClearBit(ITP3_D3_A);
  else
    SetBit(ITP3_D3_A);
  endif;

  // jetzt wird dem Client mitgeteilt, das Daten fuer ihn anliegen
  DEV_NR_ClearBit;

  // warten solange der Client die Daten uebernimmt
  while BitHigh(ITP3_DR_E) do
  endwhile;

  // Client hat die Daten uebernommen,
  // die DS-Leitung wird wieder frei gegeben
  DEV_NR_SetBit;

  // warten solange, bis der Client die DR-Leitung
  // wieder frei gibt
  while BitLow(ITP3_DR_E) do
  endwhile;

end ITP3_sende_Halbbyte;




procedure ITP3_sende_Byte(SB : Byte);
var
  b1 : Byte;
begin

  // alle Datenleitungen auf Ausgang schalten
  SetBit(ITP3_D0_D);
  SetBit(ITP3_D1_D);
  SetBit(ITP3_D2_D);
  SetBit(ITP3_D3_D);

  // Steuerleitungen setzen
  DEV_NR_SetBit;    // DSX auf 1

  ClearBit(ITP3_DR_D);  // DR auf Eingang

  // senden des Low-Halbbyte
  b1:=SB;
  b1:=b1 and %00001111;
  ITP3_sende_Halbbyte(b1);

  // senden des High-Halbbyte
  b1:=SB;
  SHR(b1);
  SHR(b1);
  SHR(b1);
  SHR(b1);
  ITP3_sende_Halbbyte(b1);

  // alle Datenleitungen auf Eingang schalten
  ClearBit(ITP3_D0_D);
  ClearBit(ITP3_D1_D);
  ClearBit(ITP3_D2_D);
  ClearBit(ITP3_D3_D);

end ITP3_sende_Byte;







// Test-Byte senden

function ITP3_sende_Test_Halbbyte(SB : Byte) : Boolean;
var
  b1 : Byte;
  Wait_counter : Word;
  Result_Byte : Boolean;
begin

  // D0 setzen
  b1:=SB and %00000001;
  if b1=0 then
    ClearBit(ITP3_D0_A);
  else
    SetBit(ITP3_D0_A);
  endif;

  // D1 setzen
  b1:=SB and %00000010;
  if b1=0 then
    ClearBit(ITP3_D1_A);
  else
    SetBit(ITP3_D1_A);
  endif;

  // D2 setzen
  b1:=SB and %00000100;
  if b1=0 then
    ClearBit(ITP3_D2_A);
  else
    SetBit(ITP3_D2_A);
  endif;

  // D3 setzen
  b1:=SB and %00001000;
  if b1=0 then
    ClearBit(ITP3_D3_A);
  else
    SetBit(ITP3_D3_A);
  endif;

  // jetzt wird dem Client mitgeteilt, das Daten fuer ihn anliegen
  DEV_NR_ClearBit;

  // warten solange der Client die Daten uebernimmt
  Wait_counter:=0;
  Result_Byte:=true;
  while Result_Byte do

    if BitLow(ITP3_DR_E) then
      Result_Byte:=false;
    endif;

    if Wait_counter>60000 then
      Result_Byte:=false;
    endif;

    Inc(Wait_counter);

  endwhile;



  // hat der Client reagiert, dann ist
  // ter test erfolgreich
  if BitLow(ITP3_DR_E) then


    // die DS-Leitung wird wieder frei gegeben
    DEV_NR_SetBit;


    Result_Byte:=true;

    // Client hat die Daten uebernommen,

    // warten solange, bis der Client die DR-Leitung
    // wieder frei gibt
    while BitLow(ITP3_DR_E) do
    endwhile;

  else

    // die DS-Leitung wird wieder frei gegeben
    DEV_NR_SetBit;

    Result_Byte:=false;

  endif;


  Result:=Result_Byte;

end ITP3_sende_Test_Halbbyte;




function ITP3_sende_Test_Byte(SB : Byte) : Boolean;
var
  b1 : Byte;
  Result_Byte : Boolean;
begin

  // alle Datenleitungen auf Ausgang schalten
  SetBit(ITP3_D0_D);
  SetBit(ITP3_D1_D);
  SetBit(ITP3_D2_D);
  SetBit(ITP3_D3_D);

  // Steuerleitungen setzen
  DEV_NR_SetBit;    // DSX auf 1

  ClearBit(ITP3_DR_D);  // DR auf Eingang

  // senden des Low-Halbbyte
  b1:=SB;
  b1:=b1 and %00001111;
  Result_Byte:=ITP3_sende_Test_Halbbyte(b1);

  if Result_Byte then

    // senden des High-Halbbyte
    b1:=SB;
    SHR(b1);
    SHR(b1);
    SHR(b1);
    SHR(b1);
    ITP3_sende_Halbbyte(b1);

  endif;

  // alle Datenleitungen auf Eingang schalten
  ClearBit(ITP3_D0_D);
  ClearBit(ITP3_D1_D);
  ClearBit(ITP3_D2_D);
  ClearBit(ITP3_D3_D);

  Result:=Result_Byte;

end ITP3_sende_Test_Byte;







// Byte empfangen

function ITP3_empfange_Halbbyte : Byte;
var
  Result_Byte : Byte;
begin

  // SA

  // nun wird dem Client durch Aktivierung
  // der DSX-Leitung mitgeteilt,
  // dass der Server das naechste Halbbyte
  // empfangen kann
  DEV_NR_ClearBit;

  // SB

  // warten, solange bis der Client das
  // Halbbyte bereit stellt
  while BitHigh(ITP3_DR_E) do
  endwhile;

  // SC

  // nun liegt das Halbbyte an

  Result_Byte:=%00000000;

  // D0 einlesen
  if BitHigh(ITP3_D0_E) then
    Result_Byte:=Result_Byte or %00000001;
  endif;

  // D1 einlesen
  if BitHigh(ITP3_D1_E) then
    Result_Byte:=Result_Byte or %00000010;
  endif;

  // D2 einlesen
  if BitHigh(ITP3_D2_E) then
    Result_Byte:=Result_Byte or %00000100;
  endif;

  // D3 einlesen
  if BitHigh(ITP3_D3_E) then
    Result_Byte:=Result_Byte or %00001000;
  endif;

  // SD

  // jetzt wird dem Client mitgeteilt,
  // das der Server das Halbbyte
  // uebernommen hat
  DEV_NR_SetBit;

  // SE

  // warten solange bis der Client die
  // Bestaetigung angenommen hat
  while BitLow(ITP3_DR_E) do
  endwhile;

  // SF

  Result:=Result_Byte;

end ITP3_empfange_Halbbyte;






function ITP3_empfange_Byte : Byte;
var
  Result_Byte_01 : Byte;
  Result_Byte_02 : Byte;
begin

  // alle Datenleitungen auf Eingang schalten
  ClearBit(ITP3_D0_D);
  ClearBit(ITP3_D1_D);
  ClearBit(ITP3_D2_D);
  ClearBit(ITP3_D3_D);

  DEV_NR_SetBit;

  // unteres Halbbyte
  Result_Byte_01:=ITP3_empfange_Halbbyte;

  // oberes Halbbyte
  Result_Byte_02:=ITP3_empfange_Halbbyte;

  SHL(Result_Byte_02);
  SHL(Result_Byte_02);
  SHL(Result_Byte_02);
  SHL(Result_Byte_02);

  Result_Byte_01:=Result_Byte_01+Result_Byte_02;

  Result:=Result_Byte_01;

end ITP3_empfange_Byte;





// ****************************
// *** ITP3-Server-Routinen ***
// *** Softwareteil - 2 -   ***
// ****************************






procedure ITP3_sende_CONOUT(CO_Byte : Byte);
begin

  ITP3_sende_Byte(ITP3_CONOUT);
  ITP3_sende_Byte(CO_Byte);

end ITP3_sende_CONOUT;





function ITP3_empfange_CONST : Byte;
var
  RESULT_Byte : Byte;
begin

  ITP3_sende_Byte(ITP3_CONST);
  RESULT_Byte:=ITP3_empfange_Byte;

  Result:=RESULT_Byte;

end ITP3_empfange_CONST;






function ITP3_empfange_CONIN : Byte;
var
  RESULT_Byte : Byte;
begin

  ITP3_sende_Byte(ITP3_CONIN);
  RESULT_Byte:=ITP3_empfange_Byte;

  Result:=RESULT_Byte;

end ITP3_empfange_CONIN;







procedure ITP3_CONIN_Schleife;
begin

  ConsoleIn:=0;

  while ConsoleIn=0 do
    ConsoleIn:=ITP3_empfange_CONST;
  endwhile;

  ConsoleIn:=ITP3_empfange_CONIN;

end ITP3_CONIN_Schleife;





// ***********************
// ITP3 - Laufwerk D
// ***********************



procedure ITP3_sende_STD;
begin

  // ITP3-DRIVE_D_Device
  if DRIVE_D_Device<100 then

    DEV_NR:=DRIVE_D_Device;

    ITP3_sende_Byte(ITP3_STD);
    ITP3_sende_Byte(SECTOR);
    ITP3_sende_Byte(TRACK_L);
    ITP3_sende_Byte(TRACK_H);
    ITP3_sende_Byte(DISKNO);

  endif;

end ITP3_sende_STD;




procedure ITP3_Sektor_lesen;
var
  b1 : Byte;
begin

  // ITP3-DRIVE_D_Device
  if DRIVE_D_Device<100 then

    DEV_NR:=DRIVE_D_Device;

    ITP3_sende_Byte(ITP3_RD_SEC);

    for Sektor_Puffer_Zeiger:=0 to 127 do
      b1:=ITP3_empfange_Byte;
      Sektor_Puffer[Sektor_Puffer_Zeiger]:=b1;
    endfor;

  endif;

end ITP3_Sektor_lesen;







procedure ITP3_Sektor_schreiben;
var
  b1 : Byte;
begin

  // ITP3-DRIVE_D_Device
  if DRIVE_D_Device<100 then

    DEV_NR:=DRIVE_D_Device;

    ITP3_sende_Byte(ITP3_WR_SEC);

    for Sektor_Puffer_Zeiger:=0 to 127 do

      b1:=Sektor_Puffer[Sektor_Puffer_Zeiger];
      ITP3_sende_Byte(b1);

    endfor;

  endif;

end ITP3_Sektor_schreiben;








// ***********************
// ITP3 - Anschlussabfrage
// ***********************


procedure ITP3_pruefe_einen_Anschluss;
var
  ok_Byte : Boolean;
  WHO_ARE_YOU_Byte : Byte;
  b1 : Byte;
begin

  ok_Byte:=ITP3_sende_Test_Byte(ITP3_WHO_ARE_YOU);

  if ok_Byte then

    WHO_ARE_YOU_Byte:=ITP3_empfange_Byte;

    // CONOUT
    b1:=WHO_ARE_YOU_Byte and %10000000;

    if b1>0 then
      CONOUT_Device:=DEV_NR;
    endif;

    // CONIN
    b1:=WHO_ARE_YOU_Byte and %01000000;

    if b1>0 then
      CONIN_Device:=DEV_NR;
    endif;

    // LIST
    b1:=WHO_ARE_YOU_Byte and %00100000;

    if b1>0 then
      LIST_Device:=DEV_NR;
    endif;


    // SOUND
    b1:=WHO_ARE_YOU_Byte and %00010000;

    if b1>0 then
      SOUND_Device:=DEV_NR;
    endif;


    // DRIVE_D
    b1:=WHO_ARE_YOU_Byte and %00001000;

    if b1>0 then
      DRIVE_D_Device:=DEV_NR;
    endif;


  endif;

end ITP3_pruefe_einen_Anschluss;




procedure ITP3_pruefe_Anschluesse;
begin

  // ITP-Device 0 ist selektiert

  DEV_NR:=DEV_DS0;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS1;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS2;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS3;
  ITP3_pruefe_einen_Anschluss;





  DEV_NR:=DEV_DS0;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS1;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS2;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS3;
  ITP3_pruefe_einen_Anschluss;





  DEV_NR:=DEV_DS0;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS1;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS2;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS3;
  ITP3_pruefe_einen_Anschluss;



end ITP3_pruefe_Anschluesse;










