


procedure warte_solange_RD_High;
begin

  // warten bis /RD aktiv wird (Low)
  while BitHigh(RD_Z80_E) do

    if BitHigh(RD_Z80_E) then
      SetBit(CLK_Z80);
    endif;

     if BitHigh(RD_Z80_E) then
      ClearBit(CLK_Z80);
    endif;

  endwhile; // while BitHigh(RD_Z80_E) do

end warte_solange_RD_High;





procedure warte_solange_RD_Low;
begin

  // warten bis /RD inaktiv wird (High)
    while BitLow(RD_Z80_E) do
      SetBit(CLK_Z80);
      NOP;
      ClearBit(CLK_Z80);
    endwhile; // while BitLow(RD_Z80_E) do

end warte_solange_RD_Low;




procedure warte_solange_IORQ_High;
begin

  // warten bis /IORQ aktiv wird (Low)
  while BitHigh(IORQ_Z80_E) do

    if BitHigh(IORQ_Z80_E) then
      SetBit(CLK_Z80);
    endif;

     if BitHigh(IORQ_Z80_E) then
      ClearBit(CLK_Z80);
    endif;

  endwhile; // while BitLow(IORQ_Z80_E) do

end warte_solange_IORQ_High;




procedure warte_solange_IORQ_Low;
begin

  // warten bis /IORQ inaktiv wird (High)
  while BitLow(IORQ_Z80_E) do
    SetBit(CLK_Z80);
    NOP;
    ClearBit(CLK_Z80);
  endwhile; // while BitLow(IORQ_Z80_E) do

end warte_solange_IORQ_Low;







procedure setze_RAM_PAGE(RAM_ADR : Byte);
var
  RAM_PORT : Byte;
begin

  // setzen der RAM-Page aus RAM_ADR
  // die RAM-Page muss auf die Adressbits PB5=A16, PB6=A17 und PB7=A18
  // gelegt werden

  // auswerten A16
  RAM_PORT := RAM_ADR AND %00000001;
  if RAM_PORT=0 then
    ClearBit(A16_RAM);
  else
    SetBit(A16_RAM);
  endif;


  // Festeinstellung
  SetBit(A17_RAM);
  ClearBit(A18_RAM);


end setze_RAM_PAGE;






// Kopieren des RAMs ab Adresse in den Sektor_Puffer
procedure START_RAM2ARR;
var
  SP_Zaehler : Word;
  RAM_Wert : Byte;
  RAM_ADR : Byte;
begin


  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das auszugebende Zeichen
  warte_solange_IORQ_High;

  // ist IORQ auf Low, dann legt das Byte mit der RAM-Adresse an
  RAM_ADR := PinC;

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;



  // Der naechste M1-Zyklus ist der "JMP (HL)"-Befehl


  // warte_solange_RD_High
  warte_solange_RD_High;

  // warte_solange_RD_Low
  warte_solange_RD_Low;


  // Der naechste M1-Zyklus wird abgefangen

  // *** nun wird der RAM gelesen ***

  // Abschalten der /RD und /WR Signale der Z80 an den RAM
  SetBit(G_RAMSW);


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Ausgabe
  SetBit(OE_RAM_D);
  SetBit(WE_RAM_D);

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);



  // setzen der RAM-Page aus RAM_ADR
  // die RAM-Page muss auf die Adressbits PB5=A16, PB6=A17 und PB7=A18
  // gelegt werden
  setze_RAM_PAGE(RAM_ADR);



  for SP_Zaehler:=0 to 127 do


    // warte_solange_RD_High
    warte_solange_RD_High;


    // Daten-Port auf Lesen
    DDRC  :=  %00000000;

    ClearBit(OE_RAM_A);

    NOP;
    NOP;
    NOP;

    RAM_Wert := PinC;
    Sektor_Puffer[SP_Zaehler]:=RAM_Wert;

    SetBit(OE_RAM_A);

    // Daten-Port auf Schreiben
    DDRC  :=  %11111111;


    // Anlegen von NOP an den Datenport fuer die Z80
    PortC := 0;  // NOP


    // warte_solange_RD_Low
    warte_solange_RD_Low;


  // 8. Wiederholen bis das ganze ARRAY in den RAM geladen wurde
  endfor; { for Array_Pos:=0 to Laenge_CPD6_Array do }


  // Ruecksetzen der RAM-Page
  ClearBit(A16_RAM);
  SetBit(A17_RAM);
  ClearBit(A18_RAM);


  // *** Einschreiben von RET ($C9) an Z80


  // warte_solange_RD_High
  warte_solange_RD_High;


  // Daten-Port auf Schreiben
  DDRC  :=  %11111111;

  // Anlegen von RET an den Datenport fuer die Z80
  PORTC := $C9;  // RET


  // warte_solange_RD_Low
  warte_solange_RD_Low;


  // Daten-Port auf Lesen
  DDRC  :=  %00000000;

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Eingabe
  ClearBit(OE_RAM_D);
  ClearBit(WE_RAM_D);

  // Zuschalten der /RD und /WR Signale der Z80 an den RAM
  ClearBit(G_RAMSW);

end START_RAM2ARR;








// Kopieren des Sektor_Puffer in den RAMs ab DMA-Adresse
procedure START_ARR2RAM;
var
  SP_Zaehler : Word;
  RAM_Wert : Byte;
  RAM_ADR : Byte;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das auszugebende Zeichen
  warte_solange_IORQ_High;

  //
  RAM_ADR := PinC;

  // warte_solange_IORQ_Low
  warte_solange_IORQ_Low;

  // Der naechste M1-Zyklus ist der "JMP (HL)"-Befehl

  // warte_solange_RD_High
  warte_solange_RD_High;

  // warte_solange_RD_Low
  warte_solange_RD_Low;


  // Der naechste M1-Zyklus wird abgefangen

  // *** nun wird der RAM gelesen ***

  // Abschalten der /RD und /WR Signale der Z80 an den RAM
  SetBit(G_RAMSW);


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Ausgabe
  SetBit(OE_RAM_D);
  SetBit(WE_RAM_D);

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);


  setze_RAM_PAGE(RAM_ADR);


  for SP_Zaehler:=0 to 127 do


    // warte_solange_RD_High
    warte_solange_RD_High;


    // Daten-Port auf Schreiben
    DDRC  :=  %11111111;

    RAM_Wert := Sektor_Puffer[SP_Zaehler];
    PortC := RAM_Wert;


    ClearBit(WE_RAM_A);

    NOP;
    NOP;
    NOP;

    SetBit(WE_RAM_A);

    // Anlegen von NOP an den Datenport fuer die Z80
    PortC := 0;  // NOP


    // warte_solange_RD_Low
    warte_solange_RD_Low;


  // Wiederholen bis das ganze ARRAY in den RAM geladen wurde
  endfor; { for Array_Pos:=0 to Laenge_CPD6_Array do }


  // Ruecksetzen der RAM-Page
  ClearBit(A16_RAM);
  SetBit(A17_RAM);
  ClearBit(A18_RAM);


  // *** Einschreiben von RET ($C9) an Z80


  // warte_solange_RD_High
  warte_solange_RD_High;


  // Daten-Port auf Schreiben
  DDRC  :=  %11111111;

  // Anlegen von RET an den Datenport fuer die Z80
  PORTC := $C9;  // RET


  // warte_solange_RD_Low
  warte_solange_RD_Low;


  // Daten-Port auf Lesen
  DDRC  :=  %00000000;

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Eingabe
  ClearBit(OE_RAM_D);
  ClearBit(WE_RAM_D);

  // Zuschalten der /RD und /WR Signale der Z80 an den RAM
  ClearBit(G_RAMSW);

end START_ARR2RAM;







// Kopieren des BDOS in den RAM
procedure START_BDOS2RAM;
var
  SP_Zaehler : Word;
  RAM_Wert : Byte;
  RAM_ADR : Byte;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

 // Der naechste M1-Zyklus ist der "JMP (HL)"-Befehl

  warte_solange_RD_High;
  warte_solange_RD_Low;

  // Der naechste M1-Zyklus wird abgefangen

  // *** nun wird in den RAM geschrieben ***

  // Abschalten der /RD und /WR Signale der Z80 an den RAM
  SetBit(G_RAMSW);


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Ausgabe
  SetBit(OE_RAM_D);
  SetBit(WE_RAM_D);

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);



  // Ruecksetzen der RAM-Page
  ClearBit(A16_RAM);
  SetBit(A17_RAM);
  ClearBit(A18_RAM);



  for SP_Zaehler:=0 to Laenge_BDOS_Array do

    warte_solange_RD_High;


    // Daten-Port auf Schreiben
    DDRC  :=  %11111111;

    RAM_Wert := BDOS_ARR[SP_Zaehler];
    PortC := RAM_Wert;

    ClearBit(WE_RAM_A);

    NOP;
    NOP;
    NOP;

    SetBit(WE_RAM_A);


    // Anlegen von NOP an den Datenport fuer die Z80
    PortC := 0;  // NOP

    warte_solange_RD_Low;

  // Wiederholen bis das ganze ARRAY in den RAM geladen wurde
  endfor; { for SP_Zaehler:=0 to Laenge_BDOS_Array do }



  // *** Einschreiben von RET ($C9) an Z80

  warte_solange_RD_High;

  // Daten-Port auf Schreiben
  DDRC  :=  %11111111;

  // Anlegen von RET an den Datenport fuer die Z80
  PORTC := $C9;  // RET

  warte_solange_RD_Low;

  // Daten-Port auf Lesen
  DDRC  :=  %00000000;

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Eingabe
  ClearBit(OE_RAM_D);
  ClearBit(WE_RAM_D);

  // Zuschalten der /RD und /WR Signale der Z80 an den RAM
  ClearBit(G_RAMSW);

end START_BDOS2RAM;








// Kopieren des CCP in den RAM
procedure START_CCP2RAM;
var
  SP_Zaehler : Word;
  RAM_Wert : Byte;
  RAM_ADR : Byte;
begin


  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;


  // Der naechste M1-Zyklus ist der "JMP (HL)"-Befehl

  warte_solange_RD_High;
  warte_solange_RD_Low;


  // Der naechste M1-Zyklus wird abgefangen

  // *** nun wird in den RAM geschrieben ***

  // Abschalten der /RD und /WR Signale der Z80 an den RAM
  SetBit(G_RAMSW);


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Ausgabe
  SetBit(OE_RAM_D);
  SetBit(WE_RAM_D);

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);



    // Ruecksetzen der RAM-Page
  ClearBit(A16_RAM);
  SetBit(A17_RAM);
  ClearBit(A18_RAM);



  for SP_Zaehler:=0 to Laenge_CCP_Array do

    warte_solange_RD_High;


    // Daten-Port auf Schreiben
    DDRC  :=  %11111111;

    RAM_Wert := CCP_ARR[SP_Zaehler];
    PortC := RAM_Wert;

    ClearBit(WE_RAM_A);

    NOP;
    NOP;
    NOP;

    SetBit(WE_RAM_A);


    // Anlegen von NOP an den Datenport fuer die Z80
    PortC := 0;  // NOP

    warte_solange_RD_Low;

  // Wiederholen bis das ganze ARRAY in den RAM geladen wurde
  endfor; { for SP_Zaehler:=0 to Laenge_BDOS_Array do }



  // *** Einschreiben von RET ($C9) an Z80

  warte_solange_RD_High;

  // Daten-Port auf Schreiben
  DDRC  :=  %11111111;

  // Anlegen von RET an den Datenport fuer die Z80
  PORTC := $C9;  // RET

  warte_solange_RD_Low;

  // Daten-Port auf Lesen
  DDRC  :=  %00000000;

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Eingabe
  ClearBit(OE_RAM_D);
  ClearBit(WE_RAM_D);

  // Zuschalten der /RD und /WR Signale der Z80 an den RAM
  ClearBit(G_RAMSW);

end START_CCP2RAM;






// Kopieren des Disk-Images in den RAM
procedure COPY_DISK_TO_RAM;
var
  SP_Zaehler : Word;
  RAM_Wert : Byte;
  RAM_ADR : Byte;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;


  // Der naechste M1-Zyklus ist der "JMP (HL)"-Befehl

  warte_solange_RD_High;
  warte_solange_RD_Low;


  // Der naechste M1-Zyklus wird abgefangen

  // *** nun wird in den RAM geschrieben ***

  // Abschalten der /RD und /WR Signale der Z80 an den RAM
  SetBit(G_RAMSW);


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Ausgabe
  SetBit(OE_RAM_D);
  SetBit(WE_RAM_D);

  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);



  // Setzen der RAM-Page auf 1 (0 ist CP/M RAM)
  SetBit(A16_RAM);
  SetBit(A17_RAM);
  ClearBit(A18_RAM);



  for SP_Zaehler:=0 to Laenge_DISK_Array do

    warte_solange_RD_High;

    // Daten-Port auf Schreiben
    DDRC  :=  %11111111;

    RAM_Wert := DISK_ARR[SP_Zaehler];
    PortC := RAM_Wert;

    ClearBit(WE_RAM_A);

    NOP;
    NOP;
    NOP;

    SetBit(WE_RAM_A);

    // Anlegen von NOP an den Datenport fuer die Z80
    PortC := 0;  // NOP

    warte_solange_RD_Low;

  // Wiederholen bis das ganze ARRAY in den RAM geladen wurde
  endfor; { for SP_Zaehler:=0 to Laenge_BDOS_Array do }



  // *** Einschreiben von RET ($C9) an Z80

  warte_solange_RD_High;

  // Daten-Port auf Schreiben
  DDRC  :=  %11111111;

  // Anlegen von RET an den Datenport fuer die Z80
  PORTC := $C9;  // RET

  warte_solange_RD_Low;

  // Daten-Port auf Lesen
  DDRC  :=  %00000000;


   // Ruecksetzen der RAM-Page
  ClearBit(A16_RAM);
  SetBit(A17_RAM);
  ClearBit(A18_RAM);


  // OE und WE aktivieren
  SetBit(OE_RAM_A);
  SetBit(WE_RAM_A);

  // OE und WE DIR Eingabe
  ClearBit(OE_RAM_D);
  ClearBit(WE_RAM_D);

  // Zuschalten der /RD und /WR Signale der Z80 an den RAM
  ClearBit(G_RAMSW);

end COPY_DISK_TO_RAM;





