PROGRAM ITP3_NANO;

// Arduino Nano
DEVICE = MEGA328P;

{$I mega328P_Register.INC}


CONST
  // Arduino Nano
  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 16000;

  // bei 16,000 MHz -> 38.400
  UBRR_VAL : Byte = 25;


VAR
  LED_Rot[PortB,0] : bit;   // LED_Rot
  LED_Gelb[PortB,1] : bit;  // LED_Gelb
  LED_Gruen[PortB,2] : bit; // LED_Gruen


{$I SYSTEM.INC}

{$I mega328P_UART_oI.INC}

{$I ITP3_SRV_PORT.INC}

{$I ITP3_SRV_PRG.INC}




// *** INITIALISIERUNG ***



procedure InitPorts;
begin
{
B0 - LED Rot
B1 - LED Gelb
B2 - LED Gruen
}
  //       EEEEEAAA
  DDRB:=  %00000111;

  // PORT B Voreinstellungen
  PortB:= %00000000;

{
C0..C5 - ITP3-PINs erst mal alle auf Eingang
}
  //       EEEEEEEE
  DDRC:=  %00000000;

  // PORT C Voreinstellungen
  PortC:= %00000000;

end InitPorts;




procedure a1;
begin

  ITP3_sende_CONOUT(SER0_Zeichen);
  SER0_String:='CONOUT';
  WriteLn_SER0;

end a1;



procedure b1;
var
  CI_Byte : Byte;
begin

  CI_Byte:=ITP3_empfange_CONST;
  ByteToString(CI_Byte);
  SER0_String:='CONST='+Byte_String;
  WriteLn_SER0;

end b1;



procedure c1;
var
  CI_Byte : Byte;
begin

  CI_Byte:=ITP3_empfange_CONIN;
  ByteToString(CI_Byte);
  SER0_String:='CONIN='+Byte_String;
  WriteLn_SER0;

end c1;





procedure Auswertung;
begin

  case SER0_Zeichen of

    $61 : a1;  // a
    |

    $62 : b1;  // b    |
    |

    $63 : c1;  // c
    |

  else

    SER0_String:='*** Fehler';
    WriteLn_SER0;

  endcase;

end Auswertung;





BEGIN

  InitPorts;

  INIT_SER0_PORT;

  ITP3_Init;


  SER0_String:='init o.k.';
  WriteLn_SER0;



  loop

    RX0_Puffer_abfragen;

    if SER0_Zeichen>0 then
      Auswertung;
    endif;

  endloop;


END ITP3_NANO.
