PROGRAM MEGA;

DEVICE = mega2560;

{$I mega2560_Register.INC}


CONST

  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 16000;

  // bei 16,000 MHz ->
  UBRR_VAL : Byte = 5;


  Matrix_Col_Max : Word = 79;   // 0..79 = 80
  Matrix_Row_Max : Word = 23;   // 0..23 = 24

  Fuellzeichen : Byte = $20;  // Leerzeichen
//  Fuellzeichen : Byte = $2E;  //  Punkt
  Fuellfarbe_VG : Byte = $00;
  Fuellfarbe_HG : Byte = $FF;


  // TerminalMode
  Normal_TM            : Byte = 0;
  IBM_ESC_TM           : Byte = 1;
  IBM_CSI_TM           : Byte = 2;
  IBM_CSI_TM_Par_1     : Byte = 3;
  IBM_CSI_TM_Par_2     : Byte = 4;
  IBM_CSI_TM_Par_3     : Byte = 5;
  IBM_GRAFIK_Par_1_TM  : Byte = 6;
  IBM_GRAFIK_Par_2_TM  : Byte = 7;





// Font fuer 6x8 Zeichen
{$I font6x8.INC}

// Font fuer 8x8 Zeichen
//{$I font8x8.INC}

// Font fuer 8x12 Zeichen
//{$I font8x12.INC}

// Font fuer 10x16 Zeichen
//{$I font10x16.INC}

// Font fuer 12x20 Zeichen
//{$I font12x20.INC}



// Farbtabelle fuer LCD
{$I COLOR_256.INC}



VAR

  LED_GELB[PortB, 7] : bit; // A

  // Command or Data LCD (LOW-Active)
  LCD_COM_DAT[PortD, 7]       : bit; // A
  // Write LCD (LOW-Active)
  LCD_WR[PortG, 2]       : bit; // A
  // Chip-Select LCD
  LCD_CS[PortG, 1]       : bit; // A
  // Reset LCD
  LCD_RSET[PortG, 0]     : bit; // A

  DIR_RS[DDRD, 7]    : bit; // A
  DIR_WR[DDRG, 2]    : bit; // A
  DIR_CS[DDRG, 1]    : bit; // A
  DIR_RSET[DDRG, 0]  : bit; // A



  Zeichenbreite, Zeichenhoehe,
  X_ANF, Y_ANF,
  X_KUR_POS, Y_KUR_POS : Word;




  Zeichenbreite0, Zeichenhoehe0 : Word;

  Steuer_String : String[20];


  // Variablen zum Font
  max_Spalten, max_Zeilen : Word;

  // Bezeichnung des Fonts
  Font_Bez : Byte;


  TermMode : Byte;

  CSI_Parameter1, CSI_Parameter2,
  CSI_Parameter3 : Word;

  Escape_Sequenz : String[10];

  // Kursor-Variablen
  Kursor_sichtbar : Boolean;
  Kursor_Schleife : DWord;


  // Zeichen-Matrix und Farb-Matrix
  Zeichen_Matrix : Array [0..Matrix_Col_Max,0..Matrix_Row_Max] of Byte;
  VG_Farb_Matrix : Array [0..Matrix_Col_Max,0..Matrix_Row_Max] of Byte;
  HG_Farb_Matrix : Array [0..Matrix_Col_Max,0..Matrix_Row_Max] of Byte;


  LED_ein : Word;

  WHO_AM_I_Schleife : Boolean;



// System
{$I SYSTEM.INC}

//
{$I LCD_SSD1289.INC}






{

DB0->DB7 to pin D37->D30
PORTC

DB8->DB15 to pin D22->D29
PORTA

RS -> D38
PORTD 7

WR -> D39
PORTG 2

CS(pin6) -> D40
PORTG 1

RSET-> D41
PORTG 0

}




procedure InitPorts;
begin

  // LED
  DDRB:=  %11111111;

  // DB8->DB15
  DDRA:=  %11111111;
  // DB0->DB7
  DDRC:=  %11111111;

  // Daten/Kommandos
  SetBit(LCD_COM_DAT);
  SetBit(DIR_RS);
  SetBit(LCD_COM_DAT);

  // Write Low-Aktiv
  SetBit(LCD_WR);
  SetBit(DIR_WR);
  SetBit(LCD_WR);

  // Chip-Select Low-Aktiv
  SetBit(LCD_CS);
  SetBit(DIR_CS);
  SetBit(LCD_CS);

  // Reset Low-Aktiv
  SetBit(LCD_RSET);
  SetBit(DIR_RSET);
  SetBit(LCD_RSET);

end InitPorts;




{$I CONOUT.INC}



// ITP3
{$I ITP3_CLI_PORT.INC}
{$I ITP3_CLI_PRG.INC}




BEGIN

  InitPorts;

  ITP3_Client_Init;

  Init_SSD1289;

  INIT_CONOUT;


  Write_String:='serielles LCD-Terminal';
  Text_an_CONOUT;

  Write_String:='Font = 6x8';
  Text_an_CONOUT;





  WHO_AM_I_Schleife:=true;

  while WHO_AM_I_Schleife do

     ITP3_Server_Abfrage;

     SetBit(LED_GELB);
     wait_ms(1);

  endwhile;




  clear_Screen;

  Clear_Matrix;


  Kursor_Schleife:=0;
  Kursor_sichtbar:=false;

  LED_ein:=0;


  loop

    ITP3_Server_Abfrage;

    SetBit(LED_GELB);
    wait_ms(1);

    INC(Kursor_Schleife);

    if Kursor_Schleife>160 then
      Kursor_Umschalten;
    endif;


    if LED_ein>0 then
      ClearBit(LED_BL);
      Dec(LED_ein);
    else
      SetBit(LED_BL);
    endif;


  endloop;



END MEGA.
