PROGRAM TST01;

DEVICE = mega328p;

{$I mega328P_Register.INC}


CONST

  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 8000;


VAR


  LSP_D0[PortB,0] : bit;      // Ausgang - Lautsprecher Bit 0
  LSP_D1[PortB,1] : bit;      // Ausgang - Lautsprecher Bit 1
  SERIAL_DATA[PortB,2] : bit; // Ausgang - 74595 - SERIAL_DATA

  TZ_00[PIND,1] : bit;        // Eingang - Tastatur Zeile 00
  TZ_01[PIND,0] : bit;        // Eingang - Tastatur Zeile 01
  TZ_02[PIND,2] : bit;        // Eingang - Tastatur Zeile 02
  TZ_03[PIND,3] : bit;        // Eingang - Tastatur Zeile 03
  {
  TZ_04[PIND,4] : bit;        // Eingang - Tastatur Zeile 04
  TZ_05[PIND,5] : bit;        // Eingang - Tastatur Zeile 05
  }
  LED_BL_L[PortD,4] : bit;     // Ausgang - LED Blau Links
  LED_BL_R[PortD,5] : bit;     // Ausgang - LED Blau Rechts

  SHIFT_CLOCK[PortD,6] : bit; // Ausgang - 74595 - SHIFT_CLOCK
  LATCH_CLOCK[PortD,7] : bit; // Ausgang - 74595 - LATCH_CLOCK


  Status_LED_Gelb, Status_LED_Gruen,
  Status_LED_Rot_L, Status_LED_Rot_R : Boolean;




{$I SYSTEM.INC}

{$I TON.INC}

{$I KBD.INC}

{$I ITP3_CLI_PORT.INC}
{$I ITP3_CLI_PRG.INC}






// *** INITIALISIERUNG ***


procedure InitPorts;
begin

{
  LSP_D0[PortB,0] : bit;      // Ausgang - Lautsprecher Bit 0
  LSP_D1[PortB,1] : bit;      // Ausgang - Lautsprecher Bit 1
  SERIAL_DATA[PortB,2] : bit; // Ausgang - 74595 - SERIAL_DATA
}
  //       EEEEEAAA
  DDRB:=  %00000111;

  // PORT B Voreinstellungen
  PORTB:= %00000000;


{
C0..C3 - Daten fuer ITP3

C4 - DS - E -> L
C5 - DR - E -> L
}
  //       EEEEEEEE
  DDRC:=  %00000000;

  // PORT C Voreinstellungen
  PortC:= %00000000;


{
D0..D3 - TZ_00 bis TZ_03
D4 - LED_BL_L - Ausgaenge
D5 - LED_BL_R - Ausgaenge
D6 und D7 - Daten fuer 74HC165 - Ausgaenge
}
  //       AAAAEEEE
  DDRD:=  %11110000;

  // PORT D Voreinstellungen
  PortD:= %00000000;



end InitPorts;



PROCEDURE wait_ms2(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 10 do
    endfor;
  endfor;
END wait_ms2;




PROCEDURE ton(Frq, Dauer : Word);
var
  w0 : Word;
BEGIN

  for w0:=1 to Dauer do

  ClearBit(LSP_D0);
  ClearBit(LSP_D1);
  wait_ms2(Frq);

  SetBit(LSP_D0);
  ClearBit(LSP_D1);
  wait_ms2(Frq);

  ClearBit(LSP_D0);
  SetBit(LSP_D1);
  wait_ms2(Frq);

  SetBit(LSP_D0);
  SetBit(LSP_D1);
  wait_ms2(Frq);

  ClearBit(LSP_D0);
  SetBit(LSP_D1);
  wait_ms2(Frq);

  SetBit(LSP_D0);
  ClearBit(LSP_D1);
  wait_ms2(Frq);

  endfor;

END ton;




PROCEDURE ton2;
BEGIN
    WD_Word:=$0000;
    Write_Data_Word;

  //  SetBit(LED_BL_L);

    ton(10,20);
    wait_ms(20);

    ton(80,20);
    wait_ms(20);

 //   ClearBit(LED_BL_L);

    ton(60,20);
    wait_ms(20);

    ton(30,20);
    wait_ms(20);

    WD_Word:=$FFFF;
    Write_Data_Word;


 //   SetBit(LED_BL_R);

    ton(20,10);
    ton(25,10);
    ton(22,10);
    ton(18,10);

  //  ClearBit(LED_BL_R);

    WD_Word:=$0000;
    Write_Data_Word;

END ton2;




PROCEDURE ton3;
BEGIN

  SetBit(LED_BL_L);
  SetBit(LED_BL_R);

  WD_Word:=$FFFF;
  Write_Data_Word;

  ton(20,5);
  ton(25,5);
  ton(22,5);
  ton(18,5);

  ClearBit(LED_BL_L);
  ClearBit(LED_BL_R);

  WD_Word:=$0000;
  Write_Data_Word;

END ton3;







BEGIN


  InitPorts;

  KBD_Init;

  ITP3_Client_Init;

  ton3;



  ClearBit(LED_BL_R);

  loop

    Tastatur_lesen;
    ITP3_Server_Abfrage;

  endloop;




END TST01.
