
CONST
  WaitKon : Word = TaktFrequenz / 1000;
  WaitKon2 : Word = WaitKon * 45;


VAR
  Byte_Hex_String  : String[2];
  Byte_Dez_String  : String[3];
  Word_Hex_String  : String[4];
  DWord_Hex_String : String[8];


// ***********************************************
// *****    Bit-Manipulations-Programme      *****
// ***********************************************



function BytePosToORMaske(BytePos : Byte) : Byte;
begin
  case BytePos of
    0 : RESULT:=%00000001;
    |
    1 : RESULT:=%00000010;
    |
    2 : RESULT:=%00000100;
    |
    3 : RESULT:=%00001000;
    |
    4 : RESULT:=%00010000;
    |
    5 : RESULT:=%00100000;
    |
    6 : RESULT:=%01000000;
    |
    7 : RESULT:=%10000000;
    |
  else
    RESULT:=%00000001;
  endcase;

end BytePosToORMaske;





function BytePosToANDMaske(BytePos : Byte) : Byte;
begin
  case BytePos of
    0 : RESULT:=%11111110;
    |
    1 : RESULT:=%11111101;
    |
    2 : RESULT:=%11111011;
    |
    3 : RESULT:=%11110111;
    |
    4 : RESULT:=%11101111;
    |
    5 : RESULT:=%11011111;
    |
    6 : RESULT:=%10111111;
    |
    7 : RESULT:=%01111111;
    |
  else
    RESULT:=%11111110;
  endcase;

end BytePosToANDMaske;




function Read_Bit_in_Byte(TestByte, BytePos : Byte) : Boolean;
var
  Vergleich : Byte;
  Maske : Byte;
begin

  Maske:=BytePosToORMaske(BytePos);

  Vergleich:=TestByte and Maske;

  if Vergleich=0 then
    RESULT:=false;
  else
    RESULT:=true;
  endif;

end  Read_Bit_in_Byte;







function Set_Bit_in_Byte(TestByte, BytePos : Byte) : Byte;
var
  Ergebnis : Byte;
  Maske : Byte;
begin

  Maske:=BytePosToORMaske(BytePos);

  Ergebnis:=TestByte or Maske;

  RESULT:=Ergebnis;

end  Set_Bit_in_Byte;







function Clear_Bit_in_Byte(TestByte, BytePos : Byte) : Byte;
var
  Ergebnis : Byte;
  Maske : Byte;
begin

  Maske:=BytePosToANDMaske(BytePos);

  Ergebnis:=TestByte AND Maske;

  RESULT:=Ergebnis;

end  Clear_Bit_in_Byte;




function Negation_Byte(das_Byte : Byte) : Byte;
begin

  ASM;
    COM    R0
  ENDASM;

  RESULT:=das_Byte;

end  Negation_Byte;






// ******************************
// ***    Hilfssprogramme     ***
// ******************************



// WAIT in Millisekunden
PROCEDURE wait_ms(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to WaitKon2 do
    endfor;
  endfor;
END wait_ms;







// ******************************
// ***       INT to STR       ***
// ******************************




// Wert_Byte in BW_String
procedure ByteToHexString(Wert_Byte : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
  c1 : Char;
begin

  HexHigh:=Wert_Byte and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  c1:=ByteToChar(HexHigh);
  Byte_Hex_String:=c1;

  HexLow:=Wert_Byte and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  c1:=ByteToChar(HexLow);
  Byte_Hex_String:=Byte_Hex_String+c1;

end ByteToHexString;






// Wert_Byte in BW_String
procedure ByteToDezString(Wert_Byte : Byte);
var
  b1 : Byte;
  b2 : Byte;
  c1 : Char;
begin

  b1:=0;
  while Wert_Byte>100 do
  endwhile;

  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  // nicht implementiert

  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

end ByteToDezString;






function HexStringToByte : Byte;
var
  HexLow : Byte;
  HexHigh : Byte;
  S2B : Byte;
  c1 : Char;
begin

  c1:=Byte_Hex_String[1];
  HexHigh:=CharToByte(c1);
  HexHigh:=HexHigh-48;
  if HexHigh>9 then
    HexHigh:=HexHigh-7;
  endif;
  SHL(HexHigh);
  SHL(HexHigh);
  SHL(HexHigh);
  SHL(HexHigh);

  c1:=Byte_Hex_String[2];
  HexLow:=CharToByte(c1);
  HexLow:=HexLow-48;
  if HexLow>9 then
    HexLow:=HexLow-7;
  endif;

  S2B:=HexHigh+HexLow;

  RESULT:=S2B;

end HexStringToByte;







procedure WordToHexString(Wert_Word : Word);
var
  Byte_Low  : Byte;
  Byte_High : Byte;
begin

  Byte_Low:=Low(Wert_Word);
  Byte_High:=High(Wert_Word);
  ByteToHexString(Byte_High);
  Word_Hex_String:=Byte_Hex_String;
  ByteToHexString(Byte_Low);
  Word_Hex_String:=Word_Hex_String+Byte_Hex_String;

end WordToHexString;





//
function HexStringToWord : Word;
var
  c1 : Char;
  S2W : Word;
  S2B : Byte;
  S2W2 : Word;
begin

  // HWT
  c1:=Word_Hex_String[1];
  Byte_Hex_String:=c1;
  c1:=Word_Hex_String[2];
  Byte_Hex_String:=Byte_Hex_String+c1;

  S2B:=HexStringToByte;

  S2W:=ByteToWord(S2B);
  S2W:=S2W*256;


  // LWT
  c1:=Word_Hex_String[3];
  Byte_Hex_String:=c1;
  c1:=Word_Hex_String[4];
  Byte_Hex_String:=Byte_Hex_String+c1;

  S2B:=HexStringToByte;

  S2W2:=ByteToWord(S2B);
  S2W:=S2W+S2W2;

  RESULT:=S2W;

end HexStringToWord;





// *** DWord ***



procedure DWordToHexString(Wert_DWord : DWord);
var
  Word_Low  : Word;
  Word_High : Word;
begin

  Word_Low:=DWLow(Wert_DWord);
  Word_High:=DWHigh(Wert_DWord);
  WordToHexString(Word_High);
  DWord_Hex_String:=Word_Hex_String;
  WordToHexString(Word_Low);
  DWord_Hex_String:=DWord_Hex_String+Word_Hex_String;

end DWordToHexString;







