

CONST


  cl_White    : Byte = 255;
  cl_Black    : Byte = 000;
  cl_Red      : Byte = 214;
  cl_Green    : Byte = 040;
  cl_Blue     : Byte = 003;
  cl_Yellow   : Byte = 250;
  cl_Purple   : Byte = 133;   // ?
  cl_Aqua     : Byte = 045;
  cl_Gray     : Byte = 133;   // ?
  cl_DarkGray : Byte = 133;   // ?
  cl_Silver   : Byte = 202;   // ?
  cl_Maroon   : Byte = 130;   // ?
  cl_Olive    : Byte = 154;   // ?
  cl_Lime     : Byte = 040;
  cl_Teal     : Byte = 026;
  cl_Navy     : Byte = 001;
  cl_Fuchsia  : Byte = 219;





  // Werte fuer Font_Bez
  fnt_6x8   : Byte = 1;
  fnt_8x8   : Byte = 2;
  fnt_8x12  : Byte = 3;
  fnt_10x16 : Byte = 4;
  fnt_12x20 : Byte = 5;



VAR

  // Direction = Richtung
  LCD_RD_DIR[DDRF ,0] : bit; // D
  LCD_WR_DIR[DDRF ,1] : bit; // D
  LCD_RS_DIR[DDRF ,2] : bit; // D
  LCD_CS_DIR[DDRF ,3] : bit; // D
  LCD_RST_DIR[DDRF,4] : bit; // D

  LCD_D7_DIR[DDRH ,4] : bit; // D
  LCD_D6_DIR[DDRH ,3] : bit; // D
  LCD_D5_DIR[DDRE ,3] : bit; // D
  LCD_D4_DIR[DDRG ,5] : bit; // D
  LCD_D3_DIR[DDRE ,5] : bit; // D
  LCD_D2_DIR[DDRE ,4] : bit; // D
  LCD_D1_DIR[DDRH ,6] : bit; // D
  LCD_D0_DIR[DDRH ,5] : bit; // D


  // Ausgang
  LCD_RD_A[PortF ,0] : bit; // D
  LCD_WR_A[PortF ,1] : bit; // D
  LCD_RS_A[PortF ,2] : bit; // D
  LCD_CS_A[PortF ,3] : bit; // D
  LCD_RST_A[PortF,4] : bit; // D

  LCD_D7_A[PortH ,4] : bit; // D
  LCD_D6_A[PortH ,3] : bit; // D
  LCD_D5_A[PortE ,3] : bit; // D
  LCD_D4_A[PortG ,5] : bit; // D
  LCD_D3_A[PortE ,5] : bit; // D
  LCD_D2_A[PortE ,4] : bit; // D
  LCD_D1_A[PortH ,6] : bit; // D
  LCD_D0_A[PortH ,5] : bit; // D


  // Eingang
  LCD_RD_E[PinF ,0] : bit; // D
  LCD_WR_E[PinF ,1] : bit; // D
  LCD_RS_E[PinF ,2] : bit; // D
  LCD_CS_E[PinF ,3] : bit; // D
  LCD_RST_E[PinF,4] : bit; // D

  LCD_D7_E[PinH ,4] : bit; // D
  LCD_D6_E[PinH ,3] : bit; // D
  LCD_D5_E[PinE ,3] : bit; // D
  LCD_D4_E[PinG ,5] : bit; // D
  LCD_D3_E[PinE ,5] : bit; // D
  LCD_D2_E[PinE ,4] : bit; // D
  LCD_D1_E[PinH ,6] : bit; // D
  LCD_D0_E[PinH ,5] : bit; // D






VAR
  L_Zeichen : Byte;
  L_FCOLOR, L_BCOLOR : DWord;

  // Hilfsvariable fuer die Pixel-Farbe (nur fuer diese INC)
  L_Pixel_Farbe : DWord;
  L_X_PIX_POS, L_Y_PIX_POS : Word;






{ *************************************************** }
{ *******     PORT spezifische Routinen       ******* }
{ *************************************************** }






procedure Init_ILI9481_PORT;
begin

  // Steuerleitungen auf Ausgang
  SetBit(LCD_RD_DIR); // RD = Ausgang
  SetBit(LCD_WR_DIR); // WR = Ausgang
  SetBit(LCD_RS_DIR); // RS = Ausgang
  SetBit(LCD_CS_DIR); // CS = Ausgang
  SetBit(LCD_RST_DIR); // RST = Ausgang

  // Steuerleitungen Pegel auf inaktiv (High)
  SetBit(LCD_RD_A);
  SetBit(LCD_WR_A);
  SetBit(LCD_RS_A);
  SetBit(LCD_CS_A);
  SetBit(LCD_RST_A);

  // Datenleitungen auf Ausgang
  SetBit(LCD_D0_DIR);
  SetBit(LCD_D1_DIR);
  SetBit(LCD_D2_DIR);
  SetBit(LCD_D3_DIR);
  SetBit(LCD_D4_DIR);
  SetBit(LCD_D5_DIR);
  SetBit(LCD_D6_DIR);
  SetBit(LCD_D7_DIR);


end Init_ILI9481_PORT;








procedure LCD_Write(WR_Byte : Byte);
var
  b1 : Byte;
begin

  // D0
  b1:=WR_Byte and %00000001;

  if b1=0 then
    ClearBit(LCD_D0_A);
  else
    SetBit(LCD_D0_A);
  endif;


  // D1
  b1:=WR_Byte and %00000010;

  if b1=0 then
    ClearBit(LCD_D1_A);
  else
    SetBit(LCD_D1_A);
  endif;


  // D2
  b1:=WR_Byte and %00000100;

  if b1=0 then
    ClearBit(LCD_D2_A);
  else
    SetBit(LCD_D2_A);
  endif;


  // D3
  b1:=WR_Byte and %00001000;

  if b1=0 then
    ClearBit(LCD_D3_A);
  else
    SetBit(LCD_D3_A);
  endif;


  // D4
  b1:=WR_Byte and %00010000;

  if b1=0 then
    ClearBit(LCD_D4_A);
  else
    SetBit(LCD_D4_A);
  endif;


  // D5
  b1:=WR_Byte and %00100000;

  if b1=0 then
    ClearBit(LCD_D5_A);
  else
    SetBit(LCD_D5_A);
  endif;


  // D6
  b1:=WR_Byte and %01000000;

  if b1=0 then
    ClearBit(LCD_D6_A);
  else
    SetBit(LCD_D6_A);
  endif;


  // D7
  b1:=WR_Byte and %10000000;

  if b1=0 then
    ClearBit(LCD_D7_A);
  else
    SetBit(LCD_D7_A);
  endif;


  ClearBit(LCD_WR_A);
  NOP;
  NOP;
  NOP;
  NOP;
  SetBit(LCD_WR_A);

end LCD_Write;





procedure LCD_Write_Com(COM_Byte : Byte);
begin

  // //RS=0 -> COM
  ClearBit(LCD_RS_A);
  LCD_Write(COM_Byte);

end LCD_Write_Com;




procedure LCD_Write_Data(DATA_Byte : Byte);
begin

  // //RS=1 -> DATA
  SetBit(LCD_RS_A);
  LCD_Write(DATA_Byte);

end LCD_Write_Data;






procedure LCD_Write_Data_Word(DATA_Word : Word);
var
  b1 : Byte;
begin

  // //RS=1 -> DATA
  SetBit(LCD_RS_A);

  b1 := High(DATA_Word);
  LCD_Write(b1);

  b1 := Low(DATA_Word);
  LCD_Write(b1);

end LCD_Write_Data_Word;






procedure LCD_Write_Data_DWord(DATA_DWord : DWord);
var
  b1 : Byte;
begin

  // //RS=1 -> DATA
  SetBit(LCD_RS_A);

  b1 := DWordToByte(2,DATA_DWord);
  LCD_Write(b1);

  b1 := DWordToByte(1,DATA_DWord);
  LCD_Write(b1);

  b1 := DWordToByte(0,DATA_DWord);
  LCD_Write(b1);

end LCD_Write_Data_DWord;



{ *************************************************** }
{ *******         Software Routinen           ******* }
{ *************************************************** }







procedure Init_ILI9481_SW;
begin

  SetBit(LCD_RST_A);
  wait_ms(5);
  ClearBit(LCD_RST_A);
  wait_ms(15);
  SetBit(LCD_RST_A);
  wait_ms(15);

  ClearBit(LCD_CS_A);


  // Exit_sleep_mode
  // Einschalten aller Baugruppen
  LCD_Write_Com($11);
  wait_ms(120);


  // Power_Setting
  // Einstellung der Optionen zur internen Stromversorgung Teil 1
  LCD_Write_Com($D0);
  LCD_Write_Data($07);
  LCD_Write_Data($42);
  LCD_Write_Data($18);


  // VCOM Control
  // Einstellung der Optionen zur internen Stromversorgung Teil 2
  LCD_Write_Com($D1);
  LCD_Write_Data($00);
  LCD_Write_Data($07);//07
  LCD_Write_Data($10);


  // Power_Setting for Normal Mode
  // Einstellung der Optionen zur internen Stromversorgung Teil 3
  LCD_Write_Com($D2);
  LCD_Write_Data($01);
  LCD_Write_Data($02);


  // Panel Driving Setting
  //
  LCD_Write_Com($C0);
  Lcd_Write_Data($10);  // REV=1  Enables the grayscale inversion of the image by setting REV=1.
  Lcd_Write_Data($3B);  // 001111011
  Lcd_Write_Data($00);
  Lcd_Write_Data($02);
  Lcd_Write_Data($11);


  // Frame Rate and Inversion Control
  // Set the frame frequency of the full colors normal mode.
  // The frame frequency needs to meet 80Hz±5% in this mode.
  Lcd_Write_Com($C5);
  Lcd_Write_Data($03);  // 111 -> 42 Hz






  // Gamma Settings
  Lcd_Write_Com($C8);
  Lcd_Write_Data($00);
  Lcd_Write_Data($32);
  Lcd_Write_Data($36);
  Lcd_Write_Data($45);
  Lcd_Write_Data($06);
  Lcd_Write_Data($16);
  Lcd_Write_Data($37);
  Lcd_Write_Data($75);
  Lcd_Write_Data($77);
  Lcd_Write_Data($54);
  Lcd_Write_Data($0C);
  Lcd_Write_Data($00);







  // Set_address_mode
  // This command defines read/write scanning direction of frame memory.
  // This command makes no change on the other driver status.
  Lcd_Write_Com($36);

  Lcd_Write_Data(%01011000);
  // Bit B6 – Column Address Order  =>  1 = Right to Left
  // Bit B4 – Line Address Order    =>  1 = LCD Refresh Bottom to Top
  // Bit B3 – RGB/BGR Order         =>  1 = Pixels sent in BGR order



  // Set_pixel_format
  // This command sets the pixel format for the RGB image data used by the interface.
  Lcd_Write_Com($3A);
  Lcd_Write_Data($06); // DBI = 110 -> 18bit/pixel



  // Set_column_address
  // This command defines the column extent of the frame memory accessed by the host processor with the
  // read_memory_continue and write_memory_continue commands. No status bits are changed.
  Lcd_Write_Com($2A);
  Lcd_Write_Data($00);
  Lcd_Write_Data($00);
  Lcd_Write_Data($01); // 319
  Lcd_Write_Data($3F);


  // Set_page_address
  // This command defines the page extent of the frame memory accessed by the host processor with the
  // write_memory_continue and read_memory_continue command. No status bits are changed.
  Lcd_Write_Com($2B);
  Lcd_Write_Data($00);
  Lcd_Write_Data($00);
  Lcd_Write_Data($01); // 480
  Lcd_Write_Data($E0);

  wait_ms(120);





  // Set_display_on
  // Display einschalten
  Lcd_Write_Com($29);


  // Write_memory_start
  // This command transfers image data from the host processor to the display module’s frame memory starting at the pixel
  // location specified by preceding set_column_address (2Ah) and set_page_address (2Bh) commands.
  Lcd_Write_Com($2C);


  SetBit(LCD_CS_A);


end Init_ILI9481_SW;









// Adressfenster von x1,y1 nach x2,y2
procedure setze_Adresse_Hoch(x1,y1,x2,y2 : Word);
var
  b1 : Byte;
begin

  Lcd_Write_Com($2A);
  b1:=High(x1);
  Lcd_Write_Data(b1);
  b1:=Low(x1);
  Lcd_Write_Data(b1);
  b1:=High(x2);
  Lcd_Write_Data(b1);
  b1:=Low(x2);
  Lcd_Write_Data(b1);

  Lcd_Write_Com($2B);
  b1:=High(y1);
  Lcd_Write_Data(b1);
  b1:=Low(y1);
  Lcd_Write_Data(b1);
  b1:=High(y2);
  Lcd_Write_Data(b1);
  b1:=Low(y2);
  Lcd_Write_Data(b1);

  Lcd_Write_Com($2C);

end setze_Adresse_Hoch;





// Adressfenster um 90 Grad gedreht von x1,y1 nach x2,y2
//
// von H nach Q
// Qx1 = 479 - Hy2
// Qy1 = Hx1
// Qx2 = 479 - Hy1
// Qy2 = Hx2
//
// von Q nach H
// Hx1 = Qy1
// Hy1 = 479-Qx2
// Hx2 = Qy2
// Hy2 = 479-Qx1
procedure setze_Adresse_Quer(x1,y1,x2,y2 : Word);
var
  b1 : Byte;
  w1 : Word;
begin

  // Umwandeln der Koordinaten von Quer nach Hoch
  // Retten von x1
  w1 := x1;
  // Hx1 = Qy1
  x1 := y1;   // y1 ist nun frei
  // Hy1 = 479-Qx2
  y1 := 479-x2;  // x2 ist nun frei
  // Hx2 = Qy2
  x2 := y2;  // y2 ist nun frei
  // Hy2 = 479-Qx1
  y2 := 479 - w1;


  Lcd_Write_Com($2A);
  b1:=High(x1);
  Lcd_Write_Data(b1);
  b1:=Low(x1);
  Lcd_Write_Data(b1);
  b1:=High(x2);
  Lcd_Write_Data(b1);
  b1:=Low(x2);
  Lcd_Write_Data(b1);

  Lcd_Write_Com($2B);
  b1:=High(y1);
  Lcd_Write_Data(b1);
  b1:=Low(y1);
  Lcd_Write_Data(b1);
  b1:=High(y2);
  Lcd_Write_Data(b1);
  b1:=Low(y2);
  Lcd_Write_Data(b1);

  Lcd_Write_Com($2C);

end setze_Adresse_Quer;











procedure clear_Screen;
var
  w1 : Word;
  w2 : Word;
  b1 : Byte;
  b2 : Byte;
begin

  ClearBit(LCD_CS_A);

  setze_Adresse_Hoch(0,0,319,479);


  Lcd_Write_Com($2C); //write_memory_start

  for w1:=1 to 320 do

    for w2:=1 to 480 do

      LCD_Write_Data_DWord(L_Pixel_Farbe);

    endfor;

  endfor;

  SetBit(LCD_WR_A);

  SetBit(LCD_CS_A);

end clear_Screen;






 procedure clear_Screen_Quick;
var
  w1 : Word;
  w2 : Word;
  b1 : Byte;
  b2 : Byte;
begin

  ClearBit(LCD_CS_A);

  setze_Adresse_Hoch(0,0,319,479);

  Lcd_Write_Com($2C); //write_memory_start


  LCD_Write_Data_DWord(L_Pixel_Farbe);


  for w1:=1 to 320 do

    for w2:=1 to 480 do

      ClearBit(LCD_WR_A);
      NOP;
      NOP;
      SetBit(LCD_WR_A);
      NOP;
      NOP;
      ClearBit(LCD_WR_A);
      NOP;
      NOP;
      SetBit(LCD_WR_A);
      NOP;
      NOP;
      ClearBit(LCD_WR_A);
      NOP;
      NOP;
      SetBit(LCD_WR_A);

    endfor;

  endfor;

  SetBit(LCD_WR_A);

  SetBit(LCD_CS_A);

end clear_Screen_Quick;






// *** Hochformat ***



procedure drawPixel_Hoch(Pos_x, Pos_y : Word);
var
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin
  Pixel_x2:=Pos_x+1;
  Pixel_y2:=Pos_y+1;
  ClearBit(LCD_CS_A);
  setze_Adresse_Hoch(Pos_x,Pos_y,Pixel_x2,Pixel_y2);
  LCD_Write_Data_DWord(L_Pixel_Farbe);
  SetBit(LCD_CS_A);

end drawPixel_Hoch;




procedure drawHorizontalLine_Hoch(Pos_x1, Pos_x2, Pos_y : Word);
var
  Line : Word;
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin

  ClearBit(LCD_CS_A);

  Pixel_y2:=Pos_y+1;

  for Line:=Pos_x1 to Pos_x2 do
    Pixel_x2:=Line+1;
    setze_Adresse_Hoch(Line,Pos_y,Pixel_x2,Pixel_y2);
    LCD_Write_Data_DWord(L_Pixel_Farbe);
  endfor;

  SetBit(LCD_CS_A);

end drawHorizontalLine_Hoch;







// *** Querformat ***


procedure drawPixel_Quer(Pos_x, Pos_y : Word);
var
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin
  Pixel_x2:=Pos_x+1;
  Pixel_y2:=Pos_y+1;
  ClearBit(LCD_CS_A);
  setze_Adresse_Quer(Pos_x,Pos_y,Pixel_x2,Pixel_y2);
  LCD_Write_Data_DWord(L_Pixel_Farbe);
  SetBit(LCD_CS_A);

end drawPixel_Quer;




procedure drawVertikalLine_Quer(Pos_x, Pos_y1, Pos_y2 : Word);
var
  Line : Word;
begin

  ClearBit(LCD_CS_A);

  setze_Adresse_Quer(Pos_x,Pos_y1,Pos_x,Pos_y2);

  for Line:=Pos_y1 to Pos_y2 do
    LCD_Write_Data_DWord(L_Pixel_Farbe);
  endfor;

  SetBit(LCD_CS_A);

end drawVertikalLine_Quer;








procedure drawHorizontalLine_Quer(Pos_x1, Pos_x2, Pos_y : Word);
var
  Line : Word;
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin

  ClearBit(LCD_CS_A);

  for Line:=Pos_x1 to Pos_x2 do
    Pixel_x2:=Line+1;
    Pixel_y2:=Pos_y+1;
    setze_Adresse_Quer(Line,Pos_y,Pixel_x2,Pixel_y2);
    LCD_Write_Data_DWord(L_Pixel_Farbe);
  endfor;

  SetBit(LCD_CS_A);

end drawHorizontalLine_Quer;






// **********************
// *** FONT-Programme ***
// **********************



PROCEDURE setze_Font(FontGroesse : Byte);
BEGIN
  Font_Bez:=FontGroesse;

  CASE Font_Bez OF

    fnt_6x8 : Zeichenbreite := 6;
              Zeichenbreite0 := 5;
              Zeichenhoehe  := 10; // 8 + 2 = 10
              Zeichenhoehe0 := 7;

              X_ANF := 0;
              Y_ANF := 0;

              max_Spalten := 79;  // 0..79 = 80
              max_Zeilen := 31;   // 0..31 = 32

    |

    fnt_8x8 : Zeichenbreite := 8;
              Zeichenbreite0 := 7;
              Zeichenhoehe  := 10; // 8 + 2 = 10
              Zeichenhoehe0 := 7;

              X_ANF := 0;
              Y_ANF := 0;

              max_Spalten := 59;  // 0..59 = 60
              max_Zeilen := 31;   // 0..31 = 32

    |

    fnt_8x12 : Zeichenbreite := 8;
               Zeichenbreite0 := 7;
               Zeichenhoehe  := 13; // 12 + 1 = 13
               Zeichenhoehe0 := 11;

               X_ANF := 0;
               Y_ANF := 4;

               max_Spalten := 59;  // 0..59 = 60
               max_Zeilen := 23;   // 0..23 = 24

    |

    fnt_10x16 : Zeichenbreite := 10;
                Zeichenbreite0 := 9;
                Zeichenhoehe  := 16; // 16 + 0 = 16
                Zeichenhoehe0 := 15;

                X_ANF := 0;
                Y_ANF := 0;

                max_Spalten := 47;  // 0..47 = 48
                max_Zeilen := 19;  // 0..19 = 20

    |

    fnt_12x20 : Zeichenbreite := 12;
                Zeichenbreite0 := 11;
                Zeichenhoehe  := 20; // 20 + 0 = 20
                Zeichenhoehe0 := 19; // 0..19 = 20

                X_ANF := 0;
                Y_ANF := 0;

                max_Spalten := 39;  // 0..39 = 40
                max_Zeilen := 15;  // 0..15 = 16

    |

  ENDCASE;

  L_Pixel_Farbe:=L_BCOLOR;
  clear_Screen_Quick;

END setze_Font;







// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_6x8;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;

begin

  // LCD Anfang
  ClearBit(LCD_CS_A);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;


  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1-$20;
  w1:=w1*8;

  Font_Mask:=%10000000;

  for x_cnt:=0 to 5 do

    for y_cnt:=0 to 7 do

 //     Font_Color:=font6x8[w1];
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      LCD_Write_Data_DWord(L_Pixel_Farbe);


    endfor; { for x_cnt:=0 to 5 do }

    w1:=w1-8;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 7 do }

  SetBit(LCD_CS_A);

end Write_Char_6x8;







// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_8x8;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;

begin

  // LCD Anfang
  ClearBit(LCD_CS_A);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;

  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);

  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1-$20;
  w1:=w1*8;

  Font_Mask:=%10000000;

  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 7 do

  //    Font_Color:=font8x8[w1];
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      LCD_Write_Data_DWord(L_Pixel_Farbe);


    endfor; { for x_cnt:=0 to 7 do }

    w1:=w1-8;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 7 do }

  SetBit(LCD_CS_A);

end Write_Char_8x8;







// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_8x12;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;


begin

  // LCD Anfang
  ClearBit(LCD_CS_A);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;


  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1*12;


  Font_Mask:=%10000000;


  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 11 do

      Font_Color:=font8x12[w1];
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      LCD_Write_Data_DWord(L_Pixel_Farbe);


    endfor; { for x_cnt:=0 to 7 do }

    w1:=w1-12;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 7 do }

  SetBit(LCD_CS_A);

end Write_Char_8x12;






// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_8x12_schnell;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;
  L_Pixel_Farbe_alt : DWord;

begin

  // LCD Anfang
  ClearBit(LCD_CS_A);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;


  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1*12;


  Font_Mask:=%10000000;
  L_Pixel_Farbe_alt:=L_BCOLOR;
  Inc(L_Pixel_Farbe_alt);

  if L_Pixel_Farbe_alt=L_FCOLOR then
    Inc(L_Pixel_Farbe_alt);
  endif;


  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 11 do

      Font_Color:=font8x12[w1];
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then

        L_Pixel_Farbe:=L_BCOLOR;

        if L_Pixel_Farbe=L_Pixel_Farbe_alt then

          ClearBit(LCD_WR_A);
          NOP;
          NOP;
          SetBit(LCD_WR_A);
          NOP;
          NOP;
          ClearBit(LCD_WR_A);
          NOP;
          NOP;
          SetBit(LCD_WR_A);
          NOP;
          NOP;
          ClearBit(LCD_WR_A);
          NOP;
          NOP;
          SetBit(LCD_WR_A);

        else
          LCD_Write_Data_DWord(L_Pixel_Farbe);
        endif;

      else

        L_Pixel_Farbe:=L_FCOLOR;

        if L_Pixel_Farbe=L_Pixel_Farbe_alt then

          ClearBit(LCD_WR_A);
          NOP;
          NOP;
          SetBit(LCD_WR_A);
          NOP;
          NOP;
          ClearBit(LCD_WR_A);
          NOP;
          NOP;
          SetBit(LCD_WR_A);
          NOP;
          NOP;
          ClearBit(LCD_WR_A);
          NOP;
          NOP;
          SetBit(LCD_WR_A);

        else
          LCD_Write_Data_DWord(L_Pixel_Farbe);
        endif;

      endif;

      L_Pixel_Farbe_alt:=L_Pixel_Farbe;

    endfor; { for x_cnt:=0 to 7 do }

    w1:=w1-12;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 7 do }

  SetBit(LCD_CS_A);

end Write_Char_8x12_schnell;








// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_10x16;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;


begin

  // LCD Anfang
  ClearBit(LCD_CS_A);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;

  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1*32;
  w2:=w1+1;


  Font_Mask:=%10000000;


  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 15 do

 //     Font_Color:=font10x16[w2];
      INC(w2);
      INC(w2);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      LCD_Write_Data_DWord(L_Pixel_Farbe);


    endfor; { for x_cnt:=0 to 15 do }

    w2:=w2-32;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 1 do }


  Font_Mask:=%10000000;

  for x_cnt:=0 to 1 do

    for y_cnt:=0 to 15 do

 //     Font_Color:=font10x16[w1];
      INC(w1);
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      LCD_Write_Data_DWord(L_Pixel_Farbe);


    endfor; { for x_cnt:=0 to 15 do }

    w1:=w1-32;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 1 do }

  SetBit(LCD_CS_A);

end Write_Char_10x16;





// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_12x20;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;


begin

  // LCD Anfang
  ClearBit(LCD_CS_A);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;

  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1*40;
  w2:=w1+1;

  Font_Mask:=%10000000;

  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 19 do

 //     Font_Color:=font12x20[w2];
      INC(w2);
      INC(w2);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      LCD_Write_Data_DWord(L_Pixel_Farbe);


    endfor; { for x_cnt:=0 to 15 do }

    w2:=w2-40;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 1 do }


  Font_Mask:=%10000000;

  for x_cnt:=0 to 3 do

    for y_cnt:=0 to 19 do

//      Font_Color:=font12x20[w1];
      INC(w1);
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      LCD_Write_Data_DWord(L_Pixel_Farbe);


    endfor; { for x_cnt:=0 to 15 do }

    w1:=w1-40;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 1 do }

  SetBit(LCD_CS_A);

end Write_Char_12x20;




// ****************************************
// Hauptprogramm zur Anzeige eines Zeichens
// ****************************************
//
// Uebergabeparameter:
// L_Zeichen (Byte) - das auszugebende Zeichen
// L_FCOLOR (Word)  - die Vordergrundfarbe des Zeichens
// L_BCOLOR (Word)  - die Hintergrundfarbe des Zeichens
// X_KUR_POS, Y_KUR_POS (Word) - die genaue Position des auszugebenden Zeichens
//                               beginnend mit 0,0
//
procedure Write_Char;
var
  b1 : Byte;
  b2 : Byte;
  b_schnell : Boolean;
begin

  b_schnell:=false;

  b1:=DWordToByte(0,L_BCOLOR);
  b2:=DWordToByte(1,L_BCOLOR);

  if b1=b2 then

    b1:=DWordToByte(0,L_FCOLOR);
    b2:=DWordToByte(1,L_FCOLOR);

    if b1=b2 then

      b_schnell:=true;

    endif;

  endif;


  if  b_schnell then

    CASE Font_Bez OF
      fnt_6x8 : Write_Char_6x8;
      |
      fnt_8x8 : Write_Char_8x8;
      |
      fnt_8x12 : Write_Char_8x12_schnell;
      |
      fnt_10x16 : Write_Char_10x16;
      |
      fnt_12x20 : Write_Char_12x20;
      |
    ENDCASE;

  else

    CASE Font_Bez OF
      fnt_6x8 : Write_Char_6x8;
      |
      fnt_8x8 : Write_Char_8x8;
      |
      fnt_8x12 : Write_Char_8x12;
      |
      fnt_10x16 : Write_Char_10x16;
      |
      fnt_12x20 : Write_Char_12x20;
      |
  ENDCASE;

  endif;

end Write_Char;
















