PROGRAM MEGA;

DEVICE = mega2560;

{$I mega2560_Register.INC}


CONST

  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 16000;

  // bei 16,000 MHz ->
  UBRR_VAL : Byte = 5;


  Matrix_Col_Max : Word = 59;   // 0..79 = 80
  Matrix_Row_Max : Word = 23;   // 0..23 = 24

  Fuellzeichen : Byte = $20;  // Leerzeichen
//  Fuellzeichen : Byte = $2E;  //  Punkt
  Fuellfarbe_VG : Byte = $00;
  Fuellfarbe_HG : Byte = $FF;


  // TerminalMode
  Normal_TM            : Byte = 0;
  IBM_ESC_TM           : Byte = 1;
  IBM_CSI_TM           : Byte = 2;
  IBM_CSI_TM_Par_1     : Byte = 3;
  IBM_CSI_TM_Par_2     : Byte = 4;
  IBM_CSI_TM_Par_3     : Byte = 5;
  IBM_GRAFIK_Par_1_TM  : Byte = 6;
  IBM_GRAFIK_Par_2_TM  : Byte = 7;





// Font fuer 6x8 Zeichen
//{$I font6x8.INC}

// Font fuer 8x8 Zeichen
//{$I font8x8.INC}

// Font fuer 8x12 Zeichen
{$I font8x12.INC}

// Font fuer 10x16 Zeichen
//{$I font10x16.INC}

// Font fuer 12x20 Zeichen
//{$I font12x20.INC}



// Farbtabelle fuer LCD
{$I COLOR_256.INC}



VAR

  LED_GELB[PortB, 7] : bit; // A



  Zeichenbreite, Zeichenhoehe,
  X_ANF, Y_ANF,
  X_KUR_POS, Y_KUR_POS : Word;




  Zeichenbreite0, Zeichenhoehe0 : Word;

  Steuer_String : String[20];


  // Variablen zum Font
  max_Spalten, max_Zeilen : Word;

  // Bezeichnung des Fonts
  Font_Bez : Byte;


  TermMode : Byte;

  CSI_Parameter1, CSI_Parameter2,
  CSI_Parameter3 : Word;

  Escape_Sequenz : String[10];

  // Kursor-Variablen
  Kursor_sichtbar : Boolean;
  Kursor_Schleife : DWord;


  // Zeichen-Matrix und Farb-Matrix
  Zeichen_Matrix : Array [0..Matrix_Col_Max,0..Matrix_Row_Max] of Byte;
  VG_Farb_Matrix : Array [0..Matrix_Col_Max,0..Matrix_Row_Max] of Byte;
  HG_Farb_Matrix : Array [0..Matrix_Col_Max,0..Matrix_Row_Max] of Byte;


  LED_ein : Word;

  WHO_AM_I_Schleife : Boolean;


// System
{$I SYSTEM.INC}

//
{$I LCD_ILI9481.INC}






procedure InitPorts;
begin

  // LED auf Bit 7
  DDRB:=  %10000000;

end InitPorts;




{$I CONOUT.INC}



// ITP3
{$I ITP3_CLI_PORT.INC}
{$I ITP3_CLI_PRG.INC}




BEGIN

  InitPorts;

  ITP3_Client_Init;


  Init_ILI9481_PORT;

  Init_ILI9481_SW;

  INIT_CONOUT;


  Write_String:='serielles LCD-Terminal';
  Text_an_CONOUT;

  Write_String:='Font = 8x12';
  Text_an_CONOUT;



  WHO_AM_I_Schleife:=true;

  while WHO_AM_I_Schleife do

     ITP3_Server_Abfrage;

     SetBit(LED_GELB);
     wait_ms(1);

  endwhile;




  Clear_Matrix;

  clear_Screen_Quick;



  Kursor_Schleife:=0;
  Kursor_sichtbar:=false;

  LED_ein:=0;



  loop

    ITP3_Server_Abfrage;

    SetBit(LED_GELB);
    wait_ms(1);

    INC(Kursor_Schleife);

    if Kursor_Schleife>160 then
      Kursor_Umschalten;
    endif;


    if LED_ein>0 then
      ClearBit(LED_BL);
      Dec(LED_ein);
    else
      SetBit(LED_BL);
    endif;




  endloop;



END MEGA.

