; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: CONIO2.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x5666 ; WORD
.equ        UBRR_VAL  =  0x01 ; BYTE
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        CHAR_NULL  =  0x00 ; CHAR
.equ        CHAR_FC  =  0xFC ; CHAR
.equ        CHAR_FD  =  0xFD ; CHAR
.equ        CHAR_FE  =  0xFE ; CHAR
.equ        CHAR_FF  =  0xFF ; CHAR
.equ        NO_LED_STATE  =  0x00 ; BYTE
.equ        LEDSCROLL  =  0x01 ; BYTE
.equ        LEDNUM  =  0x02 ; BYTE
.equ        LEDCAPS  =  0x04 ; BYTE
.equ        KEYSTAT_BYTE1  =  0x01 ; BYTE
.equ        KEYSTAT_E0  =  0x02 ; BYTE
.equ        KEYSTAT_F0  =  0x03 ; BYTE
.equ        NO_SHIFTSTATE  =  0x00 ; BYTE
.equ        SHSHIFT  =  0x20 ; BYTE
.equ        SHCTRL  =  0x10 ; BYTE
.equ        SHALT  =  0x08 ; BYTE
.equ        SHCAPS  =  0x04 ; BYTE
.equ        SHNUM  =  0x02 ; BYTE
.equ        SHSCROLL  =  0x01 ; BYTE
.equ        KBDNUM  =  0x77 ; BYTE
.equ        KBDCAPS  =  0x58 ; BYTE
.equ        KBDSCROLL  =  0x7E ; BYTE
.equ        KBDALT  =  0x11 ; BYTE
.equ        KBDCTRL  =  0x14 ; BYTE
.equ        KBDLSHIFT  =  0x12 ; BYTE
.equ        KBDRSHIFT  =  0x59 ; BYTE
.equ        KBDENTER  =  0x5A ; BYTE
.equ        KBDSPACE  =  0x29 ; BYTE
.equ        KBDBS  =  0x66 ; BYTE
.equ        KBDTAB  =  0x0D ; BYTE
.equ        KBDESC  =  0x76 ; BYTE
.equ        KBDF1  =  0x05 ; BYTE
.equ        KBDF2  =  0x06 ; BYTE
.equ        KBDF3  =  0x04 ; BYTE
.equ        KBDF4  =  0x0C ; BYTE
.equ        KBDF5  =  0x03 ; BYTE
.equ        KBDF6  =  0x0B ; BYTE
.equ        KBDF7  =  0x83 ; BYTE
.equ        KBDF8  =  0x0A ; BYTE
.equ        KBDF9  =  0x01 ; BYTE
.equ        KBDF10  =  0x09 ; BYTE
.equ        KBDF11  =  0x78 ; BYTE
.equ        KBDF12  =  0x07 ; BYTE
.equ        KBDRGUI  =  0x27 ; BYTE
.equ        KBDLGUI  =  0x1F ; BYTE
.equ        KBDAPPS  =  0x2F ; BYTE
.equ        KBDEND  =  0x69 ; BYTE
.equ        KBDHOME  =  0x6C ; BYTE
.equ        KBDUP  =  0x75 ; BYTE
.equ        KBDDN  =  0x72 ; BYTE
.equ        KBDLEFT  =  0x6B ; BYTE
.equ        KBDRIGHT  =  0x74 ; BYTE
.equ        KBDPGUP  =  0x7D ; BYTE
.equ        KBDPGDN  =  0x7A ; BYTE
.equ        KBDINSERT  =  0x70 ; BYTE
.equ        KBDDELETE  =  0x71 ; BYTE
.equ        KBDPRINT  =  0x12 ; BYTE
.equ        KBDPAUSE  =  0xE1 ; BYTE
.equ        SCANBREAK  =  0xF0 ; BYTE
.equ        SCANEXT  =  0xE0 ; BYTE
.equ        HSTSCROLL  =  0x00 ; BYTE
.equ        HSTPRINT  =  0x10 ; BYTE
.equ        HSTINS  =  0x16 ; BYTE
.equ        HSTHOME  =  0x00 ; BYTE
.equ        HSTPGUP  =  0x12 ; BYTE
.equ        HSTPGDN  =  0x03 ; BYTE
.equ        HSTDEL  =  0x08 ; BYTE
.equ        HSTEND  =  0x00 ; BYTE
.equ        HSTLEFT  =  0x13 ; BYTE
.equ        HSTRIGHT  =  0x04 ; BYTE
.equ        HSTUP  =  0x05 ; BYTE
.equ        HSTDN  =  0x18 ; BYTE
.equ        HSTRGUI  =  0x00 ; BYTE
.equ        HSTLGUI  =  0x00 ; BYTE
.equ        HSTAPPS  =  0x00 ; BYTE
.equ        HSTF1  =  0x80 ; BYTE
.equ        HSTF2  =  0x81 ; BYTE
.equ        HSTF3  =  0x82 ; BYTE
.equ        HSTF4  =  0x83 ; BYTE
.equ        HSTF5  =  0x84 ; BYTE
.equ        HSTF6  =  0x85 ; BYTE
.equ        HSTF7  =  0x86 ; BYTE
.equ        HSTF8  =  0x87 ; BYTE
.equ        HSTF9  =  0x88 ; BYTE
.equ        HSTF10  =  0x89 ; BYTE
.equ        HSTF11  =  0x8A ; BYTE
.equ        HSTF12  =  0x8B ; BYTE
.equ        BA_MODE_KEINEBA  =  0x00 ; BYTE
.equ        BA_MODE_INI  =  0x01 ; BYTE
.equ        BA_MODE_SET_WR  =  0x02 ; BYTE
.equ        BA_MODE_WR  =  0x03 ; BYTE
.equ        BA_MODE_SET_RD  =  0x04 ; BYTE
.equ        BA_MODE_RD  =  0x05 ; BYTE
.equ        NO_RECEIVE_MODE  =  0x00 ; BYTE
.equ        RECEIVE_CONST  =  0x01 ; BYTE
.equ        RECEIVE_CONIN  =  0x02 ; BYTE
.equ        RECEIVE_CONOUT  =  0x03 ; BYTE
.equ        RECEIVE_DEVCODE  =  0x04 ; BYTE
.equ        RECEIVE_ERROR_CODE  =  0x05 ; BYTE
.equ        NO_SEND_MODE  =  0x00 ; BYTE
.equ        SEND_CONOUT  =  0x01 ; BYTE
.equ        SEND_LIST  =  0x02 ; BYTE
.equ        RE_CONST  =  0x01 ; BYTE
.equ        RE_CONIN  =  0x02 ; BYTE
.equ        SE_CONOUT  =  0x03 ; BYTE
.equ        RE_SECNT  =  0x04 ; BYTE
.equ        RE_SECTOR  =  0x05 ; BYTE
.equ        RE_RD_ISEC  =  0x06 ; BYTE
.equ        SE_WR_ISEC  =  0x07 ; BYTE
.equ        SE_STD  =  0x08 ; BYTE
.equ        SE_LIST  =  0x09 ; BYTE
.equ        RE_ERROR_CODE  =  0x0A ; BYTE
.equ        RE_WHO_ARE_YOU  =  0x14 ; BYTE
.equ        DEVCODE_PC_CPM_EMU  =  0x02 ; BYTE
.equ        DEVCODE_KEYBOARD  =  0x03 ; BYTE
.equ        DEVCODE_DISPLAY  =  0x04 ; BYTE
.equ        DEVCODE_RAMFLOPPY  =  0x05 ; BYTE
.equ        DEVCODE_CONINOUT  =  0x06 ; BYTE
.equ        DEVCODE_SOUND  =  0x07 ; BYTE
.equ        MESSAGE_WHO_AM_I  =  0x06 ; BYTE
.equ        WAITKON  =  0x0016 ; WORD
.equ        WAITKON2  =  0x03DE ; WORD
.equ        TWI_BIT_RATE  =  0x67 ; BYTE
.equ        TWI_PRESCALER  =  0x00 ; BYTE
.equ        ADR_DS1307_WR  =  0xD0 ; BYTE
.equ        ADR_DS1307_RD  =  0xD1 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
STEUER_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
TEXT_STRING:   ; String(15)
.byte     1     ; STRING-Laenge
.byte     15
BITCNTR:   ; Byte
.byte     1
KEYBSTATE:   ; Byte
.byte     1
LEDSTATE:   ; Byte
.byte     1
LOCALBYTE:   ; Byte
.byte     1
KBSHIFTSTATE:   ; Byte
.byte     1
TMPBYTE:   ; Byte
.byte     1
CAPS_PRESSED:   ; Boolean
.byte     1
NUM_PRESSED:   ; Boolean
.byte     1
SCROLL_PRESSED:   ; Boolean
.byte     1
DOCLICK:   ; Boolean
.byte     1
INITFAILED:   ; Boolean
.byte     1
LOCALMODE:   ; Boolean
.byte     1
CH:   ; Char
.byte     1
SCANBUFFERPTR:   ; Word
.byte     2
KEYBUFFERPTR:   ; Word
.byte     2
SCAN_ZEICHEN:   ; Byte
.byte     1
BA_MODE:   ; Byte
.byte     1
RECEIVE_MODE:   ; Byte
.byte     1
SEND_MODE:   ; Byte
.byte     1
ERROR_CODE:   ; Byte
.byte     1
ERROR_PARAM:   ; Byte
.byte     1
SOUND_BYTE:   ; Byte
.byte     1
LADE_BYTE:   ; Byte
.byte     1
TX_WARTEN:   ; Boolean
.byte     1
AUSGABEBYTE:   ; Byte
.byte     1
WRITE_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
SER0_ZEICHEN:   ; Byte
.byte     1
 
SCANBUFFER:
.byte     33
KEYBUFFER:
.byte     33
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; External Interrupt Request 0
.ORG INT0addr
        JMP        EI_INT0
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
    COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x03DE)
        LDI        R17, HIGH(0x03DE)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_065
        RJMP       M_IF_066
M_IF_065:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_066:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (INIT_SER0_PORT)
INIT_SER0_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRR0H)
        STS        UBRR0H, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (UBRR0L)
        STS        UBRR0L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER0_PORT)
        RET
 
; PROCEDURE - Anfang (RX0_PUFFER_ABFRAGEN)
RX0_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_078
        CLR        R16
        RJMP       M_VERGL_079
M_VERGL_078:
        SER        R16
M_VERGL_079:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_075
        RJMP       M_IF_076
M_IF_075:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_077
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_076:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_077:
 
; PROCEDURE - Ende (RX0_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN0)
SENDE_ZEICHEN0:
 
; WHILE DO ...
M_WHILE_080:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_083
        CLR        R16
        RJMP       M_VERGL_084
M_VERGL_083:
        SER        R16
M_VERGL_084:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_081
        RJMP       M_WHILE_082
M_WHILE_081:
 
; WHILE DO ...
        RJMP       M_WHILE_080
M_WHILE_082:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN0)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN0)
        RET
 
; PROCEDURE - Anfang (SENDE_HEX_ZEICHEN0)
SENDE_HEX_ZEICHEN0:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_088
        CLR        R16
        RJMP       M_VERGL_089
M_VERGL_088:
        SER        R16
M_VERGL_089:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_085
        RJMP       M_IF_086
M_IF_085:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_087
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_086:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_087:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN0)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (HEXHIGH) retten
        MOV        R18, R2
 
; lokalen Parameter (HEXHIGH) an Prozedur (SENDE_ZEICHEN0)
        MOV        R0, R18
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN0)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_093
        CLR        R16
        RJMP       M_VERGL_094
M_VERGL_093:
        SER        R16
M_VERGL_094:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_090
        RJMP       M_IF_091
M_IF_090:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_092
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_091:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_092:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN0)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (HEXLOW) retten
        MOV        R17, R1
 
; lokalen Parameter (HEXLOW) an Prozedur (SENDE_ZEICHEN0)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN0)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN0)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x48
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN0)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (SENDE_HEX_ZEICHEN0)
        RET
 
; PROCEDURE - Anfang (SENDE_HEX_ZEICHEN0_LN)
SENDE_HEX_ZEICHEN0_LN:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN0_LN)
        PUSH       R0
 
; Aufruf PROCEDURE (SENDE_HEX_ZEICHEN0)
        CALL       SENDE_HEX_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN0_LN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN0_LN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN0_LN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN0_LN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN0_LN)
        POP        R0
 
; PROCEDURE - Ende (SENDE_HEX_ZEICHEN0_LN)
        RET
 
; PROCEDURE - Anfang (WRITE_SER0)
WRITE_SER0:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_095:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_096
        RJMP       M_FTD_097
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_096:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_SER0)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SENDE_ZEICHEN0)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_SER0)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_095
 
; FOR TO DO - Ende
M_FTD_097:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_SER0)
        RET
 
; PROCEDURE - Anfang (WRITELN_SER0)
WRITELN_SER0:
 
; Aufruf PROCEDURE (WRITE_SER0)
        CALL       WRITE_SER0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; PROCEDURE - Ende (WRITELN_SER0)
        RET
 
; PROCEDURE - Anfang (TWI_INIT)
TWI_INIT:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (TWI_BIT_RATE)
        LDI        R16, 0x67
 
; Zuweisung Ziel /  VAR (TWBR)
        STS        TWBR, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (TWI_PRESCALER)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TWSR)
        STS        TWSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; PROCEDURE - Ende (TWI_INIT)
        RET
 
; FUNCTION - Anfang (TWI_READ_STATUS)
TWI_READ_STATUS:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TWSR)
        LDS        R16, TWSR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF8)
        LDI        R18, 0xF8
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (TWI_READ_STATUS)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (TWI_READ_STATUS)
        MOV        R16, R0
 
; FUNCTION - Ende (TWI_READ_STATUS)
        RET
 
; PROCEDURE - Anfang (TWI_START)
TWI_START:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xA4)
        LDI        R16, 0xA4
 
; Zuweisung Ziel /  VAR (TWCR)
        STS        TWCR, R16
 
; WHILE DO ...
M_WHILE_098:
 
; WHILE - Ausdruck /; BitLow(TWINT_E)
        LDS        R16, TWCR
        BST        R16, 7
        BRTC       M_VERGL_0101
        CLR        R16
        RJMP       M_VERGL_0102
M_VERGL_0101:
        SER        R16
M_VERGL_0102:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_099
        RJMP       M_WHILE_0100
M_WHILE_099:
 
; WHILE DO ...
        RJMP       M_WHILE_098
M_WHILE_0100:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TWSR)
        LDS        R16, TWSR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF8)
        LDI        R18, 0xF8
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0106
        CLR        R16
        RJMP       M_VERGL_0107
M_VERGL_0106:
        SER        R16
M_VERGL_0107:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0103
        RJMP       M_IF_0104
M_IF_0103:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0104:
 
; PROCEDURE - Ende (TWI_START)
        RET
 
; PROCEDURE - Anfang (TWI_RESTART)
TWI_RESTART:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xA4)
        LDI        R16, 0xA4
 
; Zuweisung Ziel /  VAR (TWCR)
        STS        TWCR, R16
 
; WHILE DO ...
M_WHILE_0108:
 
; WHILE - Ausdruck /; BitLow(TWINT_E)
        LDS        R16, TWCR
        BST        R16, 7
        BRTC       M_VERGL_0111
        CLR        R16
        RJMP       M_VERGL_0112
M_VERGL_0111:
        SER        R16
M_VERGL_0112:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0109
        RJMP       M_WHILE_0110
M_WHILE_0109:
 
; WHILE DO ...
        RJMP       M_WHILE_0108
M_WHILE_0110:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TWSR)
        LDS        R16, TWSR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF8)
        LDI        R18, 0xF8
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x10)
        LDI        R18, 0x10
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0116
        CLR        R16
        RJMP       M_VERGL_0117
M_VERGL_0116:
        SER        R16
M_VERGL_0117:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0113
        RJMP       M_IF_0114
M_IF_0113:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0114:
 
; PROCEDURE - Ende (TWI_RESTART)
        RET
 
; PROCEDURE - Anfang (TWI_STOP)
TWI_STOP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x94)
        LDI        R16, 0x94
 
; Zuweisung Ziel /  VAR (TWCR)
        STS        TWCR, R16
 
; PROCEDURE - Ende (TWI_STOP)
        RET
 
; PROCEDURE - Anfang (TWI_WRITE)
TWI_WRITE:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DATEN)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (TWDR)
        STS        TWDR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x84)
        LDI        R16, 0x84
 
; Zuweisung Ziel /  VAR (TWCR)
        STS        TWCR, R16
 
; WHILE DO ...
M_WHILE_0118:
 
; WHILE - Ausdruck /; BitLow(TWINT_E)
        LDS        R16, TWCR
        BST        R16, 7
        BRTC       M_VERGL_0121
        CLR        R16
        RJMP       M_VERGL_0122
M_VERGL_0121:
        SER        R16
M_VERGL_0122:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0119
        RJMP       M_WHILE_0120
M_WHILE_0119:
 
; WHILE DO ...
        RJMP       M_WHILE_0118
M_WHILE_0120:
 
; PROCEDURE - Ende (TWI_WRITE)
        RET
 
; FUNCTION - Anfang (TWI_READACK)
TWI_READACK:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC4)
        LDI        R16, 0xC4
 
; Zuweisung Ziel /  VAR (TWCR)
        STS        TWCR, R16
 
; WHILE DO ...
M_WHILE_0123:
 
; WHILE - Ausdruck /; BitLow(TWINT_E)
        LDS        R16, TWCR
        BST        R16, 7
        BRTC       M_VERGL_0126
        CLR        R16
        RJMP       M_VERGL_0127
M_VERGL_0126:
        SER        R16
M_VERGL_0127:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0124
        RJMP       M_WHILE_0125
M_WHILE_0124:
 
; WHILE DO ...
        RJMP       M_WHILE_0123
M_WHILE_0125:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (TWDR)
        LDS        R16, TWDR
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (TWI_READACK)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (TWI_READACK)
        MOV        R16, R0
 
; FUNCTION - Ende (TWI_READACK)
        RET
 
; FUNCTION - Anfang (TWI_READNACK)
TWI_READNACK:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x84)
        LDI        R16, 0x84
 
; Zuweisung Ziel /  VAR (TWCR)
        STS        TWCR, R16
 
; WHILE DO ...
M_WHILE_0128:
 
; WHILE - Ausdruck /; BitLow(TWINT_E)
        LDS        R16, TWCR
        BST        R16, 7
        BRTC       M_VERGL_0131
        CLR        R16
        RJMP       M_VERGL_0132
M_VERGL_0131:
        SER        R16
M_VERGL_0132:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0129
        RJMP       M_WHILE_0130
M_WHILE_0129:
 
; WHILE DO ...
        RJMP       M_WHILE_0128
M_WHILE_0130:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (TWDR)
        LDS        R16, TWDR
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (TWI_READNACK)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (TWI_READNACK)
        MOV        R16, R0
 
; FUNCTION - Ende (TWI_READNACK)
        RET
 
; PROCEDURE - Anfang (TWI_1307A)
TWI_1307A:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Aufruf PROCEDURE (TWI_START)
        CALL       TWI_START
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (TWI_WRITE)
        LDI        R16, 0xD0
        MOV        R0, R16
 
; Aufruf PROCEDURE (TWI_WRITE)
        CALL       TWI_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x18)
        LDI        R18, 0x18
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0136
        CLR        R16
        RJMP       M_VERGL_0137
M_VERGL_0136:
        SER        R16
M_VERGL_0137:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0133
        RJMP       M_IF_0134
M_IF_0133:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0134:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (TWI_WRITE)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (TWI_WRITE)
        CALL       TWI_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x28)
        LDI        R18, 0x28
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0141
        CLR        R16
        RJMP       M_VERGL_0142
M_VERGL_0141:
        SER        R16
M_VERGL_0142:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0138
        RJMP       M_IF_0139
M_IF_0138:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0139:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (TWI_WRITE)
        LDI        R16, 0x05
        MOV        R0, R16
 
; Aufruf PROCEDURE (TWI_WRITE)
        CALL       TWI_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x28)
        LDI        R18, 0x28
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0146
        CLR        R16
        RJMP       M_VERGL_0147
M_VERGL_0146:
        SER        R16
M_VERGL_0147:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0143
        RJMP       M_IF_0144
M_IF_0143:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0144:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (TWI_WRITE)
        LDI        R16, 0x14
        MOV        R0, R16
 
; Aufruf PROCEDURE (TWI_WRITE)
        CALL       TWI_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x28)
        LDI        R18, 0x28
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0151
        CLR        R16
        RJMP       M_VERGL_0152
M_VERGL_0151:
        SER        R16
M_VERGL_0152:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0148
        RJMP       M_IF_0149
M_IF_0148:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0149:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (TWI_WRITE)
        LDI        R16, 0x18
        MOV        R0, R16
 
; Aufruf PROCEDURE (TWI_WRITE)
        CALL       TWI_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x28)
        LDI        R18, 0x28
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0156
        CLR        R16
        RJMP       M_VERGL_0157
M_VERGL_0156:
        SER        R16
M_VERGL_0157:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0153
        RJMP       M_IF_0154
M_IF_0153:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0154:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307A)
        PUSH       R0
 
; Aufruf PROCEDURE (TWI_STOP)
        CALL       TWI_STOP
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307A)
        POP        R0
 
; PROCEDURE - Ende (TWI_1307A)
        RET
 
; PROCEDURE - Anfang (TWI_1307B)
TWI_1307B:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (TWI_START)
        CALL       TWI_START
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (TWI_WRITE)
        LDI        R16, 0xD0
        MOV        R0, R16
 
; Aufruf PROCEDURE (TWI_WRITE)
        CALL       TWI_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x18)
        LDI        R18, 0x18
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0161
        CLR        R16
        RJMP       M_VERGL_0162
M_VERGL_0161:
        SER        R16
M_VERGL_0162:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0158
        RJMP       M_IF_0159
M_IF_0158:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x08)
        LDI        R16, 0x08
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0159:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (TWI_WRITE)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (TWI_WRITE)
        CALL       TWI_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x28)
        LDI        R18, 0x28
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0166
        CLR        R16
        RJMP       M_VERGL_0167
M_VERGL_0166:
        SER        R16
M_VERGL_0167:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0163
        RJMP       M_IF_0164
M_IF_0163:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0164:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (TWI_RESTART)
        CALL       TWI_RESTART
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (TWI_WRITE)
        LDI        R16, 0xD1
        MOV        R0, R16
 
; Aufruf PROCEDURE (TWI_WRITE)
        CALL       TWI_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x40)
        LDI        R18, 0x40
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0171
        CLR        R16
        RJMP       M_VERGL_0172
M_VERGL_0171:
        SER        R16
M_VERGL_0172:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0168
        RJMP       M_IF_0169
M_IF_0168:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0A)
        LDI        R16, 0x0A
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0169:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READACK)
        CALL       TWI_READACK
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SEKUNDEN)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x50)
        LDI        R18, 0x50
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0176
        CLR        R16
        RJMP       M_VERGL_0177
M_VERGL_0176:
        SER        R16
M_VERGL_0177:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0173
        RJMP       M_IF_0174
M_IF_0173:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0174:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SEKUNDEN)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x7F)
        LDI        R18, 0x7F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SEKUNDEN)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READACK)
        CALL       TWI_READACK
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MINUTEN)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x50)
        LDI        R18, 0x50
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0181
        CLR        R16
        RJMP       M_VERGL_0182
M_VERGL_0181:
        SER        R16
M_VERGL_0182:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0178
        RJMP       M_IF_0179
M_IF_0178:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0C)
        LDI        R16, 0x0C
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0179:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READNACK)
        CALL       TWI_READNACK
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (STUNDEN)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (TWI_READ_STATUS)
        CALL       TWI_READ_STATUS
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x58)
        LDI        R18, 0x58
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0186
        CLR        R16
        RJMP       M_VERGL_0187
M_VERGL_0186:
        SER        R16
M_VERGL_0187:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0183
        RJMP       M_IF_0184
M_IF_0183:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0D)
        LDI        R16, 0x0D
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; IF_THEN - Ende
M_IF_0184:
 
; Retten der lokalen Parameter fuer PROCEDURE (TWI_1307B)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (TWI_STOP)
        CALL       TWI_STOP
 
; Retten der Parameter-Register fuer PROCEDURE (TWI_1307B)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (TWI_1307B)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x22)
        LDI        R16, 0x22
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (INIT_INT0)
INIT_INT0:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (EICRA)
        LDS        R16, EICRA
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EICRA)
        STS        EICRA, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIMSK
        IN         R16, EIMSK
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIMSK)
        OUT        EIMSK, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIFR
        IN         R16, EIFR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIFR)
        OUT        EIFR, R16
 
; PROCEDURE - Ende (INIT_INT0)
        RET
 
; PROCEDURE - Anfang (TON_SIRENE)
TON_SIRENE:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FREQUENZ)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0188:
 
; FOR TO DO - Word-Vergleichsteil (DOWNTO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_FTD_0189
        RJMP       M_FTD_0190
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0189:
 
; SetBit(SUMMER)
        SBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(SUMMER)
        CBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-DEC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        SUB        R18, R20
        CLR        R20
        SBC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0188
 
; FOR TO DO - Ende
M_FTD_0190:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FREQUENZ)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0191:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0192
        RJMP       M_FTD_0193
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0192:
 
; SetBit(SUMMER)
        SBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(SUMMER)
        CBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0191
 
; FOR TO DO - Ende
M_FTD_0193:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (TON_SIRENE)
        RET
 
; PROCEDURE - Anfang (CLICK)
CLICK:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; PROCEDURE - Ende (CLICK)
        RET
 
; PROCEDURE - Anfang (RX_PUFFER_ABFRAGEN)
RX_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_0197
        CLR        R16
        RJMP       M_VERGL_0198
M_VERGL_0197:
        SER        R16
M_VERGL_0198:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0194
        RJMP       M_IF_0195
M_IF_0194:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (XON)
        LDI        R18, 0x11
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0202
        CLR        R16
        RJMP       M_VERGL_0203
M_VERGL_0202:
        SER        R16
M_VERGL_0203:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0199
        RJMP       M_IF_0200
M_IF_0199:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TX_WARTEN)
        STS        TX_WARTEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0201
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0200:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (XOFF)
        LDI        R18, 0x13
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0207
        CLR        R16
        RJMP       M_VERGL_0208
M_VERGL_0207:
        SER        R16
M_VERGL_0208:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0204
        RJMP       M_IF_0205
M_IF_0204:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (TX_WARTEN)
        STS        TX_WARTEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0206
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0205:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; IF_THEN_ELSE - Ende
M_IF_0206:
 
; IF_THEN_ELSE - Ende
M_IF_0201:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0196
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0195:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0196:
 
; PROCEDURE - Ende (RX_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (WRITE_SCAN)
WRITE_SCAN:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0212
        CLR        R16
        RJMP       M_VERGL_0213
M_VERGL_0212:
        SER        R16
M_VERGL_0213:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0209
        RJMP       M_IF_0210
M_IF_0209:
 
; INC(SCANBUFFERPTR) - Word
        LDS        R24, SCANBUFFERPTR
        LDS        R25, SCANBUFFERPTR+1
        ADIW       R25:R24, 1
        STS        SCANBUFFERPTR, R24
        STS        SCANBUFFERPTR+1, R25
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; VAR ARRAY Ziel Zeiger berechnen (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WRITE_SCAN_VALUE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY (SCANBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF_THEN - Ende
M_IF_0210:
 
; PROCEDURE - Ende (WRITE_SCAN)
        RET
 
; FUNCTION - Anfang (READ_SCAN)
READ_SCAN:
 
; ARRAY - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_SCAN_VALUE)
        MOV        R1, R16
 
; DEC(SCANBUFFERPTR) - Word
        LDS        R24, SCANBUFFERPTR
        LDS        R25, SCANBUFFERPTR+1
        SBIW       R25:R24, 1
        STS        SCANBUFFERPTR, R24
        STS        SCANBUFFERPTR+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0217
        CLR        R16
        RJMP       M_VERGL_0218
M_VERGL_0217:
        SER        R16
M_VERGL_0218:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0214
        RJMP       M_IF_0215
M_IF_0214:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0219:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0220
        RJMP       M_FTD_0221
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0220:
 
; ARRAY - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; ARRAY - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR ARRAY (SCANBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0219
 
; FOR TO DO - Ende
M_FTD_0221:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0215:
 
; RESULT Byte-Variable - FUNCTION (READ_SCAN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (READ_SCAN)
        MOV        R16, R0
 
; FUNCTION - Ende (READ_SCAN)
        RET
 
; FUNCTION - Anfang (READ_KEY)
READ_KEY:
 
; Interrupt verbieten
        CLI
 
; ARRAY - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_KEY_VALUE)
        MOV        R1, R16
 
; DEC(KEYBUFFERPTR) - Word
        LDS        R24, KEYBUFFERPTR
        LDS        R25, KEYBUFFERPTR+1
        SBIW       R25:R24, 1
        STS        KEYBUFFERPTR, R24
        STS        KEYBUFFERPTR+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0225
        CLR        R16
        RJMP       M_VERGL_0226
M_VERGL_0225:
        SER        R16
M_VERGL_0226:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0222
        RJMP       M_IF_0223
M_IF_0222:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0227:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0228
        RJMP       M_FTD_0229
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0228:
 
; ARRAY - Ausdruck erster Faktor / lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; ARRAY - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR ARRAY (KEYBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0227
 
; FOR TO DO - Ende
M_FTD_0229:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0223:
 
; Interrupt erlauben
        SEI
 
; RESULT Byte-Variable - FUNCTION (READ_KEY)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (READ_KEY)
        MOV        R16, R0
 
; FUNCTION - Ende (READ_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_KEY)
WRITE_KEY:
 
; Interrupt verbieten
        CLI
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0233
        CLR        R16
        RJMP       M_VERGL_0234
M_VERGL_0233:
        SER        R16
M_VERGL_0234:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0230
        RJMP       M_IF_0231
M_IF_0230:
 
; INC(KEYBUFFERPTR) - Word
        LDS        R24, KEYBUFFERPTR
        LDS        R25, KEYBUFFERPTR+1
        ADIW       R25:R24, 1
        STS        KEYBUFFERPTR, R24
        STS        KEYBUFFERPTR+1, R25
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; VAR ARRAY Ziel Zeiger berechnen (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WRITE_KEY_VALUE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY (KEYBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF_THEN - Ende
M_IF_0231:
 
; Interrupt erlauben
        SEI
 
; PROCEDURE - Ende (WRITE_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_C_KEY)
WRITE_C_KEY:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(CKEY)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_C_KEY)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (WRITE_KEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (WRITE_KEY)
        CALL       WRITE_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_C_KEY)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (WRITE_C_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_TEXT)
WRITE_TEXT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Length(TEXT_STRING)
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        LD         R16, Z
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0235:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0236
        RJMP       M_FTD_0237
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0236:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (TEXT_STRING)
        CLR        R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_TEXT)
        PUSH       R0
        PUSH       R1
 
; Parameter (C1) retten
        MOV        R17, R1
 
; lokalen Parameter (C1) an Prozedur (WRITE_C_KEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (WRITE_C_KEY)
        CALL       WRITE_C_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_TEXT)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0235
 
; FOR TO DO - Ende
M_FTD_0237:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_TEXT)
        RET
 
; PROCEDURE - Anfang (SENDKEY)
SENDKEY:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0D)
        LDI        R16, 0x0D
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(B1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; CASE OF - lokaler Uebergabeparameter (SKEY)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element ($00)
        CPI        R16, 0x00
        BREQ       M_CASE_0240
        RJMP       M_CASE_0239
M_CASE_0240:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0239:
 
; CASE OF - vergleiche Einzel-Element ($80)
        CPI        R16, 0x80
        BREQ       M_CASE_0242
        RJMP       M_CASE_0241
M_CASE_0242:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('DIR')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0243
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0243:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0245
M_PRG_CONST_STRING_0244:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0244
M_PRG_CONST_STRING_0245:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0246
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0246:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0248
        MOV        R16, R17
M_PRG_CONST_STRING_0247:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0247
M_PRG_CONST_STRING_0248:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0241:
 
; CASE OF - vergleiche Einzel-Element ($81)
        CPI        R16, 0x81
        BREQ       M_CASE_0250
        RJMP       M_CASE_0249
M_CASE_0250:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('POWER')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0251
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0251:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0253
M_PRG_CONST_STRING_0252:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0252
M_PRG_CONST_STRING_0253:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0254
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0254:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0256
        MOV        R16, R17
M_PRG_CONST_STRING_0255:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0255
M_PRG_CONST_STRING_0256:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0249:
 
; CASE OF - vergleiche Einzel-Element ($82)
        CPI        R16, 0x82
        BREQ       M_CASE_0258
        RJMP       M_CASE_0257
M_CASE_0258:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('COPY')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0259
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0259:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0261
M_PRG_CONST_STRING_0260:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0260
M_PRG_CONST_STRING_0261:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0262
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0262:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0264
        MOV        R16, R17
M_PRG_CONST_STRING_0263:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0263
M_PRG_CONST_STRING_0264:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0257:
 
; CASE OF - vergleiche Einzel-Element ($83)
        CPI        R16, 0x83
        BREQ       M_CASE_0266
        RJMP       M_CASE_0265
M_CASE_0266:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('ERA')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0267
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0267:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0269
M_PRG_CONST_STRING_0268:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0268
M_PRG_CONST_STRING_0269:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0270
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0270:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0272
        MOV        R16, R17
M_PRG_CONST_STRING_0271:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0271
M_PRG_CONST_STRING_0272:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0265:
 
; CASE OF - vergleiche Einzel-Element ($84)
        CPI        R16, 0x84
        BREQ       M_CASE_0274
        RJMP       M_CASE_0273
M_CASE_0274:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TYPEX')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0275
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0275:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0277
M_PRG_CONST_STRING_0276:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0276
M_PRG_CONST_STRING_0277:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0278
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0278:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0280
        MOV        R16, R17
M_PRG_CONST_STRING_0279:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0279
M_PRG_CONST_STRING_0280:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0273:
 
; CASE OF - vergleiche Einzel-Element ($85)
        CPI        R16, 0x85
        BREQ       M_CASE_0282
        RJMP       M_CASE_0281
M_CASE_0282:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('EXIT')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0283
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0283:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0285
M_PRG_CONST_STRING_0284:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0284
M_PRG_CONST_STRING_0285:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0286
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0286:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0288
        MOV        R16, R17
M_PRG_CONST_STRING_0287:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0287
M_PRG_CONST_STRING_0288:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0281:
 
; CASE OF - vergleiche Einzel-Element ($86)
        CPI        R16, 0x86
        BREQ       M_CASE_0290
        RJMP       M_CASE_0289
M_CASE_0290:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TURBO')
        LDI        ZL, LOW(2*M_CONST_STRING_6)
        LDI        ZH, HIGH(2*M_CONST_STRING_6)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0291
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0291:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0293
M_PRG_CONST_STRING_0292:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0292
M_PRG_CONST_STRING_0293:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0294
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0294:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0296
        MOV        R16, R17
M_PRG_CONST_STRING_0295:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0295
M_PRG_CONST_STRING_0296:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0289:
 
; CASE OF - vergleiche Einzel-Element ($87)
        CPI        R16, 0x87
        BREQ       M_CASE_0298
        RJMP       M_CASE_0297
M_CASE_0298:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TURBO')
        LDI        ZL, LOW(2*M_CONST_STRING_7)
        LDI        ZH, HIGH(2*M_CONST_STRING_7)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0299
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0299:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0301
M_PRG_CONST_STRING_0300:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0300
M_PRG_CONST_STRING_0301:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0302
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0302:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0304
        MOV        R16, R17
M_PRG_CONST_STRING_0303:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0303
M_PRG_CONST_STRING_0304:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0297:
 
; CASE OF - vergleiche Einzel-Element ($88)
        CPI        R16, 0x88
        BREQ       M_CASE_0306
        RJMP       M_CASE_0305
M_CASE_0306:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_FC)
        LDI        R16, 0xFC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0307
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0307:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0309
        MOV        R16, R17
M_PRG_CONST_STRING_0308:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0308
M_PRG_CONST_STRING_0309:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0305:
 
; CASE OF - vergleiche Einzel-Element ($89)
        CPI        R16, 0x89
        BREQ       M_CASE_0311
        RJMP       M_CASE_0310
M_CASE_0311:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_FD)
        LDI        R16, 0xFD
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0312
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0312:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0314
        MOV        R16, R17
M_PRG_CONST_STRING_0313:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0313
M_PRG_CONST_STRING_0314:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0310:
 
; CASE OF - vergleiche Einzel-Element ($8A)
        CPI        R16, 0x8A
        BREQ       M_CASE_0316
        RJMP       M_CASE_0315
M_CASE_0316:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_FE)
        LDI        R16, 0xFE
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0317
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0317:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0319
        MOV        R16, R17
M_PRG_CONST_STRING_0318:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0318
M_PRG_CONST_STRING_0319:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
M_CASE_0315:
 
; CASE OF - vergleiche Einzel-Element ($8B)
        CPI        R16, 0x8B
        BREQ       M_CASE_0321
        RJMP       M_CASE_0320
M_CASE_0321:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_FF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0322
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0322:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0324
        MOV        R16, R17
M_PRG_CONST_STRING_0323:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0323
M_PRG_CONST_STRING_0324:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0238
 
; CASE OF ELSE
M_CASE_0320:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_KEY)
        CALL       WRITE_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0238:
 
; PROCEDURE - Ende (SENDKEY)
        RET
 
; PROCEDURE - Anfang (SENDKEYCHAR)
SENDKEYCHAR:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(SKEY)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEYCHAR)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (SENDKEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEYCHAR)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (SENDKEYCHAR)
        RET
 
; ISR - Einsprung
EI_INT0:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
  PUSH   R18
 
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0325
        RJMP       M_IF_0326
M_IF_0325:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0327
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0326:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0331
        CLR        R16
        RJMP       M_VERGL_0332
M_VERGL_0331:
        SER        R16
M_VERGL_0332:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0328
        RJMP       M_IF_0329
M_IF_0328:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0B)
        LDI        R18, 0x0B
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0336
        CLR        R16
        RJMP       M_VERGL_0337
M_VERGL_0336:
        SER        R16
M_VERGL_0337:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0333
        RJMP       M_IF_0334
M_IF_0333:
 
; SHR(TMPBYTE) - Byte
        LDS        R16, TMPBYTE
        LSR        R16
        STS        TMPBYTE, R16
 
; IF THEN - Ausdruck /; BitHigh(KEY_DAT_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0341
        CLR        R16
        RJMP       M_VERGL_0342
M_VERGL_0341:
        SER        R16
M_VERGL_0342:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0338
        RJMP       M_IF_0339
M_IF_0338:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (TMPBYTE)
        STS        TMPBYTE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0340
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0339:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x7F)
        LDI        R18, 0x7F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (TMPBYTE)
        STS        TMPBYTE, R16
 
; IF_THEN_ELSE - Ende
M_IF_0340:
 
; IF_THEN - Ende
M_IF_0334:
 
; IF_THEN - Ende
M_IF_0329:
 
; DEC(BITCNTR) - Byte
        LDS        R16, BITCNTR
        DEC        R16
        STS        BITCNTR, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0346
        CLR        R16
        RJMP       M_VERGL_0347
M_VERGL_0346:
        SER        R16
M_VERGL_0347:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0343
        RJMP       M_IF_0344
M_IF_0343:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; IF THEN - Ausdruck / Byte-VAR (LOCALMODE)
        LDS        R16, LOCALMODE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0348
        RJMP       M_IF_0349
M_IF_0348:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Ziel /  VAR (LOCALBYTE)
        STS        LOCALBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOCALMODE)
        STS        LOCALMODE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0350
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0349:
 
; ASM
          PUSH   R0
          PUSH   R17
          PUSH   R19
          PUSH   R24
          PUSH   R25
          PUSH   ZL
          PUSH   ZH
 
 
; Byte-Parameter(1) fuer PROCEDURE (WRITE_SCAN)
        LDS        R0, TMPBYTE
 
; Aufruf PROCEDURE (WRITE_SCAN)
        CALL       WRITE_SCAN
 
; ASM
          POP   ZH
          POP   ZL
          POP   R25
          POP   R24
          POP   R19
          POP   R17
          POP   R0
 
 
; IF_THEN_ELSE - Ende
M_IF_0350:
 
; IF_THEN - Ende
M_IF_0344:
 
; IF_THEN_ELSE - Ende
M_IF_0327:
 
; ASM
  POP   R18
 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (INITKEYB)
INITKEYB:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SCANBUFFERPTR)
        STS        SCANBUFFERPTR, R16
        STS        SCANBUFFERPTR+1, R17
 
; PROCEDURE - Ende (INITKEYB)
        RET
 
; PROCEDURE - Anfang (SET_KBD_CLK)
SET_KBD_CLK:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIFR
        IN         R16, EIFR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIFR)
        OUT        EIFR, R16
 
; SetBit(KEY_CLK_A)
        SBI        PORTD, 2
 
; ClearBit(KEY_CLK_D)
        CBI        DDRD, 2
 
; Interrupt erlauben
        SEI
 
; PROCEDURE - Ende (SET_KBD_CLK)
        RET
 
; PROCEDURE - Anfang (RESET_KBD_CLK)
RESET_KBD_CLK:
 
; Interrupt verbieten
        CLI
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; ClearBit(KEY_CLK_A)
        CBI        PORTD, 2
 
; SetBit(KEY_CLK_D)
        SBI        DDRD, 2
 
; PROCEDURE - Ende (RESET_KBD_CLK)
        RET
 
; FUNCTION - Anfang (NOT_PARITY)
NOT_PARITY:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B4)
        MOV        R5, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R5
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0351:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0352
        RJMP       M_FTD_0353
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0352:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (DAS_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0357
        CLR        R16
        RJMP       M_VERGL_0358
M_VERGL_0357:
        SER        R16
M_VERGL_0358:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0354
        RJMP       M_IF_0355
M_IF_0354:
 
; INC(B3) - Byte
        INC        R4
 
; IF_THEN - Ende
M_IF_0355:
 
; SHR(DAS_BYTE) - Byte
        LSR        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R5
        INC        R17
        MOV        R5, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0351
 
; FOR TO DO - Ende
M_FTD_0353:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B3)
        MOV        R16, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0362
        CLR        R16
        RJMP       M_VERGL_0363
M_VERGL_0362:
        SER        R16
M_VERGL_0363:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0359
        RJMP       M_IF_0360
M_IF_0359:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0361
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0360:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_0361:
 
; RESULT Byte-Variable - FUNCTION (NOT_PARITY)
        MOV        R1, R2
 
; Ende Byte - FUNCTION (NOT_PARITY)
        MOV        R16, R1
 
; FUNCTION - Ende (NOT_PARITY)
        RET
 
; PROCEDURE - Anfang (SENDTOKBD)
SENDTOKBD:
 
; Interrupt verbieten
        CLI
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf Funktion (NOT_PARITY)
        CALL       NOT_PARITY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (P)
        MOV        R1, R16
 
; ClearBit(KEY_CLK_D)
        CBI        DDRD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0364:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0367
        CLR        R16
        RJMP       M_VERGL_0368
M_VERGL_0367:
        SER        R16
M_VERGL_0368:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0365
        RJMP       M_WHILE_0366
M_WHILE_0365:
 
; DEC(W) - Word
        MOVW       R25:R24, R3:R2
        SBIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0372
        CLR        R16
        RJMP       M_VERGL_0373
M_VERGL_0372:
        SER        R16
M_VERGL_0373:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0369
        RJMP       M_IF_0370
M_IF_0369:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN - Ende
M_IF_0370:
 
; WHILE DO ...
        RJMP       M_WHILE_0364
M_WHILE_0366:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0377
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0378
M_VERGL_0377:
        SER        R16
M_VERGL_0378:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0374
        RJMP       M_IF_0375
M_IF_0374:
 
; SetBit(KEY_CLK_D)
        SBI        DDRD, 2
 
; ClearBit(KEY_CLK_A)
        CBI        PORTD, 2
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(KEY_DAT_A)
        CBI        PORTD, 3
 
; SetBit(KEY_DAT_D)
        SBI        DDRD, 3
 
; SetBit(KEY_CLK_A)
        SBI        PORTD, 2
 
; ClearBit(KEY_CLK_D)
        CBI        DDRD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0379:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0382
        CLR        R16
        RJMP       M_VERGL_0383
M_VERGL_0382:
        SER        R16
M_VERGL_0383:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0380
        RJMP       M_WHILE_0381
M_WHILE_0380:
 
; DEC(W) - Word
        MOVW       R25:R24, R3:R2
        SBIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0387
        CLR        R16
        RJMP       M_VERGL_0388
M_VERGL_0387:
        SER        R16
M_VERGL_0388:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0384
        RJMP       M_IF_0385
M_IF_0384:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN - Ende
M_IF_0385:
 
; WHILE DO ...
        RJMP       M_WHILE_0379
M_WHILE_0381:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0392
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0393
M_VERGL_0392:
        SER        R16
M_VERGL_0393:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0389
        RJMP       M_IF_0390
M_IF_0389:
 
; ASM
    MOV    R16, R0

    // Zaehler in R17
    LDI    R17, 8

M_tx_data:
    // Bit 0 in C
    ROR    R16

    // Set/reset the Data line to send the first data bit
    BRCS     M_tx_data0

    // set databit -> 0
    CBI    PortD, 3
    RJMP     M_tx_data1

M_tx_data0:
    // set databit -> 1
    SBI    PortD, 3

M_tx_data1:
    // Wait for the device to bring Clock high.
    SBIS   PIND, 2
    RJMP   M_tx_data1;         // wait till CLK rise

M_tx_data2:
    // Wait for the device to bring Clock low.
    SBIC   PIND, 2
    RJMP   M_tx_data2;         // now wait till CLK falls down

    // next bit please ...
    DEC    R17
    BRNE   M_tx_data


 
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (P)
        MOV        R16, R1
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0394
        RJMP       M_IF_0395
M_IF_0394:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (REG)
        MOV        R16, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (REG)
        MOV        R5, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0396
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0395:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (REG)
        MOV        R16, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xFE)
        LDI        R18, 0xFE
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (REG)
        MOV        R5, R16
 
; IF_THEN_ELSE - Ende
M_IF_0396:
 
; ASM
    MOV    R16, R5

    ROR    R16
    BRCS   M_tx_data3

    // set databit -> 0
    CBI    PortD, 3
    RJMP   M_tx_data5

M_tx_data3:
    // set databit -> 1
    SBI    PortD, 3


M_tx_data5:
    // Wait for the device to bring Clock high.
    SBIS   PIND, 2
    RJMP   M_tx_data5;     // wait till CLK rise

    M_tx_data6:
    // Wait for the device to bring Clock low.
    SBIC   PIND, 2
    RJMP   M_tx_data6;     // now wait till CLK falls down

    // Getting stopbit
    SBI PortD, 3

    M_tx_data7:
    // waiting until clock will rise
    SBIS   PIND, 2
    RJMP   M_tx_data7;     // wait till CLK rise

    // Now release the Data line.
    //  DDRD.3 := 0;
    CBI    DDRD, 3;

 
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0397:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0400
        CLR        R16
        RJMP       M_VERGL_0401
M_VERGL_0400:
        SER        R16
M_VERGL_0401:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0398
        RJMP       M_WHILE_0399
M_WHILE_0398:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0405
        CLR        R16
        RJMP       M_VERGL_0406
M_VERGL_0405:
        SER        R16
M_VERGL_0406:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0402
        RJMP       M_IF_0403
M_IF_0402:
 
; INC(W) - Word
        MOVW       R25:R24, R3:R2
        ADIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; IF_THEN - Ende
M_IF_0403:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0410
        CLR        R16
        RJMP       M_VERGL_0411
M_VERGL_0410:
        SER        R16
M_VERGL_0411:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0407
        RJMP       M_IF_0408
M_IF_0407:
 
; INC(W) - Word
        MOVW       R25:R24, R3:R2
        ADIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; IF_THEN - Ende
M_IF_0408:
 
; WHILE DO ...
        RJMP       M_WHILE_0397
M_WHILE_0399:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0412:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0415
        CLR        R16
        RJMP       M_VERGL_0416
M_VERGL_0415:
        SER        R16
M_VERGL_0416:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0413
        RJMP       M_WHILE_0414
M_WHILE_0413:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0420
        CLR        R16
        RJMP       M_VERGL_0421
M_VERGL_0420:
        SER        R16
M_VERGL_0421:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0417
        RJMP       M_IF_0418
M_IF_0417:
 
; INC(W) - Word
        MOVW       R25:R24, R3:R2
        ADIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; IF_THEN - Ende
M_IF_0418:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0425
        CLR        R16
        RJMP       M_VERGL_0426
M_VERGL_0425:
        SER        R16
M_VERGL_0426:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0422
        RJMP       M_IF_0423
M_IF_0422:
 
; INC(W) - Word
        MOVW       R25:R24, R3:R2
        ADIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; IF_THEN - Ende
M_IF_0423:
 
; WHILE DO ...
        RJMP       M_WHILE_0412
M_WHILE_0414:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (RESET_KBD_CLK)
        CALL       RESET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LOCALMODE)
        STS        LOCALMODE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (SET_KBD_CLK)
        CALL       SET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0427:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0430
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0431
M_VERGL_0430:
        SER        R16
M_VERGL_0431:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0428
        RJMP       M_WHILE_0429
M_WHILE_0428:
 
; IF THEN - Ausdruck / Byte-VAR (LOCALMODE)
        LDS        R16, LOCALMODE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0432
        RJMP       M_IF_0433
M_IF_0432:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0434
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0433:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0434:
 
; WHILE DO ...
        RJMP       M_WHILE_0427
M_WHILE_0429:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0391
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0390:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0391:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0376
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0375:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0376:
 
; PROCEDURE - Ende (SENDTOKBD)
        RET
 
; PROCEDURE - Anfang (SET_KBD_STATE)
SET_KBD_STATE:
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDI        R16, 0xED
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDS        R0, LEDSTATE
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; PROCEDURE - Ende (SET_KBD_STATE)
        RET
 
; PROCEDURE - Anfang (KBDRESET)
KBDRESET:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (RESET_KBD_CLK)
        CALL       RESET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x01F4)
        MOV        R0, R16
        LDI        R17, HIGH(0x01F4)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOCALBYTE)
        STS        LOCALBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; WHILE DO ...
M_WHILE_0435:
 
; WHILE - Ausdruck / lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R16, R0
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0436
        RJMP       M_WHILE_0437
M_WHILE_0436:
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDI        R16, 0xFF
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (LOCALBYTE)
        LDS        R16, LOCALBYTE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xAA)
        LDI        R18, 0xAA
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0441
        CLR        R16
        RJMP       M_VERGL_0442
M_VERGL_0441:
        SER        R16
M_VERGL_0442:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0438
        RJMP       M_IF_0439
M_IF_0438:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0439:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (LOCALBYTE)
        LDS        R16, LOCALBYTE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFA)
        LDI        R18, 0xFA
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0446
        CLR        R16
        RJMP       M_VERGL_0447
M_VERGL_0446:
        SER        R16
M_VERGL_0447:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0443
        RJMP       M_IF_0444
M_IF_0443:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0444:
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0448
        RJMP       M_IF_0449
M_IF_0448:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0449:
 
; WHILE DO ...
        RJMP       M_WHILE_0435
M_WHILE_0437:
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0451
        RJMP       M_IF_0452
M_IF_0451:
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (SET_KBD_CLK)
        CALL       SET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_LED_STATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SHIFTSTATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0453
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0452:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (LEDNUM)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (INITKEYB)
        CALL       INITKEYB
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0453:
 
; PROCEDURE - Ende (KBDRESET)
        RET
 
; PROCEDURE - Anfang (START_KEYBOARD)
START_KEYBOARD:
 
; Aufruf PROCEDURE (INITKEYB)
        CALL       INITKEYB
 
; Aufruf PROCEDURE (KBDRESET)
        CALL       KBDRESET
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0454
        RJMP       M_IF_0455
M_IF_0454:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0456
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0455:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0004)
        MOV        R0, R16
        LDI        R17, HIGH(0x0004)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; IF_THEN_ELSE - Ende
M_IF_0456:
 
; PROCEDURE - Ende (START_KEYBOARD)
        RET
 
; PROCEDURE - Anfang (SETZE_BIT_IN_KBSHIFTSTATE)
SETZE_BIT_IN_KBSHIFTSTATE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (SHIFT_TASTE)
        MOV        R18, R0
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; PROCEDURE - Ende (SETZE_BIT_IN_KBSHIFTSTATE)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BIT_IN_KBSHIFTSTATE)
LOESCHE_BIT_IN_KBSHIFTSTATE:
 
; Retten der lokalen Parameter fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (NEGATION_BYTE)
        CALL       NEGATION_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; PROCEDURE - Ende (LOESCHE_BIT_IN_KBSHIFTSTATE)
        RET
 
; PROCEDURE - Anfang (SETZE_BIT_IN_LEDSTATE)
SETZE_BIT_IN_LEDSTATE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (LEDSTATE)
        LDS        R16, LEDSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (STATE_LED)
        MOV        R18, R0
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; PROCEDURE - Ende (SETZE_BIT_IN_LEDSTATE)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BIT_IN_LEDSTATE)
LOESCHE_BIT_IN_LEDSTATE:
 
; Retten der lokalen Parameter fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (NEGATION_BYTE)
        CALL       NEGATION_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (LEDSTATE)
        LDS        R16, LEDSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; PROCEDURE - Ende (LOESCHE_BIT_IN_LEDSTATE)
        RET
 
; PROCEDURE - Anfang (SCAN_TO_KEY)
SCAN_TO_KEY:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(CURSCAN)
        MOV        R16, R0
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R2, R16
        MOV        R3, R17
 
; CASE OF - Byte-VAR (KEYBSTATE)
        LDS        R16, KEYBSTATE
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_BYTE1)
        CPI        R16, 0x01
        BREQ       M_CASE_0459
        RJMP       M_CASE_0458
M_CASE_0459:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (SCANEXT)
        CPI        R16, 0xE0
        BREQ       M_CASE_0462
        RJMP       M_CASE_0461
M_CASE_0462:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_E0)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0461:
 
; CASE OF - vergleiche Einzel-Element (SCANBREAK)
        CPI        R16, 0xF0
        BREQ       M_CASE_0464
        RJMP       M_CASE_0463
M_CASE_0464:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_F0)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0463:
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0466
        RJMP       M_CASE_0465
M_CASE_0466:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0465:
 
; CASE OF - vergleiche Einzel-Element (KBDLSHIFT)
        CPI        R16, 0x12
        BREQ       M_CASE_0468
        RJMP       M_CASE_0467
M_CASE_0468:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0467:
 
; CASE OF - vergleiche Einzel-Element (KBDRSHIFT)
        CPI        R16, 0x59
        BREQ       M_CASE_0470
        RJMP       M_CASE_0469
M_CASE_0470:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0469:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0472
        RJMP       M_CASE_0471
M_CASE_0472:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0471:
 
; CASE OF - vergleiche Einzel-Element (KBDCAPS)
        CPI        R16, 0x58
        BREQ       M_CASE_0474
        RJMP       M_CASE_0473
M_CASE_0474:
 
; IF THEN - Ausdruck / Byte-VAR (CAPS_PRESSED)
        LDS        R16, CAPS_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0475
        RJMP       M_IF_0476
M_IF_0475:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0477
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0476:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0481
        CLR        R16
        RJMP       M_VERGL_0482
M_VERGL_0481:
        SER        R16
M_VERGL_0482:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0478
        RJMP       M_IF_0479
M_IF_0478:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0480
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0479:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0480:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0477:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0473:
 
; CASE OF - vergleiche Einzel-Element (KBDNUM)
        CPI        R16, 0x77
        BREQ       M_CASE_0484
        RJMP       M_CASE_0483
M_CASE_0484:
 
; IF THEN - Ausdruck / Byte-VAR (NUM_PRESSED)
        LDS        R16, NUM_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0485
        RJMP       M_IF_0486
M_IF_0485:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0487
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0486:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHNUM)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHNUM)
        LDI        R18, 0x02
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0491
        CLR        R16
        RJMP       M_VERGL_0492
M_VERGL_0491:
        SER        R16
M_VERGL_0492:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0488
        RJMP       M_IF_0489
M_IF_0488:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0490
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0489:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0490:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0487:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0483:
 
; CASE OF - vergleiche Einzel-Element (KBDSCROLL)
        CPI        R16, 0x7E
        BREQ       M_CASE_0494
        RJMP       M_CASE_0493
M_CASE_0494:
 
; IF THEN - Ausdruck / Byte-VAR (SCROLL_PRESSED)
        LDS        R16, SCROLL_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0495
        RJMP       M_IF_0496
M_IF_0495:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0497
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0496:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHSCROLL)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHSCROLL)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0501
        CLR        R16
        RJMP       M_VERGL_0502
M_VERGL_0501:
        SER        R16
M_VERGL_0502:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0498
        RJMP       M_IF_0499
M_IF_0498:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0500
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0499:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0500:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0497:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0493:
 
; CASE OF - vergleiche Einzel-Element (KBDENTER)
        CPI        R16, 0x5A
        BREQ       M_CASE_0504
        RJMP       M_CASE_0503
M_CASE_0504:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0503:
 
; CASE OF - vergleiche Einzel-Element (KBDSPACE)
        CPI        R16, 0x29
        BREQ       M_CASE_0506
        RJMP       M_CASE_0505
M_CASE_0506:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEYCHAR)
        LDI        R16, ' '
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEYCHAR)
        CALL       SENDKEYCHAR
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0505:
 
; CASE OF - vergleiche Einzel-Element (KBDBS)
        CPI        R16, 0x66
        BREQ       M_CASE_0508
        RJMP       M_CASE_0507
M_CASE_0508:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x7F
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0507:
 
; CASE OF - vergleiche Einzel-Element (KBDTAB)
        CPI        R16, 0x0D
        BREQ       M_CASE_0510
        RJMP       M_CASE_0509
M_CASE_0510:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x09
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0509:
 
; CASE OF - vergleiche Einzel-Element (KBDESC)
        CPI        R16, 0x76
        BREQ       M_CASE_0512
        RJMP       M_CASE_0511
M_CASE_0512:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x1B
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0511:
 
; CASE OF - vergleiche Einzel-Element (KBDF1)
        CPI        R16, 0x05
        BREQ       M_CASE_0514
        RJMP       M_CASE_0513
M_CASE_0514:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x80
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0513:
 
; CASE OF - vergleiche Einzel-Element (KBDF2)
        CPI        R16, 0x06
        BREQ       M_CASE_0516
        RJMP       M_CASE_0515
M_CASE_0516:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x81
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0515:
 
; CASE OF - vergleiche Einzel-Element (KBDF3)
        CPI        R16, 0x04
        BREQ       M_CASE_0518
        RJMP       M_CASE_0517
M_CASE_0518:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x82
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0517:
 
; CASE OF - vergleiche Einzel-Element (KBDF4)
        CPI        R16, 0x0C
        BREQ       M_CASE_0520
        RJMP       M_CASE_0519
M_CASE_0520:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x83
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0519:
 
; CASE OF - vergleiche Einzel-Element (KBDF5)
        CPI        R16, 0x03
        BREQ       M_CASE_0522
        RJMP       M_CASE_0521
M_CASE_0522:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x84
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0521:
 
; CASE OF - vergleiche Einzel-Element (KBDF6)
        CPI        R16, 0x0B
        BREQ       M_CASE_0524
        RJMP       M_CASE_0523
M_CASE_0524:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x85
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0523:
 
; CASE OF - vergleiche Einzel-Element (KBDF7)
        CPI        R16, 0x83
        BREQ       M_CASE_0526
        RJMP       M_CASE_0525
M_CASE_0526:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x86
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0525:
 
; CASE OF - vergleiche Einzel-Element (KBDF8)
        CPI        R16, 0x0A
        BREQ       M_CASE_0528
        RJMP       M_CASE_0527
M_CASE_0528:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x87
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0527:
 
; CASE OF - vergleiche Einzel-Element (KBDF9)
        CPI        R16, 0x01
        BREQ       M_CASE_0530
        RJMP       M_CASE_0529
M_CASE_0530:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x88
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0529:
 
; CASE OF - vergleiche Einzel-Element (KBDF10)
        CPI        R16, 0x09
        BREQ       M_CASE_0532
        RJMP       M_CASE_0531
M_CASE_0532:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x89
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0531:
 
; CASE OF - vergleiche Einzel-Element (KBDF11)
        CPI        R16, 0x78
        BREQ       M_CASE_0534
        RJMP       M_CASE_0533
M_CASE_0534:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x8A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0533:
 
; CASE OF - vergleiche Einzel-Element (KBDF12)
        CPI        R16, 0x07
        BREQ       M_CASE_0536
        RJMP       M_CASE_0535
M_CASE_0536:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x8B
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
M_CASE_0535:
 
; CASE OF - vergleiche Einzel-Element (KBDPAUSE)
        CPI        R16, 0xE1
        BREQ       M_CASE_0538
        RJMP       M_CASE_0537
M_CASE_0538:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0460
 
; CASE OF ELSE
M_CASE_0537:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_NULL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHSHIFT)
        LDI        R18, 0x20
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHSHIFT)
        LDI        R18, 0x20
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0542
        CLR        R16
        RJMP       M_VERGL_0543
M_VERGL_0542:
        SER        R16
M_VERGL_0543:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0539
        RJMP       M_IF_0540
M_IF_0539:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0547
        CLR        R16
        RJMP       M_VERGL_0548
M_VERGL_0547:
        SER        R16
M_VERGL_0548:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0544
        RJMP       M_IF_0545
M_IF_0544:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL)
        LDI        ZL, LOW(2*CODETAB_NORMAL)
        LDI        ZH, HIGH(2*CODETAB_NORMAL)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0546
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0545:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_SHIFT)
        LDI        ZL, LOW(2*CODETAB_SHIFT)
        LDI        ZH, HIGH(2*CODETAB_SHIFT)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0546:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0541
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0540:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0552
        CLR        R16
        RJMP       M_VERGL_0553
M_VERGL_0552:
        SER        R16
M_VERGL_0553:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0549
        RJMP       M_IF_0550
M_IF_0549:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_SHIFT)
        LDI        ZL, LOW(2*CODETAB_SHIFT)
        LDI        ZH, HIGH(2*CODETAB_SHIFT)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0551
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0550:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL)
        LDI        ZL, LOW(2*CODETAB_NORMAL)
        LDI        ZH, HIGH(2*CODETAB_NORMAL)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0551:
 
; IF_THEN_ELSE - Ende
M_IF_0541:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCTRL)
        LDI        R18, 0x10
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCTRL)
        LDI        R18, 0x10
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0557
        CLR        R16
        RJMP       M_VERGL_0558
M_VERGL_0557:
        SER        R16
M_VERGL_0558:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0554
        RJMP       M_IF_0555
M_IF_0554:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_CTRL)
        LDI        ZL, LOW(2*CODETAB_CTRL)
        LDI        ZH, HIGH(2*CODETAB_CTRL)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN - Ende
M_IF_0555:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHALT)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHALT)
        LDI        R18, 0x08
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0562
        CLR        R16
        RJMP       M_VERGL_0563
M_VERGL_0562:
        SER        R16
M_VERGL_0563:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0559
        RJMP       M_IF_0560
M_IF_0559:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_ALT)
        LDI        ZL, LOW(2*CODETAB_ALT)
        LDI        ZH, HIGH(2*CODETAB_ALT)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN - Ende
M_IF_0560:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEYCHAR)
        LDS        R0, CH
 
; Aufruf PROCEDURE (SENDKEYCHAR)
        CALL       SENDKEYCHAR
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0460:
 
; IF THEN - Ausdruck / Byte-VAR (DOCLICK)
        LDS        R16, DOCLICK
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0564
        RJMP       M_IF_0565
M_IF_0564:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (CLICK)
        CALL       CLICK
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0565:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0457
M_CASE_0458:
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_E0)
        CPI        R16, 0x02
        BREQ       M_CASE_0568
        RJMP       M_CASE_0567
M_CASE_0568:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (SCANBREAK)
        CPI        R16, 0xF0
        BREQ       M_CASE_0571
        RJMP       M_CASE_0570
M_CASE_0571:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_F0)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0570:
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0573
        RJMP       M_CASE_0572
M_CASE_0573:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0572:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0575
        RJMP       M_CASE_0574
M_CASE_0575:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0574:
 
; CASE OF - vergleiche Einzel-Element (KBDENTER)
        CPI        R16, 0x5A
        BREQ       M_CASE_0577
        RJMP       M_CASE_0576
M_CASE_0577:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0576:
 
; CASE OF - vergleiche Einzel-Element (KBDUP)
        CPI        R16, 0x75
        BREQ       M_CASE_0579
        RJMP       M_CASE_0578
M_CASE_0579:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x05
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0578:
 
; CASE OF - vergleiche Einzel-Element (KBDDN)
        CPI        R16, 0x72
        BREQ       M_CASE_0581
        RJMP       M_CASE_0580
M_CASE_0581:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x18
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0580:
 
; CASE OF - vergleiche Einzel-Element (KBDLEFT)
        CPI        R16, 0x6B
        BREQ       M_CASE_0583
        RJMP       M_CASE_0582
M_CASE_0583:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x13
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0582:
 
; CASE OF - vergleiche Einzel-Element (KBDRIGHT)
        CPI        R16, 0x74
        BREQ       M_CASE_0585
        RJMP       M_CASE_0584
M_CASE_0585:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0584:
 
; CASE OF - vergleiche Einzel-Element (KBDPGUP)
        CPI        R16, 0x7D
        BREQ       M_CASE_0587
        RJMP       M_CASE_0586
M_CASE_0587:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x12
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0586:
 
; CASE OF - vergleiche Einzel-Element (KBDPGDN)
        CPI        R16, 0x7A
        BREQ       M_CASE_0589
        RJMP       M_CASE_0588
M_CASE_0589:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0588:
 
; CASE OF - vergleiche Einzel-Element (KBDHOME)
        CPI        R16, 0x6C
        BREQ       M_CASE_0591
        RJMP       M_CASE_0590
M_CASE_0591:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0590:
 
; CASE OF - vergleiche Einzel-Element (KBDINSERT)
        CPI        R16, 0x70
        BREQ       M_CASE_0593
        RJMP       M_CASE_0592
M_CASE_0593:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x16
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0592:
 
; CASE OF - vergleiche Einzel-Element (KBDDELETE)
        CPI        R16, 0x71
        BREQ       M_CASE_0595
        RJMP       M_CASE_0594
M_CASE_0595:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0594:
 
; CASE OF - vergleiche Einzel-Element (KBDEND)
        CPI        R16, 0x69
        BREQ       M_CASE_0597
        RJMP       M_CASE_0596
M_CASE_0597:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0596:
 
; CASE OF - vergleiche Einzel-Element (KBDRGUI)
        CPI        R16, 0x27
        BREQ       M_CASE_0599
        RJMP       M_CASE_0598
M_CASE_0599:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0598:
 
; CASE OF - vergleiche Einzel-Element (KBDLGUI)
        CPI        R16, 0x1F
        BREQ       M_CASE_0601
        RJMP       M_CASE_0600
M_CASE_0601:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0600:
 
; CASE OF - vergleiche Einzel-Element (KBDAPPS)
        CPI        R16, 0x2F
        BREQ       M_CASE_0603
        RJMP       M_CASE_0602
M_CASE_0603:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0569
M_CASE_0602:
 
; CASE OF - vergleiche Einzel-Element (KBDPRINT)
        CPI        R16, 0x12
        BREQ       M_CASE_0605
        RJMP       M_CASE_0604
M_CASE_0605:
 
; ENDCASE;
M_CASE_0604:
M_CASE_0569:
 
; IF THEN - Ausdruck / Byte-VAR (DOCLICK)
        LDS        R16, DOCLICK
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0606
        RJMP       M_IF_0607
M_IF_0606:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (CLICK)
        CALL       CLICK
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0607:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0457
M_CASE_0567:
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_F0)
        CPI        R16, 0x03
        BREQ       M_CASE_0610
        RJMP       M_CASE_0609
M_CASE_0610:
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0613
        RJMP       M_CASE_0612
M_CASE_0613:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0611
M_CASE_0612:
 
; CASE OF - vergleiche Einzel-Element (KBDLSHIFT)
        CPI        R16, 0x12
        BREQ       M_CASE_0615
        RJMP       M_CASE_0614
M_CASE_0615:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0611
M_CASE_0614:
 
; CASE OF - vergleiche Einzel-Element (KBDRSHIFT)
        CPI        R16, 0x59
        BREQ       M_CASE_0617
        RJMP       M_CASE_0616
M_CASE_0617:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0611
M_CASE_0616:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0619
        RJMP       M_CASE_0618
M_CASE_0619:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0611
M_CASE_0618:
 
; CASE OF - vergleiche Einzel-Element (KBDCAPS)
        CPI        R16, 0x58
        BREQ       M_CASE_0621
        RJMP       M_CASE_0620
M_CASE_0621:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0611
M_CASE_0620:
 
; CASE OF - vergleiche Einzel-Element (KBDNUM)
        CPI        R16, 0x77
        BREQ       M_CASE_0623
        RJMP       M_CASE_0622
M_CASE_0623:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0611
M_CASE_0622:
 
; CASE OF - vergleiche Einzel-Element (KBDSCROLL)
        CPI        R16, 0x7E
        BREQ       M_CASE_0625
        RJMP       M_CASE_0624
M_CASE_0625:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; ENDCASE;
M_CASE_0624:
M_CASE_0611:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; ENDCASE;
M_CASE_0609:
M_CASE_0457:
 
; PROCEDURE - Ende (SCAN_TO_KEY)
        RET
 
; PROCEDURE - Anfang (CHANGE_MODE)
CHANGE_MODE:
 
; CASE OF - lokaler Uebergabeparameter (DATA_BYTE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (RE_CONST)
        CPI        R16, 0x01
        BREQ       M_CASE_0628
        RJMP       M_CASE_0627
M_CASE_0628:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RECEIVE_CONST)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0627:
 
; CASE OF - vergleiche Einzel-Element (RE_CONIN)
        CPI        R16, 0x02
        BREQ       M_CASE_0630
        RJMP       M_CASE_0629
M_CASE_0630:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RECEIVE_CONIN)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0629:
 
; CASE OF - vergleiche Einzel-Element (SE_CONOUT)
        CPI        R16, 0x03
        BREQ       M_CASE_0632
        RJMP       M_CASE_0631
M_CASE_0632:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SEND_CONOUT)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (SEND_MODE)
        STS        SEND_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0631:
 
; CASE OF - vergleiche Einzel-Element (RE_WHO_ARE_YOU)
        CPI        R16, 0x14
        BREQ       M_CASE_0634
        RJMP       M_CASE_0633
M_CASE_0634:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RECEIVE_DEVCODE)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0633:
 
; CASE OF - vergleiche Einzel-Element (RE_ERROR_CODE)
        CPI        R16, 0x0A
        BREQ       M_CASE_0636
        RJMP       M_CASE_0635
M_CASE_0636:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RECEIVE_ERROR_CODE)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
 
; CASE OF ELSE
M_CASE_0635:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (ERROR_PARAM)
        STS        ERROR_PARAM, R16
 
; ENDCASE;
M_CASE_0626:
 
; PROCEDURE - Ende (CHANGE_MODE)
        RET
 
; PROCEDURE - Anfang (DATA_SEND)
DATA_SEND:
 
; CASE OF - Byte-VAR (SEND_MODE)
        LDS        R16, SEND_MODE
 
; CASE OF - vergleiche Einzel-Element (NO_SEND_MODE)
        CPI        R16, 0x00
        BREQ       M_CASE_0639
        RJMP       M_CASE_0638
M_CASE_0639:
 
; Retten der lokalen Parameter fuer PROCEDURE (DATA_SEND)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (CHANGE_MODE)
        CALL       CHANGE_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (DATA_SEND)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0637
M_CASE_0638:
 
; CASE OF - vergleiche Einzel-Element (SEND_CONOUT)
        CPI        R16, 0x01
        BREQ       M_CASE_0641
        RJMP       M_CASE_0640
M_CASE_0641:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (AUSGABEBYTE)
        STS        AUSGABEBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SEND_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SEND_MODE)
        STS        SEND_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RECEIVE_CONOUT)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0637
 
; CASE OF ELSE
M_CASE_0640:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (ERROR_PARAM)
        STS        ERROR_PARAM, R16
 
; ENDCASE;
M_CASE_0637:
 
; PROCEDURE - Ende (DATA_SEND)
        RET
 
; PROCEDURE - Anfang (SEND_ONE_NIBBLE)
SEND_ONE_NIBBLE:
 
; ClearBit(CDEN_A)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (ONE_NIBBLE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; WHILE DO ...
M_WHILE_0642:
 
; WHILE - Ausdruck /; BitLow(CRAC_E)
        IN         R16, PIND
        BST        R16, 7
        BRTC       M_VERGL_0645
        CLR        R16
        RJMP       M_VERGL_0646
M_VERGL_0645:
        SER        R16
M_VERGL_0646:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0643
        RJMP       M_WHILE_0644
M_WHILE_0643:
 
; SetBit(CDEN_A)
        SBI        PORTD, 6
 
; WHILE DO ...
        RJMP       M_WHILE_0642
M_WHILE_0644:
 
; WHILE DO ...
M_WHILE_0647:
 
; WHILE - Ausdruck /; BitHigh(CRAC_E)
        IN         R16, PIND
        BST        R16, 7
        BRTS       M_VERGL_0650
        CLR        R16
        RJMP       M_VERGL_0651
M_VERGL_0650:
        SER        R16
M_VERGL_0651:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0648
        RJMP       M_WHILE_0649
M_WHILE_0648:
 
; ClearBit(CDEN_A)
        CBI        PORTD, 6
 
; WHILE DO ...
        RJMP       M_WHILE_0647
M_WHILE_0649:
 
; PROCEDURE - Ende (SEND_ONE_NIBBLE)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_MESSAGE)
RUN_RECEIVE_MESSAGE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (RECEIVE_MESSAGE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ONE_NIBBLE)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        PUSH       R0
        PUSH       R1
 
; Parameter (ONE_NIBBLE) retten
        MOV        R17, R1
 
; lokalen Parameter (ONE_NIBBLE) an Prozedur (SEND_ONE_NIBBLE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SEND_ONE_NIBBLE)
        CALL       SEND_ONE_NIBBLE
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (RECEIVE_MESSAGE)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ONE_NIBBLE)
        MOV        R1, R16
 
; SHR(ONE_NIBBLE) - Byte
        LSR        R1
 
; SHR(ONE_NIBBLE) - Byte
        LSR        R1
 
; SHR(ONE_NIBBLE) - Byte
        LSR        R1
 
; SHR(ONE_NIBBLE) - Byte
        LSR        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        PUSH       R0
        PUSH       R1
 
; Parameter (ONE_NIBBLE) retten
        MOV        R17, R1
 
; lokalen Parameter (ONE_NIBBLE) an Prozedur (SEND_ONE_NIBBLE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SEND_ONE_NIBBLE)
        CALL       SEND_ONE_NIBBLE
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (RUN_RECEIVE_MESSAGE)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_CONST)
RUN_RECEIVE_CONST:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0655
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0656
M_VERGL_0655:
        SER        R16
M_VERGL_0656:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0652
        RJMP       M_IF_0653
M_IF_0652:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RECEIVE_MESSAGE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0654
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0653:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RECEIVE_MESSAGE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Ende
M_IF_0654:
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_RECEIVE_CONST)
        PUSH       R0
 
; Aufruf PROCEDURE (RUN_RECEIVE_MESSAGE)
        CALL       RUN_RECEIVE_MESSAGE
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_RECEIVE_CONST)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; PROCEDURE - Ende (RUN_RECEIVE_CONST)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_CONIN)
RUN_RECEIVE_CONIN:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0660
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0661
M_VERGL_0660:
        SER        R16
M_VERGL_0661:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0657
        RJMP       M_IF_0658
M_IF_0657:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RECEIVE_MESSAGE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0659
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0658:
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_RECEIVE_CONIN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (READ_KEY)
        CALL       READ_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_RECEIVE_CONIN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RECEIVE_MESSAGE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Ende
M_IF_0659:
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_RECEIVE_CONIN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (RUN_RECEIVE_MESSAGE)
        CALL       RUN_RECEIVE_MESSAGE
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_RECEIVE_CONIN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; PROCEDURE - Ende (RUN_RECEIVE_CONIN)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_CONOUT)
RUN_RECEIVE_CONOUT:
 
; WHILE DO ...
M_WHILE_0662:
 
; WHILE - Ausdruck / Byte-VAR (TX_WARTEN)
        LDS        R16, TX_WARTEN
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0663
        RJMP       M_WHILE_0664
M_WHILE_0663:
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; SetBit(LED_GN)
        SBI        PORTB, 1
 
; WHILE DO ...
        RJMP       M_WHILE_0662
M_WHILE_0664:
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDS        R0, AUSGABEBYTE
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (TX_WARTEN)
        STS        TX_WARTEN, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; PROCEDURE - Ende (RUN_RECEIVE_CONOUT)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_DEVCODE)
RUN_RECEIVE_DEVCODE:
 
; Byte-Parameter(1) fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        LDI        R16, 0x06
        MOV        R0, R16
 
; Aufruf PROCEDURE (RUN_RECEIVE_MESSAGE)
        CALL       RUN_RECEIVE_MESSAGE
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; PROCEDURE - Ende (RUN_RECEIVE_DEVCODE)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_ERROR_CODE)
RUN_RECEIVE_ERROR_CODE:
 
; Byte-Parameter(1) fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        LDS        R0, ERROR_CODE
 
; Aufruf PROCEDURE (RUN_RECEIVE_MESSAGE)
        CALL       RUN_RECEIVE_MESSAGE
 
; Byte-Parameter(1) fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        LDS        R0, ERROR_PARAM
 
; Aufruf PROCEDURE (RUN_RECEIVE_MESSAGE)
        CALL       RUN_RECEIVE_MESSAGE
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; PROCEDURE - Ende (RUN_RECEIVE_ERROR_CODE)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_KEINEBA)
RUN_BA_MODE_KEINEBA:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (BA_MODE_INI)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (BA_MODE)
        STS        BA_MODE, R16
 
; PROCEDURE - Ende (RUN_BA_MODE_KEINEBA)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_SET_RD)
RUN_BA_MODE_SET_RD:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ClearBit(CDEN_A)
        CBI        PORTD, 6
 
; SetBit(CDEN_P)
        SBI        DDRD, 6
 
; ClearBit(CDEN_A)
        CBI        PORTD, 6
 
; ClearBit(CRAC_P)
        CBI        DDRD, 7
 
; ClearBit(DDAC_A)
        CBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (BA_MODE_RD)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (BA_MODE)
        STS        BA_MODE, R16
 
; PROCEDURE - Ende (RUN_BA_MODE_SET_RD)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_INI)
RUN_BA_MODE_INI:
 
; IF THEN - Ausdruck /; BitLow(DDWR_E)
        IN         R16, PIND
        BST        R16, 4
        BRTC       M_VERGL_0668
        CLR        R16
        RJMP       M_VERGL_0669
M_VERGL_0668:
        SER        R16
M_VERGL_0669:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0665
        RJMP       M_IF_0666
M_IF_0665:
 
; Aufruf PROCEDURE (RUN_BA_MODE_SET_RD)
        CALL       RUN_BA_MODE_SET_RD
 
; IF_THEN - Ende
M_IF_0666:
 
; PROCEDURE - Ende (RUN_BA_MODE_INI)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_SET_WR)
RUN_BA_MODE_SET_WR:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (BA_MODE_WR)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (BA_MODE)
        STS        BA_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ClearBit(CDEN_P)
        CBI        DDRD, 6
 
; ClearBit(CRAC_A)
        CBI        PORTD, 7
 
; SetBit(CRAC_P)
        SBI        DDRD, 7
 
; ClearBit(CRAC_A)
        CBI        PORTD, 7
 
; SetBit(DDAC_A)
        SBI        PORTD, 5
 
; PROCEDURE - Ende (RUN_BA_MODE_SET_WR)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_RD)
RUN_BA_MODE_RD:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (RECEIVE_MODE)
        LDS        R16, RECEIVE_MODE
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0673
        CLR        R16
        RJMP       M_VERGL_0674
M_VERGL_0673:
        SER        R16
M_VERGL_0674:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0670
        RJMP       M_IF_0671
M_IF_0670:
 
; CASE OF - Byte-VAR (RECEIVE_MODE)
        LDS        R16, RECEIVE_MODE
 
; CASE OF - vergleiche Einzel-Element (RECEIVE_CONST)
        CPI        R16, 0x01
        BREQ       M_CASE_0677
        RJMP       M_CASE_0676
M_CASE_0677:
 
; Aufruf PROCEDURE (RUN_RECEIVE_CONST)
        CALL       RUN_RECEIVE_CONST
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0675
M_CASE_0676:
 
; CASE OF - vergleiche Einzel-Element (RECEIVE_CONIN)
        CPI        R16, 0x02
        BREQ       M_CASE_0679
        RJMP       M_CASE_0678
M_CASE_0679:
 
; Aufruf PROCEDURE (RUN_RECEIVE_CONIN)
        CALL       RUN_RECEIVE_CONIN
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0675
M_CASE_0678:
 
; CASE OF - vergleiche Einzel-Element (RECEIVE_CONOUT)
        CPI        R16, 0x03
        BREQ       M_CASE_0681
        RJMP       M_CASE_0680
M_CASE_0681:
 
; Aufruf PROCEDURE (RUN_RECEIVE_CONOUT)
        CALL       RUN_RECEIVE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0675
M_CASE_0680:
 
; CASE OF - vergleiche Einzel-Element (RECEIVE_DEVCODE)
        CPI        R16, 0x04
        BREQ       M_CASE_0683
        RJMP       M_CASE_0682
M_CASE_0683:
 
; Aufruf PROCEDURE (RUN_RECEIVE_DEVCODE)
        CALL       RUN_RECEIVE_DEVCODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0675
M_CASE_0682:
 
; CASE OF - vergleiche Einzel-Element (RECEIVE_ERROR_CODE)
        CPI        R16, 0x05
        BREQ       M_CASE_0685
        RJMP       M_CASE_0684
M_CASE_0685:
 
; Aufruf PROCEDURE (RUN_RECEIVE_ERROR_CODE)
        CALL       RUN_RECEIVE_ERROR_CODE
 
; ENDCASE;
M_CASE_0684:
M_CASE_0675:
 
; IF_THEN - Ende
M_IF_0671:
 
; IF THEN - Ausdruck /; BitHigh(DDWR_E)
        IN         R16, PIND
        BST        R16, 4
        BRTS       M_VERGL_0689
        CLR        R16
        RJMP       M_VERGL_0690
M_VERGL_0689:
        SER        R16
M_VERGL_0690:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0686
        RJMP       M_IF_0687
M_IF_0686:
 
; Aufruf PROCEDURE (RUN_BA_MODE_SET_WR)
        CALL       RUN_BA_MODE_SET_WR
 
; IF_THEN - Ende
M_IF_0687:
 
; PROCEDURE - Ende (RUN_BA_MODE_RD)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_WR)
RUN_BA_MODE_WR:
 
; IF THEN - Ausdruck /; BitHigh(CDEN_E)
        IN         R16, PIND
        BST        R16, 6
        BRTS       M_VERGL_0694
        CLR        R16
        RJMP       M_VERGL_0695
M_VERGL_0694:
        SER        R16
M_VERGL_0695:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0691
        RJMP       M_IF_0692
M_IF_0691:
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BUF_LOW)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DATA_BUF_LOW)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BUF_LOW)
        MOV        R0, R16
 
; WHILE DO ...
M_WHILE_0696:
 
; WHILE - Ausdruck /; BitHigh(CDEN_E)
        IN         R16, PIND
        BST        R16, 6
        BRTS       M_VERGL_0699
        CLR        R16
        RJMP       M_VERGL_0700
M_VERGL_0699:
        SER        R16
M_VERGL_0700:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0697
        RJMP       M_WHILE_0698
M_WHILE_0697:
 
; SetBit(CRAC_A)
        SBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0696
M_WHILE_0698:
 
; WHILE DO ...
M_WHILE_0701:
 
; WHILE - Ausdruck /; BitLow(CDEN_E)
        IN         R16, PIND
        BST        R16, 6
        BRTC       M_VERGL_0704
        CLR        R16
        RJMP       M_VERGL_0705
M_VERGL_0704:
        SER        R16
M_VERGL_0705:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0702
        RJMP       M_WHILE_0703
M_WHILE_0702:
 
; ClearBit(CRAC_A)
        CBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0701
M_WHILE_0703:
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BUF_HIGH)
        MOV        R1, R16
 
; SHL(DATA_BUF_HIGH) - Byte
        LSL        R1
 
; SHL(DATA_BUF_HIGH) - Byte
        LSL        R1
 
; SHL(DATA_BUF_HIGH) - Byte
        LSL        R1
 
; SHL(DATA_BUF_HIGH) - Byte
        LSL        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DATA_BUF_HIGH)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (DATA_BUF_LOW)
        MOV        R18, R0
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BUF)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_BA_MODE_WR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (DATA_BUF) retten
        MOV        R18, R2
 
; lokalen Parameter (DATA_BUF) an Prozedur (DATA_SEND)
        MOV        R0, R18
 
; Aufruf PROCEDURE (DATA_SEND)
        CALL       DATA_SEND
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_BA_MODE_WR)
        POP        R2
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0706:
 
; WHILE - Ausdruck /; BitHigh(CDEN_E)
        IN         R16, PIND
        BST        R16, 6
        BRTS       M_VERGL_0709
        CLR        R16
        RJMP       M_VERGL_0710
M_VERGL_0709:
        SER        R16
M_VERGL_0710:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0707
        RJMP       M_WHILE_0708
M_WHILE_0707:
 
; SetBit(CRAC_A)
        SBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0706
M_WHILE_0708:
 
; ClearBit(CRAC_A)
        CBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0692:
 
; IF THEN - Ausdruck /; BitLow(DDWR_E)
        IN         R16, PIND
        BST        R16, 4
        BRTC       M_VERGL_0714
        CLR        R16
        RJMP       M_VERGL_0715
M_VERGL_0714:
        SER        R16
M_VERGL_0715:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0711
        RJMP       M_IF_0712
M_IF_0711:
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_BA_MODE_WR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (RUN_BA_MODE_SET_RD)
        CALL       RUN_BA_MODE_SET_RD
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_BA_MODE_WR)
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0712:
 
; PROCEDURE - Ende (RUN_BA_MODE_WR)
        RET
 
; PROCEDURE - Anfang (TEXT_AN_CONOUT)
TEXT_AN_CONOUT:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R1
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0716:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0717
        RJMP       M_FTD_0718
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0717:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (AUSGABEBYTE)
        STS        AUSGABEBYTE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TEXT_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (RUN_RECEIVE_CONOUT)
        CALL       RUN_RECEIVE_CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (TEXT_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R1
        INC        R17
        MOV        R1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0716
 
; FOR TO DO - Ende
M_FTD_0718:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0D)
        LDI        R16, 0x0D
 
; Zuweisung Ziel /  VAR (AUSGABEBYTE)
        STS        AUSGABEBYTE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TEXT_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (RUN_RECEIVE_CONOUT)
        CALL       RUN_RECEIVE_CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (TEXT_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0A)
        LDI        R16, 0x0A
 
; Zuweisung Ziel /  VAR (AUSGABEBYTE)
        STS        AUSGABEBYTE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TEXT_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (RUN_RECEIVE_CONOUT)
        CALL       RUN_RECEIVE_CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (TEXT_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (TEXT_AN_CONOUT)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ASM
.equ UBRR0 = UBRR0L

 
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x000A)
        MOV        R0, R16
        LDI        R17, HIGH(0x000A)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_INT0)
        CALL       INIT_INT0
 
; Aufruf PROCEDURE (INIT_SER0_PORT)
        CALL       INIT_SER0_PORT
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (BA_MODE_KEINEBA)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (BA_MODE)
        STS        BA_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SEND_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SEND_MODE)
        STS        SEND_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ERROR_PARAM)
        STS        ERROR_PARAM, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_LED_STATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SHIFTSTATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KEYBUFFERPTR)
        STS        KEYBUFFERPTR, R16
        STS        KEYBUFFERPTR+1, R17
 
; SetBit(DDAC_A)
        SBI        PORTD, 5
 
; ClearBit(CRAC_A)
        CBI        PORTD, 7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TX_WARTEN)
        STS        TX_WARTEN, R16
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; ClearBit(SUMMER)
        CBI        PORTB, 0
 
; Aufruf PROCEDURE (START_KEYBOARD)
        CALL       START_KEYBOARD
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('Systemtest CONIO2 o.k.')
        LDI        ZL, LOW(2*M_CONST_STRING_8)
        LDI        ZH, HIGH(2*M_CONST_STRING_8)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0719
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0719:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0721
M_PRG_CONST_STRING_0720:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0720
M_PRG_CONST_STRING_0721:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0723
        MOV        R16, R17
M_PRG_CONST_STRING_0722:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0722
M_PRG_CONST_STRING_0723:
        ST         -Z, R17
 
; Aufruf PROCEDURE (TEXT_AN_CONOUT)
        CALL       TEXT_AN_CONOUT
 
; LOOP - Start_Marke
M_LOOP_0724:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0728
        CLR        R16
        RJMP       M_VERGL_0729
M_VERGL_0728:
        SER        R16
M_VERGL_0729:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0725
        RJMP       M_IF_0726
M_IF_0725:
 
; Aufruf Funktion (READ_SCAN)
        CALL       READ_SCAN
 
; Zuweisung Ziel /  VAR (SCAN_ZEICHEN)
        STS        SCAN_ZEICHEN, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SCAN_TO_KEY)
        LDS        R0, SCAN_ZEICHEN
 
; Aufruf PROCEDURE (SCAN_TO_KEY)
        CALL       SCAN_TO_KEY
 
; IF_THEN - Ende
M_IF_0726:
 
; CASE OF - Byte-VAR (BA_MODE)
        LDS        R16, BA_MODE
 
; CASE OF - vergleiche Einzel-Element (BA_MODE_KEINEBA)
        CPI        R16, 0x00
        BREQ       M_CASE_0732
        RJMP       M_CASE_0731
M_CASE_0732:
 
; Aufruf PROCEDURE (RUN_BA_MODE_KEINEBA)
        CALL       RUN_BA_MODE_KEINEBA
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0730
M_CASE_0731:
 
; CASE OF - vergleiche Einzel-Element (BA_MODE_INI)
        CPI        R16, 0x01
        BREQ       M_CASE_0734
        RJMP       M_CASE_0733
M_CASE_0734:
 
; Aufruf PROCEDURE (RUN_BA_MODE_INI)
        CALL       RUN_BA_MODE_INI
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0730
M_CASE_0733:
 
; CASE OF - vergleiche Einzel-Element (BA_MODE_RD)
        CPI        R16, 0x05
        BREQ       M_CASE_0736
        RJMP       M_CASE_0735
M_CASE_0736:
 
; Aufruf PROCEDURE (RUN_BA_MODE_RD)
        CALL       RUN_BA_MODE_RD
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0730
M_CASE_0735:
 
; CASE OF - vergleiche Einzel-Element (BA_MODE_WR)
        CPI        R16, 0x03
        BREQ       M_CASE_0738
        RJMP       M_CASE_0737
M_CASE_0738:
 
; Aufruf PROCEDURE (RUN_BA_MODE_WR)
        CALL       RUN_BA_MODE_WR
 
; ENDCASE;
M_CASE_0737:
M_CASE_0730:
 
; LOOP - Ende
        RJMP       M_LOOP_0724
 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; TAKTFREQUENZ (C) WORD Wert=0x5666
; UBRR_VAL (C) BYTE Wert=0x01
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; CHAR_NULL (C) CHAR Wert=0x00
; CHAR_FC (C) CHAR Wert=0xFC
; CHAR_FD (C) CHAR Wert=0xFD
; CHAR_FE (C) CHAR Wert=0xFE
; CHAR_FF (C) CHAR Wert=0xFF
; NO_LED_STATE (C) BYTE Wert=0x00
; LEDSCROLL (C) BYTE Wert=0x01
; LEDNUM (C) BYTE Wert=0x02
; LEDCAPS (C) BYTE Wert=0x04
; KEYSTAT_BYTE1 (C) BYTE Wert=0x01
; KEYSTAT_E0 (C) BYTE Wert=0x02
; KEYSTAT_F0 (C) BYTE Wert=0x03
; NO_SHIFTSTATE (C) BYTE Wert=0x00
; SHSHIFT (C) BYTE Wert=0x20
; SHCTRL (C) BYTE Wert=0x10
; SHALT (C) BYTE Wert=0x08
; SHCAPS (C) BYTE Wert=0x04
; SHNUM (C) BYTE Wert=0x02
; SHSCROLL (C) BYTE Wert=0x01
; CODETAB_NORMAL (A) 
; CODETAB_SHIFT (A) 
; CODETAB_CTRL (A) 
; CODETAB_ALT (A) 
; KBDNUM (C) BYTE Wert=0x77
; KBDCAPS (C) BYTE Wert=0x58
; KBDSCROLL (C) BYTE Wert=0x7E
; KBDALT (C) BYTE Wert=0x11
; KBDCTRL (C) BYTE Wert=0x14
; KBDLSHIFT (C) BYTE Wert=0x12
; KBDRSHIFT (C) BYTE Wert=0x59
; KBDENTER (C) BYTE Wert=0x5A
; KBDSPACE (C) BYTE Wert=0x29
; KBDBS (C) BYTE Wert=0x66
; KBDTAB (C) BYTE Wert=0x0D
; KBDESC (C) BYTE Wert=0x76
; KBDF1 (C) BYTE Wert=0x05
; KBDF2 (C) BYTE Wert=0x06
; KBDF3 (C) BYTE Wert=0x04
; KBDF4 (C) BYTE Wert=0x0C
; KBDF5 (C) BYTE Wert=0x03
; KBDF6 (C) BYTE Wert=0x0B
; KBDF7 (C) BYTE Wert=0x83
; KBDF8 (C) BYTE Wert=0x0A
; KBDF9 (C) BYTE Wert=0x01
; KBDF10 (C) BYTE Wert=0x09
; KBDF11 (C) BYTE Wert=0x78
; KBDF12 (C) BYTE Wert=0x07
; KBDRGUI (C) BYTE Wert=0x27
; KBDLGUI (C) BYTE Wert=0x1F
; KBDAPPS (C) BYTE Wert=0x2F
; KBDEND (C) BYTE Wert=0x69
; KBDHOME (C) BYTE Wert=0x6C
; KBDUP (C) BYTE Wert=0x75
; KBDDN (C) BYTE Wert=0x72
; KBDLEFT (C) BYTE Wert=0x6B
; KBDRIGHT (C) BYTE Wert=0x74
; KBDPGUP (C) BYTE Wert=0x7D
; KBDPGDN (C) BYTE Wert=0x7A
; KBDINSERT (C) BYTE Wert=0x70
; KBDDELETE (C) BYTE Wert=0x71
; KBDPRINT (C) BYTE Wert=0x12
; KBDPAUSE (C) BYTE Wert=0xE1
; SCANBREAK (C) BYTE Wert=0xF0
; SCANEXT (C) BYTE Wert=0xE0
; HSTSCROLL (C) BYTE Wert=0x00
; HSTPRINT (C) BYTE Wert=0x10
; HSTINS (C) BYTE Wert=0x16
; HSTHOME (C) BYTE Wert=0x00
; HSTPGUP (C) BYTE Wert=0x12
; HSTPGDN (C) BYTE Wert=0x03
; HSTDEL (C) BYTE Wert=0x08
; HSTEND (C) BYTE Wert=0x00
; HSTLEFT (C) BYTE Wert=0x13
; HSTRIGHT (C) BYTE Wert=0x04
; HSTUP (C) BYTE Wert=0x05
; HSTDN (C) BYTE Wert=0x18
; HSTRGUI (C) BYTE Wert=0x00
; HSTLGUI (C) BYTE Wert=0x00
; HSTAPPS (C) BYTE Wert=0x00
; HSTF1 (C) BYTE Wert=0x80
; HSTF2 (C) BYTE Wert=0x81
; HSTF3 (C) BYTE Wert=0x82
; HSTF4 (C) BYTE Wert=0x83
; HSTF5 (C) BYTE Wert=0x84
; HSTF6 (C) BYTE Wert=0x85
; HSTF7 (C) BYTE Wert=0x86
; HSTF8 (C) BYTE Wert=0x87
; HSTF9 (C) BYTE Wert=0x88
; HSTF10 (C) BYTE Wert=0x89
; HSTF11 (C) BYTE Wert=0x8A
; HSTF12 (C) BYTE Wert=0x8B
; BA_MODE_KEINEBA (C) BYTE Wert=0x00
; BA_MODE_INI (C) BYTE Wert=0x01
; BA_MODE_SET_WR (C) BYTE Wert=0x02
; BA_MODE_WR (C) BYTE Wert=0x03
; BA_MODE_SET_RD (C) BYTE Wert=0x04
; BA_MODE_RD (C) BYTE Wert=0x05
; NO_RECEIVE_MODE (C) BYTE Wert=0x00
; RECEIVE_CONST (C) BYTE Wert=0x01
; RECEIVE_CONIN (C) BYTE Wert=0x02
; RECEIVE_CONOUT (C) BYTE Wert=0x03
; RECEIVE_DEVCODE (C) BYTE Wert=0x04
; RECEIVE_ERROR_CODE (C) BYTE Wert=0x05
; NO_SEND_MODE (C) BYTE Wert=0x00
; SEND_CONOUT (C) BYTE Wert=0x01
; SEND_LIST (C) BYTE Wert=0x02
; RE_CONST (C) BYTE Wert=0x01
; RE_CONIN (C) BYTE Wert=0x02
; SE_CONOUT (C) BYTE Wert=0x03
; RE_SECNT (C) BYTE Wert=0x04
; RE_SECTOR (C) BYTE Wert=0x05
; RE_RD_ISEC (C) BYTE Wert=0x06
; SE_WR_ISEC (C) BYTE Wert=0x07
; SE_STD (C) BYTE Wert=0x08
; SE_LIST (C) BYTE Wert=0x09
; RE_ERROR_CODE (C) BYTE Wert=0x0A
; RE_WHO_ARE_YOU (C) BYTE Wert=0x14
; DEVCODE_PC_CPM_EMU (C) BYTE Wert=0x02
; DEVCODE_KEYBOARD (C) BYTE Wert=0x03
; DEVCODE_DISPLAY (C) BYTE Wert=0x04
; DEVCODE_RAMFLOPPY (C) BYTE Wert=0x05
; DEVCODE_CONINOUT (C) BYTE Wert=0x06
; DEVCODE_SOUND (C) BYTE Wert=0x07
; MESSAGE_WHO_AM_I (C) BYTE Wert=0x06
; SUMMER (B) BIT
; LED_GN (B) BIT
; TASTE_01 (B) BIT
; KEY_CLK_A (B) BIT
; KEY_CLK_E (B) BIT
; KEY_CLK_D (B) BIT
; KEY_DAT_A (B) BIT
; KEY_DAT_E (B) BIT
; KEY_DAT_D (B) BIT
; STEUER_STRING (V) STRING
; TEXT_STRING (V) STRING
; BITCNTR (V) BYTE
; KEYBSTATE (V) BYTE
; LEDSTATE (V) BYTE
; LOCALBYTE (V) BYTE
; KBSHIFTSTATE (V) BYTE
; TMPBYTE (V) BYTE
; CAPS_PRESSED (V) BOOLEAN
; NUM_PRESSED (V) BOOLEAN
; SCROLL_PRESSED (V) BOOLEAN
; DOCLICK (V) BOOLEAN
; INITFAILED (V) BOOLEAN
; LOCALMODE (V) BOOLEAN
; CH (V) CHAR
; SCANBUFFER (Y) BYTE
; SCANBUFFERPTR (V) WORD
; KEYBUFFER (Y) BYTE
; KEYBUFFERPTR (V) WORD
; SCAN_ZEICHEN (V) BYTE
; BA_MODE (V) BYTE
; RECEIVE_MODE (V) BYTE
; SEND_MODE (V) BYTE
; ERROR_CODE (V) BYTE
; ERROR_PARAM (V) BYTE
; SOUND_BYTE (V) BYTE
; LADE_BYTE (V) BYTE
; DDWR_E (B) BIT
; DDAC_A (B) BIT
; CDEN_E (B) BIT
; CDEN_A (B) BIT
; CDEN_P (B) BIT
; CRAC_A (B) BIT
; CRAC_E (B) BIT
; CRAC_P (B) BIT
; TX_WARTEN (V) BOOLEAN
; AUSGABEBYTE (V) BYTE
; WAITKON (C) WORD Wert=0x0016
; WAITKON2 (C) WORD Wert=0x03DE
; WRITE_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; SER0_ZEICHEN (V) BYTE
; INIT_SER0_PORT (P) 
; RX0_PUFFER_ABFRAGEN (P) 
; SENDE_ZEICHEN0 (P) 
; SENDE_HEX_ZEICHEN0 (P) 
; SENDE_HEX_ZEICHEN0_LN (P) 
; WRITE_SER0 (P) 
; WRITELN_SER0 (P) 
; TWI_BIT_RATE (C) BYTE Wert=0x67
; TWI_PRESCALER (C) BYTE Wert=0x00
; ADR_DS1307_WR (C) BYTE Wert=0xD0
; ADR_DS1307_RD (C) BYTE Wert=0xD1
; TWINT_E (B) BIT
; TWI_INIT (P) 
; TWI_READ_STATUS (F) 
; TWI_START (P) 
; TWI_RESTART (P) 
; TWI_STOP (P) 
; TWI_WRITE (P) 
; TWI_READACK (F) 
; TWI_READNACK (F) 
; TWI_1307A (P) 
; TWI_1307B (P) 
; INITPORTS (P) 
; INIT_INT0 (P) 
; TON_SIRENE (P) 
; CLICK (P) 
; RX_PUFFER_ABFRAGEN (P) 
; WRITE_SCAN (P) 
; READ_SCAN (F) 
; READ_KEY (F) 
; WRITE_KEY (P) 
; WRITE_C_KEY (P) 
; WRITE_TEXT (P) 
; SENDKEY (P) 
; SENDKEYCHAR (P) 
; INITKEYB (P) 
; SET_KBD_CLK (P) 
; RESET_KBD_CLK (P) 
; NOT_PARITY (F) 
; SENDTOKBD (P) 
; SET_KBD_STATE (P) 
; KBDRESET (P) 
; START_KEYBOARD (P) 
; SETZE_BIT_IN_KBSHIFTSTATE (P) 
; LOESCHE_BIT_IN_KBSHIFTSTATE (P) 
; SETZE_BIT_IN_LEDSTATE (P) 
; LOESCHE_BIT_IN_LEDSTATE (P) 
; SCAN_TO_KEY (P) 
; CHANGE_MODE (P) 
; DATA_SEND (P) 
; SEND_ONE_NIBBLE (P) 
; RUN_RECEIVE_MESSAGE (P) 
; RUN_RECEIVE_CONST (P) 
; RUN_RECEIVE_CONIN (P) 
; RUN_RECEIVE_CONOUT (P) 
; RUN_RECEIVE_DEVCODE (P) 
; RUN_RECEIVE_ERROR_CODE (P) 
; RUN_BA_MODE_KEINEBA (P) 
; RUN_BA_MODE_SET_RD (P) 
; RUN_BA_MODE_INI (P) 
; RUN_BA_MODE_SET_WR (P) 
; RUN_BA_MODE_RD (P) 
; RUN_BA_MODE_WR (P) 
; TEXT_AN_CONOUT (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE INIT_SER0_PORT;
; PROCEDURE RX0_PUFFER_ABFRAGEN;
; PROCEDURE SENDE_ZEICHEN0 (S_ZEICHEN0 : BYTE);
; PROCEDURE SENDE_HEX_ZEICHEN0 (H_ZEICHEN : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE);
; PROCEDURE SENDE_HEX_ZEICHEN0_LN (WERT_BYTE : BYTE);
; PROCEDURE WRITE_SER0 (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN_SER0;
; PROCEDURE TWI_INIT;
; FUNCTION TWI_READ_STATUS (B1 : BYTE) : BYTE;
; PROCEDURE TWI_START (B1 : BYTE);
; PROCEDURE TWI_RESTART (B1 : BYTE);
; PROCEDURE TWI_STOP;
; PROCEDURE TWI_WRITE (DATEN : BYTE) (B1 : BYTE);
; FUNCTION TWI_READACK (B1 : BYTE) : BYTE;
; FUNCTION TWI_READNACK (B1 : BYTE) : BYTE;
; PROCEDURE TWI_1307A (B1 : BYTE);
; PROCEDURE TWI_1307B (B1 : BYTE) (SEKUNDEN : BYTE) (MINUTEN : BYTE) (STUNDEN : BYTE);
; PROCEDURE INITPORTS;
; PROCEDURE INIT_INT0;
; PROCEDURE TON_SIRENE (DAUER : WORD) (FREQUENZ : WORD);
; PROCEDURE CLICK;
; PROCEDURE RX_PUFFER_ABFRAGEN;
; PROCEDURE WRITE_SCAN (WRITE_SCAN_VALUE : BYTE);
; FUNCTION READ_SCAN (READ_SCAN_VALUE : BYTE) (SCAN_COUNTER : WORD) (B1 : BYTE) : BYTE;
; FUNCTION READ_KEY (READ_KEY_VALUE : BYTE) (KEY_COUNTER : WORD) (B1 : BYTE) : BYTE;
; PROCEDURE WRITE_KEY (WRITE_KEY_VALUE : BYTE);
; PROCEDURE WRITE_C_KEY (CKEY : CHAR) (B1 : BYTE);
; PROCEDURE WRITE_TEXT (ZAEHLER : BYTE) (C1 : CHAR);
; PROCEDURE SENDKEY (SKEY : BYTE) (C1 : CHAR) (B1 : BYTE);
; PROCEDURE SENDKEYCHAR (SKEY : CHAR) (B1 : BYTE);
; PROCEDURE INITKEYB;
; PROCEDURE SET_KBD_CLK;
; PROCEDURE RESET_KBD_CLK;
; FUNCTION NOT_PARITY (DAS_BYTE : BYTE) (ERGEBNIS : BOOLEAN) (B2 : BYTE) (B3 : BYTE) (B4 : BYTE) : BOOLEAN;
; PROCEDURE SENDTOKBD (B1 : BYTE) (P : BOOLEAN) (W : WORD) (CNT : BYTE) (REG : BYTE) (TEST : BYTE);
; PROCEDURE SET_KBD_STATE;
; PROCEDURE KBDRESET (WARTEN_AUF_TASTATUR : BOOLEAN);
; PROCEDURE START_KEYBOARD;
; PROCEDURE SETZE_BIT_IN_KBSHIFTSTATE (SHIFT_TASTE : BYTE);
; PROCEDURE LOESCHE_BIT_IN_KBSHIFTSTATE (SHIFT_TASTE : BYTE) (B1 : BYTE);
; PROCEDURE SETZE_BIT_IN_LEDSTATE (STATE_LED : BYTE);
; PROCEDURE LOESCHE_BIT_IN_LEDSTATE (STATE_LED : BYTE) (B1 : BYTE);
; PROCEDURE SCAN_TO_KEY (CURSCAN : BYTE) (B1 : BYTE) (CURSCAN_WORD : WORD);
; PROCEDURE CHANGE_MODE (DATA_BYTE : BYTE);
; PROCEDURE DATA_SEND (DATA_BYTE : BYTE) (ZEICHEN : CHAR);
; PROCEDURE SEND_ONE_NIBBLE (ONE_NIBBLE : BYTE) (BIT_TEST : BYTE);
; PROCEDURE RUN_RECEIVE_MESSAGE (RECEIVE_MESSAGE : BYTE) (ONE_NIBBLE : BYTE);
; PROCEDURE RUN_RECEIVE_CONST (RECEIVE_MESSAGE : BYTE);
; PROCEDURE RUN_RECEIVE_CONIN (RECEIVE_MESSAGE : BYTE) (C_ZAEHLER : BYTE);
; PROCEDURE RUN_RECEIVE_CONOUT;
; PROCEDURE RUN_RECEIVE_DEVCODE;
; PROCEDURE RUN_RECEIVE_ERROR_CODE;
; PROCEDURE RUN_BA_MODE_KEINEBA;
; PROCEDURE RUN_BA_MODE_SET_RD;
; PROCEDURE RUN_BA_MODE_INI;
; PROCEDURE RUN_BA_MODE_SET_WR;
; PROCEDURE RUN_BA_MODE_RD;
; PROCEDURE RUN_BA_MODE_WR (DATA_BUF_LOW : BYTE) (DATA_BUF_HIGH : BYTE) (DATA_BUF : BYTE);
; PROCEDURE TEXT_AN_CONOUT (B1 : BYTE) (B2 : BYTE) (C1 : CHAR);
 
; *** Konstanten-ARRAYs ***
;
 
CODETAB_NORMAL:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    '^',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'q'
.db    '1',0x00
.db    0x00,0x00
.db    'y','s'
.db    'a','w'
.db    '2',0x00
.db    0x00,'c'
.db    'x','d'
.db    'e','4'
.db    '3',0x00
.db    0x00,' '
.db    'v','f'
.db    't','r'
.db    '5',0x00
.db    0x00,'n'
.db    'b','h'
.db    'g','z'
.db    '6',0x00
.db    0x00,0x00
.db    'm','j'
.db    'u','7'
.db    '8',0x00
.db    0x00,','
.db    'k','i'
.db    'o','0'
.db    '9',0x00
.db    0x00,'.'
.db    '-','l'
.db    'o','p'
.db    0x5C,0x00
.db    0x00,0x00
.db    'a',0x00
.db    'u',0x27
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'+'
.db    0x00,'#'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_SHIFT:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    '^',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'Q'
.db    '!',0x00
.db    0x00,0x00
.db    'Y','S'
.db    'A','W'
.db    '"',0x00
.db    0x00,'C'
.db    'X','D'
.db    'E','$'
.db    '#',0x00
.db    0x00,' '
.db    'V','F'
.db    'T','R'
.db    '%',0x00
.db    0x00,'N'
.db    'B','H'
.db    'G','Z'
.db    '&',0x00
.db    0x00,0x00
.db    'M','J'
.db    'U','/'
.db    '(',0x00
.db    0x00,';'
.db    'K','I'
.db    'O','='
.db    ')',0x00
.db    0x00,':'
.db    '_','L'
.db    'O','P'
.db    '?',0x00
.db    0x00,0x00
.db    'A',0x00
.db    'U',0x60
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'*'
.db    0x00,0x27
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_CTRL:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x1E,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x11
.db    0x00,0x00
.db    0x00,0x00
.db    0x19,0x13
.db    0x01,0x17
.db    0x00,0x00
.db    0x00,0x03
.db    0x18,0x04
.db    0x05,0x00
.db    0x00,0x00
.db    0x00,' '
.db    0x16,0x06
.db    0x14,0x12
.db    0x00,0x00
.db    0x00,0x0E
.db    0x02,0x08
.db    0x07,0x1A
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,0x0A
.db    0x15,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x0B,0x09
.db    0x0F,0x00
.db    0x1D,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x0F,0x10
.db    0x1C,0x00
.db    0x00,0x00
.db    0x01,0x00
.db    0x15,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_ALT:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'@'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x24,0x00
.db    '#',0x00
.db    0x00,' '
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'{'
.db    '[',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'}'
.db    ']',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x5C,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'~'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    3, "DIR"
 
M_CONST_STRING_1:
 .db    5, "POWER"
 
M_CONST_STRING_2:
 .db    4, "COPY "
 
M_CONST_STRING_3:
 .db    3, "ERA"
 
M_CONST_STRING_4:
 .db    5, "TYPEX"
 
M_CONST_STRING_5:
 .db    4, "EXIT "
 
M_CONST_STRING_6:
 .db    5, "TURBO"
 
M_CONST_STRING_7:
 .db    5, "TURBO"
 
M_CONST_STRING_8:
 .db    22, "Systemtest CONIO2 o.k. "
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=EI_INT0       Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=EI_INT1       Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=5    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=6    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=7    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=8    ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=9    ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=10   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=11   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=12   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=13   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=14   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=15   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=16   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=17   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=18   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=19   ORG=URXCaddr     ISR=USART_RXC     Bemerkung=USART, Rx Complete
; Nummer=20   ORG=UDREaddr     ISR=USART_UDRE    Bemerkung=USART Data Register Empty
; Nummer=21   ORG=UTXCaddr     ISR=USART_TXC     Bemerkung=USART, Tx Complete
; Nummer=22   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=23   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=26   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
